﻿// The use and distribution terms for this software are covered by the 
// Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
// which can be found in the file CPL.TXT at the root of this distribution.
// By using this software in any fashion, you are agreeing to be bound by 
// the terms of this license.
//
// You must not remove this notice, or any other, from this software.
//
// Author:					Joe Audette
// Created:				    2009-05-23
// Last Modified:			2009-05-23
// 

using System;
using System.Collections.Generic;
using System.Web;
using mojoPortal.Web.Controls;
using mojoPortal.Business;
using mojoPortal.Business.WebHelpers;

namespace mojoPortal.Web.UI
{
    /// <summary>
    /// automatically sets the addthis accountid from site settings
    /// </summary>
    public class mojoAddThisButton : AddThisButton
    {
        private SiteSettings siteSettings = null;

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            siteSettings = CacheHelper.GetCurrentSiteSettings();
            if (siteSettings == null) { return; }

            AccountId = siteSettings.AddThisDotComUsername;

        }
    }
}
