--
-- PostgreSQL database dump
--

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: postgres
--

CREATE PROCEDURAL LANGUAGE plpgsql;


ALTER PROCEDURAL LANGUAGE plpgsql OWNER TO postgres;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: mp_authorizenetlog; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_authorizenetlog (
    rowguid character(36) NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    siteguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    storeguid character(36) NOT NULL,
    cartguid character(36) NOT NULL,
    rawresponse text,
    responsecode character(1),
    responsereasoncode character varying(20),
    reason text,
    avscode character varying(50),
    ccvcode character(1),
    cavcode character(1),
    transactionid character varying(50),
    transactiontype character varying(50),
    method character varying(20),
    authcode character varying(50),
    amount numeric(15,4),
    tax numeric(15,4),
    duty numeric(15,4),
    freight numeric(15,4)
);


ALTER TABLE public.mp_authorizenetlog OWNER TO test;

--
-- Name: mp_bannedipaddresses; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_bannedipaddresses (
    rowid integer DEFAULT nextval(('"mp_bannedipaddressesid_seq"'::text)::regclass) NOT NULL,
    bannedip character varying(50) NOT NULL,
    bannedutc timestamp without time zone NOT NULL,
    bannedreason character varying(255)
);


ALTER TABLE public.mp_bannedipaddresses OWNER TO test;

--
-- Name: mp_bannedipaddresses_select_all_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_bannedipaddresses_select_all_type AS (
	rowid integer,
	bannedip character varying(50),
	bannedutc timestamp without time zone,
	bannedreason character varying(255)
);


ALTER TYPE public.mp_bannedipaddresses_select_all_type OWNER TO test;

--
-- Name: mp_bannedipaddresses_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_bannedipaddresses_select_one_type AS (
	rowid integer,
	bannedip character varying(50),
	bannedutc timestamp without time zone,
	bannedreason character varying(255)
);


ALTER TYPE public.mp_bannedipaddresses_select_one_type OWNER TO test;

--
-- Name: mp_blog_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blog_select_type AS (
	itemid integer,
	moduleid integer,
	createdbyuser character varying(100),
	createddate timestamp without time zone,
	title character varying(100),
	excerpt character varying(512),
	startdate timestamp without time zone,
	isinnewsletter boolean,
	description text,
	commentcount character varying(20),
	trackbackcount integer,
	includeinfeed boolean,
	allowcommentsfordays integer,
	blogguid character(36),
	moduleguid character(36),
	location text,
	userguid character(36),
	lastmoduserguid character(36),
	lastmodutc timestamp without time zone,
	itemurl character varying(255)
);


ALTER TYPE public.mp_blog_select_type OWNER TO test;

--
-- Name: mp_blog_selectarchivebymonth_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blog_selectarchivebymonth_type AS (
	month integer,
	monthname character varying(10),
	year integer,
	day integer,
	count integer
);


ALTER TYPE public.mp_blog_selectarchivebymonth_type OWNER TO test;

--
-- Name: mp_blog_selectbycategory_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blog_selectbycategory_type AS (
	itemid integer,
	moduleid integer,
	createdbyuser character varying(100),
	createddate timestamp without time zone,
	title character varying(100),
	excerpt character varying(512),
	description text,
	startdate timestamp without time zone,
	isinnewsletter boolean,
	includeinfeed boolean,
	commentcount integer,
	itemurl character varying(255)
);


ALTER TYPE public.mp_blog_selectbycategory_type OWNER TO test;

--
-- Name: mp_blog_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blog_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	commentcount integer,
	title character varying(255),
	itemurl character varying(255),
	description text,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_blog_selectbypage_type OWNER TO test;

--
-- Name: mp_blogcategories; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_blogcategories (
    categoryid integer DEFAULT nextval(('"mp_blogcategories_categoryid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    category character varying(255)
);


ALTER TABLE public.mp_blogcategories OWNER TO test;

--
-- Name: mp_blogcategories_select_bymodule_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blogcategories_select_bymodule_type AS (
	categoryid integer,
	moduleid integer,
	category character varying(255),
	postcount bigint
);


ALTER TYPE public.mp_blogcategories_select_bymodule_type OWNER TO test;

--
-- Name: mp_blogcategories_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blogcategories_select_one_type AS (
	categoryid integer,
	moduleid integer,
	category character varying(255)
);


ALTER TYPE public.mp_blogcategories_select_one_type OWNER TO test;

--
-- Name: mp_blogcomments; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_blogcomments (
    blogcommentid integer DEFAULT nextval(('"mp_blogcomments_blogcommentid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    itemid integer NOT NULL,
    comment text NOT NULL,
    title character varying(100),
    name character varying(100),
    url character varying(200),
    datecreated timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL
);


ALTER TABLE public.mp_blogcomments OWNER TO test;

--
-- Name: mp_blogcomments_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blogcomments_select_type AS (
	blogcommentid integer,
	itemid integer,
	moduleid integer,
	name character varying(100),
	title character varying(100),
	url character varying(200),
	comment text,
	datecreated timestamp without time zone
);


ALTER TYPE public.mp_blogcomments_select_type OWNER TO test;

--
-- Name: mp_blogitemcategories; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_blogitemcategories (
    id integer DEFAULT nextval(('"mp_blogitemcategories_id_seq"'::text)::regclass) NOT NULL,
    itemid integer NOT NULL,
    categoryid integer NOT NULL
);


ALTER TABLE public.mp_blogitemcategories OWNER TO test;

--
-- Name: mp_blogitemcategories_select_byitem_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blogitemcategories_select_byitem_type AS (
	categoryid integer,
	category character varying(255)
);


ALTER TYPE public.mp_blogitemcategories_select_byitem_type OWNER TO test;

--
-- Name: mp_blogs; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_blogs (
    itemid integer DEFAULT nextval(('"mp_blogs_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    createdbyuser character varying(100),
    createddate timestamp without time zone,
    title character varying(100),
    excerpt character varying(512),
    startdate timestamp without time zone,
    isinnewsletter boolean,
    includeinfeed boolean,
    description text,
    commentcount integer DEFAULT 0 NOT NULL,
    trackbackcount integer DEFAULT 0 NOT NULL,
    category character varying(50),
    allowcommentsfordays integer DEFAULT 0 NOT NULL,
    blogguid character varying(36),
    moduleguid character varying(36),
    location text,
    userguid character varying(36),
    lastmoduserguid character varying(36),
    lastmodutc timestamp without time zone,
    itemurl character varying(255)
);


ALTER TABLE public.mp_blogs OWNER TO test;

--
-- Name: mp_blogstats; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_blogstats (
    moduleid integer NOT NULL,
    entrycount integer DEFAULT 0 NOT NULL,
    commentcount integer DEFAULT 0 NOT NULL,
    trackbackcount integer DEFAULT 0 NOT NULL,
    moduleguid character varying(36)
);


ALTER TABLE public.mp_blogstats OWNER TO test;

--
-- Name: mp_blogstats_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_blogstats_select_type AS (
	moduleid integer,
	entrycount integer,
	commentcount integer
);


ALTER TYPE public.mp_blogstats_select_type OWNER TO test;

--
-- Name: mp_calendarevents; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_calendarevents (
    itemid integer DEFAULT nextval(('"mp_calendarevents_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    title character varying(255),
    description text,
    imagename character varying(100),
    eventdate timestamp without time zone,
    starttime timestamp without time zone,
    endtime timestamp without time zone,
    createddate timestamp without time zone,
    userid integer DEFAULT 0 NOT NULL,
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36),
    lastmoduserguid character varying(36),
    location text,
    lastmodutc timestamp without time zone,
    requiresticket boolean DEFAULT false NOT NULL,
    ticketprice numeric(15,4)
);


ALTER TABLE public.mp_calendarevents OWNER TO test;

--
-- Name: mp_calendarevents_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_calendarevents_select_one_type AS (
	itemid integer,
	moduleid integer,
	title character varying(255),
	description text,
	imagename character varying(100),
	eventdate timestamp without time zone,
	starttime timestamp without time zone,
	endtime timestamp without time zone,
	createddate timestamp without time zone,
	userid integer,
	itemguid character(36),
	moduleguid character(36),
	userguid character(36),
	location text,
	lastmoduserguid character(36),
	lastmodutc timestamp without time zone,
	ticketprice numeric(15,4),
	requiresticket boolean
);


ALTER TYPE public.mp_calendarevents_select_one_type OWNER TO test;

--
-- Name: mp_calendarevents_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_calendarevents_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	title character varying(255),
	description text,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_calendarevents_selectbypage_type OWNER TO test;

--
-- Name: mp_contactformmessage; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_contactformmessage (
    rowguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    moduleguid character(36) NOT NULL,
    email character varying(100) NOT NULL,
    url character varying(255) NOT NULL,
    subject character varying(255) NOT NULL,
    message text NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    createdfromipaddress character varying(255) NOT NULL,
    userguid character(36) NOT NULL
);


ALTER TABLE public.mp_contactformmessage OWNER TO test;

--
-- Name: mp_contentrating; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_contentrating (
    rowguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    contentguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    emailaddress character varying(100),
    rating integer NOT NULL,
    comments text,
    ipaddress character varying(50),
    createdutc timestamp without time zone NOT NULL,
    lastmodutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_contentrating OWNER TO test;

--
-- Name: mp_currency; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_currency (
    guid character(36) NOT NULL,
    title character varying(50) NOT NULL,
    code character(3) NOT NULL,
    symbolleft character varying(15),
    symbolright character varying(15),
    decimalpointchar character(1),
    thousandspointchar character(1),
    decimalplaces character(1),
    value numeric(13,8),
    lastmodified timestamp without time zone,
    created timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_currency OWNER TO test;

--
-- Name: mp_forumposts; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_forumposts (
    postid integer DEFAULT nextval(('"mp_forumposts_postid_seq"'::text)::regclass) NOT NULL,
    threadid integer NOT NULL,
    threadsequence integer DEFAULT 1 NOT NULL,
    subject character varying(255) NOT NULL,
    postdate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    approved boolean DEFAULT false NOT NULL,
    userid integer DEFAULT (-1) NOT NULL,
    sortorder integer DEFAULT 100 NOT NULL,
    post text NOT NULL
);


ALTER TABLE public.mp_forumposts OWNER TO test;

--
-- Name: mp_forumposts_selectallbythread_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumposts_selectallbythread_type AS (
	postid integer,
	threadid integer,
	threadsequence integer,
	subject character varying(255),
	postdate timestamp without time zone,
	approved boolean,
	userid integer,
	sortorder integer,
	post text,
	forumid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50),
	postauthor character varying(50),
	authoremail character varying(100),
	postauthortotalposts integer,
	trusted boolean,
	postauthoravatar character varying(255),
	postauthorwebsiteurl character varying(100),
	postauthorsignature character varying(255)
);


ALTER TYPE public.mp_forumposts_selectallbythread_type OWNER TO test;

--
-- Name: mp_forumposts_selectbythread_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumposts_selectbythread_type AS (
	postid integer,
	threadid integer,
	threadsequence integer,
	subject character varying(255),
	postdate timestamp without time zone,
	approved boolean,
	userid integer,
	sortorder integer,
	post text,
	forumid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50),
	postauthor character varying(50),
	authoremail character varying(100),
	trusted boolean,
	postauthortotalposts integer,
	postauthoravatar character varying(255),
	postauthorwebsiteurl character varying(100),
	postauthorsignature character varying(255)
);


ALTER TYPE public.mp_forumposts_selectbythread_type OWNER TO test;

--
-- Name: mp_forumposts_selectbythread_v2_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumposts_selectbythread_v2_type AS (
	postid integer,
	threadid integer,
	threadsequence integer,
	subject character varying(255),
	postdate timestamp without time zone,
	approved boolean,
	userid integer,
	sortorder integer,
	post text,
	forumid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50),
	postauthor character varying(50),
	postauthortotalposts integer,
	postauthoravatar character varying(255),
	postauthorwebsiteurl character varying(100),
	postauthorsignature character varying(255)
);


ALTER TYPE public.mp_forumposts_selectbythread_v2_type OWNER TO test;

--
-- Name: mp_forumposts_selectforrss_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumposts_selectforrss_type AS (
	postid integer,
	threadid integer,
	threadsequence integer,
	subject character varying(255),
	postdate timestamp without time zone,
	approved boolean,
	userid integer,
	sortorder integer,
	post text,
	threadsubject character varying(255),
	forumid integer,
	startedby character varying(50),
	postauthor character varying(50),
	postauthortotalposts integer,
	postauthoravatar character varying(255),
	postauthorwebsiteurl character varying(100),
	postauthorsignature character varying(255)
);


ALTER TYPE public.mp_forumposts_selectforrss_type OWNER TO test;

--
-- Name: mp_forums; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_forums (
    itemid integer DEFAULT nextval(('"mp_forums_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    createddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    createdby integer NOT NULL,
    title character varying(100) NOT NULL,
    description text NOT NULL,
    ismoderated boolean DEFAULT false NOT NULL,
    isactive boolean DEFAULT true NOT NULL,
    sortorder integer DEFAULT 100 NOT NULL,
    threadcount integer DEFAULT 0 NOT NULL,
    postcount integer DEFAULT 0 NOT NULL,
    mostrecentpostdate timestamp without time zone,
    mostrecentpostuserid integer DEFAULT (-1) NOT NULL,
    postsperpage integer DEFAULT 10 NOT NULL,
    threadsperpage integer DEFAULT 40 NOT NULL,
    allowanonymousposts boolean DEFAULT true NOT NULL
);


ALTER TABLE public.mp_forums OWNER TO test;

--
-- Name: mp_forums_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forums_select_type AS (
	itemid integer,
	moduleid integer,
	createddate timestamp without time zone,
	createdby integer,
	title character varying(100),
	description text,
	ismoderated boolean,
	isactive boolean,
	sortorder integer,
	threadcount integer,
	postcount integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	postsperpage integer,
	threadsperpage integer,
	allowanonymousposts boolean,
	mostrecentpostuser character varying(50),
	subscribed boolean
);


ALTER TYPE public.mp_forums_select_type OWNER TO test;

--
-- Name: mp_forums_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forums_selectone_type AS (
	itemid integer,
	moduleid integer,
	createddate timestamp without time zone,
	createdby integer,
	title character varying(100),
	description text,
	ismoderated boolean,
	isactive boolean,
	sortorder integer,
	threadcount integer,
	postcount integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	postsperpage integer,
	threadsperpage integer,
	allowanonymousposts boolean,
	createdbyuser character varying(50),
	mostrecentpostuser character varying(50)
);


ALTER TYPE public.mp_forums_selectone_type OWNER TO test;

--
-- Name: mp_forumsubscriptions; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_forumsubscriptions (
    subscriptionid integer DEFAULT nextval(('"mp_forumsubscriptions_subscriptionid_seq"'::text)::regclass) NOT NULL,
    forumid integer NOT NULL,
    userid integer NOT NULL,
    subscribedate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    unsubscribedate timestamp without time zone
);


ALTER TABLE public.mp_forumsubscriptions OWNER TO test;

--
-- Name: mp_forumthreads; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_forumthreads (
    threadid integer DEFAULT nextval(('"mp_forumthreads_threadid_seq"'::text)::regclass) NOT NULL,
    forumid integer NOT NULL,
    threadsubject character varying(255) NOT NULL,
    threaddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    totalviews integer DEFAULT 0 NOT NULL,
    totalreplies integer DEFAULT 0 NOT NULL,
    sortorder integer DEFAULT 1000 NOT NULL,
    islocked boolean DEFAULT false NOT NULL,
    forumsequence integer DEFAULT 1 NOT NULL,
    mostrecentpostdate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone,
    mostrecentpostuserid integer,
    startedbyuserid integer NOT NULL
);


ALTER TABLE public.mp_forumthreads OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforum_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreads_selectbyforum_type AS (
	threadid integer,
	forumid integer,
	threadsubject character varying(255),
	threaddate timestamp without time zone,
	totalviews integer,
	totalreplies integer,
	sortorder integer,
	islocked boolean,
	forumsequence integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	startedbyuserid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50)
);


ALTER TYPE public.mp_forumthreads_selectbyforum_type OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforumdesc_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreads_selectbyforumdesc_type AS (
	threadid integer,
	forumid integer,
	threadsubject character varying(255),
	threaddate timestamp without time zone,
	totalviews integer,
	totalreplies integer,
	sortorder integer,
	islocked boolean,
	forumsequence integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	startedbyuserid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50)
);


ALTER TYPE public.mp_forumthreads_selectbyforumdesc_type OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforumdesc_v2_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreads_selectbyforumdesc_v2_type AS (
	threadid integer,
	forumid integer,
	threadsubject character varying(255),
	threaddate timestamp without time zone,
	totalviews integer,
	totalreplies integer,
	sortorder integer,
	islocked boolean,
	forumsequence integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	startedbyuserid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50)
);


ALTER TYPE public.mp_forumthreads_selectbyforumdesc_v2_type OWNER TO test;

--
-- Name: mp_forumthreads_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreads_selectbypage_type AS (
	threadid integer,
	postid integer,
	subject character varying(255),
	post text,
	moduleid integer,
	itemid integer,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_forumthreads_selectbypage_type OWNER TO test;

--
-- Name: mp_forumthreads_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreads_selectone_type AS (
	threadid integer,
	forumid integer,
	threadsubject character varying(255),
	threaddate timestamp without time zone,
	totalviews integer,
	totalreplies integer,
	sortorder integer,
	islocked boolean,
	forumsequence integer,
	mostrecentpostdate timestamp without time zone,
	mostrecentpostuserid integer,
	startedbyuserid integer,
	mostrecentpostuser character varying(50),
	startedby character varying(50),
	postsperpage integer
);


ALTER TYPE public.mp_forumthreads_selectone_type OWNER TO test;

--
-- Name: mp_forumthreadsubscribers_selectbythread_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_forumthreadsubscribers_selectbythread_type AS (
	email character varying(100)
);


ALTER TYPE public.mp_forumthreadsubscribers_selectbythread_type OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_forumthreadsubscriptions (
    threadsubscriptionid integer DEFAULT nextval(('"mp_forumthreadsubscriptions_threadsubscriptionid_seq"'::text)::regclass) NOT NULL,
    threadid integer NOT NULL,
    userid integer NOT NULL,
    subscribedate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    unsubscribedate timestamp without time zone
);


ALTER TABLE public.mp_forumthreadsubscriptions OWNER TO test;

--
-- Name: mp_friendlyurls; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_friendlyurls (
    urlid integer DEFAULT nextval(('"mp_friendlyurls_urlid_seq"'::text)::regclass) NOT NULL,
    siteid integer NOT NULL,
    friendlyurl character varying(255),
    realurl character varying(255),
    ispattern boolean,
    siteguid character varying(36),
    itemguid character varying(36),
    pageguid character varying(36)
);


ALTER TABLE public.mp_friendlyurls OWNER TO test;

--
-- Name: mp_friendlyurls_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_friendlyurls_select_one_type AS (
	urlid integer,
	siteid integer,
	friendlyurl character varying(255),
	realurl character varying(255),
	ispattern boolean,
	pageguid character(36),
	siteguid character(36),
	itemguid character(36)
);


ALTER TYPE public.mp_friendlyurls_select_one_type OWNER TO test;

--
-- Name: mp_friendlyurls_selectbyhost_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_friendlyurls_selectbyhost_type AS (
	urlid integer,
	siteid integer,
	friendlyurl character varying(255),
	realurl character varying(255),
	ispattern boolean
);


ALTER TYPE public.mp_friendlyurls_selectbyhost_type OWNER TO test;

--
-- Name: mp_friendlyurls_selectbyurl_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_friendlyurls_selectbyurl_type AS (
	urlid integer,
	siteid integer,
	friendlyurl character varying(255),
	realurl character varying(255),
	ispattern boolean
);


ALTER TYPE public.mp_friendlyurls_selectbyurl_type OWNER TO test;

--
-- Name: mp_galleryimages; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_galleryimages (
    itemid integer DEFAULT nextval(('"mp_galleryimages_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    displayorder integer DEFAULT 100 NOT NULL,
    caption character varying(255),
    description text,
    metadataxml text,
    imagefile character varying(100),
    webimagefile character varying(100),
    thumbnailfile character varying(100),
    uploaddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    uploaduser character varying(100),
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36)
);


ALTER TABLE public.mp_galleryimages OWNER TO test;

--
-- Name: mp_galleryimages_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_galleryimages_select_type AS (
	itemid integer,
	moduleid integer,
	displayorder integer,
	caption character varying(255),
	description text,
	metadataxml text,
	imagefile character varying(100),
	webimagefile character varying(100),
	thumbnailfile character varying(100),
	uploaddate timestamp without time zone,
	uploaduser character varying(100)
);


ALTER TYPE public.mp_galleryimages_select_type OWNER TO test;

--
-- Name: mp_galleryimages_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_galleryimages_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	caption character varying(255),
	description text,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_galleryimages_selectbypage_type OWNER TO test;

--
-- Name: mp_galleryimages_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_galleryimages_selectone_type AS (
	itemid integer,
	moduleid integer,
	displayorder integer,
	caption character varying(255),
	description text,
	metadataxml text,
	imagefile character varying(100),
	webimagefile character varying(100),
	thumbnailfile character varying(100),
	uploaddate timestamp without time zone,
	uploaduser character varying(100),
	itemguid character(36),
	moduleguid character(36),
	userguid character(36)
);


ALTER TYPE public.mp_galleryimages_selectone_type OWNER TO test;

--
-- Name: mp_galleryimages_selectthumbsbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_galleryimages_selectthumbsbypage_type AS (
	itemid integer,
	caption character varying(255),
	thumbnailfile character varying(100),
	webimagefile character varying(100),
	indexid integer,
	totalpages integer
);


ALTER TYPE public.mp_galleryimages_selectthumbsbypage_type OWNER TO test;

--
-- Name: mp_galleryimages_selectwebimagebypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_galleryimages_selectwebimagebypage_type AS (
	moduleid integer,
	itemid integer,
	totalpages integer
);


ALTER TYPE public.mp_galleryimages_selectwebimagebypage_type OWNER TO test;

--
-- Name: mp_geocountry; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_geocountry (
    guid character(36) NOT NULL,
    name character varying(255) NOT NULL,
    isocode2 character(2) NOT NULL,
    isocode3 character(3) NOT NULL
);


ALTER TABLE public.mp_geocountry OWNER TO test;

--
-- Name: mp_geozone; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_geozone (
    guid character(36) NOT NULL,
    countryguid character(36) NOT NULL,
    name character varying(255) NOT NULL,
    code character varying(255) NOT NULL
);


ALTER TABLE public.mp_geozone OWNER TO test;

--
-- Name: mp_googlecheckoutlog; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_googlecheckoutlog (
    rowguid character(36) NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    siteguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    storeguid character(36) NOT NULL,
    cartguid character(36) NOT NULL,
    notificationtype character varying(255),
    rawresponse text,
    serialnumber character varying(50),
    gtimestamp timestamp without time zone,
    ordernumber character varying(50),
    buyerid character varying(50),
    fullfillstate character varying(50),
    financestate character varying(50),
    emaillistoptin boolean NOT NULL,
    avsresponse character varying(5),
    cvnresponse character varying(5),
    authexpdate timestamp without time zone,
    authamt numeric(15,4) NOT NULL,
    discounttotal numeric(15,4) NOT NULL,
    shippingtotal numeric(15,4) NOT NULL,
    taxtotal numeric(15,4) NOT NULL,
    ordertotal numeric(15,4) NOT NULL,
    latestchgamt numeric(15,4) NOT NULL,
    totalchgamt numeric(15,4) NOT NULL,
    latestrefundamt numeric(15,4) NOT NULL,
    totalrefundamt numeric(15,4) NOT NULL,
    latestchargeback numeric(15,4) NOT NULL,
    totalchargeback numeric(15,4) NOT NULL,
    cartxml text,
    providername character varying(255)
);


ALTER TABLE public.mp_googlecheckoutlog OWNER TO test;

--
-- Name: mp_htmlcontent; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_htmlcontent (
    itemid integer DEFAULT nextval(('"mp_htmlcontent_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    title character varying(255),
    excerpt text,
    body text NOT NULL,
    morelink character varying(255),
    sortorder integer DEFAULT 500 NOT NULL,
    begindate timestamp without time zone DEFAULT '1901-01-01 00:00:00'::timestamp without time zone NOT NULL,
    enddate timestamp without time zone DEFAULT '2200-01-01 00:00:00'::timestamp without time zone NOT NULL,
    createddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone,
    userid integer,
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36),
    lastmoduserguid character varying(36),
    lastmodutc timestamp without time zone
);


ALTER TABLE public.mp_htmlcontent OWNER TO test;

--
-- Name: mp_htmlcontent_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_htmlcontent_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	title character varying(255),
	body text,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_htmlcontent_selectbypage_type OWNER TO test;

--
-- Name: mp_indexingqueue; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_indexingqueue (
    rowid bigint DEFAULT nextval(('"mp_indexingqueueid_seq"'::text)::regclass) NOT NULL,
    indexpath character varying(255) NOT NULL,
    serializeditem text NOT NULL,
    itemkey character varying(255) NOT NULL,
    removeonly boolean NOT NULL
);


ALTER TABLE public.mp_indexingqueue OWNER TO test;

--
-- Name: mp_language; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_language (
    guid character(36) NOT NULL,
    name character varying(255) NOT NULL,
    code character(2) NOT NULL,
    sort integer NOT NULL
);


ALTER TABLE public.mp_language OWNER TO test;

--
-- Name: mp_letter; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_letter (
    letterguid character(36) NOT NULL,
    letterinfoguid character(36) NOT NULL,
    subject character varying(255) NOT NULL,
    htmlbody text NOT NULL,
    textbody text NOT NULL,
    createdby character(36) NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    lastmodby character(36) NOT NULL,
    lastmodutc timestamp without time zone NOT NULL,
    isapproved boolean NOT NULL,
    approvedby character(36) NOT NULL,
    sendclickedutc timestamp without time zone,
    sendstartedutc timestamp without time zone,
    sendcompleteutc timestamp without time zone,
    sendcount integer NOT NULL
);


ALTER TABLE public.mp_letter OWNER TO test;

--
-- Name: mp_letter_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_letter_select_one_type AS (
	letterguid character(36),
	letterinfoguid character(36),
	subject character varying(255),
	htmlbody text,
	textbody text,
	createdby character(36),
	createdutc timestamp without time zone,
	lastmodby character(36),
	lastmodutc timestamp without time zone,
	isapproved boolean,
	approvedby character(36),
	sendclickedutc timestamp without time zone,
	sendstartedutc timestamp without time zone,
	sendcompleteutc timestamp without time zone,
	sendcount integer
);


ALTER TYPE public.mp_letter_select_one_type OWNER TO test;

--
-- Name: mp_letterhtmltemplate; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_letterhtmltemplate (
    guid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    title character varying(255) NOT NULL,
    html text NOT NULL,
    lastmodutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_letterhtmltemplate OWNER TO test;

--
-- Name: mp_letterhtmltemplate_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_letterhtmltemplate_select_one_type AS (
	guid character(36),
	siteguid character(36),
	title character varying(255),
	html text,
	lastmodutc timestamp without time zone
);


ALTER TYPE public.mp_letterhtmltemplate_select_one_type OWNER TO test;

--
-- Name: mp_letterinfo; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_letterinfo (
    letterinfoguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    title character varying(255) NOT NULL,
    description text NOT NULL,
    availabletoroles text NOT NULL,
    enabled boolean NOT NULL,
    allowuserfeedback boolean NOT NULL,
    allowanonfeedback boolean NOT NULL,
    fromaddress character varying(255) NOT NULL,
    fromname character varying(255) NOT NULL,
    replytoaddress character varying(255) NOT NULL,
    sendmode integer NOT NULL,
    enableviewaswebpage boolean NOT NULL,
    enablesendlog boolean NOT NULL,
    rolesthatcanedit text NOT NULL,
    rolesthatcanapprove text NOT NULL,
    rolesthatcansend text NOT NULL,
    subscribercount integer NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    createdby character(36) NOT NULL,
    lastmodutc timestamp without time zone NOT NULL,
    lastmodby character(36) NOT NULL
);


ALTER TABLE public.mp_letterinfo OWNER TO test;

--
-- Name: mp_letterinfo_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_letterinfo_select_one_type AS (
	letterinfoguid character(36),
	siteguid character(36),
	title character varying(255),
	description text,
	availabletoroles text,
	enabled boolean,
	allowuserfeedback boolean,
	allowanonfeedback boolean,
	fromaddress character varying(255),
	fromname character varying(255),
	replytoaddress character varying(255),
	sendmode integer,
	enableviewaswebpage boolean,
	enablesendlog boolean,
	rolesthatcanedit text,
	rolesthatcanapprove text,
	rolesthatcansend text,
	subscribercount integer,
	createdutc timestamp without time zone,
	createdby character(36),
	lastmodutc timestamp without time zone,
	lastmodby character(36)
);


ALTER TYPE public.mp_letterinfo_select_one_type OWNER TO test;

--
-- Name: mp_lettersendlog; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_lettersendlog (
    rowid integer DEFAULT nextval(('"mp_lettersendlogrowid_seq"'::text)::regclass) NOT NULL,
    letterguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    emailaddress character varying(100),
    utc timestamp without time zone NOT NULL,
    erroroccurred boolean NOT NULL,
    errormessage text
);


ALTER TABLE public.mp_lettersendlog OWNER TO test;

--
-- Name: mp_lettersendlog_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_lettersendlog_select_one_type AS (
	rowid integer,
	letterguid character(36),
	userguid character(36),
	emailaddress character varying(100),
	utc timestamp without time zone,
	erroroccurred boolean,
	errormessage text
);


ALTER TYPE public.mp_lettersendlog_select_one_type OWNER TO test;

--
-- Name: mp_lettersubscriber; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_lettersubscriber (
    letterinfoguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    usehtml boolean NOT NULL,
    beginutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_lettersubscriber OWNER TO test;

--
-- Name: mp_lettersubscriber_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_lettersubscriber_select_one_type AS (
	letterinfoguid character(36),
	userguid character(36),
	usehtml boolean,
	beginutc timestamp without time zone,
	email character varying(100),
	name character varying(100)
);


ALTER TYPE public.mp_lettersubscriber_select_one_type OWNER TO test;

--
-- Name: mp_lettersubscriberhx; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_lettersubscriberhx (
    rowid integer DEFAULT nextval(('"mp_lettersubscriberhxrowid_seq"'::text)::regclass) NOT NULL,
    letterinfoguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    usehtml boolean NOT NULL,
    beginutc timestamp without time zone NOT NULL,
    endutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_lettersubscriberhx OWNER TO test;

--
-- Name: mp_links; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_links (
    itemid integer DEFAULT nextval(('"mp_links_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    title character varying(255),
    target character varying(20),
    url character varying(255),
    vieworder integer,
    description text,
    createddate timestamp without time zone,
    createdby integer,
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36)
);


ALTER TABLE public.mp_links OWNER TO test;

--
-- Name: mp_links_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_links_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	title character varying(255),
	description text,
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_links_selectbypage_type OWNER TO test;

--
-- Name: mp_moduledefinitions; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_moduledefinitions (
    moduledefid integer DEFAULT nextval(('"mp_moduledefinitions_moduledefid_seq"'::text)::regclass) NOT NULL,
    featurename character varying(255) NOT NULL,
    controlsrc character varying(255) NOT NULL,
    sortorder integer DEFAULT 500 NOT NULL,
    isadmin boolean DEFAULT false NOT NULL,
    icon character varying(255),
    defaultcachetime integer DEFAULT 0 NOT NULL,
    guid character(36) NOT NULL,
    resourcefile character varying(255)
);


ALTER TABLE public.mp_moduledefinitions OWNER TO test;

--
-- Name: mp_moduledefinitionsettings; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_moduledefinitionsettings (
    id integer DEFAULT nextval(('"mp_moduledefinitionsettings_id_seq"'::text)::regclass) NOT NULL,
    moduledefid integer NOT NULL,
    settingname character varying(50) NOT NULL,
    settingvalue character varying(255) NOT NULL,
    controltype character varying(50),
    regexvalidationexpression text,
    featureguid character(36) NOT NULL,
    resourcefile character varying(255),
    controlsrc character varying(255),
    helpkey character varying(255),
    sortorder integer DEFAULT 100 NOT NULL
);


ALTER TABLE public.mp_moduledefinitionsettings OWNER TO test;

--
-- Name: mp_modules; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_modules (
    moduleid integer DEFAULT nextval(('"mp_modules_moduleid_seq"'::text)::regclass) NOT NULL,
    moduledefid integer NOT NULL,
    moduletitle character varying(255),
    authorizededitroles text,
    cachetime integer NOT NULL,
    edituserid integer DEFAULT 0 NOT NULL,
    showtitle boolean DEFAULT true,
    siteid integer DEFAULT 0 NOT NULL,
    availableformypage boolean DEFAULT false NOT NULL,
    createdbyuserid integer,
    createddate timestamp without time zone,
    countofuseonmypage integer DEFAULT 0 NOT NULL,
    icon character varying(255),
    allowmultipleinstancesonmypage boolean DEFAULT true NOT NULL,
    guid character varying(36),
    featureguid character varying(36),
    siteguid character varying(36),
    edituserguid character varying(36),
    hidefromauth boolean DEFAULT false NOT NULL,
    hidefromunauth boolean DEFAULT false NOT NULL
);


ALTER TABLE public.mp_modules OWNER TO test;

--
-- Name: mp_modules_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectbypage_type AS (
	moduleid integer,
	pageid integer,
	moduledefid integer,
	moduleorder integer,
	panename character varying(50),
	moduletitle character varying(255),
	authorizededitroles text,
	cachetime integer,
	showtitle boolean,
	controlsrc character varying(255)
);


ALTER TYPE public.mp_modules_selectbypage_type OWNER TO test;

--
-- Name: mp_modules_selectbypageid_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectbypageid_type AS (
	moduleid integer,
	pageid integer,
	moduledefid integer,
	moduleorder integer,
	panename character varying(50),
	moduletitle character varying(255),
	authorizededitroles text,
	cachetime integer,
	showtitle boolean,
	hidefromauth boolean,
	hidefromunauth boolean,
	controlsrc character varying(255),
	edituserid integer,
	availableformypage boolean,
	createdbyuserid integer,
	createddate timestamp without time zone,
	publishbegindate timestamp without time zone,
	publishenddate timestamp without time zone,
	guid character(36),
	featureguid character(36),
	siteguid character(36),
	edituserguid character(36)
);


ALTER TYPE public.mp_modules_selectbypageid_type OWNER TO test;

--
-- Name: mp_modules_selectformypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectformypage_type AS (
	moduleid integer,
	siteid integer,
	moduledefid integer,
	moduletitle character varying(255),
	allowmultipleinstancesonmypage boolean,
	moduleicon character varying(255),
	featureicon character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_modules_selectformypage_type OWNER TO test;

--
-- Name: mp_modules_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectone_type AS (
	moduleid integer,
	siteid integer,
	moduledefid integer,
	moduletitle character varying(255),
	authorizededitroles text,
	cachetime integer,
	showtitle boolean,
	hidefromauth boolean,
	hidefromunauth boolean,
	edituserid integer,
	availableformypage boolean,
	allowmultipleinstancesonmypage boolean,
	icon character varying(255),
	createdbyuserid integer,
	createddate timestamp without time zone,
	countofuseonmypage integer,
	guid character(36),
	featureguid character(36),
	siteguid character(36),
	edituserguid character(36)
);


ALTER TYPE public.mp_modules_selectone_type OWNER TO test;

--
-- Name: mp_modules_selectonebypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectonebypage_type AS (
	moduleid integer,
	siteid integer,
	pageid integer,
	moduledefid integer,
	moduleorder integer,
	panename character varying(50),
	moduletitle character varying(255),
	authorizededitroles text,
	cachetime integer,
	showtitle boolean,
	hidefromauth boolean,
	hidefromunauth boolean,
	edituserid integer,
	availableformypage boolean,
	allowmultipleinstancesonmypage boolean,
	countofuseonmypage integer,
	icon character varying(255),
	createdbyuserid integer,
	createddate timestamp without time zone,
	publishbegindate timestamp without time zone,
	publishenddate timestamp without time zone,
	controlsrc character varying(255),
	guid character(36),
	featureguid character(36),
	siteguid character(36),
	edituserguid character(36)
);


ALTER TYPE public.mp_modules_selectonebypage_type OWNER TO test;

--
-- Name: mp_modules_selectpage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modules_selectpage_type AS (
	moduleid integer,
	moduletitle character varying(255),
	featurename character varying(255),
	resourcefile character varying(255),
	controlsrc character varying(255),
	authorizededitroles text,
	createdby character varying(100),
	createddate timestamp without time zone
);


ALTER TYPE public.mp_modules_selectpage_type OWNER TO test;

--
-- Name: mp_modulesettings; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_modulesettings (
    id integer DEFAULT nextval(('"mp_modulesettings_id_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    settingname character varying(50) NOT NULL,
    settingvalue character varying(255) NOT NULL,
    controltype character varying(50),
    regexvalidationexpression text,
    moduleguid character varying(36),
    settingguid character varying(36),
    controlsrc character varying(255),
    helpkey character varying(255),
    sortorder integer DEFAULT 100 NOT NULL
);


ALTER TABLE public.mp_modulesettings OWNER TO test;

--
-- Name: mp_modulesettings_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_modulesettings_select_type AS (
	id integer,
	moduleid integer,
	settingname character varying(50),
	settingvalue character varying(255),
	controltype character varying(50),
	controlsrc character varying(255),
	helpkey character varying(255),
	sortorder integer,
	regexvalidationexpression text,
	featureguid character(36),
	resourcefile character varying(255)
);


ALTER TYPE public.mp_modulesettings_select_type OWNER TO test;

--
-- Name: mp_mp_galleryimages_selectall_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_mp_galleryimages_selectall_type AS (
	itemid integer,
	moduleid integer,
	displayorder integer,
	caption character varying(255),
	description text,
	imagefile character varying(100),
	webimagefile character varying(100),
	thumbnailfile character varying(100),
	uploaddate timestamp without time zone,
	uploaduser character varying(100)
);


ALTER TYPE public.mp_mp_galleryimages_selectall_type OWNER TO test;

--
-- Name: mp_mp_galleryimages_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_mp_galleryimages_selectone_type AS (
	itemid integer,
	moduleid integer,
	displayorder integer,
	caption character varying(255),
	description text,
	metadataxml text,
	imagefile character varying(100),
	webimagefile character varying(100),
	thumbnailfile character varying(100),
	uploaddate timestamp without time zone,
	uploaduser character varying(100)
);


ALTER TYPE public.mp_mp_galleryimages_selectone_type OWNER TO test;

--
-- Name: mp_pagemodules; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_pagemodules (
    pageid integer NOT NULL,
    moduleid integer NOT NULL,
    panename character varying(50),
    moduleorder integer NOT NULL,
    publishbegindate timestamp without time zone NOT NULL,
    publishenddate timestamp without time zone,
    moduleguid character varying(36),
    pageguid character varying(36)
);


ALTER TABLE public.mp_pagemodules OWNER TO test;

--
-- Name: mp_pages; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_pages (
    pageid integer DEFAULT nextval(('"mp_pages_pageid_seq"'::text)::regclass) NOT NULL,
    parentid integer DEFAULT (-1),
    pageorder integer NOT NULL,
    siteid integer NOT NULL,
    pagename character varying(50) NOT NULL,
    pagetitle character varying(255),
    authorizedroles text,
    editroles text,
    createchildpageroles text,
    requiressl boolean DEFAULT false NOT NULL,
    allowbrowsercache boolean DEFAULT true NOT NULL,
    showbreadcrumbs boolean DEFAULT false NOT NULL,
    pagekeywords character varying(255),
    pagedescription character varying(255),
    pageencoding character varying(255),
    additionalmetatags character varying(255),
    menuimage character varying(50),
    useurl boolean DEFAULT false NOT NULL,
    url character varying(255),
    openinnewwindow boolean DEFAULT false NOT NULL,
    showchildbreadcrumbs boolean DEFAULT false NOT NULL,
    showchildpagemenu boolean DEFAULT false NOT NULL,
    hidemainmenu boolean DEFAULT false NOT NULL,
    skin character varying(100),
    includeinmenu boolean DEFAULT true NOT NULL,
    changefrequency character varying(20),
    sitemappriority character varying(10),
    lastmodifiedutc timestamp without time zone,
    pageguid character(36),
    parentguid character(36),
    hideafterlogin boolean DEFAULT false NOT NULL,
    siteguid character varying(36),
    compiledmeta text,
    compiledmetautc timestamp without time zone
);


ALTER TABLE public.mp_pages OWNER TO test;

--
-- Name: mp_pages_getauthroles_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_pages_getauthroles_type AS (
	accessroles character varying(255),
	editroles character varying(255)
);


ALTER TYPE public.mp_pages_getauthroles_type OWNER TO test;

--
-- Name: mp_pages_getbreadcrumbs_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_pages_getbreadcrumbs_type AS (
	pageid integer,
	pagename character varying(50),
	parent1id integer,
	parent1name character varying(50),
	parent2id integer,
	parent2name character varying(50),
	parent3id integer,
	parent3name character varying(50),
	parent4id integer,
	parent4name character varying(50),
	parent5id integer,
	parent5name character varying(50),
	parent6id integer,
	parent6name character varying(50),
	parent7id integer,
	parent7name character varying(50),
	parent8id integer,
	parent8name character varying(50),
	parent9id integer,
	parent9name character varying(50),
	parent10id integer,
	parent10name character varying(50),
	parent11id integer,
	parent11name character varying(50),
	parent12id integer,
	parent12name character varying(50)
);


ALTER TYPE public.mp_pages_getbreadcrumbs_type OWNER TO test;

--
-- Name: mp_pages_selecttree_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_pages_selecttree_type AS (
	pageid integer,
	parentid integer,
	pagename character varying(100),
	pagetitle character varying(255),
	pageorder integer,
	nestlevel integer,
	authorizedroles text,
	editroles text,
	createchildpageroles text
);


ALTER TYPE public.mp_pages_selecttree_type OWNER TO test;

--
-- Name: mp_pages_selecttreeformodule_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_pages_selecttreeformodule_type AS (
	pageid integer,
	parentid integer,
	pagename character varying(100),
	pageorder integer,
	nestlevel integer,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	ispublished integer,
	panename character varying(50),
	moduleorder integer,
	publishbegindate timestamp without time zone,
	publishenddate timestamp without time zone
);


ALTER TYPE public.mp_pages_selecttreeformodule_type OWNER TO test;

--
-- Name: mp_pages_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_pages_type AS (
	pageid integer,
	parentid integer,
	pageorder integer,
	siteid integer,
	pagename character varying(50),
	pagetitle character varying(255),
	requiressl boolean,
	allowbrowsercache boolean,
	showbreadcrumbs boolean,
	pagekeywords character varying(255),
	pagedescription character varying(255),
	pageencoding character varying(255),
	additionalmetatags character varying(255),
	menuimage character varying(50),
	useurl boolean,
	url character varying(255),
	openinnewwindow boolean,
	showchildpagemenu boolean,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	showchildbreadcrumbs boolean,
	hidemainmenu boolean,
	skin character varying(100),
	includeinmenu boolean,
	changefrequency character varying(20),
	sitemappriority character varying(10),
	lastmodifiedutc timestamp without time zone,
	pageguid character(36),
	parentguid character(36),
	hideafterlogin boolean
);


ALTER TYPE public.mp_pages_type OWNER TO test;

--
-- Name: mp_paypallog; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_paypallog (
    rowguid character(36) NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    siteguid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    storeguid character(36) NOT NULL,
    cartguid character(36) NOT NULL,
    requesttype character varying(255) NOT NULL,
    apiversion character varying(50),
    rawresponse text,
    token character varying(50),
    payerid character varying(50),
    transactionid character varying(50),
    paymenttype character varying(10),
    paymentstatus character varying(50),
    pendingreason character varying(255),
    reasoncode character varying(50),
    currencycode character varying(50),
    exchangerate numeric(15,4) NOT NULL,
    carttotal numeric(15,4) NOT NULL,
    paypalamt numeric(15,4) NOT NULL,
    taxamt numeric(15,4) NOT NULL,
    feeamt numeric(15,4) NOT NULL,
    settleamt numeric(15,4) NOT NULL,
    providername character varying(255),
    returnurl character varying(255),
    serializedobject text,
    pdtprovidername character varying(255),
    ipnprovidername character varying(255),
    response character varying(255)
);


ALTER TABLE public.mp_paypallog OWNER TO test;

--
-- Name: mp_redirectlist; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_redirectlist (
    rowguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    siteid integer NOT NULL,
    oldurl character varying(255) NOT NULL,
    newurl character varying(255) NOT NULL,
    createdutc timestamp without time zone NOT NULL,
    expireutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_redirectlist OWNER TO test;

--
-- Name: mp_roles; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_roles (
    roleid integer DEFAULT nextval(('"mp_roles_roleid_seq"'::text)::regclass) NOT NULL,
    siteid integer NOT NULL,
    rolename character varying(50) NOT NULL,
    displayname character varying(50) NOT NULL,
    siteguid character varying(36),
    roleguid character varying(36)
);


ALTER TABLE public.mp_roles OWNER TO test;

--
-- Name: mp_roles_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_roles_select_type AS (
	siteid integer,
	roleid integer,
	rolename character varying(50),
	displayname character varying(50)
);


ALTER TYPE public.mp_roles_select_type OWNER TO test;

--
-- Name: mp_rssfeedentries; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_rssfeedentries (
    rowguid character(36) NOT NULL,
    moduleguid character(36) NOT NULL,
    feedguid character(36) NOT NULL,
    feedid integer NOT NULL,
    pubdate timestamp without time zone NOT NULL,
    title character varying(255) NOT NULL,
    author character varying(100),
    blogurl character varying(255) NOT NULL,
    description text NOT NULL,
    link character varying(255) NOT NULL,
    confirmed boolean NOT NULL,
    entryhash integer NOT NULL,
    cachedtimeutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_rssfeedentries OWNER TO test;

--
-- Name: mp_rssfeeds; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_rssfeeds (
    itemid integer DEFAULT nextval(('"mp_rssfeeds_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    createddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    userid integer DEFAULT 0 NOT NULL,
    author character varying(100),
    url character varying(255),
    rssurl character varying(255),
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36),
    lastmoduserguid character varying(36),
    lastmodutc timestamp without time zone,
    imageurl character varying(255),
    feedtype character varying(20),
    publishbydefault boolean
);


ALTER TABLE public.mp_rssfeeds OWNER TO test;

--
-- Name: mp_rssfeeds_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_rssfeeds_select_one_type AS (
	itemid integer,
	moduleid integer,
	createddate timestamp without time zone,
	userid integer,
	author character varying(100),
	url character varying(255),
	rssurl character varying(255)
);


ALTER TYPE public.mp_rssfeeds_select_one_type OWNER TO test;

--
-- Name: mp_rssfeeds_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_rssfeeds_select_type AS (
	itemid integer,
	moduleid integer,
	createddate timestamp without time zone,
	userid integer,
	author character varying(100),
	url character varying(255),
	rssurl character varying(255)
);


ALTER TYPE public.mp_rssfeeds_select_type OWNER TO test;

--
-- Name: mp_schemascripthistory; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_schemascripthistory (
    id integer DEFAULT nextval(('"mp_schemascripthistoryid_seq"'::text)::regclass) NOT NULL,
    applicationid character varying(36) NOT NULL,
    scriptfile character varying(255) NOT NULL,
    runtime timestamp without time zone NOT NULL,
    erroroccurred boolean NOT NULL,
    errormessage text,
    scriptbody text
);


ALTER TABLE public.mp_schemascripthistory OWNER TO test;

--
-- Name: mp_schemascripthistory_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_schemascripthistory_select_one_type AS (
	id integer,
	applicationid character varying(36),
	scriptfile character varying(255),
	runtime timestamp without time zone,
	erroroccurred boolean,
	errormessage text,
	scriptbody text
);


ALTER TYPE public.mp_schemascripthistory_select_one_type OWNER TO test;

--
-- Name: mp_schemaversion; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_schemaversion (
    applicationid character varying(36) NOT NULL,
    applicationname character varying(255) NOT NULL,
    major integer DEFAULT 0 NOT NULL,
    minor integer DEFAULT 0 NOT NULL,
    build integer DEFAULT 0 NOT NULL,
    revision integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.mp_schemaversion OWNER TO test;

--
-- Name: mp_schemaversion_select_all_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_schemaversion_select_all_type AS (
	applicationid character varying(36),
	applicationname character varying(255),
	major integer,
	minor integer,
	build integer,
	revision integer
);


ALTER TYPE public.mp_schemaversion_select_all_type OWNER TO test;

--
-- Name: mp_schemaversion_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_schemaversion_select_one_type AS (
	applicationid character varying(36),
	applicationname character varying(255),
	major integer,
	minor integer,
	build integer,
	revision integer
);


ALTER TYPE public.mp_schemaversion_select_one_type OWNER TO test;

--
-- Name: mp_sharedfilefolders; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sharedfilefolders (
    folderid integer DEFAULT nextval(('"mp_sharedfilefolders_folderid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    foldername character varying(255) NOT NULL,
    parentid integer DEFAULT 0 NOT NULL,
    folderguid character varying(36),
    moduleguid character varying(36),
    parentguid character varying(36)
);


ALTER TABLE public.mp_sharedfilefolders OWNER TO test;

--
-- Name: mp_sharedfiles; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sharedfiles (
    itemid integer DEFAULT nextval(('"mp_sharedfiles_itemid_seq"'::text)::regclass) NOT NULL,
    moduleid integer NOT NULL,
    uploaduserid integer NOT NULL,
    friendlyname character varying(255) NOT NULL,
    originalfilename character varying(255) NOT NULL,
    serverfilename character varying(255) NOT NULL,
    sizeinkb integer DEFAULT 0 NOT NULL,
    uploaddate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    folderid integer DEFAULT 0 NOT NULL,
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36),
    folderguid character varying(36),
    fileblob bytea
);


ALTER TABLE public.mp_sharedfiles OWNER TO test;

--
-- Name: mp_sharedfiles_selectbymodule_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sharedfiles_selectbymodule_type AS (
	itemid integer,
	moduleid integer,
	uploaduserid integer,
	friendlyname character varying(255),
	originalfilename character varying(255),
	serverfilename character varying(255),
	sizeinkb integer,
	uploaddate timestamp without time zone,
	folderid integer,
	folderguid character(36),
	username character varying(100)
);


ALTER TYPE public.mp_sharedfiles_selectbymodule_type OWNER TO test;

--
-- Name: mp_sharedfiles_selectbypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sharedfiles_selectbypage_type AS (
	itemid integer,
	moduleid integer,
	friendlyname character varying(255),
	moduletitle character varying(255),
	featurename character varying(255)
);


ALTER TYPE public.mp_sharedfiles_selectbypage_type OWNER TO test;

--
-- Name: mp_sharedfiles_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sharedfiles_selectone_type AS (
	itemid integer,
	moduleid integer,
	uploaduserid integer,
	friendlyname character varying(255),
	originalfilename character varying(255),
	serverfilename character varying(255),
	sizeinkb integer,
	uploaddate timestamp without time zone,
	folderid integer,
	itemguid character(36),
	moduleguid character(36),
	userguid character(36),
	folderguid character(36)
);


ALTER TYPE public.mp_sharedfiles_selectone_type OWNER TO test;

--
-- Name: mp_sharedfileshistory; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sharedfileshistory (
    id integer DEFAULT nextval(('"mp_sharedfileshistory_id_seq"'::text)::regclass) NOT NULL,
    itemid integer NOT NULL,
    moduleid integer NOT NULL,
    friendlyname character varying(255) NOT NULL,
    originalfilename character varying(255),
    serverfilename character varying(50) NOT NULL,
    sizeinkb integer DEFAULT 0 NOT NULL,
    uploaddate timestamp without time zone NOT NULL,
    archivedate timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    uploaduserid integer DEFAULT 0 NOT NULL,
    itemguid character varying(36),
    moduleguid character varying(36),
    userguid character varying(36)
);


ALTER TABLE public.mp_sharedfileshistory OWNER TO test;

--
-- Name: mp_sharedfileshistory_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sharedfileshistory_select_type AS (
	id integer,
	itemid integer,
	moduleid integer,
	friendlyname character varying(255),
	originalfilename character varying(255),
	serverfilename character varying(50),
	sizeinkb integer,
	uploaddate timestamp without time zone,
	uploaduserid integer,
	archivedate timestamp without time zone,
	name character varying(50),
	itemguid character(36),
	moduleguid character(36),
	userguid character(36)
);


ALTER TYPE public.mp_sharedfileshistory_select_type OWNER TO test;

--
-- Name: mp_sharedfileshistory_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sharedfileshistory_selectone_type AS (
	id integer,
	itemid integer,
	moduleid integer,
	friendlyname character varying(255),
	originalfilename character varying(255),
	serverfilename character varying(50),
	sizeinkb integer,
	uploaddate timestamp without time zone,
	archivedate timestamp without time zone,
	uploaduserid integer,
	itemguid character(36),
	moduleguid character(36),
	userguid character(36)
);


ALTER TYPE public.mp_sharedfileshistory_selectone_type OWNER TO test;

--
-- Name: mp_sitefolders; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitefolders (
    guid character varying(36) NOT NULL,
    siteguid character varying(36) NOT NULL,
    foldername character varying(255) NOT NULL
);


ALTER TABLE public.mp_sitefolders OWNER TO test;

--
-- Name: mp_sitefolders_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitefolders_select_one_type AS (
	guid character varying(36),
	siteguid character varying(36),
	foldername character varying(255)
);


ALTER TYPE public.mp_sitefolders_select_one_type OWNER TO test;

--
-- Name: mp_sitehosts; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitehosts (
    hostid integer DEFAULT nextval(('"mp_sitehosts_hostid_seq"'::text)::regclass) NOT NULL,
    siteid integer NOT NULL,
    hostname character varying(255) NOT NULL,
    siteguid character varying(36)
);


ALTER TABLE public.mp_sitehosts OWNER TO test;

--
-- Name: mp_sitehosts_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitehosts_select_type AS (
	hostid integer,
	siteid integer,
	hostname character varying(255)
);


ALTER TYPE public.mp_sitehosts_select_type OWNER TO test;

--
-- Name: mp_sitehosts_selectone_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitehosts_selectone_type AS (
	hostid integer,
	siteid integer,
	hostname character varying(255)
);


ALTER TYPE public.mp_sitehosts_selectone_type OWNER TO test;

--
-- Name: mp_sitemoduledefinitions; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitemoduledefinitions (
    siteid integer NOT NULL,
    moduledefid integer NOT NULL,
    authorizedroles text,
    siteguid character varying(36),
    featureguid character varying(36)
);


ALTER TABLE public.mp_sitemoduledefinitions OWNER TO test;

--
-- Name: mp_sitepaths; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitepaths (
    pathid character varying(36) NOT NULL,
    siteid integer NOT NULL,
    path character varying(255) NOT NULL,
    loweredpath character varying(255) NOT NULL,
    siteguid character varying(36)
);


ALTER TABLE public.mp_sitepaths OWNER TO test;

--
-- Name: mp_sitepaths_getpathidtype; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitepaths_getpathidtype AS (
	pathid character varying(36)
);


ALTER TYPE public.mp_sitepaths_getpathidtype OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitepersonalizationallusers (
    pathid character varying(36) NOT NULL,
    pagesettings bytea NOT NULL,
    lastupdate timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_sitepersonalizationallusers OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_getpersonalizationblobtype; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitepersonalizationallusers_getpersonalizationblobtype AS (
	pagesettings bytea
);


ALTER TYPE public.mp_sitepersonalizationallusers_getpersonalizationblobtype OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitepersonalizationperuser (
    id character varying(36) NOT NULL,
    pathid character varying(36) NOT NULL,
    userid character varying(36) NOT NULL,
    pagesettings bytea NOT NULL,
    lastupdate timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_sitepersonalizationperuser OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_getpersonalizationblobtype; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitepersonalizationperuser_getpersonalizationblobtype AS (
	pagesettings bytea
);


ALTER TYPE public.mp_sitepersonalizationperuser_getpersonalizationblobtype OWNER TO test;

--
-- Name: mp_sites; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sites (
    siteid integer DEFAULT nextval(('"mp_sites_siteid_seq"'::text)::regclass) NOT NULL,
    sitealias character varying(50),
    sitename character varying(255) NOT NULL,
    skin character varying(100),
    editorskin character varying(50) DEFAULT 'normal'::character varying NOT NULL,
    logo character varying(50),
    icon character varying(50),
    defaultfriendlyurlpatternenum character varying(50) DEFAULT 'PageNameWithDotASPX'::character varying NOT NULL,
    allowuserskins boolean DEFAULT false NOT NULL,
    allowpageskins boolean DEFAULT true NOT NULL,
    allowhidemenuonpages boolean DEFAULT true NOT NULL,
    allownewregistration boolean DEFAULT true NOT NULL,
    usesecureregistration boolean DEFAULT false NOT NULL,
    reallydeleteusers boolean DEFAULT true NOT NULL,
    allowuserfullnamechange boolean DEFAULT false NOT NULL,
    useemailforlogin boolean DEFAULT true NOT NULL,
    encryptpasswords boolean DEFAULT false NOT NULL,
    usesslonallpages boolean DEFAULT false NOT NULL,
    defaultpagekeywords character varying(255),
    defaultpagedescription character varying(255),
    defaultpageencoding character varying(255),
    defaultadditionalmetatags character varying(255),
    isserveradminsite boolean DEFAULT false NOT NULL,
    useldapauth boolean DEFAULT false NOT NULL,
    autocreateldapuseronfirstlogin boolean DEFAULT true NOT NULL,
    ldapserver character varying(255),
    ldapport integer DEFAULT 389 NOT NULL,
    ldapdomain character varying(255),
    ldaprootdn character varying(255),
    ldapuserdnkey character varying(10) DEFAULT 'uid'::character varying NOT NULL,
    siteguid character varying(36),
    allowpasswordretrieval boolean DEFAULT true NOT NULL,
    allowpasswordreset boolean DEFAULT true NOT NULL,
    requiresquestionandanswer boolean DEFAULT true NOT NULL,
    requiresuniqueemail boolean DEFAULT true NOT NULL,
    maxinvalidpasswordattempts integer DEFAULT 5 NOT NULL,
    passwordattemptwindowminutes integer DEFAULT 5 NOT NULL,
    passwordformat integer DEFAULT 0 NOT NULL,
    minrequiredpasswordlength integer DEFAULT 4 NOT NULL,
    minreqnonalphachars integer DEFAULT 0 NOT NULL,
    pwdstrengthregex text,
    defaultemailfromaddress character varying(100),
    enablemypagefeature boolean DEFAULT false NOT NULL,
    editorprovider character varying(255),
    captchaprovider character varying(255),
    datepickerprovider character varying(255),
    recaptchaprivatekey character varying(255),
    recaptchapublickey character varying(255),
    wordpressapikey character varying(255),
    windowsliveappid character varying(255),
    windowslivekey character varying(255),
    allowopenidauth boolean DEFAULT false NOT NULL,
    allowwindowsliveauth boolean DEFAULT false NOT NULL,
    gmapapikey character varying(255),
    apikeyextra1 character varying(255),
    apikeyextra2 character varying(255),
    apikeyextra3 character varying(255),
    apikeyextra4 character varying(255),
    apikeyextra5 character varying(255)
);


ALTER TABLE public.mp_sites OWNER TO test;

--
-- Name: mp_sites_selectall_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sites_selectall_type AS (
	siteid integer,
	siteguid character varying(36),
	sitealias character varying(50),
	sitename character varying(255),
	skin character varying(100),
	logo character varying(50),
	icon character varying(50),
	allowuserskins boolean,
	allowpageskins boolean,
	allownewregistration boolean,
	usesecureregistration boolean,
	enablemypagefeature boolean,
	usesslonallpages boolean,
	defaultpagekeywords character varying(255),
	defaultpagedescription character varying(255),
	defaultpageencoding character varying(255),
	defaultadditionalmetatags character varying(255),
	isserveradminsite boolean
);


ALTER TYPE public.mp_sites_selectall_type OWNER TO test;

--
-- Name: mp_sitesettings_getpagelist_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitesettings_getpagelist_type AS (
	pageid integer,
	parentid integer,
	pageorder integer,
	siteid integer,
	pagename character varying(50),
	menuimage character varying(50),
	requiressl boolean,
	showbreadcrumbs boolean,
	pagekeywords character varying(255),
	pagedescription character varying(255),
	pageencoding character varying(255),
	additionalmetatags character varying(255),
	useurl boolean,
	url character varying(255),
	openinnewwindow boolean,
	showchildpagemenu boolean,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	showchildbreadcrumbs boolean,
	hidemainmenu boolean,
	skin character varying(100),
	includeinmenu boolean
);


ALTER TYPE public.mp_sitesettings_getpagelist_type OWNER TO test;

--
-- Name: mp_sitesettings_selectdefaultpage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitesettings_selectdefaultpage_type AS (
	siteid integer,
	sitename character varying(255),
	skin character varying(100),
	editorskin character varying(50),
	logo character varying(50),
	icon character varying(50),
	allownewregistration boolean,
	allowuserskins boolean,
	allowpageskins boolean,
	allowhidemenuonpages boolean,
	defaultfriendlyurlpatternenum character varying(50),
	usesecureregistration boolean,
	enablemypagefeature boolean,
	usesslonallpages boolean,
	metakeywords character varying(255),
	metadescription character varying(255),
	metaencoding character varying(255),
	metaadditional character varying(255),
	pagemetakeywords character varying(255),
	pagemetadescription character varying(255),
	pagemetaencoding character varying(255),
	pagemetaadditional character varying(255),
	isserveradminsite boolean,
	useldapauth boolean,
	autocreateldapuseronfirstlogin boolean,
	ldapserver character varying(255),
	ldapport integer,
	ldapdomain character varying(255),
	ldaprootdn character varying(255),
	ldapuserdnkey character varying(10),
	allowuserfullnamechange boolean,
	useemailforlogin boolean,
	reallydeleteusers boolean,
	pageid integer,
	parentid integer,
	pageorder integer,
	pagename character varying(50),
	menuimage character varying(50),
	requiressl boolean,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	showbreadcrumbs boolean,
	showchildbreadcrumbs boolean,
	showchildpagemenu boolean,
	hidemainmenu boolean,
	pageskin character varying(100)
);


ALTER TYPE public.mp_sitesettings_selectdefaultpage_type OWNER TO test;

--
-- Name: mp_sitesettings_selectdefaultpagebyid_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitesettings_selectdefaultpagebyid_type AS (
	siteid integer,
	sitename character varying(255),
	skin character varying(100),
	editorskin character varying(50),
	logo character varying(50),
	icon character varying(50),
	allownewregistration boolean,
	allowuserskins boolean,
	allowpageskins boolean,
	allowhidemenuonpages boolean,
	defaultfriendlyurlpatternenum character varying(50),
	usesecureregistration boolean,
	enablemypagefeature boolean,
	usesslonallpages boolean,
	metakeywords character varying(255),
	metadescription character varying(255),
	metaencoding character varying(255),
	metaadditional character varying(255),
	pagemetakeywords character varying(255),
	pagemetadescription character varying(255),
	pagemetaencoding character varying(255),
	pagemetaadditional character varying(255),
	isserveradminsite boolean,
	useldapauth boolean,
	autocreateldapuseronfirstlogin boolean,
	ldapserver character varying(255),
	ldapport integer,
	ldapdomain character varying(255),
	ldaprootdn character varying(255),
	ldapuserdnkey character varying(10),
	allowuserfullnamechange boolean,
	useemailforlogin boolean,
	reallydeleteusers boolean,
	pageid integer,
	parentid integer,
	pageorder integer,
	pagename character varying(50),
	menuimage character varying(50),
	requiressl boolean,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	showbreadcrumbs boolean,
	showchildbreadcrumbs boolean,
	showchildpagemenu boolean,
	hidemainmenu boolean,
	pageskin character varying(100)
);


ALTER TYPE public.mp_sitesettings_selectdefaultpagebyid_type OWNER TO test;

--
-- Name: mp_sitesettings_selectpage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_sitesettings_selectpage_type AS (
	siteid integer,
	sitename character varying(255),
	skin character varying(100),
	editorskin character varying(50),
	logo character varying(50),
	icon character varying(50),
	allownewregistration boolean,
	allowuserskins boolean,
	allowpageskins boolean,
	allowhidemenuonpages boolean,
	defaultfriendlyurlpatternenum character varying(50),
	usesecureregistration boolean,
	enablemypagefeature boolean,
	usesslonallpages boolean,
	metakeywords character varying(255),
	metadescription character varying(255),
	metaencoding character varying(255),
	metaadditional character varying(255),
	pagemetakeywords character varying(255),
	pagemetadescription character varying(255),
	pagemetaencoding character varying(255),
	pagemetaadditional character varying(255),
	isserveradminsite boolean,
	useldapauth boolean,
	autocreateldapuseronfirstlogin boolean,
	ldapserver character varying(255),
	ldapport integer,
	ldapdomain character varying(255),
	ldaprootdn character varying(255),
	ldapuserdnkey character varying(10),
	allowuserfullnamechange boolean,
	useemailforlogin boolean,
	reallydeleteusers boolean,
	pageid integer,
	parentid integer,
	pageorder integer,
	pagename character varying(50),
	menuimage character varying(50),
	requiressl boolean,
	authorizedroles text,
	editroles text,
	createchildpageroles text,
	showbreadcrumbs boolean,
	showchildbreadcrumbs boolean,
	showchildpagemenu boolean,
	hidemainmenu boolean,
	pageskin character varying(100)
);


ALTER TYPE public.mp_sitesettings_selectpage_type OWNER TO test;

--
-- Name: mp_sitesettingsex; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitesettingsex (
    siteid integer NOT NULL,
    keyname character varying(128) NOT NULL,
    siteguid character(36) NOT NULL,
    keyvalue text,
    groupname character varying(128)
);


ALTER TABLE public.mp_sitesettingsex OWNER TO test;

--
-- Name: mp_sitesettingsexdef; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_sitesettingsexdef (
    keyname character varying(128) NOT NULL,
    groupname character varying(128),
    defaultvalue text,
    sortorder integer NOT NULL
);


ALTER TABLE public.mp_sitesettingsexdef OWNER TO test;

--
-- Name: mp_taskqueue; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_taskqueue (
    guid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    queuedby character(36) NOT NULL,
    taskname character varying(255) NOT NULL,
    notifyoncompletion boolean NOT NULL,
    notificationtoemail character varying(255),
    notificationfromemail character varying(255),
    notificationsubject character varying(255),
    taskcompletemessage text,
    notificationsentutc timestamp without time zone,
    canstop boolean NOT NULL,
    canresume boolean NOT NULL,
    updatefrequency integer NOT NULL,
    queuedutc timestamp without time zone NOT NULL,
    startutc timestamp without time zone,
    completeutc timestamp without time zone,
    laststatusupdateutc timestamp without time zone,
    completeratio double precision NOT NULL,
    status character varying(255),
    serializedtaskobject text,
    serializedtasktype character varying(255)
);


ALTER TABLE public.mp_taskqueue OWNER TO test;

--
-- Name: mp_taskqueue_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_taskqueue_select_one_type AS (
	guid character(36),
	siteguid character(36),
	queuedby character(36),
	taskname character varying(255),
	notifyoncompletion boolean,
	notificationtoemail character varying(255),
	notificationfromemail character varying(255),
	notificationsubject character varying(255),
	taskcompletemessage text,
	notificationsentutc timestamp without time zone,
	canstop boolean,
	canresume boolean,
	updatefrequency integer,
	queuedutc timestamp without time zone,
	startutc timestamp without time zone,
	completeutc timestamp without time zone,
	laststatusupdateutc timestamp without time zone,
	completeratio double precision,
	status character varying(255),
	serializedtaskobject text,
	serializedtasktype character varying(255)
);


ALTER TYPE public.mp_taskqueue_select_one_type OWNER TO test;

--
-- Name: mp_taxclass; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_taxclass (
    guid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    title character varying(255) NOT NULL,
    description text NOT NULL,
    lastmodified timestamp without time zone,
    created timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_taxclass OWNER TO test;

--
-- Name: mp_taxrate; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_taxrate (
    guid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    geozoneguid character(36) NOT NULL,
    taxclassguid character(36) NOT NULL,
    priority integer NOT NULL,
    rate numeric(18,4) NOT NULL,
    description character varying(255) NOT NULL,
    created timestamp without time zone NOT NULL,
    createdby character(36) NOT NULL,
    lastmodified timestamp without time zone,
    modifiedby character(36)
);


ALTER TABLE public.mp_taxrate OWNER TO test;

--
-- Name: mp_taxratehistory; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_taxratehistory (
    guid character(36) NOT NULL,
    taxrateguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    geozoneguid character(36) NOT NULL,
    taxclassguid character(36) NOT NULL,
    priority integer NOT NULL,
    rate numeric(18,4) NOT NULL,
    description character varying(255),
    created timestamp without time zone NOT NULL,
    createdby character(36) NOT NULL,
    lastmodified timestamp without time zone,
    modifiedby character(36),
    logtime timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_taxratehistory OWNER TO test;

--
-- Name: mp_userlocation; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_userlocation (
    rowid character(36) NOT NULL,
    userguid character(36) NOT NULL,
    siteguid character(36) NOT NULL,
    ipaddress character varying(50) NOT NULL,
    ipaddresslong bigint NOT NULL,
    hostname character varying(255),
    longitude double precision NOT NULL,
    latitude double precision NOT NULL,
    isp character varying(255),
    continent character varying(255),
    country character varying(255),
    region character varying(255),
    city character varying(255),
    timezone character varying(255),
    capturecount integer NOT NULL,
    firstcaptureutc timestamp without time zone NOT NULL,
    lastcaptureutc timestamp without time zone NOT NULL
);


ALTER TABLE public.mp_userlocation OWNER TO test;

--
-- Name: mp_userlocation_select_one_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_userlocation_select_one_type AS (
	rowid character(36),
	userguid character(36),
	siteguid character(36),
	ipaddress character varying(50),
	ipaddresslong bigint,
	hostname character varying(255),
	longitude double precision,
	latitude double precision,
	isp character varying(255),
	continent character varying(255),
	country character varying(255),
	region character varying(255),
	city character varying(255),
	timezone character varying(255),
	capturecount integer,
	firstcaptureutc timestamp without time zone,
	lastcaptureutc timestamp without time zone
);


ALTER TYPE public.mp_userlocation_select_one_type OWNER TO test;

--
-- Name: mp_userpages; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_userpages (
    userpageid character varying(36) NOT NULL,
    siteid integer NOT NULL,
    userguid character varying(36) NOT NULL,
    pagename character varying(255) NOT NULL,
    pagepath character varying(255) NOT NULL,
    pageorder integer NOT NULL,
    siteguid character varying(36)
);


ALTER TABLE public.mp_userpages OWNER TO test;

--
-- Name: mp_userproperties; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_userproperties (
    propertyid character varying(36) NOT NULL,
    userguid character varying(36) NOT NULL,
    propertyname character varying(255),
    propertyvaluestring text,
    propertyvaluebinary bytea,
    lastupdateddate date NOT NULL,
    islazyloaded boolean DEFAULT false NOT NULL
);


ALTER TABLE public.mp_userproperties OWNER TO test;

--
-- Name: mp_userproperties_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_userproperties_select_type AS (
	propertyid character varying(36),
	userguid character varying(36),
	propertyname character varying(255),
	propertyvaluestring text,
	propertyvaluebinary bytea,
	lastupdateddate date,
	islazyloaded boolean
);


ALTER TYPE public.mp_userproperties_select_type OWNER TO test;

--
-- Name: mp_userroles; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_userroles (
    id integer DEFAULT nextval(('"mp_userroles_id_seq"'::text)::regclass) NOT NULL,
    userid integer NOT NULL,
    roleid integer NOT NULL,
    userguid character varying(36),
    roleguid character varying(36)
);


ALTER TABLE public.mp_userroles OWNER TO test;

--
-- Name: mp_userroles_selectbyroleid_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_userroles_selectbyroleid_type AS (
	userid integer,
	name character varying(50),
	email character varying(100)
);


ALTER TYPE public.mp_userroles_selectbyroleid_type OWNER TO test;

--
-- Name: mp_users; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_users (
    userid integer DEFAULT nextval(('"mp_users_userid_seq"'::text)::regclass) NOT NULL,
    siteid integer NOT NULL,
    name character varying(50) NOT NULL,
    email character varying(100) NOT NULL,
    loginname character varying(50),
    password character varying(50) NOT NULL,
    gender character(1),
    profileapproved boolean DEFAULT true NOT NULL,
    approvedforforums boolean DEFAULT true NOT NULL,
    trusted boolean DEFAULT false NOT NULL,
    displayinmemberlist boolean DEFAULT true,
    websiteurl character varying(100),
    country character varying(100),
    state character varying(100),
    occupation character varying(100),
    interests character varying(100),
    msn character varying(50),
    yahoo character varying(50),
    aim character varying(50),
    icq character varying(50),
    totalposts integer DEFAULT 0 NOT NULL,
    avatarurl character varying(255) DEFAULT 'blank.gif'::character varying,
    timeoffsethours integer DEFAULT 0 NOT NULL,
    signature character varying(255),
    datecreated timestamp without time zone DEFAULT ('now'::text)::timestamp(3) with time zone NOT NULL,
    userguid character(36),
    skin character varying(100),
    isdeleted boolean DEFAULT false NOT NULL,
    loweredemail character varying(100),
    passwordquestion character varying(255),
    passwordanswer character varying(255),
    lastactivitydate timestamp without time zone,
    lastlogindate timestamp without time zone,
    lastpasswordchangeddate timestamp without time zone,
    lastlockoutdate timestamp without time zone,
    failedpwdattemptwindowstart timestamp without time zone,
    failedpwdanswerwindowstart timestamp without time zone,
    islockedout boolean DEFAULT false NOT NULL,
    failedpasswordattemptcount integer DEFAULT 0 NOT NULL,
    failedpwdanswerattemptcount integer DEFAULT 0 NOT NULL,
    mobilepin character varying(16),
    passwordsalt character varying(128),
    comment text,
    registerconfirmguid character varying(36) DEFAULT '00000000-0000-0000-0000-000000000000'::character varying,
    openiduri character varying(255),
    windowsliveid character varying(36),
    siteguid character varying(36)
);


ALTER TABLE public.mp_users OWNER TO test;

--
-- Name: mp_users_getuserroles_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_getuserroles_type AS (
	rolename character varying(50),
	roleid integer
);


ALTER TYPE public.mp_users_getuserroles_type OWNER TO test;

--
-- Name: mp_users_login_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_login_type AS (
	username character varying(50)
);


ALTER TYPE public.mp_users_login_type OWNER TO test;

--
-- Name: mp_users_loginbyemail_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_loginbyemail_type AS (
	username character varying(50)
);


ALTER TYPE public.mp_users_loginbyemail_type OWNER TO test;

--
-- Name: mp_users_select_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_select_type AS (
	userid integer,
	email character varying(100),
	name character varying(50),
	password character varying(128)
);


ALTER TYPE public.mp_users_select_type OWNER TO test;

--
-- Name: mp_users_selectpage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_selectpage_type AS (
	userid integer,
	siteid integer,
	name character varying(100),
	loginname character varying(50),
	email character varying(100),
	loweredemail character varying(100),
	password character varying(128),
	passwordquestion character varying(255),
	passwordanswer character varying(255),
	gender character(10),
	profileapproved boolean,
	registerconfirmguid character varying(36),
	approvedforforums boolean,
	trusted boolean,
	displayinmemberlist boolean,
	websiteurl character varying(100),
	country character varying(100),
	state character varying(100),
	occupation character varying(100),
	interests character varying(100),
	msn character varying(50),
	yahoo character varying(50),
	aim character varying(50),
	icq character varying(50),
	totalposts integer,
	avatarurl character varying(255),
	timeoffsethours integer,
	signature character varying(255),
	datecreated timestamp without time zone,
	userguid character varying(36),
	skin character varying(100),
	isdeleted boolean,
	lastactivitydate timestamp without time zone,
	lastlogindate timestamp without time zone,
	lastpasswordchangeddate timestamp without time zone,
	lastlockoutdate timestamp without time zone,
	failedpasswordattemptcount integer,
	failedpwdattemptwindowstart timestamp without time zone,
	failedpwdanswerattemptcount integer,
	failedpwdanswerwindowstart timestamp without time zone,
	islockedout boolean,
	mobilepin character varying(16),
	passwordsalt character varying(128),
	comment text,
	totalpages integer
);


ALTER TYPE public.mp_users_selectpage_type OWNER TO test;

--
-- Name: mp_users_smartdropdown_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_users_smartdropdown_type AS (
	userid integer,
	siteuser character varying(100)
);


ALTER TYPE public.mp_users_smartdropdown_type OWNER TO test;

--
-- Name: mp_webparts; Type: TABLE; Schema: public; Owner: test; Tablespace: 
--

CREATE TABLE mp_webparts (
    webpartid character varying(36) NOT NULL,
    siteid integer NOT NULL,
    title character varying(255) NOT NULL,
    description character varying(255) NOT NULL,
    imageurl character varying(255),
    classname character varying(255) NOT NULL,
    assemblyname character varying(255) NOT NULL,
    availableformypage boolean DEFAULT false NOT NULL,
    allowmultipleinstancesonmypage boolean DEFAULT true NOT NULL,
    availableforcontentsystem boolean DEFAULT false NOT NULL,
    countofuseonmypage integer DEFAULT 0 NOT NULL,
    siteguid character varying(36)
);


ALTER TABLE public.mp_webparts OWNER TO test;

--
-- Name: mp_webparts_select_bysite_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_webparts_select_bysite_type AS (
	webpartid character varying(36),
	siteid integer,
	title character varying(255),
	description character varying(255),
	imageurl character varying(255),
	classname character varying(255),
	assemblyname character varying(255),
	availableformypage boolean,
	allowmultipleinstancesonmypage boolean,
	availableforcontentsystem boolean,
	countofuseonmypage integer
);


ALTER TYPE public.mp_webparts_select_bysite_type OWNER TO test;

--
-- Name: mp_webparts_select_formypage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_webparts_select_formypage_type AS (
	moduleid integer,
	siteid integer,
	moduledefid integer,
	moduletitle character varying(255),
	allowmultipleinstancesonmypage boolean,
	countofuseonmypage integer,
	moduleicon character varying(255),
	featureicon character varying(255),
	featurename character varying(255),
	isassembly boolean,
	webpartid character varying(36)
);


ALTER TYPE public.mp_webparts_select_formypage_type OWNER TO test;

--
-- Name: mp_webparts_selectpage_type; Type: TYPE; Schema: public; Owner: test
--

CREATE TYPE mp_webparts_selectpage_type AS (
	webpartid character varying(36),
	siteid integer,
	title character varying(255),
	description character varying(255),
	imageurl character varying(255),
	classname character varying(255),
	assemblyname character varying(255),
	availableformypage boolean,
	allowmultipleinstancesonmypage boolean,
	availableforcontentsystem boolean,
	countofuseonmypage integer
);


ALTER TYPE public.mp_webparts_selectpage_type OWNER TO test;

--
-- Name: monthname(timestamp with time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION monthname(timestamp with time zone) RETURNS character varying
    AS $_$
declare
	_date alias for $1;
	_month int;
	_monthname varchar(10);
begin
    _month := date_part('month', _date);
    _monthname := 'January';
    if _month = 2 then
        _monthname := 'February';
    end if;
    if _month = 3 then
        _monthname := 'March';
    end if;
    if _month = 4 then
        _monthname := 'April';
    end if;
    if _month = 5 then
        _monthname := 'May';
    end if;
    if _month = 6 then
        _monthname := 'June';
    end if;
    if _month = 7 then
        _monthname := 'July';
    end if;
    if _month = 8 then
        _monthname := 'August';
    end if;
    if _month = 9 then
        _monthname := 'September';
    end if;
    if _month = 10 then
        _monthname := 'October';
    end if;
    if _month = 11 then
        _monthname := 'November';
    end if;
    if _month = 12 then
        _monthname := 'December';
    end if;
    return _monthname;    
end;$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.monthname(timestamp with time zone) OWNER TO test;

--
-- Name: mp_bannedipaddresses_count(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_count() RETURNS integer
    AS $$
select  	cast(count(*) as int4)
from		mp_bannedipaddresses
; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_count() OWNER TO test;

--
-- Name: mp_bannedipaddresses_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_delete(integer) RETURNS integer
    AS $_$
declare
            _rowid alias for $1;
			_rowcount int4;
begin
	delete from mp_bannedipaddresses
	where rowid = _rowid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_delete(integer) OWNER TO test;

--
-- Name: mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) RETURNS integer
    AS $_$

insert into 	mp_bannedipaddresses
(				
                bannedip,
                bannedutc,
                bannedreason
) 
values 
(				
                $1, --:bannedip
                $2, --:bannedutc
                $3 --:bannedreason
);
select cast(currval('mp_bannedipaddressesid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) OWNER TO test;

--
-- Name: mp_bannedipaddresses_select_all(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_select_all() RETURNS SETOF mp_bannedipaddresses_select_all_type
    AS $$

select
        rowid,
        bannedip,
        bannedutc,
        bannedreason
from
        mp_bannedipaddresses
;$$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_select_all() OWNER TO test;

--
-- Name: mp_bannedipaddresses_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_select_one(integer) RETURNS SETOF mp_bannedipaddresses_select_one_type
    AS $_$

select
        rowid,
        bannedip,
        bannedutc,
        bannedreason
from
        mp_bannedipaddresses
        
where
        rowid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_select_one(integer) OWNER TO test;

--
-- Name: mp_bannedipaddresses_selectpage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_selectpage(integer, integer) RETURNS SETOF mp_bannedipaddresses_select_all_type
    AS $_$
declare
	_pagenumber alias for $1;
	_pagesize alias for $2;
	_pagelowerbound int;
	_rec mp_bannedipaddresses_select_all_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        rowid,
        bannedip,
        bannedutc,
        bannedreason

	from mp_bannedipaddresses
	order by bannedip
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_selectpage(integer, integer) OWNER TO test;

--
-- Name: mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) RETURNS integer
    AS $_$

declare
            _rowid alias for $1;
            _bannedip alias for $2;
            _bannedutc alias for $3;
            _bannedreason alias for $4;
			_rowcount int4;
begin
update 		mp_bannedipaddresses

set
            bannedip = _bannedip, 
            bannedutc = _bannedutc, 
            bannedreason = _bannedreason 
            
where
            rowid = _rowid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) OWNER TO test;

--
-- Name: mp_blog_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	 _moduleid int;
	_rowcount int;
begin

select into _moduleid moduleid 
from mp_blogs where itemid = _itemid;

delete from 
    mp_blogs
where
    itemid = _itemid;
    
GET DIAGNOSTICS _rowcount = ROW_COUNT;

update mp_blogstats
set 	entrycount = entrycount - 1
where moduleid = _moduleid;   

return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_delete(integer) OWNER TO test;

--
-- Name: mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_username alias for $2;
	_title alias for $3;
	_excerpt alias for $4;
	_description alias for $5;
	_startdate alias for $6;
	_isinnewsletter alias for $7;
	_includeinfeed alias for $8;
	_category alias for $9;
	_allowcommentsfordays alias for $10;
	_location alias for $11;
	_userguid alias for $12;
	_createddate alias for $13;
	_blogguid alias for $14;
	_moduleguid alias for $15;
	_itemid int4;
	t_found int;
	
begin

insert into mp_blogs
(
	moduleid,
	createdbyuser,
	createddate,
	title,
	excerpt,
	description,
	startdate,
	isinnewsletter,
	includeinfeed,
	category,
	allowcommentsfordays,
	location,
	userguid,
	lastmoduserguid,
	lastmodutc,
	blogguid,
	moduleguid
)
values
(
    _moduleid,
    _username,
    _createddate,
    _title,
    _excerpt,
    _description,
    _startdate,
    _isinnewsletter,
    _includeinfeed,
    _category,
    _allowcommentsfordays,
    _location,
    _userguid,
    _userguid,
    _createddate,
    _blogguid,
    _moduleguid
);

select into _itemid cast(currval('mp_blogs_itemid_seq') as int4);
select into t_found 1 from mp_blogstats where moduleid = _moduleid limit 1;
if found then
		update mp_blogstats
		set 	entrycount = entrycount + 1
		where moduleid = _moduleid;
else
		insert into mp_blogstats(moduleguid, moduleid, entrycount)
		values (_moduleguid,_moduleid, 1);   
end if;
return _itemid;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) OWNER TO test;

--
-- Name: mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_username alias for $2;
	_title alias for $3;
	_excerpt alias for $4;
	_description alias for $5;
	_startdate alias for $6;
	_isinnewsletter alias for $7;
	_includeinfeed alias for $8;
	_allowcommentsfordays alias for $9;
	_location alias for $10;
	_userguid alias for $11;
	_createddate alias for $12;
	_blogguid alias for $13;
	_moduleguid alias for $14;
	_itemurl alias for $15;
	_itemid int4;
	t_found int;
	
begin

insert into mp_blogs
(
	moduleid,
	createdbyuser,
	createddate,
	title,
	excerpt,
	description,
	startdate,
	isinnewsletter,
	includeinfeed,
	allowcommentsfordays,
	location,
	userguid,
	lastmoduserguid,
	lastmodutc,
	blogguid,
	moduleguid,
	itemurl
)
values
(
    _moduleid,
    _username,
    _createddate,
    _title,
    _excerpt,
    _description,
    _startdate,
    _isinnewsletter,
    _includeinfeed,
    _allowcommentsfordays,
    _location,
    _userguid,
    _userguid,
    _createddate,
    _blogguid,
    _moduleguid,
    _itemurl
);

select into _itemid cast(currval('mp_blogs_itemid_seq') as int4);
select into t_found 1 from mp_blogstats where moduleid = _moduleid limit 1;
if found then
		update mp_blogstats
		set 	entrycount = entrycount + 1
		where moduleid = _moduleid;
else
		insert into mp_blogstats(moduleguid, moduleid, entrycount)
		values (_moduleguid,_moduleid, 1);   
end if;
return _itemid;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) OWNER TO test;

--
-- Name: mp_blog_select(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_select(integer, timestamp without time zone) RETURNS SETOF mp_blog_select_type
    AS $_$
declare
	_moduleid alias for $1;
	_begindate alias for $2;
	 _rowstoget int;
	_rec mp_blog_select_type%ROWTYPE;

begin

_rowstoget := coalesce((select settingvalue::text::int4 from mp_modulesettings 
	where settingname = 'BlogEntriesToShowSetting' 
	and moduleid = _moduleid limit 1),1);
for _rec in
	select		
		itemid,
		moduleid,
		createdbyuser,
		createddate,
		title,
		excerpt,
		startdate,
		isinnewsletter,
		description,
		to_char(commentcount, '99999999999') as commentcount,
		trackbackcount,
		includeinfeed,
		allowcommentsfordays,
		blogguid,
		moduleguid,
		location,
		userguid,
		lastmoduserguid,
        	lastmodutc,
        	itemurl
		
	from        mp_blogs
	where
	    (moduleid = _moduleid) and (_begindate >= startdate)
	   order by
		startdate desc
	limit _rowstoget
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_select(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blog_selectarchivebymonth(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectarchivebymonth(integer, timestamp without time zone) RETURNS SETOF mp_blog_selectarchivebymonth_type
    AS $_$
select 	
		cast(date_part('month', startdate) as int4) as month, 
		monthname(startdate) as monthname,
		cast(date_part('year', startdate) as int4) as year, 
		1 as day, 
		cast(count(*) as int4) as count 
from 		mp_blogs
 
where 	moduleid = $1 and startdate < $2
group by 	date_part('year', startdate), 
		date_part('month', startdate),
		monthname(startdate)
order by 	year desc, month desc; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectarchivebymonth(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blog_selectbycategory(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectbycategory(integer, integer) RETURNS SETOF mp_blog_selectbycategory_type
    AS $_$
select	
        b.itemid ,
        b.moduleid ,
        b.createdbyuser ,
        b.createddate ,
        b.title , 
        b.excerpt , 
        b.description , 
        b.startdate , 
        b.isinnewsletter ,
        b.includeinfeed ,
        b.commentcount,
        b.itemurl

from	mp_blogs b

inner join    mp_blogitemcategories bic
on            b.itemid = bic.itemid

where     b.moduleid = $1 and bic.categoryid = $2

order by b.startdate desc ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectbycategory(integer, integer) OWNER TO test;

--
-- Name: mp_blog_selectbyenddate(integer, date); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectbyenddate(integer, date) RETURNS SETOF mp_blog_select_type
    AS $_$
declare
	_moduleid alias for $1;
	_enddate alias for $2;
	 _rowstoget int;
	_rec mp_blog_select_type%ROWTYPE;

begin

_rowstoget := coalesce((select settingvalue::text::int4 from mp_modulesettings 
	where settingname = 'BlogEntriesToShowSetting' 
	and moduleid = _moduleid limit 1),1);
for _rec in
	select		
		itemid,
		moduleid,
		createdbyuser,
		createddate,
		title,
		excerpt,
		startdate,
		isinnewsletter,
		description,
		to_char(commentcount, '99999999999') as commentcount,
		trackbackcount,
		includeinfeed,
		allowcommentsfordays,
		blogguid,
		moduleguid,
		location,
		userguid,
		lastmoduserguid,
        	lastmodutc,
        	itemurl
	from        mp_blogs
	where
	    (moduleid = _moduleid) and (startdate <= _enddate)
	   order by
		itemid desc,  startdate desc
	limit _rowstoget
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectbyenddate(integer, date) OWNER TO test;

--
-- Name: mp_blog_selectbymonth(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectbymonth(integer, integer, integer) RETURNS SETOF mp_blogs
    AS $_$
select	*
from 		mp_blogs
where 	moduleid = $3
		and date_part('year', startdate)  = $2 
		and date_part('month', startdate)  = $1
order by	 startdate desc; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectbymonth(integer, integer, integer) OWNER TO test;

--
-- Name: mp_blog_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectbypage(integer, integer) RETURNS SETOF mp_blog_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.commentcount,
		gi.title, 
		gi.itemurl, 
		gi.description, 
		m.moduletitle,
		md.featurename
		
from
		mp_blogs gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		
		; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_blog_selectdrafts(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectdrafts(integer, timestamp without time zone) RETURNS SETOF mp_blog_select_type
    AS $_$
declare
	_moduleid alias for $1;
	_begindate alias for $2;
	_rec mp_blog_select_type%ROWTYPE;

begin


for _rec in
	select		
		itemid,
		moduleid,
		createdbyuser,
		createddate,
		title,
		excerpt,
		startdate,
		isinnewsletter,
		description,
		to_char(commentcount, '99999999999') as commentcount,
		trackbackcount,
		includeinfeed,
		allowcommentsfordays,
		blogguid,
		moduleguid,
		location,
		userguid,
		lastmoduserguid,
        	lastmodutc
		
	from        mp_blogs
	where
	    (moduleid = _moduleid) and (startdate > _begindate)
	   order by
		startdate desc
	
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectdrafts(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blog_selectone2(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_selectone2(integer) RETURNS SETOF mp_blogs
    AS $_$
select		*
			
from	mp_blogs
where   (itemid = $1); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_selectone2(integer) OWNER TO test;

--
-- Name: mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_username alias for $3;
	_title alias for $4;
	_excerpt alias for $5;
	_description alias for $6;
	_startdate alias for $7;
	_isinnewsletter alias for $8;
	_includeinfeed alias for $9;
	_itemurl alias for $10;
	_allowcommentsfordays alias for $11;
	_location alias for $12;
	_lastmoduserguid alias for $13;
	_lastmodutc alias for $14;
	_rowcount int4;
begin

update mp_blogs
set 
moduleid = _moduleid,
createdbyuser = _username,
createddate = current_timestamp(3),
title = _title,
excerpt = _excerpt,
description = _description,
startdate = _startdate,
isinnewsletter = _isinnewsletter,
includeinfeed = _includeinfeed,
itemurl = _itemurl,
allowcommentsfordays = _allowcommentsfordays,
location = _location,
lastmoduserguid = _lastmoduserguid,
lastmodutc = _lastmodutc


where 
itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blogcategories_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_delete(integer) RETURNS integer
    AS $_$
declare
	_categoryid alias for $1;
	_rowcount int4;
begin


	delete from mp_blogcategories
	where categoryid = _categoryid;
	
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_delete(integer) OWNER TO test;

--
-- Name: mp_blogcategories_insert(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_insert(integer, character varying) RETURNS integer
    AS $_$

insert into 	mp_blogcategories
(				
                moduleid,
                category
) 
values 
(				
                $1, --:moduleid
                $2 --:category
);

select cast(currval('mp_blogcategories_categoryid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_insert(integer, character varying) OWNER TO test;

--
-- Name: mp_blogcategories_select_bymodule(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_select_bymodule(integer, timestamp without time zone) RETURNS SETOF mp_blogcategories_select_bymodule_type
    AS $_$

select
        bc.categoryid,
        bc.moduleid,
        bc.category,
        count(bic.itemid) as postcount
from
        mp_blogcategories bc
        
join    mp_blogitemcategories bic
on      bc.categoryid = bic.categoryid

join	mp_blogs b
on	b.itemid = bic.itemid
        

where   bc.moduleid = $1 and b.startdate < $2
	

group by bc.categoryid, bc.moduleid, bc.category

order by bc.category;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_select_bymodule(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blogcategories_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_select_one(integer) RETURNS SETOF mp_blogcategories_select_one_type
    AS $_$

select
        categoryid,
        moduleid,
        category
from
        mp_blogcategories
        
where
        categoryid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_select_one(integer) OWNER TO test;

--
-- Name: mp_blogcategories_selectlist_bymodule(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_selectlist_bymodule(integer) RETURNS SETOF mp_blogcategories_select_bymodule_type
    AS $_$

select
        bc.categoryid,
        bc.moduleid,
        bc.category,
        count(bic.itemid) as postcount
from
        mp_blogcategories bc
        
left outer join    mp_blogitemcategories bic
on      bc.categoryid = bic.categoryid
        

where   bc.moduleid = $1 
	

group by bc.categoryid, bc.moduleid, bc.category

order by bc.category;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_selectlist_bymodule(integer) OWNER TO test;

--
-- Name: mp_blogcategories_update(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcategories_update(integer, character varying) RETURNS integer
    AS $_$
declare
	_categoryid alias for $1;
	_category alias for $2;
	_rowcount int4;
begin

update 		mp_blogcategories

set
            category = _category --:category
            
where
            categoryid = _categoryid; --:categoryid

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcategories_update(integer, character varying) OWNER TO test;

--
-- Name: mp_blogcomment_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcomment_delete(integer) RETURNS integer
    AS $_$
declare
	_blogcommentid alias for $1;
	 _moduleid int;
	 _itemid int;
	_rowcount int;
begin

select into _moduleid, _itemid 
            moduleid, itemid
from	mp_blogcomments
where blogcommentid = _blogcommentid;

delete 
from 	mp_blogcomments
where	blogcommentid = _blogcommentid;

GET DIAGNOSTICS _rowcount = ROW_COUNT;

update mp_blogs
set commentcount = commentcount - 1
where moduleid = _moduleid and itemid = _itemid;

update mp_blogstats
set 	commentcount = commentcount - 1
where moduleid = _moduleid;   

return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcomment_delete(integer) OWNER TO test;

--
-- Name: mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_itemid alias for $2;
	_name alias for $3;
	_title alias for $4;
	_url alias for $5;
	_comment alias for $6;
	_datecreated alias for $7;
	_rowcount int4;
begin

insert into mp_blogcomments
(
    	moduleid,
	itemid,
    	name,
    	title,
	url,
    	comment,
	datecreated
)
values
(
    _moduleid,
    _itemid,
    _name,
    _title,
    _url,
    _comment,
    _datecreated
);

update mp_blogs
set commentcount = commentcount + 1
where moduleid = _moduleid and itemid = _itemid;

update mp_blogstats
set 	commentcount = commentcount + 1
where moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) OWNER TO test;

--
-- Name: mp_blogcomments_select(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogcomments_select(integer, integer) RETURNS SETOF mp_blogcomments_select_type
    AS $_$
select		
	blogcommentid,
	itemid, 
	moduleid, 
	name, 
	title, 
	url, 
	comment, 
	datecreated
from        mp_blogcomments
where
    		moduleid = $1
		and itemid = $2
   order by
   	blogcommentid,  datecreated desc; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogcomments_select(integer, integer) OWNER TO test;

--
-- Name: mp_blogitemcategories_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogitemcategories_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin


	delete from mp_blogitemcategories
	where itemid = _itemid;
	
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogitemcategories_delete(integer) OWNER TO test;

--
-- Name: mp_blogitemcategories_insert(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogitemcategories_insert(integer, integer) RETURNS integer
    AS $_$

insert into 	mp_blogitemcategories
(				
                itemid,
                categoryid
) 
values 
(				
                $1, --:itemid
                $2 --:categoryid
);

select cast(currval('mp_blogitemcategories_id_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogitemcategories_insert(integer, integer) OWNER TO test;

--
-- Name: mp_blogitemcategories_select_byitem(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogitemcategories_select_byitem(integer) RETURNS SETOF mp_blogitemcategories_select_byitem_type
    AS $_$

select
        bc.categoryid,
        bc.category
from
        mp_blogitemcategories bic
inner join mp_blogcategories bc
on         bic.categoryid = bc.categoryid
where   itemid = $1

order by bc.category;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogitemcategories_select_byitem(integer) OWNER TO test;

--
-- Name: mp_blogstats_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_blogstats_select(integer) RETURNS SETOF mp_blogstats_select_type
    AS $_$
select		
			moduleid, 
			entrycount,
			commentcount
from       		 mp_blogstats
where
    			moduleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_blogstats_select(integer) OWNER TO test;

--
-- Name: mp_calendarevents_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

/*
Author:   			Joe Audette
Created: 			4/17/2005
Last Modified: 			4/17/2005
*/	
	
	delete from mp_calendarevents
	where itemid = _itemid;
	
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_delete(integer) OWNER TO test;

--
-- Name: mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) RETURNS integer
    AS $_$
/*
Author:   			Joe Audette
Created: 			4/17/2005
Last Modified: 			2008-01-31

*/

insert into 	mp_calendarevents
(				
                moduleid,
                title,
                description,
                imagename,
                eventdate,
                starttime,
                endtime,
                createddate,
                userid,
                itemguid,
                moduleguid,
                userguid,
                lastmoduserguid,
                location,
                ticketprice,
                requiresticket,
                lastmodutc
) 
values 
(				
                $1, --:moduleid
                $2, --:title
                $3, --:description
                $4, --:imagename
                $5, --:eventdate
                $6, --:starttime
                $7, --:endtime
                $13, --:createddate
                $8, --:userid
                $9,
                $10,
                $11,
                $11,
                $12,
                $14,
                $15,
                $13
);

select cast(currval('mp_calendarevents_itemid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) OWNER TO test;

--
-- Name: mp_calendarevents_select_bydate(integer, date, date); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_select_bydate(integer, date, date) RETURNS SETOF mp_calendarevents_select_one_type
    AS $_$
/*
Author:   			Joe Audette
Created: 			4/17/2005
Last Modified: 			2008-01-31
*/

select
        itemid,
	moduleid,
	title,
	description,
	imagename,
	eventdate,
	starttime,
	endtime,
	createddate,
	userid,
	itemguid,
	moduleguid,
	userguid,
	location,
	lastmoduserguid,
	lastmodutc,
	ticketprice,
        requiresticket
from
        mp_calendarevents
        
where   moduleid = $1
	AND  eventdate >= $2
        AND eventdate <= $3

order by eventdate, starttime;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_select_bydate(integer, date, date) OWNER TO test;

--
-- Name: mp_calendarevents_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_select_one(integer) RETURNS SETOF mp_calendarevents_select_one_type
    AS $_$
/*
Author:   			Joe Audette
Created: 			4/17/2005
Last Modified: 			2008-01-31
*/

select
        itemid,
	moduleid,
	title,
	description,
	imagename,
	eventdate,
	starttime,
	endtime,
	createddate,
	userid,
	itemguid,
	moduleguid,
	userguid,
	location,
	lastmoduserguid,
	lastmodutc,
	ticketprice,
        requiresticket
from
        mp_calendarevents
        
where
        itemid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_select_one(integer) OWNER TO test;

--
-- Name: mp_calendarevents_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_selectbypage(integer, integer) RETURNS SETOF mp_calendarevents_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.title, 
		gi.description, 
		m.moduletitle,
		md.featurename
		
from
		mp_calendarevents gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) RETURNS integer
    AS $_$
/*
Author:   			Joe Audette
Updated By:			Joseph Hill
Created: 			4/17/2005
Last Modified: 			8/27/2005
*/
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_title alias for $3;
	_description alias for $4;
	_imagename alias for $5;
	_eventdate alias for $6;
	_starttime alias for $7;
	_endtime alias for $8;
	_lastmoduserguid alias for $9;
	_location alias for $10;
	_lastmodutc alias for $11;
	_ticketprice alias for $12;
	_requiresticket alias for $13;
	_rowcount int4;
begin

update 		mp_calendarevents

set
            moduleid = _moduleid, --:moduleid
            title = _title, --:title
            description = _description, --:description
            imagename = _imagename, --:imagename
            eventdate = _eventdate, --:eventdate
            starttime = _starttime, --:starttime
            endtime = _endtime, --:endtime
            lastmoduserguid = _lastmoduserguid,
            location = _location,
            lastmodutc = _lastmodutc,
            ticketprice = _ticketprice,
            requiresticket = _requiresticket
            
where
            itemid = _itemid; --:itemid

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) OWNER TO test;

--
-- Name: mp_contactformmessage_count(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_contactformmessage_count(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_contactformmessage
where		moduleguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_contactformmessage_count(character) OWNER TO test;

--
-- Name: mp_contactformmessage_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_contactformmessage_selectpage(character, integer, integer) RETURNS SETOF mp_contactformmessage
    AS $_$
declare
	_moduleguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_contactformmessage%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select  *

	from mp_contactformmessage
	where moduleguid = _moduleguid
	order by createdutc desc
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_contactformmessage_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_forum_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forum_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int;
begin

delete from mp_forumposts
where threadid IN (SELECT threadid FROM mp_forumthreads
					WHERE forumid =  _itemid);
					
delete from mp_forumthreadsubscriptions
where threadid IN (SELECT threadid FROM mp_forumthreads
					WHERE forumid =  _itemid);
					
delete from mp_forumthreads
where forumid = _itemid;

delete from mp_forumsubscriptions
where forumid = _itemid;

delete from mp_forums
where itemid = _itemid;
    
    
GET DIAGNOSTICS _rowcount = ROW_COUNT;

return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forum_delete(integer) OWNER TO test;

--
-- Name: mp_forumposts_countbythread(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_countbythread(integer) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_forumposts
where	threadid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_countbythread(integer) OWNER TO test;

--
-- Name: mp_forumposts_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_delete(integer) RETURNS integer
    AS $_$
declare
	_postid alias for $1;
	_rowcount int4;
begin

	delete from  mp_forumposts
where postid = _postid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_delete(integer) OWNER TO test;

--
-- Name: mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_subject alias for $2;
	_post alias for $3;
	_approved alias for $4;
	_userid alias for $5;
	_postdate alias for $6;
	 _threadsequence int;
	_itemid int;

begin

_threadsequence := (select coalesce(max(threadsequence) + 1,1) from mp_forumposts where threadid = _threadid);
insert into		mp_forumposts
(
			threadid,
			subject,
			post,
			approved,
			userid,
			threadsequence,
			postdate
)
values
(
			_threadid,
			_subject,
			_post,
			_approved,
			_userid,
			_threadsequence,
			_postdate
);

select into _itemid cast(currval('mp_forumposts_postid_seq') as int4); 
return _itemid;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_forumposts_selectallbythread(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectallbythread(integer) RETURNS SETOF mp_forumposts_selectallbythread_type
    AS $_$
select	
		p.postid ,
		p.threadid ,
		p.threadsequence ,
		p.subject ,
		p.postdate ,
		p.approved ,
		p.userid ,
		p.sortorder ,
		p.post ,
		ft.forumid,
		coalesce(u.name,'guest') as mostrecentpostuser,
		coalesce(s.name,'guest') as startedby,
		coalesce(up.name, 'guest') as postauthor,
		coalesce(up.email, '') as authoremail,
		COALESCE(up.totalposts, 0) as postauthortotalposts,
		COALESCE(up.trusted, false) as trusted,
		coalesce(up.avatarurl, 'blank.gif') as postauthoravatar,
		up.websiteurl as postauthorwebsiteurl,
		up.signature as postauthorsignature
from		mp_forumposts p
join		mp_forumthreads ft
on		p.threadid = ft.threadid
left outer join		mp_users u
on		ft.mostrecentpostuserid = u.userid
left outer join		mp_users s
on		ft.startedbyuserid = s.userid
left outer join		mp_users up
on		up.userid = p.userid
where	ft.threadid = $1
		
order by	p.postid ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectallbythread(integer) OWNER TO test;

--
-- Name: mp_forumposts_selectallbythreadreversesorted(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectallbythreadreversesorted(integer) RETURNS SETOF mp_forumposts_selectallbythread_type
    AS $_$
select	
		p.postid ,
		p.threadid ,
		p.threadsequence ,
		p.subject ,
		p.postdate ,
		p.approved ,
		p.userid ,
		p.sortorder ,
		p.post ,
		ft.forumid,
		coalesce(u.name,'guest') as mostrecentpostuser,
		coalesce(s.name,'guest') as startedby,
		coalesce(up.name, 'guest') as postauthor,
		coalesce(up.email, '') as authoremail,
		COALESCE(up.totalposts, 0) as postauthortotalposts,
		COALESCE(up.trusted, false) as trusted,
		coalesce(up.avatarurl, 'blank.gif') as postauthoravatar,
		up.websiteurl as postauthorwebsiteurl,
		up.signature as postauthorsignature
from		mp_forumposts p
join		mp_forumthreads ft
on		p.threadid = ft.threadid
left outer join		mp_users u
on		ft.mostrecentpostuserid = u.userid
left outer join		mp_users s
on		ft.startedbyuserid = s.userid
left outer join		mp_users up
on		up.userid = p.userid
where	ft.threadid = $1
		
order by	p.threadsequence desc ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectallbythreadreversesorted(integer) OWNER TO test;

--
-- Name: mp_forumposts_selectbythread(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectbythread(integer, integer) RETURNS SETOF mp_forumposts_selectbythread_type
    AS $_$
declare
	_threadid alias for $1;
	_pagenumber alias for $2;
	 _postsperpage	int;
	 _totalposts		int;
	 _currentpagemaxthreadsequence	int;
	 _beginsequence int;
	 _endsequence int;
	_rec mp_forumposts_selectbythread_type%ROWTYPE;

begin

select into _postsperpage, _totalposts 
	f.postsperpage, ft.totalreplies
from		mp_forumthreads ft
join		mp_forums f
on		ft.forumid = f.itemid
where	ft.threadid = _threadid;

_currentpagemaxthreadsequence := (_postsperpage * _pagenumber) ;

if _currentpagemaxthreadsequence > _postsperpage then
		_beginsequence := _currentpagemaxthreadsequence - _postsperpage + 1;
else
		_beginsequence := 1;
end if;

_endsequence := _beginsequence + _postsperpage  -1;

for _rec in
	select	
			p.postid ,
			p.threadid ,
			p.threadsequence ,
			p.subject ,
			p.postdate ,
			p.approved ,
			p.userid ,
			p.sortorder ,
			p.post ,
			ft.forumid,
			coalesce(u.name,'guest') as mostrecentpostuser,
			coalesce(s.name,'guest') as startedby,
			coalesce(up.name, 'guest') as postauthor,
			coalesce(up.email, '') as authoremail,
			coalesce(up.trusted, false) as trusted,
			coalesce(up.totalposts, 0) as postauthortotalposts,
			coalesce(up.AvatarUrl, 'blank.gif') as postauthoravatar,
			up.websiteurl as postauthorwebsiteurl,
			up.signature as postauthorsignature
	from		mp_forumposts p
	join		mp_forumthreads ft
	on		p.threadid = ft.threadid
	left outer join		mp_users u
	on		ft.mostrecentpostuserid = u.userid
	left outer join		mp_users s
	on		ft.startedbyuserid = s.userid
	left outer join		mp_users up
	on		up.userid = p.userid
	where	ft.threadid = _threadid
			and p.threadsequence >= _beginsequence
			and  p.threadsequence <= _endsequence
	order by	p.sortorder, p.postid   
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectbythread(integer, integer) OWNER TO test;

--
-- Name: mp_forumposts_selectbythread_v2(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectbythread_v2(integer, integer) RETURNS SETOF mp_forumposts_selectbythread_v2_type
    AS $_$
declare
	_threadid alias for $1;
	_pagenumber alias for $2;
	 _postsperpage	int;
	 _totalposts		int;
	 _currentpagemaxthreadsequence	int;
	 _beginsequence int;
	 _endsequence int;
	 _pagelowerbound int;
	 _pageupperbound int;
	_rec mp_forumposts_selectbythread_v2_type%ROWTYPE;

begin

select into _postsperpage, _totalposts 
		f.postsperpage, ft.totalreplies
from		mp_forumthreads ft
join		mp_forums f
on		ft.forumid = f.itemid
where	ft.threadid = _threadid;

_currentpagemaxthreadsequence := (_postsperpage * _pagenumber) ;

if (_currentpagemaxthreadsequence > _postsperpage) then
		_beginsequence := _currentpagemaxthreadsequence  - _postsperpage + 1;
else
		_beginsequence := 1;
end if;

_endsequence := _beginsequence + _postsperpage  -1;
--
--
-- set the page bounds
--_pagelowerbound := (_postsperpage * _pagenumber) ;
--_pageupperbound := _pagelowerbound + _postsperpage + 1;
-- create a temp table to store the select results

for _rec in
	select	
			p.postid ,
			p.threadid ,
			p.threadsequence ,
			p.subject ,
			p.postdate ,
			p.approved ,
			p.userid ,
			p.sortorder ,
			p.post ,
			ft.forumid,
			u.name as mostrecentpostuser,
			s.name as startedby,
			up.name as postauthor,
			up.totalposts as postauthortotalposts,
			up.avatarurl as postauthoravatar,
			up.websiteurl as postauthorwebsiteurl,
			up.signature as postauthorsignature
	from		mp_forumposts p
	join		mp_forumthreads ft
	on		p.threadid = ft.threadid
	join		mp_users u
	on		ft.mostrecentpostuserid = u.userid
	join		mp_users s
	on		ft.startedbyuserid = s.userid
	join		mp_users up
	on		up.userid = p.userid
	where	ft.threadid = _threadid
			and p.threadsequence >= _beginsequence
			and  p.threadsequence <= _endsequence
	order by	p.sortorder, p.postid
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectbythread_v2(integer, integer) OWNER TO test;

--
-- Name: mp_forumposts_selectforrss(integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectforrss(integer, integer, integer, integer, integer, integer) RETURNS SETOF mp_forumposts_selectforrss_type
    AS $_$
select		fp.postid ,
		fp.threadid,
		fp.threadsequence,
		fp.subject,
		fp.postdate,
		fp.approved,
		fp.userid,
		fp.sortorder,
		fp.post,
		ft.threadsubject,
		ft.forumid,
		coalesce(s.name, 'Guest') as startedby,
		coalesce(up.name, 'Guest') as postauthor,
		coalesce(up.totalposts, 0) as postauthortotalposts,
		up.avatarurl as postauthoravatar,
		up.websiteurl as postauthorwebsiteurl,
		up.signature as postauthorsignature


from		mp_forumposts fp

join		mp_forumthreads ft
on		fp.threadid = ft.threadid

join		mp_forums f
on		ft.forumid = f.itemid

join		mp_modules m
on		f.moduleid = m.moduleid

join		mp_pagemodules pm
on		m.moduleid = pm.moduleid

join		mp_pages p
on		pm.pageid = p.pageid

left outer join		mp_users u
on		ft.mostrecentpostuserid = u.userid

left outer join		mp_users s
on		ft.startedbyuserid = s.userid

left outer join		mp_users up
on		up.userID = fp.userid

where	p.siteid = $1
and	($2 = -1 OR p.pageid = $2)
and	($3 = -1 OR m.moduleid = $3)
and	($4 = -1 OR f.itemid = $4)
and	($5 = -1 OR ft.threadid = $5)
and	($6 = -1 OR (current_timestamp(3) - fp.PostDate) <= (to_char($6, '999999') || 'days')::interval)

order by	fp.PostDate desc;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectforrss(integer, integer, integer, integer, integer, integer) OWNER TO test;

--
-- Name: mp_forumposts_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectone(integer) RETURNS SETOF mp_forumposts
    AS $_$
select	fp.*
from		mp_forumposts fp
where	fp.postid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectone(integer) OWNER TO test;

--
-- Name: mp_forumposts_selectsortedthread(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_selectsortedthread(integer) RETURNS SETOF mp_forumposts
    AS $_$
select	fp.*
from		mp_forumposts fp
where	fp.threadid = $1
order by threadsequence; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_selectsortedthread(integer) OWNER TO test;

--
-- Name: mp_forumposts_update(integer, character varying, text, integer, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_update(integer, character varying, text, integer, boolean) RETURNS integer
    AS $_$
declare
	_postid alias for $1;
	_subject alias for $2;
	_post alias for $3;
	_sortorder alias for $4;
	_approved alias for $5;
	_rowcount int4;
begin

update		mp_forumposts
set			subject = _subject,
			post = _post,
			sortorder = _sortorder,
			approved = _approved
where		postid = _postid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_update(integer, character varying, text, integer, boolean) OWNER TO test;

--
-- Name: mp_forumposts_updatethreadsequence(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumposts_updatethreadsequence(integer, integer) RETURNS integer
    AS $_$
declare
	_postid alias for $1;
	_threadsequence alias for $2;
	_rowcount int4;
begin

update		mp_forumposts
set			threadsequence = _threadsequence
			
where		postid = _postid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumposts_updatethreadsequence(integer, integer) OWNER TO test;

--
-- Name: mp_forums_decrementpostcount(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_decrementpostcount(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
begin

update mp_forums
set postcount = postcount - 1
where itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_decrementpostcount(integer) OWNER TO test;

--
-- Name: mp_forums_decrementthreadcount(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_decrementthreadcount(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
begin

update		mp_forums
set			threadcount = threadcount - 1
where		itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_decrementthreadcount(integer) OWNER TO test;

--
-- Name: mp_forums_incrementpostcount(integer, integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_incrementpostcount(integer, integer, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_mostrecentpostuserid alias for $2;
	_mostrecentpostdate alias for $3;
	_rowcount int4;
begin

update 	mp_forums
set 		mostrecentpostdate = _mostrecentpostdate,
		mostrecentpostuserid = _mostrecentpostuserid,
 		postcount = postcount + 1
where 	itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_incrementpostcount(integer, integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_forums_incrementpostcountonly(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_incrementpostcountonly(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
begin

update 	mp_forums
set 		
 		postcount = postcount + 1
where 	itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_incrementpostcountonly(integer) OWNER TO test;

--
-- Name: mp_forums_incrementthreadcount(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_incrementthreadcount(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
begin

update		mp_forums
set			threadcount = threadcount + 1
where		itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_incrementthreadcount(integer) OWNER TO test;

--
-- Name: mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) RETURNS integer
    AS $_$
insert into			mp_forums
(
				moduleid,
				createdby,
				title,
				description,
				ismoderated,
				isactive,
				sortorder,
				postsperpage,
				threadsperpage,
				allowanonymousposts
)
values
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10
);
select cast(currval('mp_forums_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) OWNER TO test;

--
-- Name: mp_forums_recalculatepoststats(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_recalculatepoststats(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
	_mostrecentpostdate timestamp;
	_mostrecentpostuserid integer;
	_postcount integer;
begin
select into _mostrecentpostdate, _mostrecentpostuserid
        mostrecentpostdate, mostrecentpostuserid
    from mp_forumthreads 
    where forumid = _forumid
    order by mostrecentpostdate desc
    limit 1;
select into _postcount coalesce(sum(totalreplies), 0)+count(*)
    from mp_forumthreads 
    where forumid = _forumid;

update 	mp_forums
set 	mostrecentpostdate = _mostrecentpostdate,
		mostrecentpostuserid = coalesce(_mostrecentpostuserid, -1),
 		postcount = _postcount
where 	itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_recalculatepoststats(integer) OWNER TO test;

--
-- Name: mp_forums_select(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_select(integer, integer) RETURNS SETOF mp_forums_select_type
    AS $_$
select		
	f.itemid ,
	f.moduleid ,
	f.createddate ,
	f.createdby ,
	f.title ,
	f.description ,
	f.ismoderated ,
	f.isactive ,
	f.sortorder ,
	f.threadcount  ,
	f.postcount ,
	f.mostrecentpostdate,
	f.mostrecentpostuserid ,
	f.postsperpage ,
	f.threadsperpage ,
	f.allowanonymousposts ,
	u.name as mostrecentpostuser ,
	s.subscribedate is not null and s.unsubscribedate is null as subscribed
from			mp_forums f
left outer join	mp_users u
on			f.mostrecentpostuserid = u.userid
left outer join mp_forumsubscriptions s
on			f.itemid = s.forumid and s.userid = $2
where		f.moduleid	= $1
			and f.isactive = true
order by		f.sortorder, f.itemid; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_select(integer, integer) OWNER TO test;

--
-- Name: mp_forums_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_selectone(integer) RETURNS SETOF mp_forums_selectone_type
    AS $_$
select		
	f.itemid ,
	f.moduleid ,
	f.createddate ,
	f.createdby ,
	f.title ,
	f.description ,
	f.ismoderated ,
	f.isactive ,
	f.sortorder ,
	f.threadcount  ,
	f.postcount ,
	f.mostrecentpostdate,
	f.mostrecentpostuserid ,
	f.postsperpage ,
	f.threadsperpage ,
	f.allowanonymousposts ,
	u.name as createdbyuser ,
	up.name as mostrecentpostuser
from			mp_forums f
left outer join	mp_users u
on			f.createdby = u.userid
left outer join	mp_users up
on			f.mostrecentpostuserid = up.userid
where		f.itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_selectone(integer) OWNER TO test;

--
-- Name: mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_title alias for $2;
	_description alias for $3;
	_ismoderated alias for $4;
	_isactive alias for $5;
	_sortorder alias for $6;
	_postsperpage alias for $7;
	_threadsperpage alias for $8;
	_allowanonymousposts alias for $9;
	_rowcount int4;
begin

update		mp_forums
set			title = _title,
			description = _description,
			ismoderated = _ismoderated,
			isactive = _isactive,
			sortorder = _sortorder,
			postsperpage = _postsperpage,
			threadsperpage = _threadsperpage,
			allowanonymousposts = _allowanonymousposts
where		itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) OWNER TO test;

--
-- Name: mp_forums_updatepoststats(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_updatepoststats(integer, integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_mostrecentpostuserid alias for $2;
	_rowcount int4;
begin

update	mp_forums
set		mostrecentpostdate = current_timestamp(3),
		mostrecentpostuserid = _mostrecentpostuserid,
		postcount = postcount + 1
where	itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_updatepoststats(integer, integer) OWNER TO test;

--
-- Name: mp_forums_updatethreadstats(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forums_updatethreadstats(integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_rowcount int4;
begin

update		mp_forums
set			threadcount = threadcount + 1
where		itemid = _forumid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forums_updatethreadstats(integer) OWNER TO test;

--
-- Name: mp_forumsubscriptions_exists(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumsubscriptions_exists(integer, integer) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_forumsubscriptions
where	forumid = $1 AND userid = $2 AND unsubscribedate is null; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumsubscriptions_exists(integer, integer) OWNER TO test;

--
-- Name: mp_forumsubscriptions_insert(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumsubscriptions_insert(integer, integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_userid alias for $2;
	t_found int;
	_rowcount int4;

begin

select into t_found 1 
from mp_forumsubscriptions 
where 	forumid = _forumid and userid = _userid limit 1;

if  found then
	update 	mp_forumsubscriptions
	set		subscribedate = current_timestamp(3),
			unsubscribedate = null
	
	where 	forumid = _forumid and userid = _userid;
else
	insert into	mp_forumsubscriptions
	(
			forumid,
			userid
	)
	values
	(
			_forumid,
			_userid
	);   
end if;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumsubscriptions_insert(integer, integer) OWNER TO test;

--
-- Name: mp_forumsubscriptions_unsubscribe(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumsubscriptions_unsubscribe(integer, integer) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_userid alias for $2;
	_rowcount int4;
begin

update		mp_forumsubscriptions
set			unsubscribedate = current_timestamp(3)
where		forumid = _forumid
			and userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumsubscriptions_unsubscribe(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_decrementreplycount(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_decrementreplycount(integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	 _mostrecentpostuserid int;
	 _mostrecentpostdate timestamp;
	_rowcount int4;
begin

select into _mostrecentpostuserid, _mostrecentpostdate
	userid, postdate
from mp_forumposts 
where threadid = _threadid 
order by postid desc limit 1;

update		mp_forumthreads
set			mostrecentpostuserid = _mostrecentpostuserid,
			totalreplies = totalreplies - 1,
			mostrecentpostdate = _mostrecentpostdate
where		threadid = _threadid;   
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_decrementreplycount(integer) OWNER TO test;

--
-- Name: mp_forumthreads_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_delete(integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_rowcount int4;
begin

delete from  	mp_forumposts
where		threadid = _threadid; 

delete from  	mp_forumthreadsubscriptions
where		threadid = _threadid; 

delete from  	mp_forumthreads
where		threadid = _threadid; 



GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_delete(integer) OWNER TO test;

--
-- Name: mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_mostrecentpostuserid alias for $2;
	_mostrecentpostdate alias for $3;
	_rowcount int4;
begin

update		mp_forumthreads
set			mostrecentpostuserid = _mostrecentpostuserid,
			totalreplies = totalreplies + 1,
			mostrecentpostdate = _mostrecentpostdate
where		threadid = _threadid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_forumid alias for $1;
	_threadsubject alias for $2;
	_sortorder alias for $3;
	_islocked alias for $4;
	_startedbyuserid alias for $5;
	_threaddate alias for $6;
	 _forumsequence int;
	_itemid int;

begin

_forumsequence := (select coalesce(max(forumsequence) + 1,1) from mp_forumthreads where forumid = _forumid);

insert into		mp_forumthreads
(
			forumid,
			threadsubject,
			sortorder,
			forumsequence,
			islocked,
			startedbyuserid,
			threaddate,
			mostrecentpostuserid,
			mostrecentpostdate
)
values
(
			
			_forumid,
			_threadsubject,
			_sortorder,
			_forumsequence,
			_islocked,
			_startedbyuserid,
			_threaddate,
			_startedbyuserid,
			_threaddate
);

select into _itemid cast(currval('mp_forumthreads_threadid_seq') as int4);  

insert into mp_forumthreadsubscriptions (threadid, userid)
	select _itemid as threadid, userid from mp_forumsubscriptions fs 
		where fs.forumid = _forumid and fs.subscribedate is not null and fs.unsubscribedate is null;

return _itemid;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforum(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_selectbyforum(integer, integer) RETURNS SETOF mp_forumthreads_selectbyforum_type
    AS $_$
declare
	_forumid alias for $1;
	_pagenumber alias for $2;
	 _threadsperpage	int;
	 _currentpagemaxforumsequence	int;
	 _beginsequence int;
	 _endsequence int;
	_rec mp_forumthreads_selectbyforum_type%ROWTYPE;

begin

select into _threadsperpage  threadsperpage
		
from		mp_forums
where	itemid = _forumid;

_currentpagemaxforumsequence := (_threadsperpage * _pagenumber);

if _currentpagemaxforumsequence > _threadsperpage + 1 then
		_beginsequence := _currentpagemaxforumsequence - _threadsperpage + 1;
else
		_beginsequence := 1;
end if;

_endsequence := _beginsequence + _threadsperpage  -1;

for _rec in
	select	
			t.threadid,
			forumid,
			threadsubject,
			threaddate,
			totalviews,
			totalreplies,
			sortorder,
			islocked,
			forumsequence,
			mostrecentpostdate,
			mostrecentpostuserid,
			startedbyuserid,
			coalesce(u.name, 'guest') as mostrecentpostuser,
			s.name as startedby
	from		mp_forumthreads t
	left outer join		mp_users u
	on		t.mostrecentpostuserid = u.userid
	left outer join		mp_users s
	on		t.startedbyuserid = s.userid
	where	t.forumid = _forumid
			and t.forumsequence 
	between _beginsequence 
	and _endsequence
	order by	t.sortorder, t.threadid desc
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_selectbyforum(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforumdesc(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_selectbyforumdesc(integer, integer) RETURNS SETOF mp_forumthreads_selectbyforumdesc_type
    AS $_$
declare
	_forumid alias for $1;
	_pagenumber alias for $2;
	 _threadsperpage	int;
	 _totalthreads	int;
	 _beginsequence int;
	 _endsequence int;
	_rec mp_forumthreads_selectbyforumdesc_type%ROWTYPE;

begin

select into _threadsperpage, _totalthreads 
		threadsperpage, _totalthreads
from		mp_forums
where	itemid = _forumid;

_beginsequence := _totalthreads - (_threadsperpage * _pagenumber) + 1;
_endsequence := _beginsequence + _threadsperpage  -1;

for _rec in
	select	
		t.threadid ,
		t.forumid ,
		t.threadsubject ,
		t.threaddate ,
		t.totalviews ,
		t.totalreplies ,
		t.sortorder ,
		t.islocked ,
		t.forumsequence ,
		t.mostrecentpostdate ,
		t.mostrecentpostuserid,
		startedbyuserid ,
		u.name as mostrecentpostuser ,
		s.name as startedby
	from		mp_forumthreads t
	left outer join		mp_users u
	on		t.mostrecentpostuserid = u.userid
	left outer join		mp_users s
	on		t.startedbyuserid = s.userid
	where	t.forumid = _forumid
			and t.forumsequence 
	between _beginsequence 
	and _endsequence
	order by	t.sortorder, t.threadid desc
	loop
		return next _rec;
	end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_selectbyforumdesc(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_selectbyforumdesc_v2(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_selectbyforumdesc_v2(integer, integer) RETURNS SETOF mp_forumthreads_selectbyforumdesc_v2_type
    AS $_$
declare
	_forumid alias for $1;
	_pagenumber alias for $2;
	 _threadsperpage	int;
	 _totalthreads	int;
	 _beginsequence int;
	_rec mp_forumthreads_selectbyforumdesc_v2_type%ROWTYPE;

begin

select into _threadsperpage, _totalthreads 
		threadsperpage, threadcount 
from		mp_forums
where	itemid = _forumid;

_beginsequence := _totalthreads - (_threadsperpage * _pagenumber) + 1;
 
for _rec in
	select	
		t.threadid ,
		t.forumid ,
		t.threadsubject ,
		t.threaddate ,
		t.totalviews ,
		t.totalreplies ,
		t.sortorder ,
		t.islocked ,
		t.forumsequence ,
		t.mostrecentpostdate ,
		t.mostrecentpostuserid,
		startedbyuserid ,
		u.name as mostrecentpostuser ,
		s.name as startedby
	from		mp_forumthreads t
	left outer join		mp_users u
	on		t.mostrecentpostuserid = u.userid
	left outer join		mp_users s
	on		t.startedbyuserid = s.userid
	where	t.forumid = _forumid
	order by	t.mostrecentpostdate desc
	limit _threadsperpage
	offset _beginsequence
loop
		return next _rec;
	end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_selectbyforumdesc_v2(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_selectbypage(integer, integer) RETURNS SETOF mp_forumthreads_selectbypage_type
    AS $_$
select
		fp.threadid,
		fp.postid,
		fp.subject,
		fp.post,
		f.moduleid,
		f.itemid,
		m.moduletitle,
		md.featurename
		
from
		mp_forumposts fp
		
JOIN		mp_forumthreads ft
ON		fp.threadid = ft.threadid

JOIN		mp_forums f
ON		f.itemid = ft.forumid
		
JOIN		mp_modules m
ON		f.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		AND fp.approved = true  ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_selectone(integer) RETURNS SETOF mp_forumthreads_selectone_type
    AS $_$
select	
		t.threadid ,
		t.forumid ,
		t.threadsubject ,
		t.threaddate ,
		t.totalviews ,
		t.totalreplies ,
		t.sortorder ,
		t.islocked ,
		t.forumsequence ,
		t.mostrecentpostdate ,
		t.mostrecentpostuserid,
		startedbyuserid ,
		coalesce(u.name, 'guest') as mostrecentpostuser ,
		coalesce(s.name, 'guest') as startedby ,
		f.postsperpage
from			mp_forumthreads t
left outer join	mp_users u
on			t.mostrecentpostuserid = u.userid
left outer join	mp_users s
on			t.startedbyuserid = s.userid
join			mp_forums f
on			f.itemid = t.forumid
where		t.threadid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_selectone(integer) OWNER TO test;

--
-- Name: mp_forumthreads_update(integer, integer, character varying, integer, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_update(integer, integer, character varying, integer, boolean) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_forumid alias for $2;
	_threadsubject alias for $3;
	_sortorder alias for $4;
	_islocked alias for $5;
	_rowcount int4;
begin

update		mp_forumthreads
set			forumid = _forumid,
			threadsubject = _threadsubject,
			sortorder = _sortorder,
			islocked = _islocked
where		threadid = _threadid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_update(integer, integer, character varying, integer, boolean) OWNER TO test;

--
-- Name: mp_forumthreads_updateforumsequence(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_updateforumsequence(integer, integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_forumsequence alias for $2;
	_rowcount int4;
begin

update		mp_forumthreads
set			forumsequence = _forumsequence
where		threadid = _threadid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_updateforumsequence(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreads_updateviewstats(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreads_updateviewstats(integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_rowcount int4;
begin

update		mp_forumthreads
set		
			totalviews = totalviews + 1
where		threadid = _threadid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreads_updateviewstats(integer) OWNER TO test;

--
-- Name: mp_forumthreadsubscribers_selectbythread(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreadsubscribers_selectbythread(integer, integer) RETURNS SETOF mp_forumthreadsubscribers_selectbythread_type
    AS $_$
select		u.email
from			mp_users u
join			mp_forumthreadsubscriptions s
on			u.userid = s.userid
where		s.threadid = $1
			and s.unsubscribedate is null
			and u.userid <> $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreadsubscribers_selectbythread(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions_exists(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreadsubscriptions_exists(integer, integer) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_forumthreadsubscriptions
where	threadid = $1 AND userid = $2 AND unsubscribedate is null; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreadsubscriptions_exists(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions_insert(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreadsubscriptions_insert(integer, integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_userid alias for $2;
	t_found int;
	_rowcount int4;

begin

select into t_found 1 
from mp_forumthreadsubscriptions 
where 	threadid = _threadid and userid = _userid limit 1;

if  found then
	update 	mp_forumthreadsubscriptions
	set		subscribedate = current_timestamp(3),
			unsubscribedate = null
	
	where 	threadid = _threadid and userid = _userid;
else
	insert into	mp_forumthreadsubscriptions
	(
			threadid,
			userid
	)
	values
	(
			_threadid,
			_userid
	);   
end if;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreadsubscriptions_insert(integer, integer) OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions_unsubscribeallthreads(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreadsubscriptions_unsubscribeallthreads(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

update		mp_forumthreadsubscriptions
set			unsubscribedate = current_timestamp(3)
where		
			userid = _userid;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreadsubscriptions_unsubscribeallthreads(integer) OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions_unsubscribethread(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_forumthreadsubscriptions_unsubscribethread(integer, integer) RETURNS integer
    AS $_$
declare
	_threadid alias for $1;
	_userid alias for $2;
	_rowcount int4;
begin

update		mp_forumthreadsubscriptions
set			unsubscribedate = current_timestamp(3)
where		threadid = _threadid
			and userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_forumthreadsubscriptions_unsubscribethread(integer, integer) OWNER TO test;

--
-- Name: mp_friendlyurls_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_delete(integer) RETURNS integer
    AS $_$
declare
	_urlid alias for $1;
	_rowcount int4;
begin

	
	delete from mp_friendlyurls
	where urlid = _urlid;
	
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_delete(integer) OWNER TO test;

--
-- Name: mp_friendlyurls_deletebypageid(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_deletebypageid(character varying) RETURNS integer
    AS $_$
declare
	_pageid alias for $1;
	_rowcount int4;
begin

	
	delete from mp_friendlyurls
	where realurl like _pageid
	;
	
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_deletebypageid(character varying) OWNER TO test;

--
-- Name: mp_friendlyurls_exists(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_exists(integer, character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_friendlyurls
where	siteid = $1 AND friendlyurl = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_exists(integer, character varying) OWNER TO test;

--
-- Name: mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) RETURNS integer
    AS $_$

insert into 	mp_friendlyurls
(				
                siteid,
                friendlyurl,
                realurl,
                ispattern,
                pageguid,
                siteguid,
                itemguid
) 
values 
(				
                $1, --:siteid
                $2, --:friendlyurl
                $3, --:realurl
                $4, --:ispattern
                $5,
                $6,
                $7
);

select cast(currval('mp_friendlyurls_urlid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) OWNER TO test;

--
-- Name: mp_friendlyurls_selectbyhost(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_selectbyhost(character varying) RETURNS SETOF mp_friendlyurls_select_one_type
    AS $_$

select
        urlid,
	siteid,
	friendlyurl,
	realurl,
	ispattern,
	pageguid,
	siteguid,
        itemguid
from
        mp_friendlyurls
where   siteid = coalesce(	(select siteid from mp_sitehosts where hostname = $1 limit 1),
				 (select siteid from mp_sites order by siteid limit 1)
			) ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_selectbyhost(character varying) OWNER TO test;

--
-- Name: mp_friendlyurls_selectbysiteid(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_selectbysiteid(integer) RETURNS SETOF mp_friendlyurls_selectbyhost_type
    AS $_$

select
        urlid,
        siteid,
        friendlyurl,
        realurl,
        ispattern
from
        mp_friendlyurls
where   siteid = $1
order by friendlyurl;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_selectbysiteid(integer) OWNER TO test;

--
-- Name: mp_friendlyurls_selectbysiteurl(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_selectbysiteurl(integer, character varying) RETURNS SETOF mp_friendlyurls_select_one_type
    AS $_$

select
        urlid,
	siteid,
	friendlyurl,
	realurl,
	ispattern,
	pageguid,
	siteguid,
        itemguid
from
        mp_friendlyurls
        
where   siteid = $1
	and friendlyurl = $2
;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_selectbysiteurl(integer, character varying) OWNER TO test;

--
-- Name: mp_friendlyurls_selectbyurl(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_selectbyurl(character varying, character varying) RETURNS SETOF mp_friendlyurls_select_one_type
    AS $_$

select
        urlid,
	siteid,
	friendlyurl,
	realurl,
	ispattern,
	pageguid,
	siteguid,
        itemguid
from
        mp_friendlyurls
        
where   friendlyurl = $2
	and siteid = coalesce(	(select siteid from mp_sitehosts where hostname = $1 limit 1),
				 (select siteid from mp_sites order by siteid limit 1)
			) ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_selectbyurl(character varying, character varying) OWNER TO test;

--
-- Name: mp_friendlyurls_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_selectone(integer) RETURNS SETOF mp_friendlyurls_select_one_type
    AS $_$

select
        urlid,
	siteid,
	friendlyurl,
	realurl,
	ispattern,
	pageguid,
	siteguid,
        itemguid
from
        mp_friendlyurls
        
where
        urlid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_selectone(integer) OWNER TO test;

--
-- Name: mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) RETURNS integer
    AS $_$
declare
	_urlid alias for $1;
	_siteid alias for $2;
	_friendlyurl alias for $3;
	_realurl alias for $4;
	_ispattern alias for $5;
	_pageguid alias for $6;
	_rowcount int4;
begin

update 		mp_friendlyurls

set
            siteid = _siteid, --:siteid
            friendlyurl = _friendlyurl, --:friendlyurl
            realurl = _realurl, --:realurl
            ispattern = _ispattern, --:ispattern,
            pageguid = _pageguid
            
where
            urlid = _urlid; --:urlid

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) OWNER TO test;

--
-- Name: mp_galleryimages_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from  mp_galleryimages
where
	itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_delete(integer) OWNER TO test;

--
-- Name: mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) RETURNS integer
    AS $_$
insert into 	mp_galleryimages
(
				moduleid,
				displayorder,
				caption,
				description,
				metadataxml,
				imagefile,
				webimagefile,
				thumbnailfile,
				uploaddate,
				uploaduser
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10
				
);
select cast(currval('mp_galleryimages_itemid_seq') as int4);; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) OWNER TO test;

--
-- Name: mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) RETURNS integer
    AS $_$
insert into 	mp_galleryimages
(
				moduleid,
				displayorder,
				caption,
				description,
				metadataxml,
				imagefile,
				webimagefile,
				thumbnailfile,
				uploaddate,
				uploaduser,
				itemguid,
				moduleguid,
				userguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13
				
);
select cast(currval('mp_galleryimages_itemid_seq') as int4);; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_galleryimages_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_select(integer) RETURNS SETOF mp_galleryimages_select_type
    AS $_$
select
		itemid,
		moduleid,
		displayorder,
		caption,
		description,
		metadataxml,
		imagefile,
		webimagefile,
		thumbnailfile,
		uploaddate,
		uploaduser
		
from
		mp_galleryimages
where	moduleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_select(integer) OWNER TO test;

--
-- Name: mp_galleryimages_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_selectbypage(integer, integer) RETURNS SETOF mp_galleryimages_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.caption,
		gi.description,
		m.moduletitle,
		md.featurename
		
from
		mp_galleryimages gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		AND (current_timestamp(3) >= pm.publishbegindate)
		AND ((pm.publishenddate IS NULL) OR (current_timestamp(3) < pm.publishenddate)); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_galleryimages_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_selectone(integer) RETURNS SETOF mp_galleryimages_selectone_type
    AS $_$
select
	itemid,
	moduleid,
	displayorder,
	caption,
	description,
	metadataxml,
	imagefile,
	webimagefile,
	thumbnailfile,
	uploaddate,
	uploaduser,
	itemguid,
	moduleguid,
        userguid
		
from
		mp_galleryimages
		
where
		itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_selectone(integer) OWNER TO test;

--
-- Name: mp_galleryimages_selectthumbsbypage(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_selectthumbsbypage(integer, integer, integer) RETURNS SETOF mp_galleryimages_selectthumbsbypage_type
    AS $_$
declare
	_moduleid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	 _pagelowerbound int;
	 _pageupperbound int;
	 _totalrows int;
	 _totalpages int;
	 _remainder int;
	_rec mp_galleryimages_selectthumbsbypage_type%ROWTYPE;
	p_index int;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;
_pageupperbound := _pagelowerbound + _pagesize + 1;

select into _totalrows  cast(count(*) as int4) 
from	mp_galleryimages t
where  t.moduleid = _moduleid;

_totalpages := _totalrows / _pagesize;

_remainder := _totalrows % _pagesize;

p_index := _pagelowerbound;

if _remainder > 0 then
	_totalpages := _totalpages + 1;
end if; 
for _rec in
	select	
		t.itemid,
		t.caption,
		t.thumbnailfile,
		t.webimagefile,
		p_index as indexid,
		_totalpages as totalpages
	from		mp_galleryimages t
	where	t.moduleid = _moduleid	
	order by	t.displayorder, t.itemid asc
	limit 	_pagesize
	offset _pagelowerbound
loop
	return next _rec;
	p_index := p_index + 1;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_selectthumbsbypage(integer, integer, integer) OWNER TO test;

--
-- Name: mp_galleryimages_selectwebimagebypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_selectwebimagebypage(integer, integer) RETURNS SETOF mp_galleryimages_selectwebimagebypage_type
    AS $_$
declare
	_moduleid alias for $1;
	_pagenumber alias for $2;
	 _pagesize 		int;
	 _pagelowerbound 	int;
	 _pageupperbound 	int;
	 _totalrows int;
	 _totalpages int;
	 _remainder int;
	_rec mp_galleryimages_selectwebimagebypage_type%ROWTYPE;
	p_index int;

begin

_pagesize := 1;
_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;
_pageupperbound := _pagelowerbound + _pagesize + 1;

select into _totalrows  cast(count(*) as int4) 
from	mp_galleryimages t
where  t.moduleid = _moduleid;

_totalpages := _totalrows / _pagesize;
_remainder := _totalrows % _pagesize;

if _remainder > 0 then
	_totalpages := _totalpages + 1;
end if;

for _rec in
	select	t.moduleid,
		t.itemid,
            	_totalpages as totalpages
			
			
	from		mp_galleryimages t
	where	t.moduleid = _moduleid	
	order by	t.displayorder, t.itemid asc
    limit 	_pagesize
	offset _pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_selectwebimagebypage(integer, integer) OWNER TO test;

--
-- Name: mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_displayorder alias for $3;
	_caption alias for $4;
	_description alias for $5;
	_metadataxml alias for $6;
	_imagefile alias for $7;
	_webimagefile alias for $8;
	_thumbnailfile alias for $9;
	_uploaddate alias for $10;
	_uploaduser alias for $11;
	_rowcount int4;
begin

update 		mp_galleryimages 
set
			moduleid = _moduleid,
			displayorder = _displayorder,
			caption = _caption,
			description = _description,
			metadataxml = _metadataxml,
			imagefile = _imagefile,
			webimagefile = _webimagefile,
			thumbnailfile = _thumbnailfile,
			uploaddate = _uploaddate,
			uploaduser = _uploaduser
			
where
			itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) OWNER TO test;

--
-- Name: mp_htmlcontent_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from  mp_htmlcontent
where
	itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_delete(integer) OWNER TO test;

--
-- Name: mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) RETURNS integer
    AS $_$
insert into 	mp_htmlcontent 
(
				moduleid,
				title,
				excerpt,
				body,
				morelink,
				sortorder,
				begindate,
				enddate,
				createddate,
				userid,
				itemguid,
				moduleguid,
				userguid,
				lastmoduserguid,
				lastmodutc
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13,
				$13,
				$9
				
);
select cast(currval('mp_htmlcontent_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) OWNER TO test;

--
-- Name: mp_htmlcontent_select(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_select(integer, timestamp without time zone) RETURNS SETOF mp_htmlcontent
    AS $_$
select  	*
from		mp_htmlcontent
where	moduleid = $1
		and begindate <= $2
		and enddate >= $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_select(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_htmlcontent_selectall(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_selectall() RETURNS SETOF mp_htmlcontent
    AS $$
select	*
		
from
		mp_htmlcontent; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_selectall() OWNER TO test;

--
-- Name: mp_htmlcontent_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_selectbypage(integer, integer) RETURNS SETOF mp_htmlcontent_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.title,
		gi.body,
		m.moduletitle,
		md.featurename
		
from
		mp_htmlcontent gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_htmlcontent_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_selectone(integer) RETURNS SETOF mp_htmlcontent
    AS $_$
select  	*
from		mp_htmlcontent
where	itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_selectone(integer) OWNER TO test;

--
-- Name: mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_title alias for $3;
	_excerpt alias for $4;
	_body alias for $5;
	_morelink alias for $6;
	_sortorder alias for $7;
	_begindate alias for $8;
	_enddate alias for $9;
	_lastmoduserguid alias for $10;
	_lastmodutc alias for $11;
	_rowcount int4;
begin

update 		mp_htmlcontent 
set
			moduleid = _moduleid,
			title = _title,
			excerpt = _excerpt,
			body = _body,
			morelink = _morelink,
			sortorder = _sortorder,
			begindate = _begindate,
			enddate = _enddate,
			lastmoduserguid = _lastmoduserguid,
			lastmodutc = _lastmodutc
			
where
			itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_letter_count(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_count(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_letter
where		letterinfoguid = $1
		and sendclickedutc IS NOT NULL
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_count(character) OWNER TO test;

--
-- Name: mp_letter_countdrafts(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_countdrafts(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_letter
where		letterinfoguid = $1
		and sendclickedutc IS NULL
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_countdrafts(character) OWNER TO test;

--
-- Name: mp_letter_delete(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_delete(character) RETURNS integer
    AS $_$
declare
            _letterguid alias for $1;
			_rowcount int4;
begin
	delete from mp_letter
	where letterguid = _letterguid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_delete(character) OWNER TO test;

--
-- Name: mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) RETURNS integer
    AS $_$
declare
            _letterguid alias for $1;
            _letterinfoguid alias for $2;
            _subject alias for $3;
            _htmlbody alias for $4;
            _textbody alias for $5;
            _createdby alias for $6;
            _createdutc alias for $7;
            _lastmodby alias for $8;
            _lastmodutc alias for $9;
            _isapproved alias for $10;
            _approvedby alias for $11;
           
			_rowcount int4;
begin

insert into 	mp_letter
(			
                letterguid,
                letterinfoguid,
                subject,
                htmlbody,
                textbody,
                createdby,
                createdutc,
                lastmodby,
                lastmodutc,
                isapproved,
                approvedby,
                sendcount
) 
values 
(				
                _letterguid, 
                _letterinfoguid, 
                _subject, 
                _htmlbody, 
                _textbody, 
                _createdby, 
                _createdutc, 
                _lastmodby, 
                _lastmodutc, 
                _isapproved, 
                _approvedby, 
                0 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) OWNER TO test;

--
-- Name: mp_letter_select_all(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_select_all(character) RETURNS SETOF mp_letter_select_one_type
    AS $_$

select
        letterguid,
        letterinfoguid,
        subject,
        htmlbody,
        textbody,
        createdby,
        createdutc,
        lastmodby,
        lastmodutc,
        isapproved,
        approvedby,
        sendclickedutc,
        sendstartedutc,
        sendcompleteutc,
        sendcount
from
        mp_letter
        
where
        letterinfoguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_select_all(character) OWNER TO test;

--
-- Name: mp_letter_select_one(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_select_one(character) RETURNS SETOF mp_letter_select_one_type
    AS $_$

select
        letterguid,
        letterinfoguid,
        subject,
        htmlbody,
        textbody,
        createdby,
        createdutc,
        lastmodby,
        lastmodutc,
        isapproved,
        approvedby,
        sendclickedutc,
        sendstartedutc,
        sendcompleteutc,
        sendcount
from
        mp_letter
        
where
        letterguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_select_one(character) OWNER TO test;

--
-- Name: mp_letter_selectdraftspage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_selectdraftspage(character, integer, integer) RETURNS SETOF mp_letter_select_one_type
    AS $_$
declare
	_letterinfoguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_letter_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        letterguid,
        letterinfoguid,
        subject,
        htmlbody,
        textbody,
        createdby,
        createdutc,
        lastmodby,
        lastmodutc,
        isapproved,
        approvedby,
        sendclickedutc,
        sendstartedutc,
        sendcompleteutc,
        sendcount

	from mp_letter
	where letterinfoguid = _letterinfoguid
		and sendclickedutc is  null
	order by sendclickedutc desc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_selectdraftspage(character, integer, integer) OWNER TO test;

--
-- Name: mp_letter_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_selectpage(character, integer, integer) RETURNS SETOF mp_letter_select_one_type
    AS $_$
declare
	_letterinfoguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_letter_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        letterguid,
        letterinfoguid,
        subject,
        htmlbody,
        textbody,
        createdby,
        createdutc,
        lastmodby,
        lastmodutc,
        isapproved,
        approvedby,
        sendclickedutc,
        sendstartedutc,
        sendcompleteutc,
        sendcount

	from mp_letter
	where letterinfoguid = _letterinfoguid
		and sendclickedutc is not null
	order by sendclickedutc desc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) RETURNS integer
    AS $_$

declare
            _letterguid alias for $1;
            _letterinfoguid alias for $2;
            _subject alias for $3;
            _htmlbody alias for $4;
            _textbody alias for $5;
            _lastmodby alias for $6;
            _lastmodutc alias for $7;
            _isapproved alias for $8;
            _approvedby alias for $9;
           
			_rowcount int4;
begin
update 		mp_letter

set
            letterinfoguid = _letterinfoguid, 
            subject = _subject, 
            htmlbody = _htmlbody, 
            textbody = _textbody,  
            lastmodby = _lastmodby, 
            lastmodutc = _lastmodutc, 
            isapproved = _isapproved, 
            approvedby = _approvedby
            
            
where
            letterguid = _letterguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) OWNER TO test;

--
-- Name: mp_letter_updatesendclicked(character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_updatesendclicked(character, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _letterguid alias for $1;
            _sendclickedutc alias for $2;
           
	_rowcount int4;
begin
update 		mp_letter

set
            
            sendclickedutc = _sendclickedutc 
            
            
where
            letterguid = _letterguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_updatesendclicked(character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_letter_updatesendsomplete(character, timestamp without time zone, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_updatesendsomplete(character, timestamp without time zone, integer) RETURNS integer
    AS $_$

declare
            _letterguid alias for $1;
            _sendcompleteutc alias for $2;
           _sendcount alias for $3;
	_rowcount int4;
begin
update 		mp_letter

set
            
            sendcompleteutc = _sendcompleteutc,
            sendcount = _sendcount
            
            
where
            letterguid = _letterguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_updatesendsomplete(character, timestamp without time zone, integer) OWNER TO test;

--
-- Name: mp_letter_updatesendstarted(character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letter_updatesendstarted(character, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _letterguid alias for $1;
            _sendstartedutc alias for $2;
           
	_rowcount int4;
begin
update 		mp_letter

set
            
            sendstartedutc = _sendstartedutc 
            
            
where
            letterguid = _letterguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letter_updatesendstarted(character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_count(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_count(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_letterhtmltemplate
where		siteguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_count(character) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_delete(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_delete(character) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
			_rowcount int4;
begin
	delete from mp_letterhtmltemplate
	where guid = _guid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_delete(character) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
            _siteguid alias for $2;
            _title alias for $3;
            _html alias for $4;
            _lastmodutc alias for $5;
			_rowcount int4;
begin

insert into 	mp_letterhtmltemplate
(			
                guid,
                siteguid,
                title,
                html,
                lastmodutc
) 
values 
(				
                _guid, 
                _siteguid, 
                _title, 
                _html, 
                _lastmodutc 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_select_all(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_select_all(character) RETURNS SETOF mp_letterhtmltemplate_select_one_type
    AS $_$

select
        guid,
        siteguid,
        title,
        html,
        lastmodutc
from
        mp_letterhtmltemplate
        
where
        siteguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_select_all(character) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_select_one(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_select_one(character) RETURNS SETOF mp_letterhtmltemplate_select_one_type
    AS $_$

select
        guid,
        siteguid,
        title,
        html,
        lastmodutc
from
        mp_letterhtmltemplate
        
where
        guid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_select_one(character) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_selectpage(character, integer, integer) RETURNS SETOF mp_letterhtmltemplate_select_one_type
    AS $_$
declare
	_siteguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_letterhtmltemplate_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        guid,
        siteguid,
        title,
        html,
        lastmodutc

	from mp_letterhtmltemplate
	where siteguid = _siteguid
	order by title
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _title alias for $2;
            _html alias for $3;
            _lastmodutc alias for $4;
			_rowcount int4;
begin
update 		mp_letterhtmltemplate

set
            title = _title, 
            html = _html, 
            lastmodutc = _lastmodutc 
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) OWNER TO test;

--
-- Name: mp_letterinfo_count(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_count(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_letterinfo
where		siteguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_count(character) OWNER TO test;

--
-- Name: mp_letterinfo_delete(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_delete(character) RETURNS integer
    AS $_$
declare
            _letterinfoguid alias for $1;
			_rowcount int4;
begin
	delete from mp_letterinfo
	where letterinfoguid = _letterinfoguid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_delete(character) OWNER TO test;

--
-- Name: mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) RETURNS integer
    AS $_$
declare
            _letterinfoguid alias for $1;
            _siteguid alias for $2;
            _title alias for $3;
            _description alias for $4;
            _availabletoroles alias for $5;
            _enabled alias for $6;
            _allowuserfeedback alias for $7;
            _allowanonfeedback alias for $8;
            _fromaddress alias for $9;
            _fromname alias for $10;
            _replytoaddress alias for $11;
            _sendmode alias for $12;
            _enableviewaswebpage alias for $13;
            _enablesendlog alias for $14;
            _rolesthatcanedit alias for $15;
            _rolesthatcanapprove alias for $16;
            _rolesthatcansend alias for $17;
            _createdutc alias for $18;
            _createdby alias for $19;
            _lastmodutc alias for $20;
            _lastmodby alias for $21;
			_rowcount int4;
begin

insert into 	mp_letterinfo
(			
                letterinfoguid,
                siteguid,
                title,
                description,
                availabletoroles,
                enabled,
                allowuserfeedback,
                allowanonfeedback,
                fromaddress,
                fromname,
                replytoaddress,
                sendmode,
                enableviewaswebpage,
                enablesendlog,
                rolesthatcanedit,
                rolesthatcanapprove,
                rolesthatcansend,
                createdutc,
                createdby,
                lastmodutc,
                lastmodby,
                subscribercount
) 
values 
(				
                _letterinfoguid, 
                _siteguid, 
                _title, 
                _description, 
                _availabletoroles, 
                _enabled, 
                _allowuserfeedback, 
                _allowanonfeedback, 
                _fromaddress, 
                _fromname, 
                _replytoaddress, 
                _sendmode, 
                _enableviewaswebpage, 
                _enablesendlog, 
                _rolesthatcanedit, 
                _rolesthatcanapprove, 
                _rolesthatcansend, 
                _createdutc, 
                _createdby, 
                _lastmodutc, 
                _lastmodby,
                0
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) OWNER TO test;

--
-- Name: mp_letterinfo_select_all(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_select_all(character) RETURNS SETOF mp_letterinfo_select_one_type
    AS $_$

select
        letterinfoguid,
	        siteguid,
	        title,
	        description,
	        availabletoroles,
	        enabled,
	        allowuserfeedback,
	        allowanonfeedback,
	        fromaddress,
	        fromname,
	        replytoaddress,
	        sendmode,
	        enableviewaswebpage,
	        enablesendlog,
	        rolesthatcanedit,
	        rolesthatcanapprove,
	        rolesthatcansend,
	        subscribercount,
	        createdutc,
	        createdby,
	        lastmodutc,
        lastmodby
from
        mp_letterinfo
where	siteguid = $1
;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_select_all(character) OWNER TO test;

--
-- Name: mp_letterinfo_select_one(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_select_one(character) RETURNS SETOF mp_letterinfo_select_one_type
    AS $_$

select
        letterinfoguid,
        siteguid,
        title,
        description,
        availabletoroles,
        enabled,
        allowuserfeedback,
        allowanonfeedback,
        fromaddress,
        fromname,
        replytoaddress,
        sendmode,
        enableviewaswebpage,
        enablesendlog,
        rolesthatcanedit,
        rolesthatcanapprove,
        rolesthatcansend,
        subscribercount,
        createdutc,
        createdby,
        lastmodutc,
        lastmodby
from
        mp_letterinfo
        
where
        letterinfoguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_select_one(character) OWNER TO test;

--
-- Name: mp_letterinfo_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_selectpage(character, integer, integer) RETURNS SETOF mp_letterinfo_select_one_type
    AS $_$
declare
	_siteguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_letterinfo_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        letterinfoguid,
	        siteguid,
	        title,
	        description,
	        availabletoroles,
	        enabled,
	        allowuserfeedback,
	        allowanonfeedback,
	        fromaddress,
	        fromname,
	        replytoaddress,
	        sendmode,
	        enableviewaswebpage,
	        enablesendlog,
	        rolesthatcanedit,
	        rolesthatcanapprove,
	        rolesthatcansend,
	        subscribercount,
	        createdutc,
	        createdby,
	        lastmodutc,
        lastmodby

	from mp_letterinfo
	where siteguid = _siteguid
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) RETURNS integer
    AS $_$

declare
            _letterinfoguid alias for $1;
            _siteguid alias for $2;
            _title alias for $3;
            _description alias for $4;
            _availabletoroles alias for $5;
            _enabled alias for $6;
            _allowuserfeedback alias for $7;
            _allowanonfeedback alias for $8;
            _fromaddress alias for $9;
            _fromname alias for $10;
            _replytoaddress alias for $11;
            _sendmode alias for $12;
            _enableviewaswebpage alias for $13;
            _enablesendlog alias for $14;
            _rolesthatcanedit alias for $15;
            _rolesthatcanapprove alias for $16;
            _rolesthatcansend alias for $17;
            _createdutc alias for $18;
            _createdby alias for $19;
            _lastmodutc alias for $20;
            _lastmodby alias for $21;
			_rowcount int4;
begin
update 		mp_letterinfo

set
            siteguid = _siteguid, 
            title = _title, 
            description = _description, 
            availabletoroles = _availabletoroles, 
            enabled = _enabled, 
            allowuserfeedback = _allowuserfeedback, 
            allowanonfeedback = _allowanonfeedback, 
            fromaddress = _fromaddress, 
            fromname = _fromname, 
            replytoaddress = _replytoaddress, 
            sendmode = _sendmode, 
            enableviewaswebpage = _enableviewaswebpage, 
            enablesendlog = _enablesendlog, 
            rolesthatcanedit = _rolesthatcanedit, 
            rolesthatcanapprove = _rolesthatcanapprove, 
            rolesthatcansend = _rolesthatcansend, 
            createdutc = _createdutc, 
            createdby = _createdby, 
            lastmodutc = _lastmodutc, 
            lastmodby = _lastmodby 
            
where
            letterinfoguid = _letterinfoguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) OWNER TO test;

--
-- Name: mp_letterinfo_updatesubscribercount(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_letterinfo_updatesubscribercount(character) RETURNS integer
    AS $_$
declare
            _letterinfoguid alias for $1;
			_rowcount int4;
begin
	update mp_letterinfo
	set	subscribercount = (select count(*) from mp_lettersubscriber where letterinfoguid = _letterinfoguid)
	where letterinfoguid = _letterinfoguid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_letterinfo_updatesubscribercount(character) OWNER TO test;

--
-- Name: mp_lettersendlog_count(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_count(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_lettersendlog
where 		letterguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_count(character) OWNER TO test;

--
-- Name: mp_lettersendlog_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_delete(integer) RETURNS integer
    AS $_$
declare
            _rowid alias for $1;
			_rowcount int4;
begin
	delete from mp_lettersendlog
	where rowid = _rowid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_delete(integer) OWNER TO test;

--
-- Name: mp_lettersendlog_deletebyletter(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_deletebyletter(character) RETURNS integer
    AS $_$
declare
            _letterguid alias for $1;
			_rowcount int4;
begin
	delete from mp_lettersendlog
	where letterguid = _letterguid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_deletebyletter(character) OWNER TO test;

--
-- Name: mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) RETURNS integer
    AS $_$

insert into 	mp_lettersendlog
(				
                letterguid,
                userguid,
                emailaddress,
                utc,
                erroroccurred,
                errormessage
) 
values 
(				
                $1, --:letterguid
                $2, --:userguid
                $3, --:emailaddress
                $4, --:utc
                $5, --:erroroccurred
                $6 --:errormessage
);
select cast(currval('mp_lettersendlogrowid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) OWNER TO test;

--
-- Name: mp_lettersendlog_select_byletter(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_select_byletter(character) RETURNS SETOF mp_lettersendlog_select_one_type
    AS $_$

select
        rowid,
        letterguid,
        userguid,
        emailaddress,
        utc,
        erroroccurred,
        errormessage
from
        mp_lettersendlog
where letterguid = $1
;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_select_byletter(character) OWNER TO test;

--
-- Name: mp_lettersendlog_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_select_one(integer) RETURNS SETOF mp_lettersendlog_select_one_type
    AS $_$

select
        rowid,
        letterguid,
        userguid,
        emailaddress,
        utc,
        erroroccurred,
        errormessage
from
        mp_lettersendlog
        
where
        rowid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_select_one(integer) OWNER TO test;

--
-- Name: mp_lettersendlog_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_selectpage(character, integer, integer) RETURNS SETOF mp_lettersendlog_select_one_type
    AS $_$
declare
	_letterguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_lettersendlog_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        rowid,
        letterguid,
        userguid,
        emailaddress,
        utc,
        erroroccurred,
        errormessage

	from mp_lettersendlog
	where letterguid = _letterguid
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) RETURNS integer
    AS $_$

declare
            _rowid alias for $1;
            _letterguid alias for $2;
            _userguid alias for $3;
            _emailaddress alias for $4;
            _utc alias for $5;
            _erroroccurred alias for $6;
            _errormessage alias for $7;
			_rowcount int4;
begin
update 		mp_lettersendlog

set
            letterguid = _letterguid, 
            userguid = _userguid, 
            emailaddress = _emailaddress, 
            utc = _utc, 
            erroroccurred = _erroroccurred, 
            errormessage = _errormessage 
            
where
            rowid = _rowid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) OWNER TO test;

--
-- Name: mp_lettersubscriber_countbyletter(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_countbyletter(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_lettersubscriber
where		letterinfoguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_countbyletter(character) OWNER TO test;

--
-- Name: mp_lettersubscriber_delete(character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_delete(character, character) RETURNS integer
    AS $_$
declare
            _letterinfoguid alias for $1;
            _userguid alias for $2;
	   _rowcount int4;
begin
	delete from mp_lettersubscriber
	where letterinfoguid = _letterinfoguid
	and userguid = _userguid
	;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_delete(character, character) OWNER TO test;

--
-- Name: mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _letterinfoguid alias for $1;
            _userguid alias for $2;
            _usehtml alias for $3;
            _beginutc alias for $4;
	    _rowcount int4;
begin
insert into 	mp_lettersubscriber
(				
                letterinfoguid,
                userguid,
                usehtml,
                beginutc
) 
values 
(				
                _letterinfoguid, 
                _userguid, 
                _usehtml, 
                _beginutc 

);

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) OWNER TO test;

--
-- Name: mp_lettersubscriber_select_one(character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_select_one(character, character) RETURNS SETOF mp_lettersubscriber_select_one_type
    AS $_$

select

        ls.letterinfoguid,
        ls.userguid,
        ls.usehtml,
        ls.beginutc,
        u.email,
        u.name

from
        mp_lettersubscriber ls
        
join	mp_users u
on	u.userguid = ls.userguid
        
where
        ls.letterinfoguid = $1
        and ls.userguid = $2
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_select_one(character, character) OWNER TO test;

--
-- Name: mp_lettersubscriber_select_unsentbyletter(character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_select_unsentbyletter(character, character) RETURNS SETOF mp_lettersubscriber_select_one_type
    AS $_$

select

        ls.letterinfoguid,
        ls.userguid,
        ls.usehtml,
        ls.beginutc,
        u.email,
        u.name

from
        mp_lettersubscriber ls
        
join	mp_users u
on	u.userguid = ls.userguid
        
where
        ls.letterinfoguid = $2
        AND ls.userguid not in (select userguid from mp_lettersendlog where letterguid = $1)
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_select_unsentbyletter(character, character) OWNER TO test;

--
-- Name: mp_lettersubscriber_selectbyletter(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_selectbyletter(character) RETURNS SETOF mp_lettersubscriber_select_one_type
    AS $_$

select

        ls.letterinfoguid,
        ls.userguid,
        ls.usehtml,
        ls.beginutc,
        u.email,
        u.name

from
        mp_lettersubscriber ls
        
join	mp_users u
on	u.userguid = ls.userguid
        
where
        ls.letterinfoguid = $1
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_selectbyletter(character) OWNER TO test;

--
-- Name: mp_lettersubscriber_selectbyuser(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_selectbyuser(character) RETURNS SETOF mp_lettersubscriber_select_one_type
    AS $_$

select

        ls.letterinfoguid,
        ls.userguid,
        ls.usehtml,
        ls.beginutc,
        u.email,
        u.name

from
        mp_lettersubscriber ls
        
join	mp_users u
on	u.userguid = ls.userguid
        
where
        ls.userguid = $1
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_selectbyuser(character) OWNER TO test;

--
-- Name: mp_lettersubscriber_selectpage(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriber_selectpage(character, integer, integer) RETURNS SETOF mp_lettersubscriber_select_one_type
    AS $_$
declare
	_letterinfoguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_lettersubscriber_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        ls.letterinfoguid,
        ls.userguid,
        ls.usehtml,
        ls.beginutc,
        u.name,
        u.email

	from mp_lettersubscriber ls
	join mp_users u
	on u.userguid = ls.userguid
	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriber_selectpage(character, integer, integer) OWNER TO test;

--
-- Name: mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) RETURNS integer
    AS $_$

insert into 	mp_lettersubscriberhx
(				
                letterinfoguid,
                userguid,
                usehtml,
                beginutc,
                endutc
) 
values 
(				
                $1, --:letterinfoguid
                $2, --:userguid
                $3, --:usehtml
                $4, --:beginutc
                $5 --:endutc
);
select cast(currval('mp_lettersubscriberhxrowid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) OWNER TO test;

--
-- Name: mp_links_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_links
where
    itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_delete(integer) OWNER TO test;

--
-- Name: mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) RETURNS integer
    AS $_$
insert into 	mp_links 
(
				moduleid,
				title,
				url,
				vieworder,
				description,
				createddate,
				createdby,
				target,
				itemguid,
				moduleguid,
				userguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11
				
);
select cast(currval('mp_links_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) OWNER TO test;

--
-- Name: mp_links_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_select(integer) RETURNS SETOF mp_links
    AS $_$
select	*
from
    mp_links
where
    moduleid = $1
order by
    vieworder, itemid; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_select(integer) OWNER TO test;

--
-- Name: mp_links_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_selectbypage(integer, integer) RETURNS SETOF mp_links_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.title, 
		gi.description, 
		m.moduletitle,
		md.featurename
		
from
		mp_links gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_links_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_selectone(integer) RETURNS SETOF mp_links
    AS $_$
select
   *
from
    mp_links
where
    itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_selectone(integer) OWNER TO test;

--
-- Name: mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_title alias for $3;
	_url alias for $4;
	_vieworder alias for $5;
	_description alias for $6;
	_createddate alias for $7;
	_createdby alias for $8;
	_target alias for $9;
	_rowcount int4;
begin

update 		mp_links 
set
			moduleid = _moduleid,
			title = _title,
			url = _url,
			vieworder = _vieworder,
			description = _description,
			createddate = _createddate,
			createdby = _createdby,
			target = _target
			
where
			itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitions_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_delete(integer) RETURNS integer
    AS $_$
declare
	_moduledefid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_moduledefinitions
where
    moduledefid = _moduledefid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_delete(integer) OWNER TO test;

--
-- Name: mp_moduledefinitions_deletesettingbyid(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_deletesettingbyid(integer) RETURNS integer
    AS $_$
declare
	_id alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_moduledefinitionsettings
where
    id = _id; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_deletesettingbyid(integer) OWNER TO test;

--
-- Name: mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_featurename alias for $2;
	_controlsrc alias for $3;
	_sortorder alias for $4;
	_isadmin alias for $5;
	_icon alias for $6;
	_defaultcachetime alias for $7;
	_featureguid alias for $8;
	_resourcefile alias for $9;
	 _moduledefid int;

begin

insert into 	mp_moduledefinitions 
(
				guid,
				featurename,
				controlsrc,
				sortorder,
				defaultcachetime,
				icon,
				isadmin,
				resourcefile
) 
values 
(
				_featureguid,
				_featurename,
				_controlsrc,
				_sortorder,
				_defaultcachetime,
				_icon,
				_isadmin,
				_resourcefile
				
);

_moduledefid := cast(currval('mp_moduledefinitions_moduledefid_seq') as int4);

if _siteid > -1 then
perform mp_sitemoduledefinitions_insert(_siteid, _moduledefid);
end if;

return _moduledefid;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitions_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_select(integer) RETURNS SETOF mp_moduledefinitions
    AS $_$
select   	md.*
from		mp_moduledefinitions md
join		mp_sitemoduledefinitions smd
on		smd.moduledefid = md.moduledefid
    
where   	smd.siteid = $1
order by 	md.sortorder, md.featurename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_select(integer) OWNER TO test;

--
-- Name: mp_moduledefinitions_selectbysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_selectbysite(character) RETURNS SETOF mp_moduledefinitions
    AS $_$
select   	md.*
from		mp_moduledefinitions md
join		mp_sitemoduledefinitions smd
on		smd.moduledefid = md.moduledefid
    
where   	smd.siteguid = $1
order by 	md.sortorder, md.featurename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_selectbysite(character) OWNER TO test;

--
-- Name: mp_moduledefinitions_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_selectone(integer) RETURNS SETOF mp_moduledefinitions
    AS $_$
select	*
from
    mp_moduledefinitions
where
    moduledefid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_selectone(integer) OWNER TO test;

--
-- Name: mp_moduledefinitions_selectonebyguid(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_selectonebyguid(character) RETURNS SETOF mp_moduledefinitions
    AS $_$
select	*
from
    mp_moduledefinitions
where
    guid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_selectonebyguid(character) OWNER TO test;

--
-- Name: mp_moduledefinitions_selectusermodules(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_selectusermodules(integer) RETURNS SETOF mp_moduledefinitions
    AS $_$
select   		md.*
from			mp_moduledefinitions md
join			mp_sitemoduledefinitions smd
on			smd.moduledefid = md.moduledefid
    
where   		smd.siteid = $1
			and md.isadmin = false
order by 		md.sortorder, md.featurename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_selectusermodules(integer) OWNER TO test;

--
-- Name: mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) RETURNS integer
    AS $_$
declare
	_moduledefid alias for $1;
	_featurename alias for $2;
	_controlsrc alias for $3;
	_sortorder alias for $4;
	_isadmin alias for $5;
	_icon alias for $6;
	_defaultcachetime alias for $7;
	_resourcefile alias for $8;
	_rowcount int4;
begin

update 		mp_moduledefinitions 
set
			featurename = _featurename,
			controlsrc = _controlsrc,
			sortorder = _sortorder,
			defaultcachetime = _defaultcachetime,
			icon = _icon,
			isadmin = _isadmin,
			resourcefile = _resourcefile
			
where
			moduledefid = _moduledefid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_select(integer) RETURNS SETOF mp_moduledefinitionsettings
    AS $_$
select
    *
from
    mp_moduledefinitionsettings
where
    moduledefid = $1
    order by sortorder
    ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_select(integer) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_selectone(character, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_selectone(character, character varying) RETURNS SETOF mp_moduledefinitionsettings
    AS $_$
select
    *
from
    mp_moduledefinitionsettings
where
    featureguid = $1 and settingname = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_selectone(character, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) RETURNS integer
    AS $_$
declare
	_moduledefid alias for $1;
	_settingname alias for $2;
	_settingvalue alias for $3;
	_controltype alias for $4;
	_regexvalidationexpression alias for $5;
	_featureguid alias for $6;
	_resourcefile alias for $7;
	t_found int4;
	_rowcount int4;
begin

select into t_found 1 from 
        mp_moduledefinitionsettings 
    where 
        (moduledefid = _moduledefid OR featureguid = _featureguid)
      and
        settingname = _settingname limit 1;

if not found then
	insert into mp_moduledefinitionsettings (
	    featureguid,
	    moduledefid,
	    resourcefile,
	    settingname,
	    settingvalue,
	    controltype,
	    regexvalidationexpression
	    
	) 
	values (
	    _featureguid,
	    _moduledefid,
	    _resourcefile,
	    _settingname,
	    _settingvalue,
	    _controltype,
	    _regexvalidationexpression
	);
else
	update
	    mp_moduledefinitionsettings
	set
	    resourcefile = _resourcefile,
	    settingvalue = _settingvalue,
	    controltype = _controltype,
	    regexvalidationexpression = _regexvalidationexpression
	where
	    (moduledefid = _moduledefid OR featureguid = _featureguid)
	  and
	    settingname = _settingname;   
end if;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) RETURNS integer
    AS $_$
declare
	_moduledefid alias for $1;
	_settingname alias for $2;
	_settingvalue alias for $3;
	_controltype alias for $4;
	_regexvalidationexpression alias for $5;
	_featureguid alias for $6;
	_resourcefile alias for $7;
	_controlsrc alias for $8;
	_helpkey alias for $9;
	_sortorder alias for $10;
	t_found int4;
	_rowcount int4;
begin

select into t_found 1 from 
        mp_moduledefinitionsettings 
    where 
        (moduledefid = _moduledefid OR featureguid = _featureguid)
      and
        settingname = _settingname limit 1;

if not found then
	insert into mp_moduledefinitionsettings (
	    featureguid,
	    moduledefid,
	    resourcefile,
	    settingname,
	    settingvalue,
	    controltype,
	    regexvalidationexpression,
	    controlsrc,
	    helpkey,
	    sortorder
	    
	) 
	values (
	    _featureguid,
	    _moduledefid,
	    _resourcefile,
	    _settingname,
	    _settingvalue,
	    _controltype,
	    _regexvalidationexpression,
	    _controlsrc,
	    _helpkey,
	    _sortorder
	);
else
	update
	    mp_moduledefinitionsettings
	set
	    resourcefile = _resourcefile,
	    settingvalue = _settingvalue,
	    controltype = _controltype,
	    regexvalidationexpression = _regexvalidationexpression,
	    controlsrc = _controlsrc,
	    helpkey = _helpkey,
	    sortorder = _sortorder
	where
	    (moduledefid = _moduledefid OR featureguid = _featureguid)
	  and
	    settingname = _settingname;   
end if;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) RETURNS integer
    AS $_$
declare
	_id alias for $1;
	_moduledefid alias for $2;
	_settingname alias for $3;
	_settingvalue alias for $4;
	_controltype alias for $5;
	_regexvalidationexpression alias for $6;
	_resourcefile alias for $7;
	_rowcount int4;
begin


	update
	    mp_moduledefinitionsettings
	set
	    resourcefile = _resourcefile,
	    settingname = _settingname,
	    settingvalue = _settingvalue,
	    controltype = _controltype,
	    regexvalidationexpression = _regexvalidationexpression
	where
	    moduledefid = _moduledefid
	  and
	    id = _id;   

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) RETURNS integer
    AS $_$
declare
	_id alias for $1;
	_moduledefid alias for $2;
	_settingname alias for $3;
	_settingvalue alias for $4;
	_controltype alias for $5;
	_regexvalidationexpression alias for $6;
	_resourcefile alias for $7;
	_controlsrc alias for $8;
	_helpkey alias for $9;
	_sortorder alias for $10;
	_rowcount int4;
begin


	update
	    mp_moduledefinitionsettings
	set
	    resourcefile = _resourcefile,
	    settingname = _settingname,
	    settingvalue = _settingvalue,
	    controltype = _controltype,
	    regexvalidationexpression = _regexvalidationexpression,
	    controlsrc = _controlsrc,
	    helpkey = _helpkey,
	    sortorder = _sortorder
	where
	    moduledefid = _moduledefid
	  and
	    id = _id;   

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) OWNER TO test;

--
-- Name: mp_modules_countnonadmin(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_countnonadmin(integer) RETURNS integer
    AS $_$
select	cast(count(m.*) as int4)
from		mp_modules m
join		mp_moduledefinitions md
on		m.moduledefid = md.moduledefid
where	siteid = $1 AND md.isadmin = false; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_countnonadmin(integer) OWNER TO test;

--
-- Name: mp_modules_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_delete(integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_rowcount int4;
begin

delete from  mp_pagemodules
where moduleid = _moduleid;

delete from  mp_modules
where moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_delete(integer) OWNER TO test;

--
-- Name: mp_modules_deleteinstance(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_deleteinstance(integer, integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_pageid alias for $2;
	_rowcount int4;
begin

	delete from  mp_pagemodules
where moduleid = _moduleid and pageid = _pageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_deleteinstance(integer, integer) OWNER TO test;

--
-- Name: mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) RETURNS integer
    AS $_$
insert into 	mp_modules 
(
				siteid,
				moduledefid,
				moduletitle,
				authorizededitroles,
				cachetime,
				showtitle,
				availableformypage,
				createdbyuserid,
				createddate,
				allowmultipleinstancesonmypage,
				icon,
				guid,
				featureguid,
				siteguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13,
				$14
				
);
select cast(currval('mp_modules_moduleid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) OWNER TO test;

--
-- Name: mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) RETURNS integer
    AS $_$
insert into 	mp_modules 
(
				siteid,
				moduledefid,
				moduletitle,
				authorizededitroles,
				cachetime,
				showtitle,
				availableformypage,
				createdbyuserid,
				createddate,
				allowmultipleinstancesonmypage,
				icon,
				guid,
				featureguid,
				siteguid,
				hidefromauth,
				hidefromunauth
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13,
				$14,
				$15,
				$16
				
);
select cast(currval('mp_modules_moduleid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) OWNER TO test;

--
-- Name: mp_modules_selectbypageid(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_selectbypageid(integer, timestamp without time zone) RETURNS SETOF mp_modules_selectbypageid_type
    AS $_$
select  		
			m.moduleid ,
			pm.pageid ,
			m.moduledefid ,
			pm.moduleorder ,
			pm.panename ,
			m.moduletitle ,
			m.authorizededitroles ,
			m.cachetime ,
			m.showtitle ,
			m.hidefromauth,
			m.hidefromunauth,
			md.controlsrc,
			m.edituserid,
			m.availableformypage,
			m.createdbyuserid,
			m.createddate,
			pm.publishbegindate,
			pm.publishenddate,
			m.guid,
			m.featureguid,
			m.siteguid,
         		m.edituserguid
    
from
    			mp_modules m
  
inner join
    			mp_moduledefinitions md
on 			m.moduledefid = md.moduledefid

inner join		mp_pagemodules pm
on			pm.moduleid = m.moduleid
    
where   
    			pm.pageid = $1
    			AND pm.publishbegindate < $2
    			AND (pm.publishenddate IS NULL OR pm.publishenddate > $2)
		
    
order by
    			pm.moduleorder; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_selectbypageid(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_modules_selectformypage(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_selectformypage(integer) RETURNS SETOF mp_modules_selectformypage_type
    AS $_$
select  		
			m.moduleid ,
			m.siteid ,
			m.moduledefid ,
			m.moduletitle ,
			m.allowmultipleinstancesonmypage,
			m.icon as moduleicon,
			md.icon as featureicon,
			md.featurename
    
from
    			mp_modules m
  
inner join
    			mp_moduledefinitions md
on 			m.moduledefid = md.moduledefid
    
where   
    			m.siteid = $1 and m.availableformypage = true
		
    
order by
    			m.moduletitle; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_selectformypage(integer) OWNER TO test;

--
-- Name: mp_modules_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_selectone(integer) RETURNS SETOF mp_modules_selectone_type
    AS $_$
select
         moduleid,
	 siteid,
	 moduledefid,
	 moduletitle,
	 authorizededitroles,
	 cachetime,
	 showtitle,
	 hidefromauth,
	 hidefromunauth,
	 edituserid,
	 availableformypage,
	 allowmultipleinstancesonmypage,
	 icon,
	 createdbyuserid,
	 createddate,
	 countofuseonmypage,
	 guid,
	 featureguid,
	 siteguid,
        edituserguid
		
from
		mp_modules
		
where
		moduleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_selectone(integer) OWNER TO test;

--
-- Name: mp_modules_selectonebypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_selectonebypage(integer, integer) RETURNS SETOF mp_modules_selectonebypage_type
    AS $_$
select
         m.moduleid ,
         m.siteid,
         pm.pageid ,
         m.moduledefid ,
         pm.moduleorder ,
         pm.panename ,
         m.moduletitle ,
         m.authorizededitroles ,
         m.cachetime ,
         m.showtitle ,
         m.hidefromauth,
         m.hidefromunauth,
         m.edituserid,
         m.availableformypage,
         m.allowmultipleinstancesonmypage,
         m.countofuseonmypage,
         m.icon,
         m.createdbyuserid,
         m.createddate,
         pm.publishbegindate,
         pm.publishenddate,
         md.controlsrc,
         m.guid,
         m.featureguid,
         m.siteguid,
         m.edituserguid
		
from
		mp_modules m
join		mp_moduledefinitions md
on		md.moduledefid = m.moduledefid

join		mp_pagemodules pm
on		m.moduleid = pm.moduleid
		
where		
		pm.moduleid = $1 AND pm.pageid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_selectonebypage(integer, integer) OWNER TO test;

--
-- Name: mp_modules_selectpage(integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_selectpage(integer, integer, integer, boolean, boolean) RETURNS SETOF mp_modules_selectpage_type
    AS $_$
declare
	_siteid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_sortbymoduletype alias for $4;
	_sortbyauthor alias for $5;
	 _pagelowerbound int;
	 _pageupperbound int;
	 _totalrows int;
	 _remainder int;
	_rec mp_modules_selectpage_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;
_pageupperbound := _pagelowerbound + _pagesize + 1;

if _sortbymoduletype = true then
for _rec in
	select 
		m.moduleid ,
		m.moduletitle ,
		md.featurename ,
		md.resourcefile,
		md.controlsrc ,
		m.authorizededitroles ,
		u.name as createdby,
		m.createddate 
		

	from 		mp_modules m
	join		mp_moduledefinitions md
	on		m.moduledefid = md.moduledefid
	left outer join mp_users u
	on	m.createdbyuserid = u.userid
	where m.siteid = $1 and md.isadmin = false
	order by 	md.featurename, m.moduletitle
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
else
	if _sortbyauthor = true then
	for _rec in
		select 
			m.moduleid ,
			m.moduletitle ,
			md.featurename ,
			md.resourcefile,
			md.controlsrc ,
			m.authorizededitroles ,
			u.name as createdby,
			m.createddate 
			
	
		from 		mp_modules m
		join		mp_moduledefinitions md
		on		m.moduledefid = md.moduledefid
		left outer join mp_users u
		on	m.createdbyuserid = u.userid
		where m.siteid = $1 and md.isadmin = false
		order by 	u.name, m.moduletitle
		limit 	_pagesize
		offset 	_pagelowerbound
	loop
		return next _rec;
	end loop;
	else
		
		for _rec in
			select 
				m.moduleid ,
				m.moduletitle ,
				md.featurename ,
				md.resourcefile,
				md.controlsrc ,
				m.authorizededitroles ,
				u.name as createdby,
				m.createddate 
				
		
			from 		mp_modules m
			join		mp_moduledefinitions md
			on		m.moduledefid = md.moduledefid
			left outer join mp_users u
			on	m.createdbyuserid = u.userid
			where m.siteid = $1 and md.isadmin = false
			order by 	m.moduletitle, md.featurename
			limit 	_pagesize
			offset 	_pagelowerbound
		loop
			return next _rec;
		end loop;
		
	end if;
end if;

return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_selectpage(integer, integer, integer, boolean, boolean) OWNER TO test;

--
-- Name: mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_moduledefid alias for $2;
	_moduletitle alias for $3;
	_authorizededitroles alias for $4;
	_cachetime alias for $5;
	_showtitle alias for $6;
	_edituserid alias for $7;
	_availableformypage alias for $8;
	_allowmultipleinstancesonmypage alias for $9;
	_icon alias for $10;
	_rowcount int4;
begin

update 		mp_modules 
set
			
			moduledefid = _moduledefid,
			moduletitle = _moduletitle,
			authorizededitroles = _authorizededitroles,
			cachetime = _cachetime,
			showtitle = _showtitle,
			edituserid = _edituserid,
			availableformypage = _availableformypage,
			allowmultipleinstancesonmypage = _allowmultipleinstancesonmypage,
			icon = _icon
			
where
			moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) OWNER TO test;

--
-- Name: mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_moduledefid alias for $2;
	_moduletitle alias for $3;
	_authorizededitroles alias for $4;
	_cachetime alias for $5;
	_showtitle alias for $6;
	_edituserid alias for $7;
	_availableformypage alias for $8;
	_allowmultipleinstancesonmypage alias for $9;
	_icon alias for $10;
	_hidefromauth alias for $11;
	_hidefromunauth alias for $12;
	_rowcount int4;
begin

update 		mp_modules 
set
			
			moduledefid = _moduledefid,
			moduletitle = _moduletitle,
			authorizededitroles = _authorizededitroles,
			cachetime = _cachetime,
			showtitle = _showtitle,
			edituserid = _edituserid,
			availableformypage = _availableformypage,
			allowmultipleinstancesonmypage = _allowmultipleinstancesonmypage,
			icon = _icon,
			hidefromauth = _hidefromauth,
			hidefromunauth = _hidefromunauth
			
where
			moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) OWNER TO test;

--
-- Name: mp_modules_updatecountofuseonmypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_updatecountofuseonmypage(integer, integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_increment alias for $2;
	_rowcount int4;
begin

update
    mp_modules
set
    countofuseonmypage = countofuseonmypage + _increment
where
    moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_updatecountofuseonmypage(integer, integer) OWNER TO test;

--
-- Name: mp_modules_updatemoduleorder(integer, integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_updatemoduleorder(integer, integer, integer, character varying) RETURNS integer
    AS $_$
declare
	_pageid alias for $1;
	_moduleid alias for $2;
	_moduleorder alias for $3;
	_panename alias for $4;
	_rowcount int4;
begin

update
    mp_pagemodules
set
    moduleorder = _moduleorder,
    panename    = _panename
where
    moduleid = _moduleid and pageid = _pageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_updatemoduleorder(integer, integer, integer, character varying) OWNER TO test;

--
-- Name: mp_modules_updatepage(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modules_updatepage(integer, integer, integer) RETURNS integer
    AS $_$
update 	mp_pagemodules 
set
				
	pageid = $2,
	pageguid = (SELECT pageguid FROM mp_pages WHERE pageid = $2 LIMIT 1)
				
where moduleid = $3 and pageid = $1;
--GET DIAGNOSTICS _rowcount = ROW_COUNT;
--return _rowcount;
select 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modules_updatepage(integer, integer, integer) OWNER TO test;

--
-- Name: mp_modulesettings_createdefaultsettings(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_createdefaultsettings(integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_rowcount int4;
begin

insert into 	mp_modulesettings
(
			moduleid,
			settingname,
			settingvalue,
			controltype,
			regexvalidationexpression
)
select		m.moduleid,
			ds.settingname,
			ds.settingvalue,
			ds.controltype,
			ds.regexvalidationexpression
from			mp_modules m
join			mp_moduledefinitionsettings ds
on			ds.moduledefid = m.moduledefid
where		m.moduleid = _moduleid
order by		ds.id; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_createdefaultsettings(integer) OWNER TO test;

--
-- Name: mp_modulesettings_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_delete(integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_rowcount int4;
begin

	delete from  mp_modulesettings
where	moduleid = _moduleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_delete(integer) OWNER TO test;

--
-- Name: mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_settingname alias for $2;
	_settingvalue alias for $3;
	_controltype alias for $4;
	_regexvalidationexpression alias for $5;
	_settingguid alias for $6;
	_moduleguid alias for $7;
	_rowcount int4;
begin


insert into 	mp_modulesettings
(				
                moduleid,
                settingname,
                settingvalue,
                controltype,
                regexvalidationexpression,
                settingguid,
                moduleguid
) 
values 
(				
                _moduleid, --:moduleid
                _settingname, --:settingname
                _settingvalue, --:settingvalue
                _controltype, --:controltype
                _regexvalidationexpression, --:regexvalidationexpression
                _settingguid,
                _moduleguid
);

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) OWNER TO test;

--
-- Name: mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_settingname alias for $2;
	_settingvalue alias for $3;
	_controltype alias for $4;
	_regexvalidationexpression alias for $5;
	_settingguid alias for $6;
	_moduleguid alias for $7;
	_controlsrc alias for $8;
	_helpkey alias for $9;
	_sortorder alias for $10;
	_rowcount int4;
begin


insert into 	mp_modulesettings
(				
                moduleid,
                settingname,
                settingvalue,
                controltype,
                regexvalidationexpression,
                settingguid,
                moduleguid,
                controlsrc,
                helpkey,
                sortorder
) 
values 
(				
                _moduleid, --:moduleid
                _settingname, --:settingname
                _settingvalue, --:settingvalue
                _controltype, --:controltype
                _regexvalidationexpression, --:regexvalidationexpression
                _settingguid,
                _moduleguid,
                _controlsrc,
                _helpkey,
                _sortorder
);

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) OWNER TO test;

--
-- Name: mp_modulesettings_selectsettings(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_selectsettings(integer) RETURNS SETOF mp_modulesettings_select_type
    AS $_$
select distinct	ms.id,
	ms.moduleid,
	ms.settingname,
	ms.settingvalue,
	ms.controltype,
	ms.controlsrc,
	ms.helpkey,
	ms.sortorder,
	ms.regexvalidationexpression,
	mds.featureguid,
	mds.resourcefile
		
from		mp_modulesettings ms

join		mp_modules m
on			ms.moduleid = m.moduleid

join		mp_moduledefinitionsettings mds
on		m.moduledefid = mds.moduledefid
		AND mds.settingname = ms.settingname

where	m.moduleid = $1
order by ms.sortorder
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_selectsettings(integer) OWNER TO test;

--
-- Name: mp_modulesettings_update(integer, character varying, character varying, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_modulesettings_update(integer, character varying, character varying, character, character) RETURNS integer
    AS $_$
declare
	_moduleid alias for $1;
	_settingname alias for $2;
	_settingvalue alias for $3;
	_settingguid alias for $4;
	_moduleguid alias for $5;
	t_found int4;
	_rowcount int4;
begin

select into t_found 1 from 
        mp_modulesettings 
    where 
        moduleid = _moduleid
      and
        settingname = _settingname limit 1;

if not found then
	insert into mp_modulesettings (
	    moduleguid,
	    settingguid,
	    moduleid,
	    settingname,
	    settingvalue
	) 
	values (
	    _moduleguid,
	    _settingguid,
	    _moduleid,
	    _settingname,
	    _settingvalue
	);
else
	update
	    mp_modulesettings
	set
	    settingvalue = _settingvalue
	where
	    moduleid = _moduleid
	  and
	    settingname = _settingname;   
end if;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_modulesettings_update(integer, character varying, character varying, character, character) OWNER TO test;

--
-- Name: mp_mp_galleryimages_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_mp_galleryimages_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from  mp_galleryimages
where	itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_mp_galleryimages_delete(integer) OWNER TO test;

--
-- Name: mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) RETURNS integer
    AS $_$
insert into 			mp_galleryimages 
(
				moduleid,
				displayorder,
				caption,
				description,
				metadataxml,
				imagefile,
				webimagefile,
				thumbnailfile,
				uploaddate,
				uploaduser,
				itemguid,
				moduleguid,
				userguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13
				
);
select cast(currval('mp_galleryimages_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) OWNER TO test;

--
-- Name: mp_mp_galleryimages_selectall(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_mp_galleryimages_selectall() RETURNS SETOF mp_mp_galleryimages_selectall_type
    AS $$
select
		itemid,
		moduleid,
		displayorder,
		caption,
		description,
		imagefile,
		webimagefile,
		thumbnailfile,
		uploaddate,
		uploaduser
		
from
		mp_galleryimages; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_mp_galleryimages_selectall() OWNER TO test;

--
-- Name: mp_mp_galleryimages_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_mp_galleryimages_selectone(integer) RETURNS SETOF mp_mp_galleryimages_selectone_type
    AS $_$
select
		itemid,
		moduleid,
		displayorder,
		caption,
		description,
		metadataxml,
		imagefile,
		webimagefile,
		thumbnailfile,
		uploaddate,
		uploaduser
		
from
		mp_galleryimages
		
where
		itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_mp_galleryimages_selectone(integer) OWNER TO test;

--
-- Name: mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_displayorder alias for $3;
	_caption alias for $4;
	_description alias for $5;
	_metadataxml alias for $6;
	_imagefile alias for $7;
	_webimagefile alias for $8;
	_thumbnailfile alias for $9;
	_uploaddate alias for $10;
	_uploaduser alias for $11;
	_rowcount int4;
begin

update 		mp_galleryimages 
set
			moduleid = _moduleid,
			displayorder = _displayorder,
			caption = _caption,
			description = _description,
			metadataxml = _metadataxml,
			imagefile = _imagefile,
			webimagefile = _webimagefile,
			thumbnailfile = _thumbnailfile,
			uploaddate = _uploaddate,
			uploaduser = _uploaduser
			
where
			itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) OWNER TO test;

--
-- Name: mp_pagemodule_exists(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pagemodule_exists(integer, integer) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_pagemodules
where	moduleid = $1 AND pageid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pagemodule_exists(integer, integer) OWNER TO test;

--
-- Name: mp_pagemodule_selectbymodule(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pagemodule_selectbymodule(integer) RETURNS SETOF mp_pagemodules
    AS $_$
select	mp.*
from		mp_pagemodules mp
where	mp.moduleid = $1
order by pageid; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pagemodule_selectbymodule(integer) OWNER TO test;

--
-- Name: mp_pagemodule_selectbypage(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pagemodule_selectbypage(integer) RETURNS SETOF mp_pagemodules
    AS $_$
select	mp.*
from		mp_pagemodules mp
where	mp.pageid = $1
order by pageid; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pagemodule_selectbypage(integer) OWNER TO test;

--
-- Name: mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) RETURNS integer
    AS $_$
insert into mp_pagemodules(
pageid, 
moduleid, 
pageguid, 
moduleguid, 
moduleorder, 
panename, 
publishbegindate, 
publishenddate
)
values (
$1, 
$2, 
(SELECT pageguid FROM mp_pages WHERE pageid = $1 LIMIT 1),
(SELECT guid FROM mp_modules WHERE moduleid = $2 LIMIT 1),
$3, 
$4, 
$5, 
$6);
--GET DIAGNOSTICS rowcount = ROW_COUNT;
select 1;
 $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) OWNER TO test;

--
-- Name: mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) RETURNS integer
    AS $_$
update mp_pagemodules 
set
moduleorder = $3,
panename = $4,
publishbegindate = $5,
publishenddate = $6
where moduleid = $2 and pageid = $1;
--GET DIAGNOSTICS _rowcount = ROW_COUNT;
--return _rowcount;
select 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) OWNER TO test;

--
-- Name: mp_pages_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_delete(integer) RETURNS integer
    AS $_$
declare
	_pageid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_pages
where
    pageid = _pageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_delete(integer) OWNER TO test;

--
-- Name: mp_pages_getauthroles(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_getauthroles(integer, integer) RETURNS SETOF mp_pages_getauthroles_type
    AS $_$
select  
	mp_pages.authorizedroles as accessroles ,
	mp_modules.authorizededitroles as editroles 
    
from    
    mp_modules
    inner join 
    mp_pagemodules on mp_pagemodules.moduleid = mp_modules.moduleid
  inner join
    mp_pages on mp_pagemodules.pageid = mp_pages.pageid
    
where   
    mp_modules.moduleid = $2
  and
    mp_pages.siteid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_getauthroles(integer, integer) OWNER TO test;

--
-- Name: mp_pages_getbreadcrumbs(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_getbreadcrumbs(integer) RETURNS SETOF mp_pages_getbreadcrumbs_type
    AS $_$
select		
			p.pageid,
			p.pagename,
			p.parentid as parent1id,
			p1.pagename as parent1name,
			coalesce(p1.parentid,-1) as parent2id,
			p2.pagename as parent2name,
			coalesce(p2.parentid,-1) as parent3id,
			p3.pagename as parent3name,
			coalesce(p3.parentid,-1) as parent4id,
			p4.pagename as parent4name,
			coalesce(p4.parentid,-1) as parent5id,
			p5.pagename as parent5name,
			coalesce(p5.parentid,-1) as parent6id,
			p6.pagename as parent6name,
			coalesce(p6.parentid,-1) as parent7id,
			p7.pagename as parent7name,
			coalesce(p7.parentid,-1) as parent8id,
			p8.pagename as parent8name,
			coalesce(p8.parentid,-1) as parent9id,
			p9.pagename as parent9name,
			coalesce(p9.parentid,-1) as parent10id,
			p10.pagename as parent10name,
			coalesce(p10.parentid,-1) as parent11id,
			p11.pagename as parent11name,
			coalesce(p11.parentid,-1) as parent12id,
			p12.pagename as parent12name
from			mp_pages p
left outer join	mp_pages p1
on			p1.pageid = p.parentid
left outer join	mp_pages p2
on			p2.pageid = p1.parentid
left outer join	mp_pages p3
on			p3.pageid = p2.parentid
left outer join	mp_pages p4
on			p4.pageid = p3.parentid
left outer join	mp_pages p5
on			p5.pageid = p4.parentid
left outer join	mp_pages p6
on			p6.pageid = p5.parentid
left outer join	mp_pages p7
on			p7.pageid = p6.parentid
left outer join	mp_pages p8
on			p8.pageid = p7.parentid
left outer join	mp_pages p9
on			p9.pageid = p8.parentid
left outer join	mp_pages p10
on			p10.pageid = p9.parentid
left outer join	mp_pages p11
on			p11.pageid = p10.parentid
left outer join	mp_pages p12
on			p12.pageid = p11.parentid
where 		p.pageid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_getbreadcrumbs(integer) OWNER TO test;

--
-- Name: mp_pages_getnextpageorder(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_getnextpageorder(integer, integer) RETURNS integer
    AS $_$
select	coalesce(max(pageorder), -1) + 2
from		mp_pages
where siteid = $1 and parentid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_getnextpageorder(integer, integer) OWNER TO test;

--
-- Name: mp_pages_getpagelist(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_getpagelist(integer) RETURNS SETOF mp_pages
    AS $_$
select  
    		*
    
from    
    		mp_pages
    
where   
    		siteid = $1 
order by	parentid, pageorder, pagename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_getpagelist(integer) OWNER TO test;

--
-- Name: mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) RETURNS integer
    AS $_$
insert into 		mp_pages
(
    			siteid,
			parentid,
    			pagename,
    			pageorder,
			authorizedroles,
			editroles,
			createchildpageroles,
    			requiressl,
    			showbreadcrumbs,
    			showchildbreadcrumbs,
    			pagekeywords,
			pagedescription,
			pageencoding,
			additionalmetatags,
			useurl,
			url,
			openinnewwindow,
			showchildpagemenu,
			hidemainmenu,
			skin,
			includeinmenu,
			menuimage,
			pagetitle,
			allowbrowsercache,
			changefrequency,
			sitemappriority,
			lastmodifiedutc,
			pageguid,
			parentguid,
			hideafterlogin,
			siteguid,
			compiledmeta,
			compiledmetautc
)
values
(
    			$1,
			$2,
    			$3,
    			$4,
			$5,
    			$6,
    			$7,
			$8,
			$9,
			$10,
			$11,
			$12,
			$13,
			$14,
			$15,
			$16,
			$17,
			$18,
			$19,
			$20,
			$21,
			$22,
			$23,
			$24,
			$25,
			$26,
			$27,
			$28,
			$29,
			$30,
			$31,
			$32,
			$33
);
select  cast(currval('mp_pages_pageid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) OWNER TO test;

--
-- Name: mp_pages_selectchildpages(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selectchildpages(integer) RETURNS SETOF mp_pages
    AS $_$
select	
		*
		
		
from		mp_pages
where	parentid = $1
order by pageorder; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selectchildpages(integer) OWNER TO test;

--
-- Name: mp_pages_selectlist(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selectlist(integer) RETURNS SETOF mp_pages
    AS $_$
select  	*
    				
    
from    
    				mp_pages
    
where   
    				siteid = $1
order by			parentid,  pagename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selectlist(integer) OWNER TO test;

--
-- Name: mp_pages_selectone(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selectone(integer, integer) RETURNS SETOF mp_pages
    AS $_$
select		*
		
from		mp_pages

where siteid = $1 and	(pageid = $2 or $2 = -1)
order by parentid, pageorder
limit 1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selectone(integer, integer) OWNER TO test;

--
-- Name: mp_pages_selectonebyguid(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selectonebyguid(character) RETURNS SETOF mp_pages
    AS $_$
select		*
		
from		mp_pages

where pageguid = $1 

limit 1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selectonebyguid(character) OWNER TO test;

--
-- Name: mp_pages_selecttree(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selecttree(integer) RETURNS SETOF mp_pages_selecttree_type
    AS $_$
declare
	_siteid alias for $1;
	_lastlevel smallint;
	_rec mp_pages_selecttree_type%ROWTYPE;
	_rowcount int4;

begin

perform 1 from pg_class where
	  relname = 't_pagetree' and pg_table_is_visible(oid);
	if not found then
		create temp table t_pagetree
		(
			pageid int,
			pagename varchar (100),
			pagetitle varchar (255),
			parentid int,
			pageorder int,
			nestlevel int,
			treeorder varchar (1000)
		);
	end if;
  
_lastlevel := 0;

-- first, the parent levels
insert into     	t_pagetree
(
	pageid, 
	pagename, 
	pagetitle,
	parentid, 
	pageorder, 
	nestlevel, 
	treeorder
) 
select  		pageid,
			pagename,
			pagetitle,
			parentid,
			pageorder,
       			0,
        		(100000000 + pageorder)::text::varchar(20)
from   		mp_pages
where   		parentid is null  or parentid = -1
			and siteid = _siteid
order by 		pageorder;

get diagnostics _rowcount := row_count;

-- next, the children levels
while _rowcount > 0 loop

  _lastlevel := _lastlevel + 1;
  insert into     	t_pagetree
	(
		pageid, 
		pagename, 
		pagetitle,
		parentid, 
		pageorder, 
		nestlevel, 
		treeorder
	) 
                
    select  	p.pageid,
		repeat('-', _lastlevel *2) || p.pagename,
		p.pagetitle,
		p.parentid,
		p.pageorder,
		_lastlevel,
		cast(t.treeorder as varchar) || '.' || (100000000 + p.pageorder)::text::varchar
      from    	mp_pages p
 
      join 		t_pagetree t
      on 		p.parentid= t.pageid
      where   	exists (select 'x' from t_pagetree where t_pagetree.pageid = p.parentid and nestlevel = _lastlevel - 1)
                 	and siteid = _siteid
      order by 	t.pageorder;

      get diagnostics _rowcount := row_count;

end loop;

--get the orphans
  insert into     	t_pagetree
		(
		pageid, 
		pagename, 
		pagetitle,
		parentid, 
		pageorder, 
		nestlevel, 
		treeorder
		) 
              
   select  	p.pageid,
		'(orphan)' || p.pagename,
		p.pagetitle,
		p.parentid,
		p.pageorder,
		999999999,
		'999999999'
              
    from    	mp_pages p 
    where   	(select 1 from t_pagetree where pageid = p.pageid limit 1 ) is null
    and siteid  = _siteid;

-- reorder the pages by using a 2nd temp table and an identity field to keep them straight.

perform 1 from pg_class where
	  relname = 't_pages_seq' and pg_table_is_visible(oid);
	if not found then
		create temp sequence t_pages_seq
		    start -1
		    increment 2
		    maxvalue 9223372036854775807
		    minvalue -1
		    cache 1;
	end if;

perform setval('t_pages_seq', -1);

perform 1 from pg_class where
	  relname = 't_pages' and pg_table_is_visible(oid);
	if not found then
		create temp table t_pages
		(
			ord int default nextval('t_pages_seq') ,
			pageid varchar (100)
		);
	end if;

delete from t_pages;

insert into	t_pages (pageid)
select 		cast(pageid as varchar) as pageid 
from 		t_pagetree
order by 	nestlevel, treeorder;


-- change the taborder in the sirt temp table so that tabs are ordered in sequence
-- update 	t_pagetree
-- set 		pageorder = (select ord from t_pages where t_pages.pageid::text::int = t_pagetree.pageid);

--return temporary table

for _rec in
	select 	t.pageid, 
		t.parentid, 
		t.pagename, 
		t.pagetitle,
		t.pageorder, 
		t.nestlevel,
		p.authorizedroles,
		p.editroles,
		p.createchildpageroles
		
	from 		t_pagetree t
	join	mp_pages p
	on	t.pageid = p.pageid
	order by 	t.treeorder
loop
	return next _rec;
end loop;
delete from t_pages;
delete from t_pagetree;   
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selecttree(integer) OWNER TO test;

--
-- Name: mp_pages_selecttreeformodule(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_selecttreeformodule(integer, integer) RETURNS SETOF mp_pages_selecttreeformodule_type
    AS $_$
declare
	_siteid alias for $1;
	_moduleid alias for $2;
	_lastlevel smallint;
	_rec mp_pages_selecttreeformodule_type%ROWTYPE;
	_rowcount int4;

begin

perform 1 from pg_class where
	  relname = 't_pagetree' and pg_table_is_visible(oid);
	if not found then
		create temp table t_pagetree
		(
			pageid int,
			pagename varchar (100),
			parentid int,
			pageorder int,
			nestlevel int,
			treeorder varchar (1000)
		);
	end if;
  
_lastlevel := 0;

-- first, the parent levels
insert into     	t_pagetree
(
	pageid, 
	pagename, 
	parentid, 
	pageorder, 
	nestlevel, 
	treeorder
) 
select  		pageid,
			pagename,
			parentid,
			pageorder,
       			0,
        		(100000000 + pageorder)::text::varchar(20)
from   		mp_pages
where   		parentid is null  or parentid = -1
			and siteid = _siteid
order by 		pageorder;

get diagnostics _rowcount := row_count;

-- next, the children levels
while _rowcount > 0 loop

  _lastlevel := _lastlevel + 1;
  insert into     	t_pagetree
	(
		pageid, 
		pagename, 
		parentid, 
		pageorder, 
		nestlevel, 
		treeorder
	) 
                
    select  	p.pageid,
		repeat('-', _lastlevel *2) || p.pagename,
		p.parentid,
		p.pageorder,
		_lastlevel,
		cast(t.treeorder as varchar) || '.' || (100000000 + p.pageorder)::text::varchar
      from    	mp_pages p
 
      join 		t_pagetree t
      on 		p.parentid= t.pageid
      where   	exists (select 'x' from t_pagetree where t_pagetree.pageid = p.parentid and nestlevel = _lastlevel - 1)
                 	and siteid = _siteid
      order by 	t.pageorder;

      get diagnostics _rowcount := row_count;

end loop;

--get the orphans
  insert into     	t_pagetree
		(
		pageid, 
		pagename, 
		parentid, 
		pageorder, 
		nestlevel, 
		treeorder
		) 
              
   select  	p.pageid,
		'(orphan)' || p.pagename,
		p.parentid,
		p.pageorder,
		999999999,
		'999999999'
              
    from    	mp_pages p 
    where   	(select 1 from t_pagetree where pageid = p.pageid limit 1 ) is null
    and siteid  = _siteid;

-- reorder the pages by using a 2nd temp table and an identity field to keep them straight.

perform 1 from pg_class where
	  relname = 't_pages_seq' and pg_table_is_visible(oid);
	if not found then
		create temp sequence t_pages_seq
		    start -1
		    increment 2
		    maxvalue 9223372036854775807
		    minvalue -1
		    cache 1;
	end if;

perform setval('t_pages_seq', -1);

perform 1 from pg_class where
	  relname = 't_pages' and pg_table_is_visible(oid);
	if not found then
		create temp table t_pages
		(
			ord int default nextval('t_pages_seq') ,
			pageid varchar (100)
		);
	end if;

delete from t_pages;

insert into	t_pages (pageid)
select 		cast(pageid as varchar) as pageid 
from 		t_pagetree
order by 	nestlevel, treeorder;


-- change the taborder in the sirt temp table so that tabs are ordered in sequence
-- update 	t_pagetree
-- set 		pageorder = (select ord from t_pages where t_pages.pageid::text::int = t_pagetree.pageid);

--return temporary table

for _rec in
	select 	t.pageid, 
		t.parentid, 
		t.pagename, 
		t.pageorder, 
		t.nestlevel,
		p.authorizedroles,
		p.editroles,
		p.createchildpageroles,
		coalesce(pm.moduleid,-1) as ispublished,
		pm.panename,
		pm.moduleorder,
		pm.publishbegindate,
		pm.publishenddate
		
	from 		t_pagetree t
	join	mp_pages p
	on	t.pageid = p.pageid
	left outer join mp_pagemodules pm
	on pm.pageid = p.pageid AND pm.moduleid = _moduleid
	
	order by 	t.treeorder
loop
	return next _rec;
end loop;
delete from t_pages;
delete from t_pagetree;   
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_selecttreeformodule(integer, integer) OWNER TO test;

--
-- Name: mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_pageid alias for $2;
	_parentid alias for $3;
	_pageorder alias for $4;
	_pagename alias for $5;
	_authorizedroles alias for $6;
	_editroles alias for $7;
	_createchildpageroles alias for $8;
	_requiressl alias for $9;
	_showbreadcrumbs alias for $10;
	_showchildbreadcrumbs alias for $11;
	_pagekeywords alias for $12;
	_pagedescription alias for $13;
	_pageencoding alias for $14;
	_additionalmetatags alias for $15;
	_useurl alias for $16;
	_url alias for $17;
	_openinnewwindow alias for $18;
	_showchildpagemenu alias for $19;
	_hidemainmenu alias for $20;
	_skin alias for $21;
	_includeinmenu alias for $22;
	_menuimage alias for $23;
	_pagetitle alias for $24;
	_allowbrowsercache alias for $25;
	_changefrequency alias for $26;
	_sitemappriority alias for $27;
	_lastmodifiedutc alias for $28;
	_parentguid alias for $29;
	_hideafterlogin alias for $30;
	_compiledmeta alias for $31;
	_compiledmetautc alias for $32;
	t_found int4;
	_rowcount int4;
begin

	update
	    mp_pages
	set
		parentid = _parentid,
		pageorder = _pageorder,
		pagename = _pagename,
		pagetitle = _pagetitle,
		authorizedroles = _authorizedroles,
		editroles = _editroles,
		createchildpageroles = _createchildpageroles,
		requiressl = _requiressl,
		allowbrowsercache = _allowbrowsercache,
		showbreadcrumbs = _showbreadcrumbs,
		showchildbreadcrumbs = _showchildbreadcrumbs,
		pagekeywords = _pagekeywords,
		pagedescription = _pagedescription,
		pageencoding = _pageencoding,
		additionalmetatags = _additionalmetatags,
		useurl = _useurl,
		url = _url,
		openinnewwindow = _openinnewwindow,
		showchildpagemenu = _showchildpagemenu,
		hidemainmenu = _hidemainmenu,
		skin =_skin,
		includeinmenu = _includeinmenu,
		menuimage = _menuimage,
		changefrequency = _changefrequency,
		sitemappriority = _sitemappriority,
		lastmodifiedutc = _lastmodifiedutc,
		parentguid = _parentguid,
		hideafterlogin = _hideafterlogin,
		compiledmeta = _compiledmeta,
		compiledmetautc = _compiledmetautc
	where
	    pageid = _pageid;   

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) OWNER TO test;

--
-- Name: mp_pages_updatepageorder(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_updatepageorder(integer, integer) RETURNS integer
    AS $_$
declare
	_pageid alias for $1;
	_pageorder alias for $2;
	_rowcount int4;
begin

update
    mp_pages
set
    pageorder = _pageorder
where
    pageid = _pageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_updatepageorder(integer, integer) OWNER TO test;

--
-- Name: mp_pages_updatetimestamp(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_pages_updatetimestamp(integer, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_pageid alias for $1;
	_lastmodifiedutc alias for $2;
	_rowcount int4;
begin

update
    mp_pages
set
    lastmodifiedutc = _lastmodifiedutc
where
    pageid = _pageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_pages_updatetimestamp(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_roles_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_delete(integer) RETURNS integer
    AS $_$
declare
	_roleid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_roles
where
    roleid = _roleid AND rolename <> 'Admins' 
    AND rolename <> 'Content Administrators' 
    AND rolename <> 'Authenticated Users'
    AND rolename <> 'Role Admins'; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_delete(integer) OWNER TO test;

--
-- Name: mp_roles_insert(integer, character varying, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_insert(integer, character varying, character, character) RETURNS integer
    AS $_$
insert into mp_roles
(
    siteid,
    rolename,
    displayname,
    siteguid,
    roleguid
    
)
values
(
    $1,
    $2,
    $2,
    $3,
    $4
);
select  cast(currval('mp_roles_roleid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_insert(integer, character varying, character, character) OWNER TO test;

--
-- Name: mp_roles_roleexists(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_roleexists(integer, character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_roles
where	siteid = $1 AND rolename = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_roleexists(integer, character varying) OWNER TO test;

--
-- Name: mp_roles_select2(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_select2(integer) RETURNS SETOF mp_roles
    AS $_$
select  
    *
    
from
    mp_roles
where   
    siteid = $1
order by roleid; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_select2(integer) OWNER TO test;

--
-- Name: mp_roles_selectbyname(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_selectbyname(integer, character varying) RETURNS SETOF mp_roles
    AS $_$
select
    *
from
    mp_roles
where
    siteid = $1 AND rolename = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_selectbyname(integer, character varying) OWNER TO test;

--
-- Name: mp_roles_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_selectone(integer) RETURNS SETOF mp_roles
    AS $_$
select
    *
from
    mp_roles
where
    roleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_selectone(integer) OWNER TO test;

--
-- Name: mp_roles_selectrolesuserisnotin(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_selectrolesuserisnotin(integer, integer) RETURNS SETOF mp_roles_select_type
    AS $_$
select  
    r.siteid,
    r.roleid,
    r.rolename,
    r.displayname
    
from
    mp_roles r
    
left outer join 
    mp_userroles  ur
    
on ur.roleid = r.roleid
and ur.userid = $2

where   
    r.siteid = $1
    and ur.userid is null
order by r.displayname
    ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_selectrolesuserisnotin(integer, integer) OWNER TO test;

--
-- Name: mp_roles_update(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_roles_update(integer, character varying) RETURNS integer
    AS $_$
declare
	_roleid alias for $1;
	_diplayname alias for $2;
	_rowcount int4;
begin

update
    mp_roles
set
    displayname = _diplayname
where
    roleid = _roleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_roles_update(integer, character varying) OWNER TO test;

--
-- Name: mp_rssfeeds_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_rssfeeds_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from  mp_rssfeeds
where	itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_rssfeeds_delete(integer) OWNER TO test;

--
-- Name: mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) RETURNS integer
    AS $_$
insert into 	mp_rssfeeds
(				
                moduleid,
                userid,
                author,
                url,
                rssurl,
                itemguid,
                moduleguid,
                userguid,
                createddate,
                lastmoduserguid,
                lastmodutc
) 
values 
(				
                $1, --:moduleid
                $2, --:userid
                $3, --:author
                $4, --:url
                $5, --:rssurl
                $6,
                $7,
                $8,
                $9,
                $8,
                $9
);
select cast(currval('mp_rssfeeds_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_rssfeeds_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_rssfeeds_select(integer) RETURNS SETOF mp_rssfeeds
    AS $_$

select
        *
from
        mp_rssfeeds
        
where
        moduleid = $1 ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_rssfeeds_select(integer) OWNER TO test;

--
-- Name: mp_rssfeeds_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_rssfeeds_select_one(integer) RETURNS SETOF mp_rssfeeds
    AS $_$

select
        *
from
        mp_rssfeeds
        
where
        itemid = $1 ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_rssfeeds_select_one(integer) OWNER TO test;

--
-- Name: mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_author alias for $3;
	_url alias for $4;
	_rssurl alias for $5;
	_lastmoduserguid alias for $6;
	_lastmodutc alias for $7;
	_rowcount int4;
begin
update 		mp_rssfeeds

set
            moduleid = _moduleid, --:moduleid
            author = _author, --:author
            url = _url, --:url
            rssurl = _rssurl, --:rssurl
            lastmoduserguid = _lastmoduserguid,
            lastmodutc = _lastmodutc
            
where
            itemid = _itemid ; --:itemid
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_schemascripthistory_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_delete(integer) RETURNS integer
    AS $_$
declare
            _id alias for $1;
			_rowcount int4;
begin
	delete from mp_schemascripthistory
	where id = _id;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_delete(integer) OWNER TO test;

--
-- Name: mp_schemascripthistory_exists(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_exists(character varying, character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_schemascripthistory
where	applicationid = $1 AND scriptfile = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_exists(character varying, character varying) OWNER TO test;

--
-- Name: mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) RETURNS integer
    AS $_$

insert into 	mp_schemascripthistory
(				
                applicationid,
                scriptfile,
                runtime,
                erroroccurred,
                errormessage,
                scriptbody
) 
values 
(				
                $1, --:applicationid
                $2, --:scriptfile
                $3, --:runtime
                $4, --:erroroccurred
                $5, --:errormessage
                $6 --:scriptbody
);
select cast(currval('mp_schemascripthistoryid_seq') as int4);$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) OWNER TO test;

--
-- Name: mp_schemascripthistory_select_byapp(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_select_byapp(character varying) RETURNS SETOF mp_schemascripthistory_select_one_type
    AS $_$

select
        id,
        applicationid,
        scriptfile,
        runtime,
        erroroccurred,
        errormessage,
        scriptbody
from
        mp_schemascripthistory
        
where
        applicationid = $1
        
        
order by id
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_select_byapp(character varying) OWNER TO test;

--
-- Name: mp_schemascripthistory_select_errorsbyapp(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_select_errorsbyapp(character varying) RETURNS SETOF mp_schemascripthistory_select_one_type
    AS $_$

select
        id,
        applicationid,
        scriptfile,
        runtime,
        erroroccurred,
        errormessage,
        scriptbody
from
        mp_schemascripthistory
        
where
        applicationid = $1
        and erroroccurred = true
        
order by id
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_select_errorsbyapp(character varying) OWNER TO test;

--
-- Name: mp_schemascripthistory_select_one(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemascripthistory_select_one(integer) RETURNS SETOF mp_schemascripthistory_select_one_type
    AS $_$

select
        id,
        applicationid,
        scriptfile,
        runtime,
        erroroccurred,
        errormessage,
        scriptbody
from
        mp_schemascripthistory
        
where
        id = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemascripthistory_select_one(integer) OWNER TO test;

--
-- Name: mp_schemaversion_delete(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemaversion_delete(character varying) RETURNS integer
    AS $_$
declare
            _applicationid alias for $1;
			_rowcount int4;
begin
	delete from mp_schemaversion
	where applicationid = _applicationid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemaversion_delete(character varying) OWNER TO test;

--
-- Name: mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) RETURNS integer
    AS $_$
declare
            _applicationid alias for $1;
            _applicationname alias for $2;
            _major alias for $3;
            _minor alias for $4;
            _build alias for $5;
            _revision alias for $6;
			_rowcount int4;
begin

insert into 	mp_schemaversion
(			
                applicationid,
                applicationname,
                major,
                minor,
                build,
                revision
) 
values 
(				
                _applicationid, 
                _applicationname, 
                _major, 
                _minor, 
                _build, 
                _revision 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) OWNER TO test;

--
-- Name: mp_schemaversion_select_all(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemaversion_select_all() RETURNS SETOF mp_schemaversion_select_all_type
    AS $$

select
        applicationid,
        applicationname,
        major,
        minor,
        build,
        revision
from
        mp_schemaversion
;$$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemaversion_select_all() OWNER TO test;

--
-- Name: mp_schemaversion_select_one(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemaversion_select_one(character varying) RETURNS SETOF mp_schemaversion_select_one_type
    AS $_$

select
        applicationid,
        applicationname,
        major,
        minor,
        build,
        revision
from
        mp_schemaversion
        
where
        applicationid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemaversion_select_one(character varying) OWNER TO test;

--
-- Name: mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) RETURNS integer
    AS $_$

declare
            _applicationid alias for $1;
            _applicationname alias for $2;
            _major alias for $3;
            _minor alias for $4;
            _build alias for $5;
            _revision alias for $6;
			_rowcount int4;
begin
update 		mp_schemaversion

set
            applicationname = _applicationname, 
            major = _major, 
            minor = _minor, 
            build = _build, 
            revision = _revision 
            
where
            applicationid = _applicationid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) OWNER TO test;

--
-- Name: mp_sharedfilefolders_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_delete(integer) RETURNS integer
    AS $_$
declare
	_folderid alias for $1;
	_rowcount int4;
begin

	delete from  mp_sharedfilefolders
where
	folderid = _folderid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_delete(integer) OWNER TO test;

--
-- Name: mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) RETURNS integer
    AS $_$
insert into 	mp_sharedfilefolders 
(
				moduleid,
				foldername,
				parentid,
				moduleguid,
				folderguid,
				parentguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6
				
);
select cast(currval('mp_sharedfilefolders_folderid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) OWNER TO test;

--
-- Name: mp_sharedfilefolders_selectallbymodulev2(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_selectallbymodulev2(integer) RETURNS SETOF mp_sharedfilefolders
    AS $_$
select
		*
		
from
		mp_sharedfilefolders
where	moduleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_selectallbymodulev2(integer) OWNER TO test;

--
-- Name: mp_sharedfilefolders_selectbymodulev2(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_selectbymodulev2(integer, integer) RETURNS SETOF mp_sharedfilefolders
    AS $_$
select
		*
		
from
		mp_sharedfilefolders
where	moduleid = $1
		and parentid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_selectbymodulev2(integer, integer) OWNER TO test;

--
-- Name: mp_sharedfilefolders_selectonev2(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_selectonev2(integer) RETURNS SETOF mp_sharedfilefolders
    AS $_$
select
		*
		
from
		mp_sharedfilefolders
		
where
		folderid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_selectonev2(integer) OWNER TO test;

--
-- Name: mp_sharedfilefolders_update(integer, integer, character varying, integer, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfilefolders_update(integer, integer, character varying, integer, character) RETURNS integer
    AS $_$
declare
	_folderid alias for $1;
	_moduleid alias for $2;
	_foldername alias for $3;
	_parentid alias for $4;
	_parentguid alias for $5;
	_rowcount int4;
begin

update 		mp_sharedfilefolders 
set
			moduleid = _moduleid,
			foldername = _foldername,
			parentid = _parentid,
			parentguid = _parentguid
			
where
			folderid = _folderid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfilefolders_update(integer, integer, character varying, integer, character) OWNER TO test;

--
-- Name: mp_sharedfiles_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_delete(integer) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_rowcount int4;
begin

	delete from  mp_sharedfiles
where
	itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_delete(integer) OWNER TO test;

--
-- Name: mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) RETURNS integer
    AS $_$
insert into 			mp_sharedfiles 
(
				moduleid,
				uploaduserid,
				friendlyname,
				originalfilename,
				serverfilename,
				sizeinkb,
				uploaddate,
				folderid,
				itemguid,
				moduleguid,
				userguid,
				folderguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12
				
);
select cast(currval('mp_sharedfiles_itemid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) OWNER TO test;

--
-- Name: mp_sharedfiles_selectbymodule(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_selectbymodule(integer, integer) RETURNS SETOF mp_sharedfiles_selectbymodule_type
    AS $_$
select
		sf.itemid,
		sf.moduleid,
		sf.uploaduserid,
		sf.friendlyname,
		sf.originalfilename,
		sf.serverfilename,
		sf.sizeinkb,
		sf.uploaddate,
		sf.folderid,
		sf.folderguid,
		u.name as username
		
from
		mp_sharedfiles sf
left outer join
		mp_users u
on		sf.uploaduserid = u.userid
		
where	sf.moduleid = $1
		and sf.folderid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_selectbymodule(integer, integer) OWNER TO test;

--
-- Name: mp_sharedfiles_selectbypage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_selectbypage(integer, integer) RETURNS SETOF mp_sharedfiles_selectbypage_type
    AS $_$
select
		gi.itemid,
		gi.moduleid,
		gi.friendlyname, 
		m.moduletitle,
		md.featurename
		
from
		mp_sharedfiles gi
		
JOIN		mp_modules m
ON		gi.moduleid = m.moduleid

JOIN		mp_moduledefinitions md
ON		m.moduledefid = md.moduledefid

JOIN		mp_pagemodules pm
ON		pm.moduleid = m.moduleid

JOIN		mp_pages p
ON		p.pageid = pm.pageid
		
where
		p.siteid = $1
		AND pm.pageid = $2
		; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_selectbypage(integer, integer) OWNER TO test;

--
-- Name: mp_sharedfiles_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_selectone(integer) RETURNS SETOF mp_sharedfiles_selectone_type
    AS $_$
select
	itemid,
	moduleid,
	uploaduserid,
	friendlyname,
	originalfilename,
	serverfilename,
	sizeinkb,
	uploaddate,
	folderid,
	itemguid,
	moduleguid,
	userguid,
        folderguid
		
from
		mp_sharedfiles
		
where
		itemid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_selectone(integer) OWNER TO test;

--
-- Name: mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) RETURNS integer
    AS $_$
declare
	_itemid alias for $1;
	_moduleid alias for $2;
	_uploaduserid alias for $3;
	_friendlyname alias for $4;
	_originalfilename alias for $5;
	_serverfilename alias for $6;
	_sizeinkb alias for $7;
	_uploaddate alias for $8;
	_folderid alias for $9;
	_userguid alias for $10;
	_folderguid alias for $11;
	_rowcount int4;
begin

update 		mp_sharedfiles 
set
			moduleid = _moduleid,
			uploaduserid = _uploaduserid,
			friendlyname = _friendlyname,
			originalfilename = _originalfilename,
			serverfilename = _serverfilename,
			sizeinkb = _sizeinkb,
			uploaddate = _uploaddate,
			folderid = _folderid,
			userguid = _userguid,
			folderguid = _folderguid
			
where
			itemid = _itemid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) OWNER TO test;

--
-- Name: mp_sharedfileshistory_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfileshistory_delete(integer) RETURNS integer
    AS $_$
declare
	_id alias for $1;
	_rowcount int4;
begin

	delete from  mp_sharedfileshistory
where
	id = _id; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfileshistory_delete(integer) OWNER TO test;

--
-- Name: mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) RETURNS integer
    AS $_$
insert into 	mp_sharedfileshistory 
(
				itemid,
				moduleid,
				friendlyname,
				originalfilename,
				serverfilename,
				sizeinkb,
				uploaddate,
				uploaduserid,
				archivedate,
				itemguid,
				moduleguid,
				userguid
) 
values 
(
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12
				
);
select cast(currval('mp_sharedfileshistory_id_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) OWNER TO test;

--
-- Name: mp_sharedfileshistory_select(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfileshistory_select(integer, integer) RETURNS SETOF mp_sharedfileshistory_select_type
    AS $_$
select
		h.id,
		h.itemid,
		h.moduleid,
		h.friendlyname,
		h.originalfilename,
		h.serverfilename,
		h.sizeinkb,
		h.uploaddate,
		h.uploaduserid,
		h.archivedate,
		u.name,
		h.itemguid,
		h.moduleguid,
		h.userguid
		
from
		mp_sharedfileshistory h
left outer join	mp_users u
on			u.userid = h.uploaduserid
where	h.moduleid = $1
		and h.itemid = $2
order by 	h.archivedate desc; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfileshistory_select(integer, integer) OWNER TO test;

--
-- Name: mp_sharedfileshistory_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sharedfileshistory_selectone(integer) RETURNS SETOF mp_sharedfileshistory_selectone_type
    AS $_$
select
	id,
	itemid,
	moduleid,
	friendlyname,
	originalfilename,
	serverfilename,
	sizeinkb,
	uploaddate,
	archivedate,
	uploaduserid,
	itemguid,
	moduleguid,
        userguid
		
from
		mp_sharedfileshistory
where	id = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sharedfileshistory_selectone(integer) OWNER TO test;

--
-- Name: mp_sitefolders_delete(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_delete(character varying) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
			_rowcount int4;
begin
	delete from mp_sitefolders
	where guid = _guid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_delete(character varying) OWNER TO test;

--
-- Name: mp_sitefolders_exists(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_exists(character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_sitefolders
where	 foldername = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_exists(character varying) OWNER TO test;

--
-- Name: mp_sitefolders_insert(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_insert(character varying, character varying, character varying) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
            _siteguid alias for $2;
            _foldername alias for $3;
			_rowcount int4;
begin

insert into 	mp_sitefolders
(			
                guid,
                siteguid,
                foldername
) 
values 
(				
                _guid, 
                _siteguid, 
                _foldername 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_insert(character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_sitefolders_select_bysite(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_select_bysite(character varying) RETURNS SETOF mp_sitefolders_select_one_type
    AS $_$

select
        guid,
        siteguid,
        foldername
from
        mp_sitefolders
        
where
        siteguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_select_bysite(character varying) OWNER TO test;

--
-- Name: mp_sitefolders_select_one(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_select_one(character varying) RETURNS SETOF mp_sitefolders_select_one_type
    AS $_$

select
        guid,
        siteguid,
        foldername
from
        mp_sitefolders
        
where
        guid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_select_one(character varying) OWNER TO test;

--
-- Name: mp_sitefolders_selectsiteguid(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_selectsiteguid(character varying) RETURNS character varying
    AS $_$
select  	
coalesce(
	(select siteguid from mp_sitefolders where foldername = $1 limit 1),
	(select siteguid from mp_sites order by siteid limit 1)
	)
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_selectsiteguid(character varying) OWNER TO test;

--
-- Name: mp_sitefolders_update(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitefolders_update(character varying, character varying, character varying) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _siteguid alias for $2;
            _foldername alias for $3;
			_rowcount int4;
begin
update 		mp_sitefolders

set
            siteguid = _siteguid, 
            foldername = _foldername 
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitefolders_update(character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_sitehosts_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitehosts_delete(integer) RETURNS integer
    AS $_$
declare
	_hostid alias for $1;
	_rowcount int4;
begin

	delete from  mp_sitehosts
where
	hostid = _hostid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitehosts_delete(integer) OWNER TO test;

--
-- Name: mp_sitehosts_insert(integer, character varying, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitehosts_insert(integer, character varying, character) RETURNS integer
    AS $_$
insert into 	mp_sitehosts 
(
				siteid,
				hostname,
				siteguid
) 
values 
(
				$1,
				$2,
				$3
				
);
select cast(currval('mp_sitehosts_hostid_seq') as int4);; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitehosts_insert(integer, character varying, character) OWNER TO test;

--
-- Name: mp_sitehosts_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitehosts_select(integer) RETURNS SETOF mp_sitehosts_select_type
    AS $_$
select
		hostid,
		siteid,
		hostname
		
from
		mp_sitehosts
where	siteid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitehosts_select(integer) OWNER TO test;

--
-- Name: mp_sitehosts_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitehosts_selectone(integer) RETURNS SETOF mp_sitehosts_selectone_type
    AS $_$
select
		hostid,
		siteid,
		hostname
		
from
		mp_sitehosts
		
where
		hostid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitehosts_selectone(integer) OWNER TO test;

--
-- Name: mp_sitehosts_update(integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitehosts_update(integer, integer, character varying) RETURNS integer
    AS $_$
declare
	_hostid alias for $1;
	_siteid alias for $2;
	_hostname alias for $3;
	_rowcount int4;
begin

update 		mp_sitehosts 
set
			siteid = _siteid,
			hostname = _hostname
			
where
			hostid = _hostid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitehosts_update(integer, integer, character varying) OWNER TO test;

--
-- Name: mp_sitemoduledefinitions_delete(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitemoduledefinitions_delete(integer, integer) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_moduledefid alias for $2;
	_rowcount int4;
begin

	delete from  mp_sitemoduledefinitions
where	siteid = _siteid 
		and moduledefid = _moduledefid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitemoduledefinitions_delete(integer, integer) OWNER TO test;

--
-- Name: mp_sitemoduledefinitions_deletev2(character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitemoduledefinitions_deletev2(character, character) RETURNS integer
    AS $_$
declare
	_siteguid alias for $1;
	_featureguid alias for $2;
	_rowcount int4;
begin

	delete from  mp_sitemoduledefinitions
where	siteguid = _siteguid 
		and featureguid = _featureguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitemoduledefinitions_deletev2(character, character) OWNER TO test;

--
-- Name: mp_sitemoduledefinitions_ensureforadminsites(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitemoduledefinitions_ensureforadminsites() RETURNS integer
    AS $$

declare
	_rowcount int4;

begin

insert into mp_sitemoduledefinitions (siteid, moduledefid, siteguid, featureguid)
select distinct 
s.siteid, 
md.moduledefid, 
s.siteguid, 
(select guid from mp_moduledefinitions where moduledefid = md.moduledefid limit 1)

from mp_sites s, 
mp_moduledefinitions md

where s.isserveradminsite = true
and md.moduledefid not in 
(select smd.moduledefid
from mp_sitemoduledefinitions smd
where smd.siteid = s.siteid
);
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;

return _rowcount;
end$$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitemoduledefinitions_ensureforadminsites() OWNER TO test;

--
-- Name: mp_sitemoduledefinitions_insert(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitemoduledefinitions_insert(integer, integer) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_moduledefid alias for $2;
	t_found int;
	_rowcount int4;

begin

_rowcount := 0;
select into t_found 1 from mp_sitemoduledefinitions where siteid = _siteid and moduledefid = _moduledefid limit 1;
if not found then
	insert into mp_sitemoduledefinitions (
	siteid, 
	moduledefid,
	siteguid, 
	featureguid
	)
	
	values	(
	_siteid, 
	_moduledefid,
	(SELECT siteguid FROM mp_sites WHERE siteid = _siteid LIMIT 1),
	(SELECT guid FROM mp_moduledefinitions WHERE moduledefid = _moduledefid LIMIT 1)
	);   
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
end if;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitemoduledefinitions_insert(integer, integer) OWNER TO test;

--
-- Name: mp_sitemoduledefinitions_insertv2(character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitemoduledefinitions_insertv2(character, character) RETURNS integer
    AS $_$
declare
	_siteguid alias for $1;
	_featureguid alias for $2;
	t_found int;
	_rowcount int4;

begin

_rowcount := 0;
select into t_found 1 from mp_sitemoduledefinitions where siteguid = _siteguid and featureguid = _featureguid limit 1;
if not found then
	insert into mp_sitemoduledefinitions (
	siteid, 
	moduledefid,
	siteguid, 
	featureguid
	)
	
	values	(
	(SELECT siteid FROM mp_sites WHERE siteguid = _siteguid LIMIT 1),
	(SELECT moduledefid FROM mp_moduledefinitions WHERE guid = _featureguid LIMIT 1),
	__siteguid,
	_featureguid
	);   
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
end if;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitemoduledefinitions_insertv2(character, character) OWNER TO test;

--
-- Name: mp_sitepaths_count(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepaths_count(integer, character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepaths
where siteid = $1 and loweredpath = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepaths_count(integer, character varying) OWNER TO test;

--
-- Name: mp_sitepaths_getpathid(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepaths_getpathid(integer, character varying) RETURNS SETOF mp_sitepaths_getpathidtype
    AS $_$
select
	pathid
from
    mp_sitepaths
where
		siteid = $1
    		and loweredpath = $2 
limit 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepaths_getpathid(integer, character varying) OWNER TO test;

--
-- Name: mp_sitepaths_insert(character varying, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepaths_insert(character varying, integer, character varying, character varying) RETURNS boolean
    AS $_$
insert into 		mp_sitepaths
(
			pathid,
    			siteid,
    			path,
    			loweredpath,
    			siteguid
	
)
values
(
			$1,
    			$2,
    			$3,
    			$4,
    			(select siteguid from mp_sites where siteid = $2 limit 1)
			
); 

select true; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepaths_insert(character varying, integer, character varying, character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_countall(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationallusers_countall() RETURNS integer
    AS $$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationallusers
; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationallusers_countall() OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_countbypath(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationallusers_countbypath(character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationallusers
where		pathid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationallusers_countbypath(character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_getpersonalizationblob(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationallusers_getpersonalizationblob(character varying) RETURNS SETOF mp_sitepersonalizationallusers_getpersonalizationblobtype
    AS $_$
select
	pagesettings
from
    mp_sitepersonalizationallusers
where
		pathid = $1
    		
limit 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationallusers_getpersonalizationblob(character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) RETURNS boolean
    AS $_$
insert into 		mp_sitepersonalizationallusers
(
			pathid,
    			pagesettings,
    			lastupdate
    		
)
values
(
			$1,
    			$2,
    			$3
			
); 

select true; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_pathid alias for $1;
	_pagesettings alias for $2;
	_lastupdate alias for $3;
	_rowcount int4;
begin

    update 
    mp_sitepersonalizationallusers
    set pagesettings = _pagesettings,
    	lastupdate = _lastupdate
    
where
    pathid = _pathid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countall(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countall() RETURNS integer
    AS $$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countall() OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbypath(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbypath(character varying, character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
where pathid = $1 and userid = $2
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbypath(character varying, character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_sitepersonalizationperuser.pathid = $1 and mp_users.lastactivitydate <= $2
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbyuser(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbyuser(character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_users.userguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbyuser(character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_sitepersonalizationperuser.userid = $1
		and mp_sitepersonalizationperuser.pathid = $2 
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_sitepersonalizationperuser.userid = $1
		and mp_sitepersonalizationperuser.pathid = $2 and mp_users.lastactivitydate <= $3
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_users.userguid = $1 and mp_users.lastactivitydate <= $2
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_sitepersonalizationperuser
join		mp_users
on		mp_users.userguid = mp_sitepersonalizationperuser.userid
where		mp_users.lastactivitydate <= $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_deletebypath(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_deletebypath(character varying, character varying) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_pathid alias for $2;
	_rowcount int4;
begin

    delete from
    mp_sitepersonalizationperuser
    
where userid = _userid and pathid = _pathid ; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_deletebypath(character varying, character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) RETURNS SETOF mp_sitepersonalizationperuser_getpersonalizationblobtype
    AS $_$
select
	pagesettings
from
    mp_sitepersonalizationperuser
where	userid = $1 and pathid = $2	
limit 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) RETURNS boolean
    AS $_$
insert into 		mp_sitepersonalizationperuser
(
			id,
			userid,
			pathid,
    			pagesettings,
    			lastupdate
    		
)
values
(
			$1,
    			$2,
    			$3,
    			$4,
    			$5
			
); 

select true; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_pathid alias for $2;
	_pagesettings alias for $3;
	_lastupdate alias for $4;
	_rowcount int4;
begin

    update 
    mp_sitepersonalizationperuser
    set pagesettings = _pagesettings,
    	lastupdate = _lastupdate
    
where userid = _userid and
    pathid = _pathid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) OWNER TO test;

--
-- Name: mp_sites_count(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_count() RETURNS integer
    AS $$
select cast(count(*) as int4) from mp_sites; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_count() OWNER TO test;

--
-- Name: mp_sites_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_delete(integer) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_rowcount int4;
begin

DELETE FROM mp_webparts WHERE siteid = _siteid;

DELETE FROM mp_pagemodules
WHERE pageid IN (SELECT pageid FROM mp_pages WHERE siteid = _siteid);

DELETE FROM mp_modulesettings
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_blogcategories
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_blogstats
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_blogcomments
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_blogitemcategories
WHERE itemid IN (SELECT itemid FROM mp_blogs WHERE moduleid IN
(SELECT moduleid FROM mp_modules WHERE siteid = _siteid) );

DELETE FROM mp_blogs
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_calendarevents
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_forumposts
WHERE threadid IN (SELECT threadid FROM mp_forumthreads WHERE forumid IN
(SELECT itemid FROM mp_forums 
WHERE moduleid IN  (SELECT moduleid FROM mp_modules WHERE siteid = _siteid)) );

DELETE FROM mp_forumthreadsubscriptions
WHERE threadid IN (SELECT threadid FROM mp_forumthreads WHERE forumid IN
(SELECT itemid FROM mp_forums WHERE moduleid IN  
(SELECT moduleid FROM mp_modules WHERE siteid = _siteid)) );

DELETE FROM mp_forumthreads
WHERE forumid IN
(SELECT itemid FROM mp_forums WHERE moduleid IN  
(SELECT moduleid FROM mp_modules WHERE siteid = _siteid)) ;

DELETE FROM mp_forumsubscriptions
WHERE forumid IN
(SELECT itemid FROM mp_forums WHERE moduleid IN  
(SELECT moduleid FROM mp_modules WHERE siteid = _siteid)) ;

DELETE FROM mp_forums
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_galleryImages
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_links
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_htmlcontent
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_rssfeeds
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_sharedfileshistory
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_sharedfiles
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_sharedfilefolders
WHERE moduleid IN (SELECT moduleid FROM mp_modules WHERE siteid = _siteid);

DELETE FROM mp_modules WHERE siteid = _siteid;

DELETE FROM mp_sitemoduledefinitions WHERE siteid = _siteid;

DELETE FROM mp_userproperties
WHERE userguid IN (SELECT userguid FROM mp_users WHERE siteid = _siteid);

DELETE FROM mp_userroles
WHERE userid IN (SELECT userid FROM mp_users WHERE siteid = _siteid);

DELETE FROM mp_userlocation
WHERE userguid IN (SELECT userguid FROM mp_users WHERE siteid = _siteid);

DELETE FROM mp_friendlyurls WHERE siteid = _siteid;

DELETE FROM mp_userpages WHERE siteid = _siteid;

DELETE FROM mp_users WHERE siteid = _siteid;

DELETE FROM mp_pages WHERE siteid = _siteid;

DELETE FROM mp_roles WHERE siteid = _siteid;

DELETE FROM mp_sitehosts WHERE siteid = _siteid;

DELETE FROM mp_sitepersonalizationallusers
WHERE pathid IN (SELECT pathid FROM mp_sitepaths WHERE siteid = _siteid);

DELETE FROM mp_sitepersonalizationperuser
WHERE pathid IN (SELECT pathid FROM mp_sitepaths WHERE siteid = _siteid);

DELETE FROM mp_sitepaths WHERE siteid = _siteid;

DELETE FROM mp_sitefolders
WHERE siteguid IN (SELECT siteguid FROM mp_sites WHERE siteid = _siteid);




delete from  mp_sites where siteid = _siteid;

GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_delete(integer) OWNER TO test;

--
-- Name: mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) RETURNS integer
    AS $_$
insert into 	mp_sites 
(
				
				sitename,
				skin,
				logo,
				icon,
				allowuserskins,
				allownewregistration,
				usesecureregistration,
				enablemypagefeature,
				usesslonallpages,
				defaultpagekeywords,
				defaultpagedescription,
				defaultpageencoding,
				defaultadditionalmetatags,
				isserveradminsite,
				allowpageskins,
				allowhidemenuonpages,
				useldapauth,
				autocreateldapuseronfirstlogin,
				ldapserver,
				ldapport,
				ldaprootdn,
				ldapuserdnkey,
				allowuserfullnamechange,
				useemailforlogin,
				reallydeleteusers,
				editorskin,
				defaultfriendlyurlpatternenum,
				siteguid,
				ldapdomain,
				editorprovider,
				datepickerprovider,
				captchaprovider,
				recaptchaprivatekey,
				recaptchapublickey,
				wordpressapikey,
				windowsliveappid,
				windowslivekey,
				allowopenidauth,
				allowwindowsliveauth,
				gmapapikey,
				apikeyextra1,
				apikeyextra2,
				apikeyextra3,
				apikeyextra4,
				apikeyextra5
) 
values 
(
				
				$1,
				$2,
				$3,
				$4,
				$5,
				$6,
				$7,
				$8,
				$9,
				$10,
				$11,
				$12,
				$13,
				$14,
				$15,
				$16,
				$17,
				$18,
				$19,
				$20,
				$21,
				$22,
				$23,
				$24,
				$25,
				$26,
				$27,
				$28,
				$29,
				$30,
				$31,
				$32,
				$33,
				$34,
				$35,
				$36,
				$37,
				$38,
				$39,
				$40,
				$41,
				$42,
				$43,
				$44,
				$45
				
				
);
select cast(currval('mp_sites_siteid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_sites_selectall(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_selectall() RETURNS SETOF mp_sites_selectall_type
    AS $$
select
		siteid,
		siteguid,
		sitealias,
		sitename,
		skin,
		logo,
		icon,
		allowuserskins,
		allowpageskins,
		allownewregistration,
		usesecureregistration,
		enablemypagefeature,
		usesslonallpages,
		defaultpagekeywords,
		defaultpagedescription,
		defaultpageencoding,
		defaultadditionalmetatags,
		isserveradminsite
		
from
		mp_sites; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_selectall() OWNER TO test;

--
-- Name: mp_sites_selectonebyguidv2(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_selectonebyguidv2(character varying) RETURNS SETOF mp_sites
    AS $_$
select
		*
from
		mp_sites
		
where
		siteguid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_selectonebyguidv2(character varying) OWNER TO test;

--
-- Name: mp_sites_selectonebyhostv2(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_selectonebyhostv2(character varying) RETURNS SETOF mp_sites
    AS $_$
select
		*
from
		mp_sites
		
where
		siteid = coalesce(
				(select siteid from mp_sitehosts where hostname = $1 limit 1),
				 (select siteid from mp_sites order by siteid limit 1)
				)
				; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_selectonebyhostv2(character varying) OWNER TO test;

--
-- Name: mp_sites_selectonev2(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_selectonev2(integer) RETURNS SETOF mp_sites
    AS $_$
select
		*
from
		mp_sites
		
where
		siteid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_selectonev2(integer) OWNER TO test;

--
-- Name: mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
	_sitename alias for $2;
	_skin alias for $3;
	_logo alias for $4;
	_icon alias for $5;
	_allownewregistration alias for $6;
	_allowuserskins alias for $7;
	_usesecureregistration alias for $8;
	_enablemypagefeature alias for $9;
	_usesslonallpages alias for $10;
	_defaultpagekeywords alias for $11;
	_defaultpagedescription alias for $12;
	_defaultpageencoding alias for $13;
	_defaultadditionalmetatags alias for $14;
	_isserveradminsite alias for $15;
	_allowpageskins alias for $16;
	_allowhidemenuonpages alias for $17;
	_useldapauth alias for $18;
	_autocreateldapuseronfirstlogin alias for $19;
	_ldapserver alias for $20;
	_ldapport alias for $21;
	_ldaprootdn alias for $22;
	_ldapuserdnkey alias for $23;
	_allowuserfullnamechange alias for $24;
	_useemailforlogin alias for $25;
	_reallydeleteusers alias for $26;
	_editorskin alias for $27;
	_defaultfriendlyurlpatternenum alias for $28;
	_ldapdomain alias for $29;
	_editorprovider alias for $30;
	_datepickerprovider alias for $31;
	_captchaprovider alias for $32;
	_recaptchaprivatekey alias for $33;
	_recaptchapublickey alias for $34;
	_wordpressapikey alias for $35;
	_windowsliveappid alias for $36;
	_windowslivekey alias for $37;
	_allowopenidauth alias for $38;
	_allowwindowsliveauth alias for $39;
	_gmapapikey alias for $40;
	_apikeyextra1 alias for $41;
	_apikeyextra2 alias for $42;
	_apikeyextra3 alias for $43;
	_apikeyextra4 alias for $44;
	_apikeyextra5 alias for $45;
	_rowcount int4;
begin

update	mp_sites
set
    	sitename = _sitename,
	skin = _skin,
	logo = _logo,
	icon = _icon,
	allownewregistration = _allownewregistration,
	allowuserskins = _allowuserskins,
	usesecureregistration = _usesecureregistration,
	enablemypagefeature = _enablemypagefeature,
	usesslonallpages = _usesslonallpages,
	defaultpagekeywords = _defaultpagekeywords,
	defaultpagedescription = _defaultpagedescription,
	defaultpageencoding = _defaultpageencoding,
	defaultadditionalmetatags = _defaultadditionalmetatags,
	isserveradminsite = _isserveradminsite,
	allowpageskins = _allowpageskins,
	allowhidemenuonpages = _allowhidemenuonpages,
	useldapauth = _useldapauth,
	autocreateldapuseronfirstlogin = _autocreateldapuseronfirstlogin,
	ldapserver = _ldapserver,
	ldapport = _ldapport,
	ldapdomain = _ldapdomain,
	ldaprootdn = _ldaprootdn,
	ldapuserdnkey = _ldapuserdnkey,
	allowuserfullnamechange = _allowuserfullnamechange,
	useemailforlogin = _useemailforlogin,
	reallydeleteusers = _reallydeleteusers,
	editorskin = _editorskin,
	defaultfriendlyurlpatternenum = _defaultfriendlyurlpatternenum,
	editorprovider = _editorprovider,
	datepickerprovider = _datepickerprovider,
	captchaprovider = _captchaprovider,
	recaptchaprivatekey = _recaptchaprivatekey,
	recaptchapublickey = _recaptchapublickey,
	wordpressapikey = _wordpressapikey,
	windowsliveappid = _windowsliveappid,
	windowslivekey = _windowslivekey,
	allowopenidauth = _allowopenidauth,
	allowwindowsliveauth = _allowwindowsliveauth,
	gmapapikey = _gmapapikey,
	apikeyextra1 = _apikeyextra1,
	apikeyextra2 = _apikeyextra2,
	apikeyextra3 = _apikeyextra3,
	apikeyextra4 = _apikeyextra4,
	apikeyextra5 = _apikeyextra5
	
where
    	siteid = _siteid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) RETURNS integer
    AS $_$
declare
	_siteid alias for $1;
_allowpasswordretrieval alias for $2;
_allowpasswordreset alias for $3;
_requiresquestionandanswer alias for $4;
_maxinvalidpasswordattempts alias for $5;
_passwordattemptwindowminutes alias for $6;
_requiresuniqueemail alias for $7;
_passwordformat alias for $8;
_minrequiredpasswordlength alias for $9;
_minrequirednonalphanumericcharacters alias for $10;
_passwordstrengthregularexpression alias for $11;
_defaultemailfromaddress alias for $12;
_rowcount int4;
begin

update mp_sites
set
allowpasswordretrieval = _allowpasswordretrieval,
allowpasswordreset = _allowpasswordreset,
requiresquestionandanswer = _requiresquestionandanswer,
maxinvalidpasswordattempts = _maxinvalidpasswordattempts,
passwordattemptwindowminutes = _passwordattemptwindowminutes,
requiresuniqueemail = _requiresuniqueemail,
passwordformat = _passwordformat,
minrequiredpasswordlength = _minrequiredpasswordlength,
minreqnonalphachars = _minrequirednonalphanumericcharacters,
pwdstrengthregex = _passwordstrengthregularexpression,
defaultemailfromaddress = _defaultemailfromaddress
where siteid = _siteid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) OWNER TO test;

--
-- Name: mp_sitesettings_getpagelist(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitesettings_getpagelist(integer) RETURNS SETOF mp_sitesettings_getpagelist_type
    AS $_$
select  
    		pageid ,
		parentid ,
		pageorder ,
		siteid ,
		pagename ,
		menuimage,
		requiressl ,
		showbreadcrumbs ,
		pagekeywords,
		pagedescription ,
		pageencoding ,
		additionalmetatags ,
		useurl ,
		url,
		openinnewwindow ,
		showchildpagemenu ,
		authorizedroles ,
		editroles ,
		createchildpageroles,
		showchildbreadcrumbs ,
		hidemainmenu,
		skin ,
		includeinmenu
    
from    
    				mp_pages
    
where   
    				siteid = $1 
order by			parentid, pageorder, pagename; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitesettings_getpagelist(integer) OWNER TO test;

--
-- Name: mp_sitesettings_selectdefaultpage(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitesettings_selectdefaultpage(character varying) RETURNS SETOF mp_sitesettings_selectdefaultpage_type
    AS $_$

 select 
        		s.siteid,
         		s.sitename,
			s.skin,
			s.editorskin,
			s.logo,
			s.icon,
			s.allownewregistration,
			s.allowuserskins,
			s.allowpageskins,
			s.allowhidemenuonpages,
			s.defaultfriendlyurlpatternenum,
			s.usesecureregistration,
			s.enablemypagefeature,
			s.usesslonallpages,
			coalesce(s.defaultpagekeywords,  '') as metakeywords,
			coalesce(s.defaultpagedescription,  '') as metadescription,
			coalesce(s.defaultpageencoding,  '') as metaencoding,
			coalesce(s.defaultadditionalmetatags,  '') as metaadditional,
			coalesce(p.pagekeywords, '') as pagemetakeywords,
			coalesce(p.pagedescription, '') as pagemetadescription,
			coalesce(p.pageencoding, '') as pagemetaencoding,
			coalesce(p.additionalmetatags, '') as pagemetaadditional,
			s.isserveradminsite,
			s.useldapauth,
			s.autocreateldapuseronfirstlogin,
			s.ldapserver,
			s.ldapport,
			s.ldapdomain,
			s.ldaprootdn,
			s.ldapuserdnkey,
			s.allowuserfullnamechange,
			s.useemailforlogin,
			s.reallydeleteusers,
        		p.pageid,
			p.parentid,
         		p.pageorder,
        		p.pagename,
        		p.menuimage,
         		p.requiressl,
        		p.authorizedroles,
        		p.editroles,
 			p.createchildpageroles,
        		p.showbreadcrumbs,
        		p.showchildbreadcrumbs,
        		p.showchildpagemenu,
        		p.hidemainmenu,
			p.skin as pageskin
from			mp_pages p
    
inner join		mp_sites  s
on 			p.siteid = s.siteid
        
    
where
        			s.siteid = coalesce(
				(select siteid from mp_sitehosts where hostname = $1 limit 1),
				 (select siteid from mp_sites order by siteid limit 1)
				)
        
order by
        			p.parentid, p.pageorder
limit 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitesettings_selectdefaultpage(character varying) OWNER TO test;

--
-- Name: mp_sitesettings_selectdefaultpagebyid(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitesettings_selectdefaultpagebyid(integer) RETURNS SETOF mp_sitesettings_selectdefaultpagebyid_type
    AS $_$
 select 
			s.siteid,
			s.sitename,
			s.skin,
			s.editorskin,
			s.logo,
			s.icon,
			s.allownewregistration,
			s.allowuserskins,
			s.allowpageskins,
			s.allowhidemenuonpages,
			s.defaultfriendlyurlpatternenum,
			s.usesecureregistration,
			s.enablemypagefeature,
			s.usesslonallpages,
			coalesce(s.defaultpagekeywords,  '') as metakeywords ,
			coalesce(s.defaultpagedescription,  '') as metadescription ,
			coalesce(s.defaultpageencoding,  '') as metaencoding ,
			coalesce(s.defaultadditionalmetatags,  '') as metaadditional ,
			coalesce(p.pagekeywords, '') as pagemetakeywords ,
			coalesce(p.pagedescription, '') as pagemetadescription ,
			coalesce(p.pageencoding, '') as pagemetaencoding ,
			coalesce(p.additionalmetatags, '') as pagemetaadditional ,
			s.isserveradminsite,
			s.useldapauth,
			s.autocreateldapuseronfirstlogin,
			s.ldapserver,
			s.ldapport,
			s.ldapdomain,
			s.ldaprootdn,
			s.ldapuserdnkey,
			s.allowuserfullnamechange,
			s.useemailforlogin,
			s.reallydeleteusers,
			p.pageid,
			p.parentid,
			p.pageorder,
			p.pagename,
			p.menuimage,
			p.requiressl,
			p.authorizedroles,
			p.editroles,
 			p.createchildpageroles,
			p.showbreadcrumbs,
			p.showchildbreadcrumbs,
			p.showchildpagemenu,
			p.hidemainmenu,
			p.skin as pageskin
from			mp_pages p
    
inner join		mp_sites  s
on 			p.siteid = s.siteid
        
    
where
        			s.siteid = $1
        
order by
        			p.parentid, p.pageorder
limit 1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitesettings_selectdefaultpagebyid(integer) OWNER TO test;

--
-- Name: mp_sitesettings_selectpage(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_sitesettings_selectpage(integer, character varying) RETURNS SETOF mp_sitesettings_selectpage_type
    AS $_$
 select
			s.siteid,
			s.sitename,
			s.skin,
			s.editorskin,
			s.logo,
			s.icon,
			s.allownewregistration,
			s.allowuserskins,
			s.allowpageskins,
			s.allowhidemenuonpages,
			s.defaultfriendlyurlpatternenum,
			s.usesecureregistration,
			s.enablemypagefeature,
			s.usesslonallpages,
			coalesce(s.defaultpagekeywords,  '') as metakeywords ,
			coalesce(s.defaultpagedescription,  '') as metadescription ,
			coalesce(s.defaultpageencoding,  '') as metaencoding ,
			coalesce(s.defaultadditionalmetatags,  '') as metaadditional ,
			coalesce(p.pagekeywords, '') as pagemetakeywords ,
			coalesce(p.pagedescription, '') as pagemetadescription ,
			coalesce(p.pageencoding, '') as pagemetaencoding ,
			coalesce(p.additionalmetatags, '') as pagemetaadditional ,
			s.isserveradminsite,
			s.useldapauth,
			s.autocreateldapuseronfirstlogin,
			s.ldapserver,
			s.ldapport,
			s.ldapdomain,
			s.ldaprootdn,
			s.ldapuserdnkey,
			s.allowuserfullnamechange,
			s.useemailforlogin,
			s.reallydeleteusers,
			p.pageid,
			p.parentid,
			p.pageorder,
			p.pagename,
			p.menuimage,
			p.requiressl,
			p.authorizedroles,
			p.editroles,
 			p.createchildpageroles,
			p.showbreadcrumbs,
			p.showchildbreadcrumbs,
			p.showchildpagemenu,
			p.hidemainmenu,
			p.skin as pageskin
from			mp_pages p
    
inner join		mp_sites  s
on 			p.siteid = s.siteid
        
    
where		s.siteid = coalesce(	(select siteid from mp_sitehosts where hostname = $2 limit 1),
				 (select siteid from mp_sites order by siteid limit 1)
			)
        			and p.pageid = $1
        
order by
        			p.pageorder
limit 1;  $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_sitesettings_selectpage(integer, character varying) OWNER TO test;

--
-- Name: mp_taskqueue_count(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_count() RETURNS integer
    AS $$
select  	cast(count(*) as int4)
from		mp_taskqueue
; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_count() OWNER TO test;

--
-- Name: mp_taskqueue_countbysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_countbysite(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_taskqueue
where		siteguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_countbysite(character) OWNER TO test;

--
-- Name: mp_taskqueue_countunfinished(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_countunfinished() RETURNS integer
    AS $$
select  	cast(count(*) as int4)
from		mp_taskqueue
where		completeutc IS NULL
; $$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_countunfinished() OWNER TO test;

--
-- Name: mp_taskqueue_countunfinishedbysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_countunfinishedbysite(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_taskqueue
where		completeutc IS NULL
		and siteguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_countunfinishedbysite(character) OWNER TO test;

--
-- Name: mp_taskqueue_delete(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_delete(character) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
			_rowcount int4;
begin
	delete from mp_taskqueue
	where guid = _guid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_delete(character) OWNER TO test;

--
-- Name: mp_taskqueue_deletecompleted(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_deletecompleted() RETURNS integer
    AS $$
declare
           
			_rowcount int4;
begin
	delete from mp_taskqueue
	where completeutc is not null;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_deletecompleted() OWNER TO test;

--
-- Name: mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) RETURNS integer
    AS $_$
declare
            _guid alias for $1;
            _siteguid alias for $2;
            _queuedby alias for $3;
            _taskname alias for $4;
            _notifyoncompletion alias for $5;
            _notificationtoemail alias for $6;
            _notificationfromemail alias for $7;
            _notificationsubject alias for $8;
            _taskcompletemessage alias for $9;
            _canstop alias for $10;
            _canresume alias for $11;
            _updatefrequency alias for $12;
            _queuedutc alias for $13;
            _completeratio alias for $14;
            _status alias for $15;
            _serializedtaskobject alias for $16;
            _serializedtasktype alias for $17;
			_rowcount int4;
begin

insert into 	mp_taskqueue
(			
                guid,
                siteguid,
                queuedby,
                taskname,
                notifyoncompletion,
                notificationtoemail,
                notificationfromemail,
                notificationsubject,
                taskcompletemessage,
                canstop,
                canresume,
                updatefrequency,
                queuedutc,
                completeratio,
                status,
                serializedtaskobject,
                serializedtasktype
) 
values 
(				
                _guid, 
                _siteguid, 
                _queuedby, 
                _taskname, 
                _notifyoncompletion, 
                _notificationtoemail, 
                _notificationfromemail, 
                _notificationsubject, 
                _taskcompletemessage, 
                _canstop, 
                _canresume, 
                _updatefrequency, 
                _queuedutc, 
                _completeratio, 
                _status, 
                _serializedtaskobject, 
                _serializedtasktype 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) OWNER TO test;

--
-- Name: mp_taskqueue_select_one(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_select_one(character) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$

select
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype
from
        mp_taskqueue
        
where
        guid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_select_one(character) OWNER TO test;

--
-- Name: mp_taskqueue_select_tasksfornotification(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_select_tasksfornotification() RETURNS SETOF mp_taskqueue_select_one_type
    AS $$

select
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype
from
        mp_taskqueue
        
where
	notifyoncompletion = true
	and completeutc IS NOT NULL
        and notificationsentutc IS NULL
        ;$$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_select_tasksfornotification() OWNER TO test;

--
-- Name: mp_taskqueue_select_tasksnotfinished(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_select_tasksnotfinished() RETURNS SETOF mp_taskqueue_select_one_type
    AS $$

select
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype
from
        mp_taskqueue
        
where
        completeutc IS NULL
        ;$$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_select_tasksnotfinished() OWNER TO test;

--
-- Name: mp_taskqueue_select_tasksnotfinishedbysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_select_tasksnotfinishedbysite(character) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$

select
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype
from
        mp_taskqueue
        
where
        siteguid = $1
        and completeutc IS NULL
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_select_tasksnotfinishedbysite(character) OWNER TO test;

--
-- Name: mp_taskqueue_select_tasksnotstarted(); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_select_tasksnotstarted() RETURNS SETOF mp_taskqueue_select_one_type
    AS $$

select
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype
from
        mp_taskqueue
        
where
        startutc IS NULL
        ;$$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_select_tasksnotstarted() OWNER TO test;

--
-- Name: mp_taskqueue_selectpage(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_selectpage(integer, integer) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$
declare
	_pagenumber alias for $1;
	_pagesize alias for $2;
	_pagelowerbound int;
	_rec mp_taskqueue_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype

	from mp_taskqueue
	order by queuedutc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_selectpage(integer, integer) OWNER TO test;

--
-- Name: mp_taskqueue_selectpagebysite(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_selectpagebysite(character, integer, integer) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$
declare
	_siteguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_taskqueue_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype

	from mp_taskqueue
	where	siteguid = _siteguid
	order by queuedutc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_selectpagebysite(character, integer, integer) OWNER TO test;

--
-- Name: mp_taskqueue_selectpageunfinished(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_selectpageunfinished(integer, integer) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$
declare
	_pagenumber alias for $1;
	_pagesize alias for $2;
	_pagelowerbound int;
	_rec mp_taskqueue_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype

	from mp_taskqueue
	where	
		completeutc IS NULL
	order by queuedutc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_selectpageunfinished(integer, integer) OWNER TO test;

--
-- Name: mp_taskqueue_selectpageunfinishedbysite(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) RETURNS SETOF mp_taskqueue_select_one_type
    AS $_$
declare
	_siteguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_taskqueue_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        guid,
        siteguid,
        queuedby,
        taskname,
        notifyoncompletion,
        notificationtoemail,
        notificationfromemail,
        notificationsubject,
        taskcompletemessage,
        notificationsentutc,
        canstop,
        canresume,
        updatefrequency,
        queuedutc,
        startutc,
        completeutc,
        laststatusupdateutc,
        completeratio,
        status,
        serializedtaskobject,
        serializedtasktype

	from mp_taskqueue
	where	siteguid = _siteguid
		and completeutc IS NULL
	order by queuedutc	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) OWNER TO test;

--
-- Name: mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _startutc alias for $2;
            _completeutc alias for $3;
            _laststatusupdateutc alias for $4;
            _completeratio alias for $5;
            _status alias for $6;
	    _rowcount int4;
begin
update 		mp_taskqueue

set
           
            startutc = _startutc, 
            completeutc = _completeutc, 
            laststatusupdateutc = _laststatusupdateutc, 
            completeratio = _completeratio, 
            status = _status
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) OWNER TO test;

--
-- Name: mp_taskqueue_updatenotification(character, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_updatenotification(character, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _notificationsentutc alias for $2;
	    _rowcount int4;
begin
update 		mp_taskqueue

set
           
            notificationsentutc = _notificationsentutc
           
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_updatenotification(character, timestamp without time zone) OWNER TO test;

--
-- Name: mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _startutc alias for $2;
            _laststatusupdateutc alias for $3;
            _completeratio alias for $4;
            _status alias for $5;
	    _rowcount int4;
begin
update 		mp_taskqueue

set
           
            startutc = _startutc, 
            laststatusupdateutc = _laststatusupdateutc, 
            completeratio = _completeratio, 
            status = _status
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) OWNER TO test;

--
-- Name: mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) RETURNS integer
    AS $_$

declare
            _guid alias for $1;
            _laststatusupdateutc alias for $2;
            _completeratio alias for $3;
            _status alias for $4;
	    _rowcount int4;
begin
update 		mp_taskqueue

set
           
            laststatusupdateutc = _laststatusupdateutc, 
            completeratio = _completeratio, 
            status = _status
            
where
            guid = _guid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) OWNER TO test;

--
-- Name: mp_userlocation_countbysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_countbysite(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_userlocation
where		siteguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_countbysite(character) OWNER TO test;

--
-- Name: mp_userlocation_countbyuser(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_countbyuser(character) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_userlocation
where		userguid = $1
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_countbyuser(character) OWNER TO test;

--
-- Name: mp_userlocation_delete(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_delete(character) RETURNS integer
    AS $_$
declare
            _rowid alias for $1;
			_rowcount int4;
begin
	delete from mp_userlocation
	where rowid = _rowid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_delete(character) OWNER TO test;

--
-- Name: mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) RETURNS integer
    AS $_$
declare
            _rowid alias for $1;
            _userguid alias for $2;
            _siteguid alias for $3;
            _ipaddress alias for $4;
            _ipaddresslong alias for $5;
            _hostname alias for $6;
            _longitude alias for $7;
            _latitude alias for $8;
            _isp alias for $9;
            _continent alias for $10;
            _country alias for $11;
            _region alias for $12;
            _city alias for $13;
            _timezone alias for $14;
            _capturecount alias for $15;
            _firstcaptureutc alias for $16;
            _lastcaptureutc alias for $17;
			_rowcount int4;
begin

insert into 	mp_userlocation
(			
                rowid,
                userguid,
                siteguid,
                ipaddress,
                ipaddresslong,
                hostname,
                longitude,
                latitude,
                isp,
                continent,
                country,
                region,
                city,
                timezone,
                capturecount,
                firstcaptureutc,
                lastcaptureutc
) 
values 
(				
                _rowid, 
                _userguid, 
                _siteguid, 
                _ipaddress, 
                _ipaddresslong, 
                _hostname, 
                _longitude, 
                _latitude, 
                _isp, 
                _continent, 
                _country, 
                _region, 
                _city, 
                _timezone, 
                _capturecount, 
                _firstcaptureutc, 
                _lastcaptureutc 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) OWNER TO test;

--
-- Name: mp_userlocation_select_bysite(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_select_bysite(character) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$

select
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc
from
        mp_userlocation
        
where
        siteguid = $1
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_select_bysite(character) OWNER TO test;

--
-- Name: mp_userlocation_select_byuser(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_select_byuser(character) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$

select
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc
from
        mp_userlocation
        
where
        userguid = $1
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_select_byuser(character) OWNER TO test;

--
-- Name: mp_userlocation_select_one(character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_select_one(character) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$

select
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc
from
        mp_userlocation
        
where
        rowid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_select_one(character) OWNER TO test;

--
-- Name: mp_userlocation_select_onebyuserandip(character, bigint); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_select_onebyuserandip(character, bigint) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$

select
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc
from
        mp_userlocation
        
where
        userguid = $1
        and ipaddresslong = $2
        ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_select_onebyuserandip(character, bigint) OWNER TO test;

--
-- Name: mp_userlocation_selectpagebyite(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_selectpagebyite(character, integer, integer) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$
declare
	_siteguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_userlocation_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc

	from mp_userlocation
	where siteguid = _siteguid
	order by ipaddresslong	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_selectpagebyite(character, integer, integer) OWNER TO test;

--
-- Name: mp_userlocation_selectpagebyuser(character, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_selectpagebyuser(character, integer, integer) RETURNS SETOF mp_userlocation_select_one_type
    AS $_$
declare
	_userguid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_pagelowerbound int;
	_rec mp_userlocation_select_one_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;

for _rec in
	select 
        rowid,
        userguid,
        siteguid,
        ipaddress,
        ipaddresslong,
        hostname,
        longitude,
        latitude,
        isp,
        continent,
        country,
        region,
        city,
        timezone,
        capturecount,
        firstcaptureutc,
        lastcaptureutc

	from mp_userlocation
	where userguid = _userguid
	order by ipaddresslong	
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_selectpagebyuser(character, integer, integer) OWNER TO test;

--
-- Name: mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) RETURNS integer
    AS $_$

declare
            _rowid alias for $1;
            _userguid alias for $2;
            _siteguid alias for $3;
            _ipaddress alias for $4;
            _ipaddresslong alias for $5;
            _hostname alias for $6;
            _longitude alias for $7;
            _latitude alias for $8;
            _isp alias for $9;
            _continent alias for $10;
            _country alias for $11;
            _region alias for $12;
            _city alias for $13;
            _timezone alias for $14;
            _capturecount alias for $15;
            _lastcaptureutc alias for $16;
			_rowcount int4;
begin
update 		mp_userlocation

set
            userguid = _userguid, 
            siteguid = _siteguid, 
            ipaddress = _ipaddress, 
            ipaddresslong = _ipaddresslong, 
            hostname = _hostname, 
            longitude = _longitude, 
            latitude = _latitude, 
            isp = _isp, 
            continent = _continent, 
            country = _country, 
            region = _region, 
            city = _city, 
            timezone = _timezone, 
            capturecount = _capturecount, 
            lastcaptureutc = _lastcaptureutc 
            
where
            rowid = _rowid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_userpages_delete(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_delete(character varying) RETURNS integer
    AS $_$
declare
_userpageid alias for $1;
_rowcount int4;
begin
	delete from mp_userpages
	where userpageid = _userpageid;
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_delete(character varying) OWNER TO test;

--
-- Name: mp_userpages_getnextpageorder(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_getnextpageorder(character varying) RETURNS integer
    AS $_$
select	coalesce(max(pageorder), -1) + 2
from		mp_userpages
where	userguid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_getnextpageorder(character varying) OWNER TO test;

--
-- Name: mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) RETURNS integer
    AS $_$
declare
_userpageid alias for $1;
_siteid alias for $2;
_userguid alias for $3;
_pagename alias for $4;
_pagepath alias for $5;
_pageorder alias for $6;
_siteguid alias for $7;
_rowcount int4;
begin
insert into 	mp_userpages
(			
                userpageid,
                siteid,
                userguid,
                pagename,
                pagepath,
                pageorder,
                siteguid
) 
values 
(				
                _userpageid, 
                _siteid, 
                _userguid, 
                _pagename, 
                _pagepath, 
                _pageorder ,
                _siteguid
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) OWNER TO test;

--
-- Name: mp_userpages_select_byuserv2(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_select_byuserv2(character varying) RETURNS SETOF mp_userpages
    AS $_$

select
        *
from
        mp_userpages
        
where
        userguid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_select_byuserv2(character varying) OWNER TO test;

--
-- Name: mp_userpages_select_onev2(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_select_onev2(character varying) RETURNS SETOF mp_userpages
    AS $_$

select
        *
from
        mp_userpages
        
where
        userpageid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_select_onev2(character varying) OWNER TO test;

--
-- Name: mp_userpages_update(character varying, character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_update(character varying, character varying, integer) RETURNS integer
    AS $_$
declare
_userpageid alias for $1;
_pagename alias for $2;
_pageorder alias for $3;
_rowcount int4;
begin
update 		mp_userpages
set  
            pagename = _pagename, 
            pageorder = _pageorder 
            
where
            userpageid = _userpageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_update(character varying, character varying, integer) OWNER TO test;

--
-- Name: mp_userpages_updatepageorder(character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userpages_updatepageorder(character varying, integer) RETURNS integer
    AS $_$

declare
            _userpageid alias for $1;
            _pageorder alias for $2;
			_rowcount int4;
begin
update 		mp_userpages

set
          
            pageorder = _pageorder 
            
where
            userpageid = _userpageid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userpages_updatepageorder(character varying, integer) OWNER TO test;

--
-- Name: mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) RETURNS integer
    AS $_$
declare
            _propertyid alias for $1;
            _userguid alias for $2;
            _propertyname alias for $3;
            _propertyvaluestring alias for $4;
            _propertyvaluebinary alias for $5;
            _lastupdateddate alias for $6;
            _islazyloaded alias for $7;
			_rowcount int4;
begin

insert into 	mp_userproperties
(			
                propertyid,
                userguid,
                propertyname,
                propertyvaluestring,
                propertyvaluebinary,
                lastupdateddate,
                islazyloaded
) 
values 
(				
                _propertyid, 
                _userguid, 
                _propertyname, 
                _propertyvaluestring, 
                _propertyvaluebinary, 
                _lastupdateddate, 
                _islazyloaded 
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) OWNER TO test;

--
-- Name: mp_userproperties_propertyexists(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userproperties_propertyexists(character varying, character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_userproperties
where	userguid = $1 AND propertyname = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userproperties_propertyexists(character varying, character varying) OWNER TO test;

--
-- Name: mp_userproperties_select_byuser(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userproperties_select_byuser(character varying) RETURNS SETOF mp_userproperties_select_type
    AS $_$

select
        propertyid,
        userguid,
        propertyname,
        propertyvaluestring,
        propertyvaluebinary,
        lastupdateddate,
        islazyloaded
from
        mp_userproperties
        
where
        userguid = $1 and islazyloaded = false
 ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userproperties_select_byuser(character varying) OWNER TO test;

--
-- Name: mp_userproperties_select_one(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userproperties_select_one(character varying, character varying) RETURNS SETOF mp_userproperties_select_type
    AS $_$

select
        propertyid,
        userguid,
        propertyname,
        propertyvaluestring,
        propertyvaluebinary,
        lastupdateddate,
        islazyloaded
from
        mp_userproperties
        
where
        userguid = $1 and propertyname = $2
        limit 1 ;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userproperties_select_one(character varying, character varying) OWNER TO test;

--
-- Name: mp_userproperties_update(character varying, character varying, text, bytea, date, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) RETURNS integer
    AS $_$

declare
            _userguid alias for $1;
            _propertyname alias for $2;
            _propertyvaluestring alias for $3;
            _propertyvaluebinary alias for $4;
            _lastupdateddate alias for $5;
            _islazyloaded alias for $6;
			_rowcount int4;
begin
update 		mp_userproperties

set
            propertyvaluestring = _propertyvaluestring, 
            propertyvaluebinary = _propertyvaluebinary, 
            lastupdateddate = _lastupdateddate, 
            islazyloaded = _islazyloaded 
            
where
            userguid = _userguid and
            propertyname = _propertyname
            ; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) OWNER TO test;

--
-- Name: mp_userroles_delete(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userroles_delete(integer, integer) RETURNS integer
    AS $_$
declare
	_roleid alias for $1;
	_userid alias for $2;
	_rowcount int4;
begin

	delete from 
    mp_userroles
where
    userid = _userid
    and
    roleid = _roleid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userroles_delete(integer, integer) OWNER TO test;

--
-- Name: mp_userroles_deleteuserroles(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userroles_deleteuserroles(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_userroles
where
    userid = _userid  ; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userroles_deleteuserroles(integer) OWNER TO test;

--
-- Name: mp_userroles_insert(integer, integer, character, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userroles_insert(integer, integer, character, character) RETURNS integer
    AS $_$
declare
	_roleid alias for $1;
	_userid alias for $2;
	_roleguid alias for $3;
	_userguid alias for $4;
	t_found int4;
	_rowcount int4;

begin

_rowcount := 0;
select into t_found 1 from
    mp_userroles
	where
	    userid=_userid
	    and
	    roleid=_roleid limit 1;

if not found then

    insert into mp_userroles
    (
        userid,
        roleid,
        roleguid,
        userguid
    )
    values
    (
        _userid,
        _roleid,
        _roleguid,
        _userguid
    );   
	GET DIAGNOSTICS _rowcount = ROW_COUNT;
end if;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_userroles_insert(integer, integer, character, character) OWNER TO test;

--
-- Name: mp_userroles_selectbyroleid(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userroles_selectbyroleid(integer) RETURNS SETOF mp_userroles_selectbyroleid_type
    AS $_$
select  
    mp_userroles.userid,
    name,
    email
from
    mp_userroles
    
inner join 
    mp_users on mp_users.userid = mp_userroles.userid
where   
    mp_userroles.roleid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userroles_selectbyroleid(integer) OWNER TO test;

--
-- Name: mp_userroles_selectnotinrole(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_userroles_selectnotinrole(integer, integer) RETURNS SETOF mp_userroles_selectbyroleid_type
    AS $_$
select  
    u.userid,
    u.name,
    u.email
from
    mp_users u 
    
left outer join 
    mp_userroles  ur
    
on ur.userid = u.userid
and ur.roleid = $2

where   
    u.siteid = $1
    and ur.roleid is null
order by u.name
    ; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_userroles_selectnotinrole(integer, integer) OWNER TO test;

--
-- Name: mp_users_accountlockout(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_accountlockout(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_lastlockoutdate alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set islockedout = true,
    	lastlockoutdate = _lastlockoutdate
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_accountlockout(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_clearlockout(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_clearlockout(character varying) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_rowcount int4;
begin

    update 
    mp_users
    set islockedout = false
    
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_clearlockout(character varying) OWNER TO test;

--
-- Name: mp_users_confirmregistration(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_confirmregistration(character varying, character varying) RETURNS integer
    AS $_$
declare
	_emptyguid alias for $1;
	_registerconfirmguid alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set islockedout = false,
    	registerconfirmguid = _emptyguid
where
    registerconfirmguid = _registerconfirmguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_confirmregistration(character varying, character varying) OWNER TO test;

--
-- Name: mp_users_count(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_count(integer) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_users
where siteid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_count(integer) OWNER TO test;

--
-- Name: mp_users_countbyfirstletter(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_countbyfirstletter(integer, character varying) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_users
where siteid = $1
and	name like $2

; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_countbyfirstletter(integer, character varying) OWNER TO test;

--
-- Name: mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_users
where siteid = $1
and datecreated >= $2
and datecreated < $3
; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_countonlinesince(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_countonlinesince(integer, timestamp without time zone) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_users
where siteid = $1 and lastactivitydate > $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_countonlinesince(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_decrementtotalposts(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_decrementtotalposts(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

update		mp_users
set			totalposts = totalposts - 1
where		userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_decrementtotalposts(integer) OWNER TO test;

--
-- Name: mp_users_delete(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_delete(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

	delete from 
    mp_users
where
    userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_delete(integer) OWNER TO test;

--
-- Name: mp_users_flagasdeleted(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_flagasdeleted(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

 update mp_users
 set isdeleted = true
where
    userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_flagasdeleted(integer) OWNER TO test;

--
-- Name: mp_users_getnewestid(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_getnewestid(integer) RETURNS integer
    AS $_$
select  	cast(max(userid) as int4)
from		mp_users
where siteid = $1

; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_getnewestid(integer) OWNER TO test;

--
-- Name: mp_users_gettop50usersonlinesince(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_gettop50usersonlinesince(integer, timestamp without time zone) RETURNS SETOF mp_users
    AS $_$
select	*
from
    mp_users
where
	siteid = $1
   	and lastactivitydate > $2
   	order by lastactivitydate desc
   	limit 50
   	; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_gettop50usersonlinesince(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_getuserroles(integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_getuserroles(integer, integer) RETURNS SETOF mp_users_getuserroles_type
    AS $_$
select  
    		mp_roles.rolename,
    		mp_roles.roleid
from		 mp_userroles
  
inner join 	mp_users 
on 		mp_userroles.userid = mp_users.userid
inner join 	mp_roles 
on 		mp_userroles.roleid = mp_roles.roleid
where   	mp_users.siteid = $1
		and mp_users.userid = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_getuserroles(integer, integer) OWNER TO test;

--
-- Name: mp_users_getusersonlinesince(integer, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_getusersonlinesince(integer, timestamp without time zone) RETURNS SETOF mp_users
    AS $_$
select	*
from
    mp_users
where
	siteid = $1
   	and lastactivitydate > $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_getusersonlinesince(integer, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_incrementtotalposts(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_incrementtotalposts(integer) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_rowcount int4;
begin

update		mp_users
set			totalposts = totalposts + 1
where		userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_incrementtotalposts(integer) OWNER TO test;

--
-- Name: mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) RETURNS integer
    AS $_$
insert into 		mp_users
(
			siteid,
    			name,
    			loginname,
    			email,
    			password,
			userguid,
			datecreated,
			siteguid
	
)
values
(
			$1,
    			$2,
    			$3,
    			$4,
			$5,
			$6,
			$7,
			$8
);
select		cast(currval('mp_users_userid_seq') as int4); $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) OWNER TO test;

--
-- Name: mp_users_login(integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_login(integer, character varying, character varying) RETURNS SETOF mp_users_login_type
    AS $_$
select
	name as username
from
    mp_users
where
		siteid = $1
    		and loginname = $2
  		and password = $3; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_login(integer, character varying, character varying) OWNER TO test;

--
-- Name: mp_users_loginbyemail(integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_loginbyemail(integer, character varying, character varying) RETURNS SETOF mp_users_loginbyemail_type
    AS $_$
select
	name as username
from
    mp_users
where
		siteid = $1
    		and email = $2
  		and password = $3; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_loginbyemail(integer, character varying, character varying) OWNER TO test;

--
-- Name: mp_users_select(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_select(integer) RETURNS SETOF mp_users_select_type
    AS $_$
select  
    userid,
    email,
    name,
    password
from
    mp_users
where siteid = $1
    
order by email; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_select(integer) OWNER TO test;

--
-- Name: mp_users_selectbyemail(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectbyemail(integer, character varying) RETURNS SETOF mp_users
    AS $_$
select	*
from
    mp_users
where
	siteid = $1
   	and email = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectbyemail(integer, character varying) OWNER TO test;

--
-- Name: mp_users_selectbyloginname(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectbyloginname(integer, character varying) RETURNS SETOF mp_users
    AS $_$
select	*
from
    mp_users
where
	siteid = $1
   	and loginname = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectbyloginname(integer, character varying) OWNER TO test;

--
-- Name: mp_users_selectguidbyopeniduri(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectguidbyopeniduri(integer, character varying) RETURNS SETOF mp_users
    AS $_$
select	*
from		mp_users
where	siteid = $1 and openiduri = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectguidbyopeniduri(integer, character varying) OWNER TO test;

--
-- Name: mp_users_selectguidbywindowsliveid(integer, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectguidbywindowsliveid(integer, character varying) RETURNS SETOF mp_users
    AS $_$
select	*
from		mp_users
where	siteid = $1 and openiduri = $2; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectguidbywindowsliveid(integer, character varying) OWNER TO test;

--
-- Name: mp_users_selectone(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectone(integer) RETURNS SETOF mp_users
    AS $_$
select	*
from		mp_users
where	userid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectone(integer) OWNER TO test;

--
-- Name: mp_users_selectonebyguid(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectonebyguid(character varying) RETURNS SETOF mp_users
    AS $_$
select	*
from		mp_users
where	userguid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectonebyguid(character varying) OWNER TO test;

--
-- Name: mp_users_selectpage(integer, integer, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_selectpage(integer, integer, character varying, integer, integer) RETURNS SETOF mp_users_selectpage_type
    AS $_$
declare
	_pagenumber alias for $1;
	_pagesize alias for $2;
	_usernamebeginswith alias for $3;
	_siteid alias for $4;
	_totalpages alias for $5;
	 _pagelowerbound int;
	 _pageupperbound int;
	 _totalrows int;
	 _remainder int;
	_rec mp_users_selectpage_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;
_pageupperbound := _pagelowerbound + _pagesize + 1;

for _rec in
	select 
		userid,
		siteid,
		name,
		loginname,
		email,
		loweredemail,
		password,
		passwordquestion,
		passwordanswer,
		gender,
		profileapproved,
		registerconfirmguid,
		approvedforforums,
		trusted,
		displayinmemberlist,
		websiteurl,
		country,
		state,
		occupation,
		interests,
		msn,
		yahoo,
		aim,
		icq,
		totalposts,
		avatarurl,
		timeoffsethours,
		signature,
		datecreated,
		userguid,
		skin,
		isdeleted,
		lastactivitydate,
		lastlogindate,
		lastpasswordchangeddate,
		lastlockoutdate,
		failedpasswordattemptcount,
		failedpwdattemptwindowstart,
		failedpwdanswerattemptcount,
		failedpwdanswerwindowstart,
		islockedout,
		mobilepin,
		passwordsalt,
        	comment,
		_totalpages as totalpages

	from 		mp_users 
	where 	profileapproved = true
	 and 	displayinmemberlist = true  
	 and 	siteid = _siteid
	 and 	isdeleted = false
	 and	(_usernamebeginswith is null 
		or _usernamebeginswith = ''
		or name like _usernamebeginswith)
	order by 	name
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_selectpage(integer, integer, character varying, integer, integer) OWNER TO test;

--
-- Name: mp_users_setfailedpasswordanswerattemptcount(character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_setfailedpasswordanswerattemptcount(character varying, integer) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_attemptcount alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set 
    	failedpwdanswerattemptcount = _attemptcount
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_setfailedpasswordanswerattemptcount(character varying, integer) OWNER TO test;

--
-- Name: mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_windowstarttime alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set 
    	failedpwdanswerwindowstart = _windowstarttime
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_setfailedpasswordattemptcount(character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_setfailedpasswordattemptcount(character varying, integer) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_attemptcount alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set 
    	failedpasswordattemptcount = _attemptcount
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_setfailedpasswordattemptcount(character varying, integer) OWNER TO test;

--
-- Name: mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_windowstarttime alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set 
    	failedpwdattemptwindowstart = _windowstarttime
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_setregistrationguid(character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_setregistrationguid(character varying, character varying) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_registerconfirmguid alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set islockedout = true,
    	registerconfirmguid = _registerconfirmguid
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_setregistrationguid(character varying, character varying) OWNER TO test;

--
-- Name: mp_users_smartdropdown(integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_smartdropdown(integer, character varying, integer) RETURNS SETOF mp_users_smartdropdown_type
    AS $_$


SELECT 		u1.userid,
		u1.name AS siteuser

FROM		mp_users u1

WHERE		u1.siteid = $1
		AND u1.name LIKE $2 

UNION

SELECT 		u2.userid,
		u2.email As siteuser

FROM		mp_users u2

WHERE		u2.siteid = $1
		AND u2.email LIKE $2 

ORDER BY	siteuser

LIMIT $3   ;  $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_smartdropdown(integer, character varying, integer) OWNER TO test;

--
-- Name: mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) RETURNS integer
    AS $_$
declare
	_userid alias for $1;
	_name alias for $2;
	_loginname alias for $3;
	_email alias for $4;
	_password alias for $5;
	_gender alias for $6;
	_profileapproved alias for $7;
	_approvedforforums alias for $8;
	_trusted alias for $9;
	_displayinmemberlist alias for $10;
	_websiteurl alias for $11;
	_country alias for $12;
	_state alias for $13;
	_occupation alias for $14;
	_interests alias for $15;
	_msn alias for $16;
	_yahoo alias for $17;
	_aim alias for $18;
	_icq alias for $19;
	_avatarurl alias for $20;
	_signature alias for $21;
	_skin alias for $22;
	_loweredemail alias for $23;
	_passwordquestion alias for $24;
	_passwordanswer alias for $25;
	_comment alias for $26;
	_timeoffsethours alias for $27;
	_rowcount int4;
begin

update		mp_users
set			name = _name,
			loginname = _loginname,
			email = _email,
    			password = _password,
			gender = _gender,
			profileapproved = _profileapproved,
			approvedforforums = _approvedforforums,
			trusted = _trusted,
			displayinmemberlist = _displayinmemberlist,
			websiteurl = _websiteurl,
			country = _country,
			state = _state,
			occupation = _occupation,
			interests = _interests,
			msn = _msn,
			yahoo = _yahoo,
			aim = _aim,
			icq = _icq,
			avatarurl = _avatarurl,
			signature = _signature,
			skin = _skin,
			loweredemail = _loweredemail,
			passwordquestion = _passwordquestion,
			passwordanswer = _passwordanswer,
			comment = _comment,
			timeoffsethours = _timeoffsethours
			
where		userid = _userid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) OWNER TO test;

--
-- Name: mp_users_updatelastactivitytime(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_updatelastactivitytime(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_lastactivitydate alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set lastactivitydate = _lastactivitydate
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_updatelastactivitytime(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_updatelastlogintime(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_updatelastlogintime(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_lastlogindate alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set lastlogindate = _lastlogindate
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_updatelastlogintime(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_lastpasswordchangeddate alias for $2;
	_rowcount int4;
begin

    update 
    mp_users
    set 
    	lastpasswordchangeddate = _lastpasswordchangeddate
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) OWNER TO test;

--
-- Name: mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) RETURNS integer
    AS $_$
declare
	_userguid alias for $1;
	_passwordquestion alias for $2;
	_passwordanswer alias for $3;
	_rowcount int4;
begin

    update 
    mp_users
    set passwordquestion = _passwordquestion,
    	passwordanswer = _passwordanswer
where
    userguid = _userguid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) OWNER TO test;

--
-- Name: mp_webparts_count(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_count(integer) RETURNS integer
    AS $_$
select  	cast(count(*) as int4)
from		mp_webparts
where siteid = $1; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_count(integer) OWNER TO test;

--
-- Name: mp_webparts_delete(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_delete(character varying) RETURNS integer
    AS $_$
declare
            _webpartid alias for $1;
			_rowcount int4;
begin
	delete from mp_webparts
	where webpartid = _webpartid;
	
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_delete(character varying) OWNER TO test;

--
-- Name: mp_webparts_exists(integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_exists(integer, character varying, character varying) RETURNS integer
    AS $_$
select	cast(count(*) as int4)
from		mp_webparts
where	siteid = $1 AND classname = $2 AND assemblyname = $3; $_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_exists(integer, character varying, character varying) OWNER TO test;

--
-- Name: mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) RETURNS integer
    AS $_$
declare
_webpartid alias for $1;
_siteid alias for $2;
_title alias for $3;
_description alias for $4;
_imageurl alias for $5;
_classname alias for $6;
_assemblyname alias for $7;
_availableformypage alias for $8;
_allowmultipleinstancesonmypage alias for $9;
_availableforcontentsystem alias for $10;
_siteguid alias for $11;
_rowcount int4;
begin
insert into 	mp_webparts
(			
                webpartid,
                siteid,
                title,
                description,
                imageurl,
                classname,
                assemblyname,
                availableformypage,
                allowmultipleinstancesonmypage,
                availableforcontentsystem,
                siteguid
) 
values 
(				
                _webpartid, 
                _siteid, 
                _title, 
                _description, 
                _imageurl, 
                _classname, 
                _assemblyname, 
                _availableformypage, 
                _allowmultipleinstancesonmypage, 
                _availableforcontentsystem,
                _siteguid
);
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
--SELECT 1;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) OWNER TO test;

--
-- Name: mp_webparts_select_bysite(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_select_bysite(integer) RETURNS SETOF mp_webparts_select_bysite_type
    AS $_$

select
        webpartid,
        siteid,
        title,
        description,
        imageurl,
        classname,
        assemblyname,
        availableformypage,
        allowmultipleinstancesonmypage,
        availableforcontentsystem,
        countofuseonmypage 
from
        mp_webparts
        
where
        siteid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_select_bysite(integer) OWNER TO test;

--
-- Name: mp_webparts_select_formypage(integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_select_formypage(integer) RETURNS SETOF mp_webparts_select_formypage_type
    AS $_$

SELECT  		m.moduleid,
				m.siteid,
				m.moduledefid,
				m.moduletitle,
				m.allowmultipleinstancesonmypage,
				m.countofuseonmypage ,
				m.icon As moduleicon,
				md.icon As featureicon,
				md.featurename,
				false As isassembly,
				'' As webpartid
				
FROM
    			mp_modules m
  
INNER JOIN
    			mp_moduledefinitions md
ON 			m.moduledefid = md.moduledefid

WHERE   
    			m.siteid = $1
				AND m.availableformypage = true

UNION

SELECT
				-1 As moduleID,
				w.siteID,
				0 As muduledefid,
				w.title As moduletitle,
				w.allowmultipleinstancesonmypage,
				w.countofuseonmypage ,
				w.imageurl As moduleicon,
				w.imageurl As featureicon,
				w.description As featurename,
				true As isassembly,
				w.webpartid

FROM			mp_WebParts w

WHERE			w.siteid = $1
				AND w.availableformypage = true
				
ORDER BY
    			moduletitle;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_select_formypage(integer) OWNER TO test;

--
-- Name: mp_webparts_select_onev2(character varying); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_select_onev2(character varying) RETURNS SETOF mp_webparts
    AS $_$

select
        *
from
        mp_webparts
        
where
        webpartid = $1;$_$
    LANGUAGE sql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_select_onev2(character varying) OWNER TO test;

--
-- Name: mp_webparts_selectpage(integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_selectpage(integer, integer, integer, boolean, boolean) RETURNS SETOF mp_webparts_selectpage_type
    AS $_$
declare
	_siteid alias for $1;
	_pagenumber alias for $2;
	_pagesize alias for $3;
	_sortbyclassname alias for $4;
	_sortbyassemblyname alias for $5;
	 _pagelowerbound int;
	 _pageupperbound int;
	 _totalrows int;
	 _remainder int;
	_rec mp_webparts_selectpage_type%ROWTYPE;

begin

_pagelowerbound := (_pagesize * _pagenumber) - _pagesize;
_pageupperbound := _pagelowerbound + _pagesize + 1;

if _sortbyclassname = true then
for _rec in
	select 
		webpartid,
		siteid,
		title,
		description,
		imageurl,
		classname,
		assemblyname,
		availableformypage,
		allowmultipleinstancesonmypage,
		availableforcontentsystem,
        	countofuseonmypage 
		

	from 		mp_webparts 
	
	where siteid = $1 
	order by 	classname, title
	limit 	_pagesize
	offset 	_pagelowerbound
loop
	return next _rec;
end loop;
else
	if _sortbyassemblyname = true then
	for _rec in
		select 
			webpartid,
			siteid,
			title,
			description,
			imageurl,
			classname,
			assemblyname,
			availableformypage,
			allowmultipleinstancesonmypage,
			availableforcontentsystem,
        		countofuseonmypage 
			
	
		from 		mp_webparts 
		
		where siteid = $1 
		order by 	assemblyname, title
		limit 	_pagesize
		offset 	_pagelowerbound
	loop
		return next _rec;
	end loop;
	else
		
		for _rec in
			select 
			webpartid,
			siteid,
			title,
			description,
			imageurl,
			classname,
			assemblyname,
			availableformypage,
			allowmultipleinstancesonmypage,
			availableforcontentsystem,
        		countofuseonmypage 
				
		
			from 		mp_webparts 
			
			where siteid = $1 
			order by 	title, classname
			limit 	_pagesize
			offset 	_pagelowerbound
		loop
			return next _rec;
		end loop;
		
	end if;
end if;

return;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_selectpage(integer, integer, integer, boolean, boolean) OWNER TO test;

--
-- Name: mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) RETURNS integer
    AS $_$
declare
_webpartid alias for $1;
_siteid alias for $2;
_title alias for $3;
_description alias for $4;
_imageurl alias for $5;
_classname alias for $6;
_assemblyname alias for $7;
_availableformypage alias for $8;
_allowmultipleinstancesonmypage alias for $9;
_availableforcontentsystem alias for $10;
_rowcount int4;
begin
update 		mp_webparts
set
            siteid = _siteid, 
            title = _title, 
            description = _description, 
            imageurl = _imageurl, 
            classname = _classname, 
            assemblyname = _assemblyname, 
            availableformypage = _availableformypage, 
            allowmultipleinstancesonmypage = _allowmultipleinstancesonmypage, 
            availableforcontentsystem = _availableforcontentsystem   
where
            webpartid = _webpartid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) OWNER TO test;

--
-- Name: mp_webparts_updatecountofuseonmypage(character varying, integer); Type: FUNCTION; Schema: public; Owner: test
--

CREATE FUNCTION mp_webparts_updatecountofuseonmypage(character varying, integer) RETURNS integer
    AS $_$
declare
	_webpartid alias for $1;
	_increment alias for $2;
	_rowcount int4;
begin

update
    mp_webparts
set
    countofuseonmypage = countofuseonmypage + _increment
where
    webpartid = _webpartid; 
GET DIAGNOSTICS _rowcount = ROW_COUNT;
return _rowcount;
end$_$
    LANGUAGE plpgsql SECURITY DEFINER;


ALTER FUNCTION public.mp_webparts_updatecountofuseonmypage(character varying, integer) OWNER TO test;

--
-- Name: mp_bannedipaddressesid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_bannedipaddressesid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_bannedipaddressesid_seq OWNER TO test;

--
-- Name: mp_bannedipaddressesid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_bannedipaddressesid_seq', 1, false);


--
-- Name: mp_blogcategories_categoryid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_blogcategories_categoryid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_blogcategories_categoryid_seq OWNER TO test;

--
-- Name: mp_blogcategories_categoryid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_blogcategories_categoryid_seq', 1, false);


--
-- Name: mp_blogcomments_blogcommentid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_blogcomments_blogcommentid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_blogcomments_blogcommentid_seq OWNER TO test;

--
-- Name: mp_blogcomments_blogcommentid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_blogcomments_blogcommentid_seq', 1, false);


--
-- Name: mp_blogitemcategories_id_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_blogitemcategories_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_blogitemcategories_id_seq OWNER TO test;

--
-- Name: mp_blogitemcategories_id_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_blogitemcategories_id_seq', 1, false);


--
-- Name: mp_blogs_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_blogs_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_blogs_itemid_seq OWNER TO test;

--
-- Name: mp_blogs_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_blogs_itemid_seq', 1, false);


--
-- Name: mp_calendarevents_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_calendarevents_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_calendarevents_itemid_seq OWNER TO test;

--
-- Name: mp_calendarevents_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_calendarevents_itemid_seq', 1, false);


--
-- Name: mp_forumposts_postid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_forumposts_postid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_forumposts_postid_seq OWNER TO test;

--
-- Name: mp_forumposts_postid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_forumposts_postid_seq', 1, false);


--
-- Name: mp_forums_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_forums_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_forums_itemid_seq OWNER TO test;

--
-- Name: mp_forums_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_forums_itemid_seq', 1, false);


--
-- Name: mp_forumsubscriptions_subscriptionid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_forumsubscriptions_subscriptionid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_forumsubscriptions_subscriptionid_seq OWNER TO test;

--
-- Name: mp_forumsubscriptions_subscriptionid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_forumsubscriptions_subscriptionid_seq', 1, false);


--
-- Name: mp_forumthreads_threadid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_forumthreads_threadid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_forumthreads_threadid_seq OWNER TO test;

--
-- Name: mp_forumthreads_threadid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_forumthreads_threadid_seq', 1, false);


--
-- Name: mp_forumthreadsubscriptions_threadsubscriptionid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_forumthreadsubscriptions_threadsubscriptionid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_forumthreadsubscriptions_threadsubscriptionid_seq OWNER TO test;

--
-- Name: mp_forumthreadsubscriptions_threadsubscriptionid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_forumthreadsubscriptions_threadsubscriptionid_seq', 1, false);


--
-- Name: mp_friendlyurls_urlid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_friendlyurls_urlid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_friendlyurls_urlid_seq OWNER TO test;

--
-- Name: mp_friendlyurls_urlid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_friendlyurls_urlid_seq', 1, true);


--
-- Name: mp_galleryimages_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_galleryimages_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_galleryimages_itemid_seq OWNER TO test;

--
-- Name: mp_galleryimages_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_galleryimages_itemid_seq', 1, false);


--
-- Name: mp_htmlcontent_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_htmlcontent_itemid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_htmlcontent_itemid_seq OWNER TO test;

--
-- Name: mp_htmlcontent_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_htmlcontent_itemid_seq', 1, true);


--
-- Name: mp_indexingqueueid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_indexingqueueid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_indexingqueueid_seq OWNER TO test;

--
-- Name: mp_indexingqueueid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_indexingqueueid_seq', 1, true);


--
-- Name: mp_lettersendlogrowid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_lettersendlogrowid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_lettersendlogrowid_seq OWNER TO test;

--
-- Name: mp_lettersendlogrowid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_lettersendlogrowid_seq', 1, false);


--
-- Name: mp_lettersubscriberhxrowid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_lettersubscriberhxrowid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_lettersubscriberhxrowid_seq OWNER TO test;

--
-- Name: mp_lettersubscriberhxrowid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_lettersubscriberhxrowid_seq', 1, false);


--
-- Name: mp_links_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_links_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_links_itemid_seq OWNER TO test;

--
-- Name: mp_links_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_links_itemid_seq', 1, false);


--
-- Name: mp_moduledefinitions_moduledefid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_moduledefinitions_moduledefid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_moduledefinitions_moduledefid_seq OWNER TO test;

--
-- Name: mp_moduledefinitions_moduledefid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_moduledefinitions_moduledefid_seq', 14, true);


--
-- Name: mp_moduledefinitionsettings_id_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_moduledefinitionsettings_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_moduledefinitionsettings_id_seq OWNER TO test;

--
-- Name: mp_moduledefinitionsettings_id_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_moduledefinitionsettings_id_seq', 114, true);


--
-- Name: mp_modules_moduleid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_modules_moduleid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_modules_moduleid_seq OWNER TO test;

--
-- Name: mp_modules_moduleid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_modules_moduleid_seq', 1, true);


--
-- Name: mp_modulesettings_id_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_modulesettings_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_modulesettings_id_seq OWNER TO test;

--
-- Name: mp_modulesettings_id_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_modulesettings_id_seq', 6, true);


--
-- Name: mp_pages_pageid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_pages_pageid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_pages_pageid_seq OWNER TO test;

--
-- Name: mp_pages_pageid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_pages_pageid_seq', 1, true);


--
-- Name: mp_roles_roleid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_roles_roleid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_roles_roleid_seq OWNER TO test;

--
-- Name: mp_roles_roleid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_roles_roleid_seq', 7, true);


--
-- Name: mp_rssfeeds_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_rssfeeds_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_rssfeeds_itemid_seq OWNER TO test;

--
-- Name: mp_rssfeeds_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_rssfeeds_itemid_seq', 1, false);


--
-- Name: mp_schemascripthistoryid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_schemascripthistoryid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_schemascripthistoryid_seq OWNER TO test;

--
-- Name: mp_schemascripthistoryid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_schemascripthistoryid_seq', 31, true);


--
-- Name: mp_sharedfilefolders_folderid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_sharedfilefolders_folderid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_sharedfilefolders_folderid_seq OWNER TO test;

--
-- Name: mp_sharedfilefolders_folderid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_sharedfilefolders_folderid_seq', 1, false);


--
-- Name: mp_sharedfiles_itemid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_sharedfiles_itemid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_sharedfiles_itemid_seq OWNER TO test;

--
-- Name: mp_sharedfiles_itemid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_sharedfiles_itemid_seq', 1, false);


--
-- Name: mp_sharedfileshistory_id_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_sharedfileshistory_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_sharedfileshistory_id_seq OWNER TO test;

--
-- Name: mp_sharedfileshistory_id_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_sharedfileshistory_id_seq', 1, false);


--
-- Name: mp_sitehosts_hostid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_sitehosts_hostid_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_sitehosts_hostid_seq OWNER TO test;

--
-- Name: mp_sitehosts_hostid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_sitehosts_hostid_seq', 1, false);


--
-- Name: mp_sites_siteid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_sites_siteid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_sites_siteid_seq OWNER TO test;

--
-- Name: mp_sites_siteid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_sites_siteid_seq', 1, true);


--
-- Name: mp_userroles_id_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_userroles_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_userroles_id_seq OWNER TO test;

--
-- Name: mp_userroles_id_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_userroles_id_seq', 2, true);


--
-- Name: mp_users_userid_seq; Type: SEQUENCE; Schema: public; Owner: test
--

CREATE SEQUENCE mp_users_userid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.mp_users_userid_seq OWNER TO test;

--
-- Name: mp_users_userid_seq; Type: SEQUENCE SET; Schema: public; Owner: test
--

SELECT pg_catalog.setval('mp_users_userid_seq', 1, true);


--
-- Data for Name: mp_authorizenetlog; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_bannedipaddresses; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_blogcategories; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_blogcomments; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_blogitemcategories; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_blogs; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_blogstats; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_calendarevents; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_contactformmessage; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_contentrating; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_currency; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_currency VALUES ('6a5ef486-ee65-441f-9c63-c003e30981fe', 'Euro', 'EUR', '', 'EUR', '.', ',', '2', 1.00000000, '2008-12-25 23:56:58.832329', '2008-12-25 23:56:58.832329');
INSERT INTO mp_currency VALUES ('ff2dde1b-e7d7-4c3a-9ab4-6474345e0f31', 'US Dollar', 'USD', '$', '', '.', ',', '2', 1.00000000, '2008-12-25 23:56:58.832329', '2008-12-25 23:56:58.832329');


--
-- Data for Name: mp_forumposts; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_forums; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_forumsubscriptions; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_forumthreads; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_forumthreadsubscriptions; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_friendlyurls; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_friendlyurls VALUES (1, 1, 'home.aspx', '~/Default.aspx?pageid=1', false, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'f34ed4f8-ca72-40d5-bc6c-415b8462ee14', 'a62d573b-a4c2-4e8f-b953-1e47793fca07');


--
-- Data for Name: mp_galleryimages; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_geocountry; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_geocountry VALUES ('000da5ad-296a-4698-a21b-7d9c23feea14', 'Indonesia', 'ID', 'IDN');
INSERT INTO mp_geocountry VALUES ('0055471a-7993-42a1-897c-e5daf92e7c0e', 'Maldives', 'MV', 'MDV');
INSERT INTO mp_geocountry VALUES ('01261d1a-74d6-4e02-86c5-bed1a192f67d', 'Zimbabwe', 'ZW', 'ZWE');
INSERT INTO mp_geocountry VALUES ('01ca292d-86ca-4fa5-9205-2b0a37e7353b', 'Iceland', 'IS', 'ISL');
INSERT INTO mp_geocountry VALUES ('0416e2fc-c902-4452-8de9-29a2b453e685', 'Kyrgyzstan', 'KG', 'KGZ');
INSERT INTO mp_geocountry VALUES ('045a6098-a4a5-457a-aef0-6cc57cc4a813', 'Malawi', 'MW', 'MWI');
INSERT INTO mp_geocountry VALUES ('04724868-0448-48ef-840b-7d5da12495ec', 'Malaysia', 'MY', 'MYS');
INSERT INTO mp_geocountry VALUES ('056f6ed6-8f6d-4366-a755-2d6b8fb2b7ad', 'Marshall Islands', 'MH', 'MHL');
INSERT INTO mp_geocountry VALUES ('0589489d-a413-47c6-a90a-600520a8c52d', 'St. Helena', 'SH', 'SHN');
INSERT INTO mp_geocountry VALUES ('05b98ddc-f36b-4daf-9459-0717fde9b38e', 'Equatorial Guinea', 'GQ', 'GNQ');
INSERT INTO mp_geocountry VALUES ('061e11a1-33a2-42f0-8f8d-27e65fc47076', 'Sudan', 'SD', 'SDN');
INSERT INTO mp_geocountry VALUES ('06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Austria', 'AT', 'AUT');
INSERT INTO mp_geocountry VALUES ('0758cf79-94eb-4fa3-bd2c-8213034fb66c', 'Virgin Islands (U.S.)', 'VI', 'VIR');
INSERT INTO mp_geocountry VALUES ('0789d8a8-59d0-4d2f-8e26-5d917e55550c', 'To', 'TG', 'T  ');
INSERT INTO mp_geocountry VALUES ('07e1de2f-b11e-4f3b-a342-964f72d24371', 'Netherlands', 'NL', 'NLD');
INSERT INTO mp_geocountry VALUES ('085d9357-416b-48d6-8c9e-ec3e9e2582d0', 'Peru', 'PE', 'PER');
INSERT INTO mp_geocountry VALUES ('0b182ee0-0cc0-4844-9cf0-ba15f47682e8', 'Con', 'CG', 'COG');
INSERT INTO mp_geocountry VALUES ('0bd0e1a0-ea93-4883-b0a0-9f3c8668c68c', 'Singapore', 'SG', 'SGP');
INSERT INTO mp_geocountry VALUES ('0c356c5a-ca44-4301-8212-1826ccdadc42', 'Canada', 'CA', 'CAN');
INSERT INTO mp_geocountry VALUES ('0d074a4f-df7f-49f3-8375-d35bdc934ae0', 'Zaire', 'ZR', 'ZAR');
INSERT INTO mp_geocountry VALUES ('10d4d58e-d0c2-4a4e-8fdd-b99d68c0bd22', 'Eritrea', 'ER', 'ERI');
INSERT INTO mp_geocountry VALUES ('10fdc2bb-f3a6-4a9d-a6e9-f4c781e8dbff', 'Mexico', 'MX', 'MEX');
INSERT INTO mp_geocountry VALUES ('13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Brazil', 'BR', 'BRA');
INSERT INTO mp_geocountry VALUES ('14962add-4536-4854-bea3-a5a904932e1c', 'Moldova, Republic of', 'MD', 'MDA');
INSERT INTO mp_geocountry VALUES ('1583045c-5a80-4850-ac32-f177956fbd6a', 'Myanmar', 'MM', 'MMR');
INSERT INTO mp_geocountry VALUES ('167838f1-3fdd-4fb6-9268-4beafeecea4b', 'Estonia', 'EE', 'EST');
INSERT INTO mp_geocountry VALUES ('171a3e3e-cc78-4d4a-93ee-ace870dcb4c4', 'Swaziland', 'SZ', 'SWZ');
INSERT INTO mp_geocountry VALUES ('18160966-4eeb-4c6b-a526-5022042fe1e4', 'Montserrat', 'MS', 'MSR');
INSERT INTO mp_geocountry VALUES ('19f2da98-fefd-4b45-a260-8d9392c35a24', 'Czech Republic', 'CZ', 'CZE');
INSERT INTO mp_geocountry VALUES ('1a07c0b8-eb6d-4153-8cb1-be6e31feb566', 'Bosnia and Herzewina', 'BA', 'BIH');
INSERT INTO mp_geocountry VALUES ('1a6a2db1-d162-4fea-b660-b88fc25f558e', 'Grenada', 'GD', 'GRD');
INSERT INTO mp_geocountry VALUES ('1b8fbde0-e709-4f7b-838d-b09def73de8f', 'Botswana', 'BW', 'BWA');
INSERT INTO mp_geocountry VALUES ('1c7ff578-f079-4b5b-9993-2e0253b8cc14', 'Morocco', 'MA', 'MAR');
INSERT INTO mp_geocountry VALUES ('1d0dae21-cd07-4022-b86a-7780c5ea0264', 'Cayman Islands', 'KY', 'CYM');
INSERT INTO mp_geocountry VALUES ('1d925a47-3902-462a-ba2e-c58e5cb24f2f', 'American Samoa', 'AS', 'ASM');
INSERT INTO mp_geocountry VALUES ('1e64910a-bce3-402c-9035-9cb1f820b195', 'Bolivia', 'BO', 'BOL');
INSERT INTO mp_geocountry VALUES ('1fcc4a89-0e8f-4fa2-b8d0-4ff5ec2277df', 'United Kingdom', 'GB', 'GBR');
INSERT INTO mp_geocountry VALUES ('20a15881-215b-4c4c-9512-80e55abbb5ba', 'Saint Vincent and the Grenadines', 'VC', 'VCT');
INSERT INTO mp_geocountry VALUES ('216d38d9-5eeb-42b7-8d2d-0757409dc5fb', 'Pitcairn', 'PN', 'PCN');
INSERT INTO mp_geocountry VALUES ('2391213f-fcbf-479a-9ab9-af1d6deb9e11', 'Benin', 'BJ', 'BEN');
INSERT INTO mp_geocountry VALUES ('23ba8dce-c784-4712-a6a0-0271f175d4e5', 'Central African Republic', 'CF', 'CAF');
INSERT INTO mp_geocountry VALUES ('24045513-0cd8-4fb9-9cf6-78bf717f6a7e', 'Samoa', 'WS', 'WSM');
INSERT INTO mp_geocountry VALUES ('25ed463d-21f5-412c-9bdb-6d76073ea790', 'Jordan', 'JO', 'JOR');
INSERT INTO mp_geocountry VALUES ('267865b1-e8da-432d-be45-63933f18a40f', 'Korea, Republic of', 'KR', 'KOR');
INSERT INTO mp_geocountry VALUES ('278ab63a-9c7e-4cad-9c99-984f8810d151', 'Sri Lanka', 'LK', 'LKA');
INSERT INTO mp_geocountry VALUES ('27a6a985-3a89-4309-ac40-d1f0a94646ce', 'Sierra Leone', 'SL', 'SLE');
INSERT INTO mp_geocountry VALUES ('28218639-6094-4aa2-ae88-9206630bb930', 'Libyan Arab Jamahiriya', 'LY', 'LBY');
INSERT INTO mp_geocountry VALUES ('2afe5a06-2692-4b96-a385-f299e469d196', 'Panama', 'PA', 'PAN');
INSERT INTO mp_geocountry VALUES ('2bad76b2-20f3-4568-96bb-d60c39cfec37', 'Sweden', 'SE', 'SWE');
INSERT INTO mp_geocountry VALUES ('2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Germany', 'DE', 'DEU');
INSERT INTO mp_geocountry VALUES ('2dd32741-d7e9-49c9-b3d3-b58c4a913e60', 'Chad', 'TD', 'TCD');
INSERT INTO mp_geocountry VALUES ('2ebce3a9-660a-4c1d-ac8f-0e899b34a987', 'Australia', 'AU', 'AUS');
INSERT INTO mp_geocountry VALUES ('31f9b05e-e21d-41d5-8753-7cdd3bfa917b', 'Yuslavia', 'YU', 'YUG');
INSERT INTO mp_geocountry VALUES ('3220b426-8251-4f95-85c8-3f7821ecc932', 'Burkina Faso', 'BF', 'BFA');
INSERT INTO mp_geocountry VALUES ('32eb5d85-1283-4586-bb16-b2b978b6537f', 'Cameroon', 'CM', 'CMR');
INSERT INTO mp_geocountry VALUES ('333ed823-0e19-4bcc-a74e-c6c66fe76834', 'Cote D Ivoire', 'CI', 'CIV');
INSERT INTO mp_geocountry VALUES ('356d4b6e-9ccb-4dc6-9c82-837433178275', 'Palau', 'PW', 'PLW');
INSERT INTO mp_geocountry VALUES ('3664546f-14f2-4561-9b77-67e8be6a9b1f', 'Barbados', 'BB', 'BRB');
INSERT INTO mp_geocountry VALUES ('36f89c06-1509-42d2-aea6-7b4ce3bbc4f5', 'Seychelles', 'SC', 'SYC');
INSERT INTO mp_geocountry VALUES ('386812d8-e983-4d3a-b7f0-1fa0bbe5919f', 'Comoros', 'KM', 'COM');
INSERT INTO mp_geocountry VALUES ('38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Spain', 'ES', 'ESP');
INSERT INTO mp_geocountry VALUES ('391ebafd-7689-41e5-a785-df6a3280528d', 'Tokelau', 'TK', 'TKL');
INSERT INTO mp_geocountry VALUES ('392616f8-1b24-489f-8600-bae22ef478cc', 'Armenia', 'AM', 'ARM');
INSERT INTO mp_geocountry VALUES ('3a733002-9223-4bd7-b2a9-62fa359c4cbd', 'Gabon', 'GA', 'GAB');
INSERT INTO mp_geocountry VALUES ('3c864692-824c-4593-a739-d1309d4cd75e', 'Macedonia, The Former Yuslav Republic of', 'MK', 'MKD');
INSERT INTO mp_geocountry VALUES ('3d3a06a0-0853-4d01-b273-af7b7cd7002c', 'Saint Lucia', 'LC', 'LCA');
INSERT INTO mp_geocountry VALUES ('3e57398a-0006-4e48-8cb4-f9f143dfcf22', 'British Indian Ocean Territory', 'IO', 'IOT');
INSERT INTO mp_geocountry VALUES ('3e747b23-543f-4ad0-80a9-5e421651f3b4', 'Western Sahara', 'EH', 'ESH');
INSERT INTO mp_geocountry VALUES ('3f677556-1c9c-4315-9cfc-210a54f1f41d', 'Cook Islands', 'CK', 'COK');
INSERT INTO mp_geocountry VALUES ('3fbd7371-510a-45b4-813a-88373d19a5a4', 'Slovenia', 'SI', 'SVN');
INSERT INTO mp_geocountry VALUES ('4448e7b7-4e4d-4f19-b64d-e649d0f76cc1', 'Guinea', 'GN', 'GIN');
INSERT INTO mp_geocountry VALUES ('44577b6a-6918-4508-ade4-b6c2adb25000', 'Guatemala', 'GT', 'GTM');
INSERT INTO mp_geocountry VALUES ('468dca85-484a-4529-8753-b26dbc316a71', 'East Timor', 'TP', 'TMP');
INSERT INTO mp_geocountry VALUES ('48cd745a-4c47-4282-b60a-cb4b4639c6ee', 'Guam', 'GU', 'GUM');
INSERT INTO mp_geocountry VALUES ('48e5e925-6d98-4039-af6e-36d676059b85', 'Korea, Democratic Peoples Republic of', 'KP', 'PRK');
INSERT INTO mp_geocountry VALUES ('4cc52ce2-0a6c-4564-8fe6-2eeb347a9429', 'Ethiopia', 'ET', 'ETH');
INSERT INTO mp_geocountry VALUES ('4ce3df16-4d00-4f4d-a5d6-675020fa117d', 'Cocos (Keeling) Islands', 'CC', 'CCK');
INSERT INTO mp_geocountry VALUES ('4dbe5363-aad6-4019-b445-472d6e1e49bd', 'Somalia', 'SO', 'SOM');
INSERT INTO mp_geocountry VALUES ('4dcd6ecf-af6c-4c76-95db-a0efac63f3de', 'Greenland', 'GL', 'GRL');
INSERT INTO mp_geocountry VALUES ('4e6d9507-9fb0-4290-80af-e98aabaccedb', 'Lao Peoples Democratic Republic', 'LA', 'LAO');
INSERT INTO mp_geocountry VALUES ('4eb5bcbe-13aa-45f0-afdf-77b379347509', 'Norfolk Island', 'NF', 'NFK');
INSERT INTO mp_geocountry VALUES ('4f660961-0aff-4539-9c0b-3bb2662b7a99', 'France', 'FR', 'FRA');
INSERT INTO mp_geocountry VALUES ('52316192-6328-4e45-a39c-37fc96cad138', 'Nigeria', 'NG', 'NGA');
INSERT INTO mp_geocountry VALUES ('54d227b4-1f3e-4f20-b16c-6428b77f5252', 'Poland', 'PL', 'POL');
INSERT INTO mp_geocountry VALUES ('574e1b06-4332-4a1c-9b30-5daf2cce6b10', 'Andorra', 'AD', 'AND');
INSERT INTO mp_geocountry VALUES ('579fbee3-0be0-4884-b7c5-658c23c4e7d3', 'Antarctica', 'AQ', 'ATA');
INSERT INTO mp_geocountry VALUES ('58c5c312-85d2-47a3-87a7-1549ec0ccd44', 'Liberia', 'LR', 'LBR');
INSERT INTO mp_geocountry VALUES ('5aac5aa6-8bc0-4be5-a4de-76a5917dd2b2', 'Bangladesh', 'BD', 'BGD');
INSERT INTO mp_geocountry VALUES ('5c3d7f0e-1900-4d73-acf6-69459d70d616', 'Nicaragua', 'NI', 'NIC');
INSERT INTO mp_geocountry VALUES ('5dc77e2b-df39-475b-99da-c9756cabb5b6', 'Anla', 'AO', 'A  ');
INSERT INTO mp_geocountry VALUES ('5edc9ddf-242c-4533-9c38-cbf41709ef60', 'El Salvador', 'SV', 'SLV');
INSERT INTO mp_geocountry VALUES ('5f6df4ff-ef4b-43d9-98f5-d66ef9d27c67', 'Macau', 'MO', 'MAC');
INSERT INTO mp_geocountry VALUES ('60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Switzerland', 'CH', 'CHE');
INSERT INTO mp_geocountry VALUES ('612c5585-4e93-4f4f-9735-ec9ab7f2aab9', 'Thailand', 'TH', 'THA');
INSERT INTO mp_geocountry VALUES ('61ef876b-9508-48e9-afbf-2d4386c38127', 'Hungary', 'HU', 'HUN');
INSERT INTO mp_geocountry VALUES ('63404c30-266d-47b6-beda-fd252283e4e5', 'Nepal', 'NP', 'NPL');
INSERT INTO mp_geocountry VALUES ('63aecd7a-9b3f-4732-bf8c-1702ad3a49dc', 'Falkland Islands (Malvinas)', 'FK', 'FLK');
INSERT INTO mp_geocountry VALUES ('65223343-756c-4083-a20f-cf3cf98efbdc', 'Mayotte', 'YT', 'MYT');
INSERT INTO mp_geocountry VALUES ('6599493d-ead6-41ce-ae9c-2a47ea74c1a8', 'Honduras', 'HN', 'HND');
INSERT INTO mp_geocountry VALUES ('666699cd-7460-44b1-afa9-adc363778ff4', 'Romania', 'RO', 'ROM');
INSERT INTO mp_geocountry VALUES ('66c2bfb0-11c9-4191-8e91-1a0314726cc6', 'Dominican Republic', 'DO', 'DOM');
INSERT INTO mp_geocountry VALUES ('66d1d01b-a1a5-4634-9c15-4cd382a44147', 'Egypt', 'EG', 'EGY');
INSERT INTO mp_geocountry VALUES ('66d7e3d5-f89c-42c5-82d5-9e6869ab9775', 'Mauritius', 'MU', 'MUS');
INSERT INTO mp_geocountry VALUES ('66f06c44-26ff-4015-b0ce-d241a39def8b', 'Papua New Guinea', 'PG', 'PNG');
INSERT INTO mp_geocountry VALUES ('6717be36-81c1-4df3-a6f8-0f5eef45cec9', 'Puerto Rico', 'PR', 'PRI');
INSERT INTO mp_geocountry VALUES ('67497e93-c793-4134-915e-e04f5adae5d0', 'Antigua and Barbuda', 'AG', 'ATG');
INSERT INTO mp_geocountry VALUES ('68abefdb-27f4-4cb8-840c-afee8510c249', 'Tunisia', 'TN', 'TUN');
INSERT INTO mp_geocountry VALUES ('6f101294-0433-492b-99f7-d59105a9970b', 'Senegal', 'SN', 'SEN');
INSERT INTO mp_geocountry VALUES ('70a106ca-3a82-4e37-aea3-4a0bf8d50afa', 'Namibia', 'NA', 'NAM');
INSERT INTO mp_geocountry VALUES ('70e9ef51-b838-461b-a1d8-2b32ee49855b', 'Chile', 'CL', 'CHL');
INSERT INTO mp_geocountry VALUES ('72bbbb80-ea6c-43c9-8ccd-99d26290f560', 'Belgium', 'BE', 'BEL');
INSERT INTO mp_geocountry VALUES ('73355d89-317a-43a5-8ebb-fa60dd738c5b', 'South Africa', 'ZA', 'ZAF');
INSERT INTO mp_geocountry VALUES ('7376c282-b5a3-4898-a342-c45f1c18b609', 'New Zealand', 'NZ', 'NZL');
INSERT INTO mp_geocountry VALUES ('73fbc893-331d-4e67-9753-ab988ac005c7', 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM');
INSERT INTO mp_geocountry VALUES ('74dfb95b-515d-4561-938d-169ac3782280', 'New Caledonia', 'NC', 'NCL');
INSERT INTO mp_geocountry VALUES ('75f88974-01ac-47d7-bcee-6ce1f0c0d0fc', 'Trinidad and Toba', 'TT', 'TTO');
INSERT INTO mp_geocountry VALUES ('7756aa70-f22a-4f42-b8f4-e56ca9746064', 'Qatar', 'QA', 'QAT');
INSERT INTO mp_geocountry VALUES ('776102b6-3d75-4570-8215-484367ea2a80', 'Lesotho', 'LS', 'LSO');
INSERT INTO mp_geocountry VALUES ('77bbfb67-9d1d-41f9-8626-b327aa90a584', 'French Polynesia', 'PF', 'PYF');
INSERT INTO mp_geocountry VALUES ('77dce560-3d53-4483-963e-37d5f72e219e', 'Tajikistan', 'TJ', 'TJK');
INSERT INTO mp_geocountry VALUES ('78a78abb-31d9-4e2a-aea5-6744f27a6519', 'Azerbaijan', 'AZ', 'AZE');
INSERT INTO mp_geocountry VALUES ('7b3b0b11-b3cf-4e69-b4c2-c414bb7bd78d', 'Ecuador', 'EC', 'ECU');
INSERT INTO mp_geocountry VALUES ('7b534a1e-e06d-4a2c-8ea6-85c128201834', 'Latvia', 'LV', 'LVA');
INSERT INTO mp_geocountry VALUES ('7c0ba316-c6d9-48dc-919e-76e0ee0cf0fb', 'Rwanda', 'RW', 'RWA');
INSERT INTO mp_geocountry VALUES ('7c2c1e29-9e58-45eb-b512-5894496cd4dd', 'Paraguay', 'PY', 'PRY');
INSERT INTO mp_geocountry VALUES ('7e11e0dc-0a4e-4db9-9673-84600c8035c4', 'Ireland', 'IE', 'IRL');
INSERT INTO mp_geocountry VALUES ('7e83ba7d-1c8f-465c-87d3-9bd86256031a', 'Cape Verde', 'CV', 'CPV');
INSERT INTO mp_geocountry VALUES ('7f2e9d46-f5db-48bf-8e07-d6d12e77d857', 'Reunion', 'RE', 'REU');
INSERT INTO mp_geocountry VALUES ('7fe147d0-fd91-4119-83ad-4e7ebccdfd89', 'United Arab Emirates', 'AE', 'ARE');
INSERT INTO mp_geocountry VALUES ('83c5561e-e4be-40b0-ae56-28a371680af8', 'Denmark', 'DK', 'DNK');
INSERT INTO mp_geocountry VALUES ('844686ba-57c3-4c91-8b33-c1e1889a44c0', 'Albania', 'AL', 'ALB');
INSERT INTO mp_geocountry VALUES ('880f29a2-e51c-4016-ab18-ca09275673c3', 'Guinea-bissau', 'GW', 'GNB');
INSERT INTO mp_geocountry VALUES ('88592f8b-1d15-4aa0-9115-4a28b67e1753', 'Lebanon', 'LB', 'LBN');
INSERT INTO mp_geocountry VALUES ('8af11a89-1487-4b21-aabf-6af57ead8474', 'Solomon Islands', 'SB', 'SLB');
INSERT INTO mp_geocountry VALUES ('8c982139-3609-48d3-b145-b5ceb484c414', 'United States Minor Outlying Islands', 'UM', 'UMI');
INSERT INTO mp_geocountry VALUES ('8c9d27f2-fe77-4653-9696-b046d6536bfa', 'Netherlands Antilles', 'AN', 'ANT');
INSERT INTO mp_geocountry VALUES ('8f5124fa-cb2a-4cc9-87bb-bc155dc9791a', 'Gambia', 'GM', 'GMB');
INSERT INTO mp_geocountry VALUES ('8fe152e5-b58c-4d3c-b143-358d5c54ba06', 'Ukraine', 'UA', 'UKR');
INSERT INTO mp_geocountry VALUES ('90255d75-af44-4b5d-bcfd-77cd27dce782', 'Madagascar', 'MG', 'MDG');
INSERT INTO mp_geocountry VALUES ('90684e6e-2b34-4f18-bbd1-f610f76179b7', 'Malta', 'MT', 'MLT');
INSERT INTO mp_geocountry VALUES ('9151aaf1-a75b-4a2c-bf2b-c823e2586db2', 'Fiji', 'FJ', 'FJI');
INSERT INTO mp_geocountry VALUES ('92a52065-32b0-42c6-a0aa-e8b8a341f79c', 'Guyana', 'GY', 'GUY');
INSERT INTO mp_geocountry VALUES ('931ee133-2b60-4b82-8889-7c9855ca030a', 'Kazakhstan', 'KZ', 'KAZ');
INSERT INTO mp_geocountry VALUES ('96dbb697-3d7e-49bf-ac9b-0ea5cc014a6f', 'Niue', 'NU', 'NIU');
INSERT INTO mp_geocountry VALUES ('972b8208-c88d-47bb-9e79-1574fab34dfb', 'San Marino', 'SM', 'SMR');
INSERT INTO mp_geocountry VALUES ('99c347f1-1427-4d41-bc12-945d38f92a94', 'Lithuania', 'LT', 'LTU');
INSERT INTO mp_geocountry VALUES ('99f791e7-7343-42e8-8c19-3c41068b5f8d', 'Viet Nam', 'VN', 'VNM');
INSERT INTO mp_geocountry VALUES ('9ab1ee28-b81f-4b89-ae6b-3c6e5322e269', 'Jamaica', 'JM', 'JAM');
INSERT INTO mp_geocountry VALUES ('9b5a87f8-f024-4b76-b230-95913e474b57', 'Yemen', 'YE', 'YEM');
INSERT INTO mp_geocountry VALUES ('9c035e40-a5dc-406b-a83a-559f940eb355', 'Cyprus', 'CY', 'CYP');
INSERT INTO mp_geocountry VALUES ('9ca410f0-eb75-4105-90a1-09fc8d2873b8', 'France, Metropolitan', 'FX', 'FXX');
INSERT INTO mp_geocountry VALUES ('9d2c4779-1608-4d2a-b157-f5c4bb334eed', 'French Guiana', 'GF', 'GUF');
INSERT INTO mp_geocountry VALUES ('9dcf0a16-db7f-4b63-bad7-30f80bcd9901', 'Philippines', 'PH', 'PHL');
INSERT INTO mp_geocountry VALUES ('9f9ac0e3-f689-4e98-b1bb-0f5f01f20fad', 'Russian Federation', 'RU', 'RUS');
INSERT INTO mp_geocountry VALUES ('a141ab0d-7e2c-48b1-9963-ba8685bcdfe3', 'Slovakia (Slovak Republic)', 'SK', 'SVK');
INSERT INTO mp_geocountry VALUES ('a4f1d01a-ebfc-4bd3-9521-be6d73f79fac', 'Luxembourg', 'LU', 'LUX');
INSERT INTO mp_geocountry VALUES ('a566ac8d-4a81-4a11-9cfb-979517440ce2', 'Iran (Islamic Republic of)', 'IR', 'IRN');
INSERT INTO mp_geocountry VALUES ('a642097b-cc0a-430d-9425-9f8385fc6aa4', 'Italy', 'IT', 'ITA');
INSERT INTO mp_geocountry VALUES ('a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'United States', 'US', 'USA');
INSERT INTO mp_geocountry VALUES ('aa393972-1604-47d2-a533-81b41199ccf0', 'Djibouti', 'DJ', 'DJI');
INSERT INTO mp_geocountry VALUES ('aae223c8-6330-4641-b12b-f231866de4c6', 'Anguilla', 'AI', 'AIA');
INSERT INTO mp_geocountry VALUES ('ae094b3e-a8b8-4e29-9853-3bd464efd247', 'Monaco', 'MC', 'MCO');
INSERT INTO mp_geocountry VALUES ('aea2f438-77bc-43f5-84fc-c781141a1d47', 'Sao Tome and Principe', 'ST', 'STP');
INSERT INTO mp_geocountry VALUES ('aebd8175-fffe-4ee2-b208-c0bbbd049664', 'Uruguay', 'UY', 'URY');
INSERT INTO mp_geocountry VALUES ('b0fc7899-9c6f-4b80-838f-692a7a0aa83b', 'Oman', 'OM', 'OMN');
INSERT INTO mp_geocountry VALUES ('b10c1efc-5341-4ec4-be12-a70dbb1c41cc', 'Liechtenstein', 'LI', 'LIE');
INSERT INTO mp_geocountry VALUES ('b14e1447-0bca-4dd5-87e1-60c0b5d2988b', 'Saudi Arabia', 'SA', 'SAU');
INSERT INTO mp_geocountry VALUES ('b225d445-6884-4232-97e4-b33499982104', 'Northern Mariana Islands', 'MP', 'MNP');
INSERT INTO mp_geocountry VALUES ('b32a6fe3-f534-4c42-bd2d-8e2307476ba2', 'Mozambique', 'MZ', 'MOZ');
INSERT INTO mp_geocountry VALUES ('b3732bd9-c3d6-4861-8dbe-eb2884557f34', 'Vanuatu', 'VU', 'VUT');
INSERT INTO mp_geocountry VALUES ('b47e2eec-62a0-440c-9f20-af9c5c75d57b', 'Greece', 'GR', 'GRC');
INSERT INTO mp_geocountry VALUES ('b4a3405b-1293-4e98-9b11-777f666b25d4', 'Bahamas', 'BS', 'BHS');
INSERT INTO mp_geocountry VALUES ('b50f640f-0ae9-4d63-acb2-2abd94b6271b', 'Gibraltar', 'GI', 'GIB');
INSERT INTO mp_geocountry VALUES ('b5133b5b-1687-447a-b88a-ef21f7599eda', 'Argentina', 'AR', 'ARG');
INSERT INTO mp_geocountry VALUES ('b5946ea8-b8a8-45b9-827d-86fa13e034cd', 'Hong Kong', 'HK', 'HKG');
INSERT INTO mp_geocountry VALUES ('b5ee8da7-5cc3-44f3-bd63-094cb93b4674', 'Uzbekistan', 'UZ', 'UZB');
INSERT INTO mp_geocountry VALUES ('b85aa3d6-d923-438c-aad7-2063f6bfbd3c', 'Nauru', 'NR', 'NRU');
INSERT INTO mp_geocountry VALUES ('baf7d87c-f09b-42cc-becd-49c2b3426226', 'Tanzania, United Republic of', 'TZ', 'TZA');
INSERT INTO mp_geocountry VALUES ('bb176526-f5c6-4871-9e75-cfeef799ad48', 'Tuvalu', 'TV', 'TUV');
INSERT INTO mp_geocountry VALUES ('bbaaa327-f8cc-43ae-8b0e-fc054eeda968', 'Tonga', 'TO', 'TON');
INSERT INTO mp_geocountry VALUES ('bd2c67c0-26a4-46d5-b58a-f26dcfa8f34b', 'Taiwan', 'TW', 'TWN');
INSERT INTO mp_geocountry VALUES ('bdb52e20-8f5c-4a6c-a8d5-2b4dc060cc13', 'Heard and Mc Donald Islands', 'HM', 'HMD');
INSERT INTO mp_geocountry VALUES ('bec3af5b-d2d4-4dfb-aca5-cf87059469d4', 'Algerian', 'DZ', 'DZA');
INSERT INTO mp_geocountry VALUES ('bf3b8cd7-679e-4546-81fc-85652653fe8f', 'Saint Kitts and Nevis', 'KN', 'KNA');
INSERT INTO mp_geocountry VALUES ('c03527d6-1936-4fdb-ab72-93ae7cb571ed', 'Kuwait', 'KW', 'KWT');
INSERT INTO mp_geocountry VALUES ('c046ca0b-6dd9-459c-bf76-bd024363aaac', 'Pakistan', 'PK', 'PAK');
INSERT INTO mp_geocountry VALUES ('c10d2e3a-af21-4bad-9b18-fbf3fb659eae', 'Bahrain', 'BH', 'BHR');
INSERT INTO mp_geocountry VALUES ('c1ec594f-4b56-436d-aa28-ce3004de2803', 'Bhutan', 'BT', 'BTN');
INSERT INTO mp_geocountry VALUES ('c1f503a3-c6b4-4eee-9fea-1f656f3b0825', 'Kiribati', 'KI', 'KIR');
INSERT INTO mp_geocountry VALUES ('c23969d4-e195-4e53-bf7e-d3d041184325', 'China', 'CN', 'CHN');
INSERT INTO mp_geocountry VALUES ('c43b2a01-933b-4021-896f-fcd27f3820da', 'India', 'IN', 'IND');
INSERT INTO mp_geocountry VALUES ('c47bf5ea-dfe4-4c9f-8bbc-067bd15fa6d2', 'Kenya', 'KE', 'KEN');
INSERT INTO mp_geocountry VALUES ('c63d51d8-b319-4a48-a6f1-81671b28ef07', 'Bouvet Island', 'BV', 'BVT');
INSERT INTO mp_geocountry VALUES ('c7c9f73a-f4be-4c59-9278-524d6069d9dc', 'Colombia', 'CO', 'COL');
INSERT INTO mp_geocountry VALUES ('c87d4cae-84ee-4336-bc57-69c4ea33a6bc', 'Syrian Arab Republic', 'SY', 'SYR');
INSERT INTO mp_geocountry VALUES ('cd85035d-3901-4d07-a254-90750cd57c90', 'Georgia', 'GE', 'GEO');
INSERT INTO mp_geocountry VALUES ('cda35e7b-29b0-4d34-b925-bf753d16af7e', 'South Georgia and the South Sandwich Islands', 'GS', 'SGS');
INSERT INTO mp_geocountry VALUES ('ce737f29-05a4-4a9a-b5dc-f1876f409334', 'Haiti', 'HT', 'HTI');
INSERT INTO mp_geocountry VALUES ('d42bd5b7-9f7e-4cb2-a295-e37471cdb1c2', 'Virgin Islands (British)', 'VG', 'VGB');
INSERT INTO mp_geocountry VALUES ('d61f7a82-85c5-45e1-a23c-60edae497459', 'Belarus', 'BY', 'BLR');
INSERT INTO mp_geocountry VALUES ('d7a96dd1-66f4-49b4-9085-53a12facac98', 'Burundi', 'BI', 'BDI');
INSERT INTO mp_geocountry VALUES ('d9510667-ae8b-4066-811c-08c6834efadf', 'Uganda', 'UG', 'UGA');
INSERT INTO mp_geocountry VALUES ('da19b4e1-dfea-43c9-ad8b-19e7036f0da4', 'Turks and Caicos Islands', 'TC', 'TCA');
INSERT INTO mp_geocountry VALUES ('da8e07c2-7b3d-46af-bcc5-fef0a68b11d1', 'Turkey', 'TR', 'TUR');
INSERT INTO mp_geocountry VALUES ('dac6366f-295f-4ddc-b08c-5a521c70774d', 'Martinique', 'MQ', 'MTQ');
INSERT INTO mp_geocountry VALUES ('dd3d7458-318b-4c6b-891c-766a6d7ac265', 'Dominica', 'DM', 'DMA');
INSERT INTO mp_geocountry VALUES ('e0274040-ef54-4b6e-b572-af65a948d8c4', 'Wallis and Futuna Islands', 'WF', 'WLF');
INSERT INTO mp_geocountry VALUES ('e04ed9c1-face-4ee6-bade-7e522c0d210e', 'Brunei Darussalam', 'BN', 'BRN');
INSERT INTO mp_geocountry VALUES ('e1aa65e1-d524-48ba-91ef-39570b9984d7', 'Aruba', 'AW', 'ABW');
INSERT INTO mp_geocountry VALUES ('e399424a-a86a-4c61-b92b-450106831b4c', 'French Southern Territories', 'TF', 'ATF');
INSERT INTO mp_geocountry VALUES ('e55c6a3a-a5e9-4575-b24f-6da0fd4115cd', 'Norway', 'NO', 'NOR');
INSERT INTO mp_geocountry VALUES ('e6471bf0-4692-4b7a-b104-94b12b30a284', 'Turkmenistan', 'TM', 'TKM');
INSERT INTO mp_geocountry VALUES ('e691ac69-a14d-4cca-86ed-82978614283e', 'Costa Rica', 'CR', 'CRI');
INSERT INTO mp_geocountry VALUES ('e82e9dc1-7d00-47c0-9476-10eaf259967d', 'Bermuda', 'BM', 'BMU');
INSERT INTO mp_geocountry VALUES ('e8f03eaa-ddd2-4ff2-8b66-da69ff074ccd', 'Mauritania', 'MR', 'MRT');
INSERT INTO mp_geocountry VALUES ('eadabf25-0fa0-4e8e-aa1e-26d02eb70653', 'Faroe Islands', 'FO', 'FRO');
INSERT INTO mp_geocountry VALUES ('eafeb25d-265a-4899-be24-bb0f4bf64480', 'Cambodia', 'KH', 'KHM');
INSERT INTO mp_geocountry VALUES ('eb692475-f7af-402f-bb0d-cd420f670b88', 'Niger', 'NE', 'NER');
INSERT INTO mp_geocountry VALUES ('ec0d252b-7ba6-4ac4-ad41-6158a10e9ccf', 'Finland', 'FI', 'FIN');
INSERT INTO mp_geocountry VALUES ('ec4d278f-0d96-478f-b023-0fdc7520c56c', 'Iraq', 'IQ', 'IRQ');
INSERT INTO mp_geocountry VALUES ('f015e45e-d93a-4d3a-a010-648ca65b47be', 'Venezuela', 'VE', 'VEN');
INSERT INTO mp_geocountry VALUES ('f2f258d7-b650-45f9-a0e1-58687c08f4e4', 'Suriname', 'SR', 'SUR');
INSERT INTO mp_geocountry VALUES ('f321b513-8164-4882-bae0-f3657a1a98fb', 'Micronesia, Federated States of', 'FM', 'FSM');
INSERT INTO mp_geocountry VALUES ('f3418c04-e3a8-4826-a41f-dcdbb5e4613e', 'Monlia', 'MN', 'MNG');
INSERT INTO mp_geocountry VALUES ('f3b7f86f-3165-4430-b263-87e1222b5bb1', 'Croatia', 'HR', 'HRV');
INSERT INTO mp_geocountry VALUES ('f5548ac2-958f-4b3d-8669-38b58735c517', 'Belize', 'BZ', 'BLZ');
INSERT INTO mp_geocountry VALUES ('f63ce832-2c8d-4c43-a4d8-134fc4311098', 'Guadeloupe', 'GP', 'GLP');
INSERT INTO mp_geocountry VALUES ('f6e6e602-468a-4dd7-ace4-3da5fefc165a', 'St. Pierre and Miquelon', 'PM', 'SPM');
INSERT INTO mp_geocountry VALUES ('f74a81fa-3d6a-415c-88fd-5458ed8c45c2', 'Japan', 'JP', 'JPN');
INSERT INTO mp_geocountry VALUES ('f909c4c1-5fa9-4188-b848-ecd37e3dbf64', 'Cuba', 'CU', 'CUB');
INSERT INTO mp_geocountry VALUES ('f95a5bb1-59a5-4125-b803-a278b13b3d3b', 'Zambia', 'ZM', 'ZMB');
INSERT INTO mp_geocountry VALUES ('f9c72583-e1f8-4f13-bfb5-ddf68bcd656a', 'Christmas Island', 'CX', 'CXR');
INSERT INTO mp_geocountry VALUES ('fa26ae74-5404-4aaf-bd54-9b78266ccf03', 'Portugal', 'PT', 'PRT');
INSERT INTO mp_geocountry VALUES ('fbea6604-4e57-46b6-a3f2-e5de8514c7b0', 'Vatican City State (Holy See)', 'VA', 'VAT');
INSERT INTO mp_geocountry VALUES ('fbff9784-d58c-4c86-a7f2-2f8ce68d10e7', 'Mali', 'ML', 'MLI');
INSERT INTO mp_geocountry VALUES ('fd70fe71-1429-4c6e-b399-90318ed9ddcb', 'Bulgaria', 'BG', 'BGR');
INSERT INTO mp_geocountry VALUES ('fdc8539a-82a7-4d29-bd5c-67fb9769a5ac', 'Ghana', 'GH', 'GHA');
INSERT INTO mp_geocountry VALUES ('fe0e585e-fc54-4fa2-80c0-6fbfe5397e8c', 'Israel', 'IL', 'ISR');


--
-- Data for Name: mp_geozone; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_geozone VALUES ('02be94a5-3c10-4f83-858b-812796e714ae', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Minnesota', 'MN');
INSERT INTO mp_geozone VALUES ('02c10c0f-3f09-4d0a-a6ef-ad40ae0a007b', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Sachsen-Anhalt', 'SAC');
INSERT INTO mp_geozone VALUES ('053fab61-2eff-446b-a29b-e9be91e195c9', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Jura', 'JU');
INSERT INTO mp_geozone VALUES ('05974280-a62d-4fc3-be15-f16ab9e0f2d1', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Sachsen', 'SAS');
INSERT INTO mp_geozone VALUES ('070dd166-bdc9-4732-8da0-48bd318d3d9e', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Avila', 'Avila');
INSERT INTO mp_geozone VALUES ('076814fc-7422-40d5-80e0-b6978589ccdc', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Schaffhausen', 'SH');
INSERT INTO mp_geozone VALUES ('07c1030f-fa7e-4b1c-ba21-c6acd092b676', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Rheinland-Pfalz', 'RHE');
INSERT INTO mp_geozone VALUES ('0b6e3041-4368-4476-a697-a8bafc77a9e0', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Virginia', 'VA');
INSERT INTO mp_geozone VALUES ('0db04a9e-352b-46d6-88bc-b5416b31756d', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Las Palmas', 'Las Palmas');
INSERT INTO mp_geozone VALUES ('0df27c73-a612-491f-8b74-c4e384317fb8', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Manitoba', 'MB');
INSERT INTO mp_geozone VALUES ('0f115386-3220-49f1-b0f2-eaf6c78a2edd', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Albacete', 'Albacete');
INSERT INTO mp_geozone VALUES ('1026b90d-61be-4434-ab6d-ebfd92082dfe', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Iowa', 'IA');
INSERT INTO mp_geozone VALUES ('152f8dc5-5caa-44b7-89a8-6469042dc865', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Puerto Rico', 'PR');
INSERT INTO mp_geozone VALUES ('155ddc67-1e74-4791-995d-2eddb0658293', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Burgenland', 'BL');
INSERT INTO mp_geozone VALUES ('15b3d139-d927-43eb-8705-84df9122999f', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Barcelona', 'Barcelona');
INSERT INTO mp_geozone VALUES ('15c350c0-058c-474d-a7c2-e3bd359b7895', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Rhode Island', 'RI');
INSERT INTO mp_geozone VALUES ('19b7cd11-15b7-48c0-918d-73fe64eaae26', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Roraima', 'RR');
INSERT INTO mp_geozone VALUES ('1aa7127a-8c53-4840-a2da-120f8c6607bd', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Ohio', 'OH');
INSERT INTO mp_geozone VALUES ('1ba313de-0690-42db-97bb-ecba89aec4c7', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Lleida', 'Lleida');
INSERT INTO mp_geozone VALUES ('1c5d3479-59fc-4c77-8d4e-cfc5c33422e7', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Vizcaya', 'Vizcaya');
INSERT INTO mp_geozone VALUES ('1d049867-dc28-4ae1-b8a6-d44aecb4aa0b', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Rio Grande Do Sul', 'RS');
INSERT INTO mp_geozone VALUES ('1d996ba4-1906-44c3-9c51-399fd382d278', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Tocantins', 'TO');
INSERT INTO mp_geozone VALUES ('1da58a0a-d0f7-48b1-9d48-102f65819773', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Granada', 'Granada');
INSERT INTO mp_geozone VALUES ('1e1ba070-f44b-4dfb-8fc2-55c541f4943f', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Amapa', 'AP');
INSERT INTO mp_geozone VALUES ('2022f303-2481-4b44-ba3d-d261b002c9c1', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Baden-W?rttemberg', 'BAW');
INSERT INTO mp_geozone VALUES ('20a995b4-82ee-4ae7-84cf-e03c2ff8858a', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Northern Mariana Islands', 'MP');
INSERT INTO mp_geozone VALUES ('21287450-809e-4662-9742-9380159d3c90', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Guipuzcoa', 'Guipuzcoa');
INSERT INTO mp_geozone VALUES ('2282df69-bcf5-49fe-a6eb-c8c9dec87a52', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'West Virginia', 'WV');
INSERT INTO mp_geozone VALUES ('25459871-1694-4d08-9e7c-6d06f2edc7ae', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Basel-Landschaft', 'BL');
INSERT INTO mp_geozone VALUES ('2546d1ab-d4f5-4087-9b78-ea3badfafa12', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Sevilla', 'Sevilla');
INSERT INTO mp_geozone VALUES ('294f2e9c-49d1-4094-b558-dd2d4219b0e9', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Espirito Santo', 'ES');
INSERT INTO mp_geozone VALUES ('29f5ce90-8999-4a8e-91a5-fcf67b4fd8ab', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Nova Scotia', 'NS');
INSERT INTO mp_geozone VALUES ('2a20cf43-8d55-4732-b810-641886f2aed4', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'British Columbia', 'BC');
INSERT INTO mp_geozone VALUES ('2a9b8ffe-91f5-4944-983d-37f52491dde6', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Berlin', 'BER');
INSERT INTO mp_geozone VALUES ('2df783c9-e527-4105-819e-181af57e7cec', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Mato Grosso Do Sul', 'MS');
INSERT INTO mp_geozone VALUES ('2f20005e-7efc-4186-9144-6996b68ee6e3', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Tarragona', 'Tarragona');
INSERT INTO mp_geozone VALUES ('3008a1b3-1188-4f4d-a2ef-b71b4f54233e', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Tirol', 'TI');
INSERT INTO mp_geozone VALUES ('30fa3416-9fb1-43c1-999d-23a115218324', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Aargau', 'AG');
INSERT INTO mp_geozone VALUES ('31265516-54af-4551-af1b-a0900faa3028', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Nevada', 'NV');
INSERT INTO mp_geozone VALUES ('3249c886-3b1e-426a-8cd7-efc3922a964a', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Salamanca', 'Salamanca');
INSERT INTO mp_geozone VALUES ('335c6ba3-37e5-4cca-b466-6927658ee92e', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Maine', 'ME');
INSERT INTO mp_geozone VALUES ('33cd3650-d80e-4157-b145-5d8d404628e4', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Ontario', 'ON');
INSERT INTO mp_geozone VALUES ('347629b4-0c74-4e80-84c9-785fb45fb8d7', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Almeria', 'Almeria');
INSERT INTO mp_geozone VALUES ('36f88c25-7a6a-41d4-abac-ce05cd5ecfa1', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Hamburg', 'HAM');
INSERT INTO mp_geozone VALUES ('388a4219-a89a-4bf0-960f-f58936288a0a', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Luzern', 'LU');
INSERT INTO mp_geozone VALUES ('3c173b83-5149-4fec-b000-64a65832c455', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Middle East', 'AM');
INSERT INTO mp_geozone VALUES ('3dab4424-efa5-409a-b96c-40daf5ee4b6c', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'La Rioja', 'La Rioja');
INSERT INTO mp_geozone VALUES ('3deda5e5-10bb-41cd-87ff-f91688b5b7ed', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Thurgau', 'TG');
INSERT INTO mp_geozone VALUES ('3ebf7ceb-8e24-40af-801c-feccd6d780ee', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Castellon', 'Castellon');
INSERT INTO mp_geozone VALUES ('3ff66466-e523-492e-80c1-be19af171364', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Colorado', 'CO');
INSERT INTO mp_geozone VALUES ('41898a0b-a26c-44ce-9568-cfb75f1a2856', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Tennessee', 'TN');
INSERT INTO mp_geozone VALUES ('4308f7f6-1f1d-4248-8995-3af588c55976', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Newfoundland', 'NF');
INSERT INTO mp_geozone VALUES ('4344c1dd-e866-4683-9c90-22c9db369eae', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Segovia', 'Segovia');
INSERT INTO mp_geozone VALUES ('440e892d-693c-493b-ba14-81919c3fb091', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Wallis', 'VS');
INSERT INTO mp_geozone VALUES ('48184d25-0757-405d-934d-74d96f9745df', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'New Mexico', 'NM');
INSERT INTO mp_geozone VALUES ('48d12a99-bf3c-4fc7-86c5-c266424973eb', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'California', 'CA');
INSERT INTO mp_geozone VALUES ('4ab74396-fb33-4276-a518-ad05f28375d0', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Baleares', 'Baleares');
INSERT INTO mp_geozone VALUES ('4bc9f931-f1ed-489f-99bc-59f42bd77eec', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Nordrhein-Westfalen', 'NRW');
INSERT INTO mp_geozone VALUES ('4bd4724c-2e5e-4df4-8b1c-3a679c30398f', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Zug', 'ZG');
INSERT INTO mp_geozone VALUES ('4d238397-af29-4dbc-a349-7f650a5d8d67', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Oklahoma', 'OK');
INSERT INTO mp_geozone VALUES ('4e0bc53a-62fe-4dfc-9d1d-8b928e40b22e', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Maranhao', 'MA');
INSERT INTO mp_geozone VALUES ('5006ff54-aa63-4e57-8414-30d51598be60', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Bahia', 'BA');
INSERT INTO mp_geozone VALUES ('507e831c-8d74-44bf-a251-496b945faed9', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Virgin Islands', 'VI');
INSERT INTO mp_geozone VALUES ('517f1242-fe90-4322-969e-353c5dbfd061', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Alicante', 'Alicante');
INSERT INTO mp_geozone VALUES ('5399df4c-92d4-4c59-9bfb-7dc2a575a3d3', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'North Dakota', 'ND');
INSERT INTO mp_geozone VALUES ('56259f37-af84-4215-ac73-259fa74c7c8d', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Yukon Territory', 'YT');
INSERT INTO mp_geozone VALUES ('570fe94c-f226-4701-8c10-13dab9e59625', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Texas', 'TX');
INSERT INTO mp_geozone VALUES ('58c1e282-cffa-4b49-b268-5356ba47aa19', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Basel-Stadt', 'BS');
INSERT INTO mp_geozone VALUES ('5bbd88d1-5023-43df-91f0-0fdd4f3878eb', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Cadiz', 'Cadiz');
INSERT INTO mp_geozone VALUES ('5bd4a551-46ba-465a-b3f9-e15ed70a083f', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Arizona', 'AZ');
INSERT INTO mp_geozone VALUES ('60d9d569-7d0d-448f-b567-b4bb6c518140', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Zamora', 'Zamora');
INSERT INTO mp_geozone VALUES ('611023eb-d4f2-4831-812e-c3984a125310', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Alaska', 'AK');
INSERT INTO mp_geozone VALUES ('61952dad-6b28-4ba8-8580-5012a48accdc', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Marshall Islands', 'MH');
INSERT INTO mp_geozone VALUES ('61d891a3-e620-46d8-aada-6c9c1944340c', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Glarus', 'GL');
INSERT INTO mp_geozone VALUES ('62202fa8-db98-40f9-9a26-446aee191cdd', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Acre', 'AC');
INSERT INTO mp_geozone VALUES ('6243f71b-d89b-4fdc-bc01-fcf46aeb1f29', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Illinois', 'IL');
INSERT INTO mp_geozone VALUES ('6352d079-20ea-42da-9377-7a09e6b764ae', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Federated States Of Micronesia', 'FM');
INSERT INTO mp_geozone VALUES ('640cef26-1b10-4eac-a4ae-2f3491c38376', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Ciudad Real', 'Ciudad Real');
INSERT INTO mp_geozone VALUES ('66cc8a10-4dfb-4e8a-b5f0-b935d22a18f9', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Ceara', 'CE');
INSERT INTO mp_geozone VALUES ('6743c28c-580d-4705-9b01-aa4380d65ce9', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'New Jersey', 'NJ');
INSERT INTO mp_geozone VALUES ('67e1633f-7405-451d-a772-eb4119c13b2c', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Uri', 'UR');
INSERT INTO mp_geozone VALUES ('69a0494d-f8c3-434b-b8d4-c18ca5af5a4e', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Saarland', 'SAR');
INSERT INTO mp_geozone VALUES ('6c342c68-690a-4967-97c6-e6408ca1ea59', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Genf', 'GE');
INSERT INTO mp_geozone VALUES ('6cc5cf7e-df8f-4c30-8b75-3c7d7750a4c0', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Sergipe', 'SE');
INSERT INTO mp_geozone VALUES ('6e0eb9ac-76a2-434d-ae13-18dbe56212bf', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Ceuta', 'Ceuta');
INSERT INTO mp_geozone VALUES ('6e9d7937-3614-465e-8534-aa9a52f2c69b', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Nebraska', 'NE');
INSERT INTO mp_geozone VALUES ('71682c43-e9c4-4d96-89e7-b06d47caa053', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Montana', 'MT');
INSERT INTO mp_geozone VALUES ('74062d11-8784-40bc-a95d-43b785ef8196', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Maryland', 'MD');
INSERT INTO mp_geozone VALUES ('74532861-c62d-49d2-a8ed-e99f401ea768', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Northwest Territories', 'NT');
INSERT INTO mp_geozone VALUES ('7566d0a5-7394-4947-b4d7-a76a94746a23', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'American Samoa', 'AS');
INSERT INTO mp_geozone VALUES ('7783e2f6-ded1-4703-aa2b-9fc844f28018', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Caceres', 'Caceres');
INSERT INTO mp_geozone VALUES ('780d9ddb-38a2-47c8-a162-1231bea2e54d', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Bern', 'BE');
INSERT INTO mp_geozone VALUES ('79b41943-7a78-4cec-857d-1fb89d34d301', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Santa Catarina', 'SC');
INSERT INTO mp_geozone VALUES ('7ace8e48-a0c5-48ee-b992-ae6eb7142408', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Mecklenburg-Vorpommern', 'MEC');
INSERT INTO mp_geozone VALUES ('7bf366d4-e9fc-4715-b7f9-1af37cc97386', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Arkansas', 'AR');
INSERT INTO mp_geozone VALUES ('7ce436e6-349d-4f41-9053-5d7666662bb8', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Leon', 'Leon');
INSERT INTO mp_geozone VALUES ('7dc834f4-c490-4986-bfbc-10dfc94e235c', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Teruel', 'Teruel');
INSERT INTO mp_geozone VALUES ('7fcce82b-7828-40c9-a860-a21a787780c2', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Bremen', 'BRE');
INSERT INTO mp_geozone VALUES ('84bf6b91-f9ff-4203-bad1-b5cf01239b77', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Kentucky', 'KY');
INSERT INTO mp_geozone VALUES ('8587e33e-25fc-4c19-b504-0c93c027dd93', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'New Hampshire', 'NH');
INSERT INTO mp_geozone VALUES ('85f3b62e-d3e7-4dec-b13b-dd494ad7b2cc', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Idaho', 'ID');
INSERT INTO mp_geozone VALUES ('86bdbe5d-4085-4916-984c-94c191c48c67', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Schwyz', 'SZ');
INSERT INTO mp_geozone VALUES ('87268168-cf40-442f-a526-06ddaeb1befd', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Michigan', 'MI');
INSERT INTO mp_geozone VALUES ('87c1483d-e471-4166-87cb-44f9c4459aa8', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Bayern', 'BAY');
INSERT INTO mp_geozone VALUES ('8a4e0e4c-2727-42cd-86d6-ed27a6a6b74b', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Cordoba', 'Cordoba');
INSERT INTO mp_geozone VALUES ('8a6db145-7ff4-4dfa-ac88-ea161924ea03', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Freiburg', 'FR');
INSERT INTO mp_geozone VALUES ('8b1fe477-db16-4dcb-92f0-dcbf2f1de8cb', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Vermont', 'VT');
INSERT INTO mp_geozone VALUES ('8b3c48fd-9e7e-4653-a711-6dac6971cb32', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Obwalden', 'OW');
INSERT INTO mp_geozone VALUES ('8bc664a9-b12c-4f48-af34-a7f68384a76a', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Badajoz', 'Badajoz');
INSERT INTO mp_geozone VALUES ('8bd9d2b9-67db-4fd6-90c7-52d0426e2007', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Guam', 'GU');
INSERT INTO mp_geozone VALUES ('8ee2f892-4ee6-44f5-938a-b553e885161a', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Pennsylvania', 'PA');
INSERT INTO mp_geozone VALUES ('8fab7d36-b885-46cd-9dc8-41e40c8683c4', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Sao Paulo', 'SP');
INSERT INTO mp_geozone VALUES ('91bf4254-f418-404a-8cb2-5449d498991e', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Amazonas', 'AM');
INSERT INTO mp_geozone VALUES ('93215e73-4df8-4609-ac37-9da1b9bfe1c9', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Saskatchewan', 'SK');
INSERT INTO mp_geozone VALUES ('933cd9ef-c021-48ed-8260-6c013685970f', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Florida', 'FL');
INSERT INTO mp_geozone VALUES ('93cdd758-cc83-4f5a-94c0-9a3d13c7fa44', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Europe', 'AE');
INSERT INTO mp_geozone VALUES ('956b1071-d4c1-4676-be0c-e8834e47b674', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Burgos', 'Burgos');
INSERT INTO mp_geozone VALUES ('962d2729-cc0c-4052-abc9-c696307f3f26', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Voralberg', 'VB');
INSERT INTO mp_geozone VALUES ('978ecaab-c462-4d66-80b6-a65eb83b86a5', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'South Dakota', 'SD');
INSERT INTO mp_geozone VALUES ('993207ec-34a5-4896-88b0-3c43ccd11ab2', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Canada', 'AC');
INSERT INTO mp_geozone VALUES ('9c24162b-10de-47c1-b55f-0dcaaa24f86e', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Nidwalden', 'NW');
INSERT INTO mp_geozone VALUES ('9c9951d7-68d2-438a-a702-4289cbc1720e', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Valencia', 'Valencia');
INSERT INTO mp_geozone VALUES ('9fb374c6-b87c-4096-a43c-d3d9ff2fd04c', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Distrito Federal', 'DF');
INSERT INTO mp_geozone VALUES ('a34df017-1334-4f1f-aab8-f650425f937d', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'K?rnten', 'KN');
INSERT INTO mp_geozone VALUES ('a39f8a9a-6586-41fb-9d5f-f84bd5161333', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Kansas', 'KS');
INSERT INTO mp_geozone VALUES ('a3a183ae-8117-46c0-93b7-3940c7e5694f', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Americas', 'AA');
INSERT INTO mp_geozone VALUES ('a3cb237b-a940-418f-8368-fa6e35263e22', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Asturias', 'Asturias');
INSERT INTO mp_geozone VALUES ('a6ed9918-44c7-4975-b680-95b4abcfb7ac', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Salzburg', 'SB');
INSERT INTO mp_geozone VALUES ('aa492ac6-e3b1-4408-b503-81480b57f008', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Ourense', 'Ourense');
INSERT INTO mp_geozone VALUES ('ab47df32-c57d-412b-b04d-67378c120ae7', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Pacific', 'AP');
INSERT INTO mp_geozone VALUES ('ad9e0130-b735-4be0-9338-99e20bb9410d', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Th?ringen', 'THE');
INSERT INTO mp_geozone VALUES ('afa207c7-e69d-46f0-8242-2a67a06c42e3', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Appenzell Innerrhoden', 'AI');
INSERT INTO mp_geozone VALUES ('b2b175a4-09ba-4e25-919c-9de52109bf4d', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Brandenburg', 'BRG');
INSERT INTO mp_geozone VALUES ('b519aaaf-7e2c-421f-88b8-bf7853a8de4f', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Tessin', 'TI');
INSERT INTO mp_geozone VALUES ('b5812090-e7e1-492b-b9bc-04fec3ec9492', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Hawaii', 'HI');
INSERT INTO mp_geozone VALUES ('b5feb85c-2dc0-4776-ba5c-8c2d1b688e89', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Wien', 'WI');
INSERT INTO mp_geozone VALUES ('b716403c-6b15-488b-9cd0-f60b1aa1ba41', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'New Brunswick', 'NB');
INSERT INTO mp_geozone VALUES ('b7500c17-30c7-4d87-bb47-bb35d8b1d3a6', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Navarra', 'Navarra');
INSERT INTO mp_geozone VALUES ('b8bf0b26-2f14-49e4-bfda-2d01eafa364b', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Alabama', 'AL');
INSERT INTO mp_geozone VALUES ('b9093677-f26a-4b47-ad98-12caed313044', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Wisconsin', 'WI');
INSERT INTO mp_geozone VALUES ('b9f64887-ed6d-4ddc-a142-7eb8898ca47e', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Pernambuco', 'PE');
INSERT INTO mp_geozone VALUES ('b9f911eb-f762-4da4-a81f-9bc967cd3c4b', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Waadt', 'VD');
INSERT INTO mp_geozone VALUES ('ba3c2043-cc3e-4225-b28e-bdb18c1a79ef', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Hessen', 'HES');
INSERT INTO mp_geozone VALUES ('ba5a801b-11c6-4408-b097-08aac22e739e', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'South Carolina', 'SC');
INSERT INTO mp_geozone VALUES ('bb090ce7-e0ca-4d0d-96eb-1b8e044fbca8', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Melilla', 'Melilla');
INSERT INTO mp_geozone VALUES ('bb607ecb-df31-427b-88bb-4f53959b3e0c', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Nieder?sterreich', 'NO');
INSERT INTO mp_geozone VALUES ('c1983f1d-353a-4042-b097-f0e8237f7fcd', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'St. Gallen', 'SG');
INSERT INTO mp_geozone VALUES ('c26cfb75-5e44-4156-b660-a18a2a487fec', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Murcia', 'Murcia');
INSERT INTO mp_geozone VALUES ('c2ba8e9e-d370-4639-b168-c51057e2397e', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Guadalajara', 'Guadalajara');
INSERT INTO mp_geozone VALUES ('c3e70597-e8dd-4277-b7fc-e9b4206da073', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Connecticut', 'CT');
INSERT INTO mp_geozone VALUES ('c5d128d8-353a-43dc-ba0a-d0c35e33de17', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Minas Gerais', 'MG');
INSERT INTO mp_geozone VALUES ('c7330896-bd61-4282-b3bf-8713a28d3b50', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Indiana', 'IN');
INSERT INTO mp_geozone VALUES ('c7a02c1c-3076-43b3-9538-b513bab8a243', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Soria', 'Soria');
INSERT INTO mp_geozone VALUES ('ca553819-434a-408f-a2a4-92a7df9a2618', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Cuenca', 'Cuenca');
INSERT INTO mp_geozone VALUES ('ca5c0c52-e8ae-4ccd-9a45-565e352c4e2b', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Steiermark', 'ST');
INSERT INTO mp_geozone VALUES ('cb47cc62-5d26-4b17-b01f-25e5432f913c', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Lugo', 'Lugo');
INSERT INTO mp_geozone VALUES ('cb6d309d-ed20-48d0-8a5d-cd1d7fd1aad6', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Utah', 'UT');
INSERT INTO mp_geozone VALUES ('cbc4121c-d62d-410c-b699-60b08b67711f', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Piaui', 'PI');
INSERT INTO mp_geozone VALUES ('cbd2718f-dd60-4151-a24d-437ff37605c6', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Jaen', 'Jaen');
INSERT INTO mp_geozone VALUES ('cc6b7a8e-4275-4e4e-8d62-34b5480f3995', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Huesca', 'Huesca');
INSERT INTO mp_geozone VALUES ('ccd7968c-7e80-4381-958b-ab72be0d6c35', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Solothurn', 'SO');
INSERT INTO mp_geozone VALUES ('cf6e4b72-5f4f-4cc4-add3-eb0964892f7b', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Huelva', 'Huelva');
INSERT INTO mp_geozone VALUES ('cf75931a-d86f-43a0-8bd9-3942d5945ff7', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Mississippi', 'MS');
INSERT INTO mp_geozone VALUES ('cfa0c0e5-b478-41bd-9029-49bd04c68871', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Washington', 'WA');
INSERT INTO mp_geozone VALUES ('d20875cc-8572-453c-b5e0-53b49742debb', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Nunavut', 'NU');
INSERT INTO mp_geozone VALUES ('d21905c5-6ee9-4072-9618-8447d9c4390e', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Alava', 'Alava');
INSERT INTO mp_geozone VALUES ('d21e2732-779d-406a-b1b9-cf44ff280dfe', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Pontevedra', 'Pontevedra');
INSERT INTO mp_geozone VALUES ('d226235d-0eb0-49c5-9e7a-55cc91c57100', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Palencia', 'Palencia');
INSERT INTO mp_geozone VALUES ('d256f9b7-8a33-4d04-9e19-95c12c967719', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Rondonia', 'RO');
INSERT INTO mp_geozone VALUES ('d284266a-559d-42f3-a881-0136ea080c12', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Rio De Janeiro', 'RJ');
INSERT INTO mp_geozone VALUES ('d2880e75-e454-41a1-a73d-b2cff71197e2', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Massachusetts', 'MA');
INSERT INTO mp_geozone VALUES ('d318e32e-41b6-4ca6-905d-23714709f38f', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Armed Forces Africa', 'AF');
INSERT INTO mp_geozone VALUES ('d4f8133e-5580-4a66-94dd-096d295723a0', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Prince Edward Island', 'PE');
INSERT INTO mp_geozone VALUES ('d52cedac-fcc2-4b9c-8f9e-09dcda91974c', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife');
INSERT INTO mp_geozone VALUES ('d55b4820-1ccd-44ad-8fbe-60b750abc2dd', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Niedersachsen', 'NDS');
INSERT INTO mp_geozone VALUES ('d698a1b6-68d7-480e-8137-421c684f251d', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Alagoas', 'AL');
INSERT INTO mp_geozone VALUES ('d85b7129-d009-4747-9748-b116739ba660', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Alberta', 'AB');
INSERT INTO mp_geozone VALUES ('d892ea50-fccf-477a-bbdf-418e32dc5b98', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Appenzell Ausserrhoden', 'AR');
INSERT INTO mp_geozone VALUES ('d907d2a6-4caa-4687-898a-58bd5f978d03', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Missouri', 'MO');
INSERT INTO mp_geozone VALUES ('d96d5675-f3e2-42fe-b581-bd2367dc5012', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Madrid', 'Madrid');
INSERT INTO mp_geozone VALUES ('dad6586a-c504-4117-b116-4c80a0d1bf52', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Valladolid', 'Valladolid');
INSERT INTO mp_geozone VALUES ('db9ccccf-9e20-4224-88a7-067e5238960d', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Toledo', 'Toledo');
INSERT INTO mp_geozone VALUES ('dcc28b9c-8d2f-4569-ad0a-ad5717da3bb7', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Graub?nden', 'JU');
INSERT INTO mp_geozone VALUES ('ddb0ca67-8635-4f40-a01d-06ccb266ef56', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Parana', 'PR');
INSERT INTO mp_geozone VALUES ('dec30815-883a-45a2-9318-bfb111b383d6', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Oregon', 'OR');
INSERT INTO mp_geozone VALUES ('e026bf9d-66a9-49bf-ba77-860b8c60871d', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Zaragoza', 'Zaragoza');
INSERT INTO mp_geozone VALUES ('e663aef7-a697-4164-8ce4-141ac5cef6a9', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Para', 'PA');
INSERT INTO mp_geozone VALUES ('e83159f2-abe3-4f94-80de-a149bcf83428', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'District of Columbia', 'DC');
INSERT INTO mp_geozone VALUES ('e8426499-9214-41c8-9717-44f2a4d6d14e', '0c356c5a-ca44-4301-8212-1826ccdadc42', 'Quebec', 'QC');
INSERT INTO mp_geozone VALUES ('e885e0ce-a268-4db0-aff2-a0205353e7e4', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Neuenburg', 'NE');
INSERT INTO mp_geozone VALUES ('ea73c8eb-cac2-4b28-bb9a-d923f32c17ef', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'New York', 'NY');
INSERT INTO mp_geozone VALUES ('eb8efd2d-b9fa-4f99-9c49-9def24ccc5b5', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Wyoming', 'WY');
INSERT INTO mp_geozone VALUES ('ebc9105f-1f6e-44be-b4f2-6d23908278d6', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Louisiana', 'LA');
INSERT INTO mp_geozone VALUES ('ec2a6fed-19c2-4364-99cb-a59e8e0929fe', '60ce9ab1-945d-4fef-aba8-a1bb640165be', 'Z?rich', 'ZH');
INSERT INTO mp_geozone VALUES ('f1bbc9fc-4b0a-4065-843e-f428f1c20346', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Georgia', 'GA');
INSERT INTO mp_geozone VALUES ('f23bab33-cad9-4d9c-9ced-a66b3ff4969f', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Delaware', 'DE');
INSERT INTO mp_geozone VALUES ('f2e5ffce-bf2a-4f21-9696-fd948c07d6ae', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Rio Grande Do Norte', 'RN');
INSERT INTO mp_geozone VALUES ('f5315bf8-0dc2-49e7-abeb-0d7348492e6b', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Cantabria', 'Cantabria');
INSERT INTO mp_geozone VALUES ('f6b97ed0-d090-4c68-a590-8fe743ee6d43', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'Palau', 'PW');
INSERT INTO mp_geozone VALUES ('f92a3196-5c67-4fec-8877-78b28803b8d6', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'A Coru?a', 'A Coru?a');
INSERT INTO mp_geozone VALUES ('f93295d1-7501-487d-93ad-6bd019e82cc2', '06bb7816-9ad4-47dc-b1cd-6e206afdfcca', 'Ober?sterreich', 'OO');
INSERT INTO mp_geozone VALUES ('fb63f22d-2a32-484e-a3e8-41bbae13891b', '2d5b53a8-8341-4da4-a296-e516fe5bb953', 'Schleswig-Holstein', 'SCN');
INSERT INTO mp_geozone VALUES ('fbe69225-8cad-4e54-b4e5-03d6e404bc3f', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Paraiba', 'PB');
INSERT INTO mp_geozone VALUES ('fcd4595b-4b67-4b73-84c6-29706a57af38', '13faa99e-18f2-4e6f-b275-1e785b3383f3', 'Mato Grosso', 'MT');
INSERT INTO mp_geozone VALUES ('fe29ffdb-5e1c-44bd-bb9a-2e2e43c1b206', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Malaga', 'Malaga');
INSERT INTO mp_geozone VALUES ('fea759da-4280-46a8-af3f-ec2cc03b436a', '38dc01c3-48d8-4ff8-a78a-2c35d4fbfa7b', 'Girona', 'Girona');
INSERT INTO mp_geozone VALUES ('fec3a4f7-e3b5-44d3-bbde-62628489b459', 'a71d6727-61e7-4282-9fcb-526d1e7bc24f', 'North Carolina', 'NC');


--
-- Data for Name: mp_googlecheckoutlog; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_htmlcontent; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_htmlcontent VALUES (1, 1, '', '', '<p>Welcome to <strong>mojoPortal</strong>, this is sample data, you can edit this content to get started. <br />
<br />
You can login using admin@admin.com and the password admin.  <br />
<br />
Be sure and change the administrator name and password on the profile page after you login.  <br />
<br />
After you login, you will see a key icon which links to the Administration menu.</p>
<p>The Administration menu provides management tools for creating and editing content, users, roles and more.</p>
<p>Tip: Once you are logged in you will see pencil icons for editing content and gears icons for editing settings. Mouse over icons to see the tooltip message of what they are for.<br />
<br />
For more info on using mojoPortal:</p>
<ul class="simplelist">
    <li><a href="http://www.mojoportal.com">www.mojoportal.com</a></li>
    <li><a href="http://www.mojoportal.com/documentation.aspx">Documentation</a></li>
    <li><a href="http://www.mojoportal.com/forums.aspx">Support Forums</a></li>
</ul>
<p>If you like <a href="http://www.mojoportal.com">mojoPortal</a>, please register on our site. We won''t spam you or share your email address, but having more registered users is a measure of the success of this project and is a simple way you can help support the project.</p>', '', 500, '2008-12-26 04:57:05.383107', '2028-12-26 04:57:05.383109', '2008-12-26 04:57:05.383117', -1, 'f34203ef-2850-4329-83c4-cd5fc619567c', '3c85bbad-1b11-4e32-a014-6346d85d327a', '00000000-0000-0000-0000-000000000000', '00000000-0000-0000-0000-000000000000', '2008-12-26 04:57:05.383117');


--
-- Data for Name: mp_indexingqueue; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_indexingqueue VALUES (1, '/usr/share/mono/asp.net/apps/mojoportal-2.2.6.8/Data/Sites/1/index/', '<?xml version="1.0" encoding="utf-16"?>
<IndexItem>
  <IndexPath />
  <SiteId>1</SiteId>
  <PageId>1</PageId>
  <ModuleId>1</ModuleId>
  <ItemId>1</ItemId>
  <PageIndex>0</PageIndex>
  <PageNumber>0</PageNumber>
  <PageName>Home</PageName>
  <FeatureName>HtmlContentFeatureName</FeatureName>
  <FeatureResourceFile>Resource</FeatureResourceFile>
  <ModuleTitle>Welcome</ModuleTitle>
  <Title />
  <Content>&lt;p&gt;Welcome to &lt;strong&gt;mojoPortal&lt;/strong&gt;, this is sample data, you can edit this content to get started. &lt;br /&gt;
&lt;br /&gt;
You can login using admin@admin.com and the password admin.  &lt;br /&gt;
&lt;br /&gt;
Be sure and change the administrator name and password on the profile page after you login.  &lt;br /&gt;
&lt;br /&gt;
After you login, you will see a key icon which links to the Administration menu.&lt;/p&gt;
&lt;p&gt;The Administration menu provides management tools for creating and editing content, users, roles and more.&lt;/p&gt;
&lt;p&gt;Tip: Once you are logged in you will see pencil icons for editing content and gears icons for editing settings. Mouse over icons to see the tooltip message of what they are for.&lt;br /&gt;
&lt;br /&gt;
For more info on using mojoPortal:&lt;/p&gt;
&lt;ul class="simplelist"&gt;
    &lt;li&gt;&lt;a href="http://www.mojoportal.com"&gt;www.mojoportal.com&lt;/a&gt;&lt;/li&gt;
    &lt;li&gt;&lt;a href="http://www.mojoportal.com/documentation.aspx"&gt;Documentation&lt;/a&gt;&lt;/li&gt;
    &lt;li&gt;&lt;a href="http://www.mojoportal.com/forums.aspx"&gt;Support Forums&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;
&lt;p&gt;If you like &lt;a href="http://www.mojoportal.com"&gt;mojoPortal&lt;/a&gt;, please register on our site. We won''t spam you or share your email address, but having more registered users is a measure of the success of this project and is a simple way you can help support the project.&lt;/p&gt;</Content>
  <OtherContent />
  <ViewRoles>All Users;</ViewRoles>
  <ViewPage>home.aspx</ViewPage>
  <UseQueryStringParams>false</UseQueryStringParams>
  <QueryStringAddendum />
  <PublishBeginDate>2008-12-26T04:57:05.2985829</PublishBeginDate>
  <PublishEndDate>9999-12-31T23:59:59.9999999</PublishEndDate>
</IndexItem>', '1~1~1~1', false);


--
-- Data for Name: mp_language; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_language VALUES ('346a1ca8-fafd-420a-bde2-c535e5bdbc26', 'Deutsch', 'de', 100);
INSERT INTO mp_language VALUES ('6d81a11e-f1d3-4cd6-b713-8c7b2bb32b3f', 'English', 'en', 100);
INSERT INTO mp_language VALUES ('fba6e2aa-2a69-4d89-b389-d5ae92f2aa06', 'Espanol', 'es', 100);


--
-- Data for Name: mp_letter; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_letterhtmltemplate; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_letterinfo; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_lettersendlog; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_lettersubscriber; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_lettersubscriberhx; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_links; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_moduledefinitions; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_moduledefinitions VALUES (2, 'BlogFeatureName', 'Modules/BlogModule.ascx', 500, false, 'blank.gif', 0, '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (3, 'ContactFormFeatureName', 'Modules/ContactForm.ascx', 500, false, 'blank.gif', 0, '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (4, 'EventCalendarFeatureName', 'Modules/EventCalendar.ascx', 500, false, 'blank.gif', 0, 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (5, 'ForumsFeatureName', 'Modules/ForumModule.ascx', 500, false, 'blank.gif', 0, '38aa5a84-9f5c-42eb-8f4c-105983d419fb', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (6, 'GoogleMapFeatureName', 'Modules/GoogleMapModule.ascx', 500, false, 'blank.gif', 0, '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (7, 'FolderGalleryFeatureName', 'Modules/FolderGalleryModule.ascx', 500, false, 'blank.gif', 0, '9e58fcda-90de-4ed7-abc7-12f096f5c58f', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (8, 'ImageGalleryFeatureName', 'Modules/Gallery.ascx', 500, false, 'blank.gif', 360, 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (9, 'LinksFeatureName', 'Modules/Links.ascx', 500, false, 'blank.gif', 360, '74bdbcc2-0e79-47ff-bcd4-a159270bf36e', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (10, 'RSSAggregatorFeatureName', 'Modules/RSSAggregator.ascx', 500, false, 'blank.gif', 0, '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (11, 'SharedFilesFeatureName', 'Modules/SharedFiles.ascx', 500, false, 'blank.gif', 0, 'dc873d76-5bf2-4ac5-bff7-434a87a3fc8e', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (13, 'HtmlFragmentIncludeFeatureName', 'Modules/HtmlFragmentInclude.ascx', 500, false, 'blank.gif', 360, 'f193cce1-6e28-4b73-88e7-e00cd1d642c9', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (14, 'XmlXslFeatureName', 'Modules/XmlModule.ascx', 500, false, 'blank.gif', 360, 'fa969c0a-6d02-4dcb-86b8-ac69d80c1fb1', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (1, 'HtmlContentFeatureName', 'Modules/HtmlModule.ascx', 300, false, 'blank.gif', 360, '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource');
INSERT INTO mp_moduledefinitions VALUES (12, 'SiteStatisticsFeatureName', 'Modules/SiteStatisticsModule.ascx', 500, false, 'blank.gif', 0, '1999e312-0378-4bca-8753-201d17957a74', 'Resource');


--
-- Data for Name: mp_moduledefinitionsettings; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_moduledefinitionsettings VALUES (1, 1, 'HtmlMultipleItemsSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (2, 1, 'HtmlShowDateSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (3, 1, 'HtmlUseExcerptSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (4, 1, 'HtmlUseMoreLinkSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (5, 1, 'HtmlMoreLinkNewWindowSetting', 'true', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (7, 2, 'BlogAuthorSetting', 'Blog Author', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (8, 2, 'BlogAuthorEmailSetting', 'blogauthor@yourportal.com', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (9, 2, 'BlogCopyrightSetting', 'Copyright 2006 Blog Author', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (10, 2, 'BlogDescriptionSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (11, 2, 'BlogEntriesToShowSetting', '10', 'TextBox', '^[1-9][0-9]{0,2}$', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (12, 2, 'BlogRSSCacheTimeSetting', '120', 'TextBox', '^[1-9][0-9]{0,2}$', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (13, 2, 'BlogEditorHeightSetting', '350', 'TextBox', '^[1-9][0-9]{0,4}$', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (14, 2, 'RSSAddSignature', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (15, 2, 'RSSAddCommentsLink', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 180);
INSERT INTO mp_moduledefinitionsettings VALUES (16, 2, 'BlogShowCalendarSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 190);
INSERT INTO mp_moduledefinitionsettings VALUES (17, 2, 'BlogShowArchiveSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 200);
INSERT INTO mp_moduledefinitionsettings VALUES (18, 2, 'BlogShowCategoriesSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 210);
INSERT INTO mp_moduledefinitionsettings VALUES (19, 2, 'BlogNavigationOnRightSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 220);
INSERT INTO mp_moduledefinitionsettings VALUES (20, 2, 'ContentNotifyOnComment', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 230);
INSERT INTO mp_moduledefinitionsettings VALUES (21, 2, 'BlogShowStatisticsSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 240);
INSERT INTO mp_moduledefinitionsettings VALUES (22, 2, 'BlogShowFeedLinksSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 250);
INSERT INTO mp_moduledefinitionsettings VALUES (23, 2, 'BlogShowAddFeedLinksSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 260);
INSERT INTO mp_moduledefinitionsettings VALUES (24, 2, 'BlogAllowComments', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 270);
INSERT INTO mp_moduledefinitionsettings VALUES (25, 2, 'BlogUseCommentSpamBlocker', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 280);
INSERT INTO mp_moduledefinitionsettings VALUES (26, 2, 'GoogleMapHeightSetting', '300', 'TextBox', '^[1-9][0-9]{0,4}$', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 290);
INSERT INTO mp_moduledefinitionsettings VALUES (27, 2, 'GoogleMapWidthSetting', '500', 'TextBox', '^[1-9][0-9]{0,4}$', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 300);
INSERT INTO mp_moduledefinitionsettings VALUES (28, 2, 'GoogleMapEnableMapTypeSetting', 'false', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 310);
INSERT INTO mp_moduledefinitionsettings VALUES (29, 2, 'GoogleMapEnableZoomSetting', 'false', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 320);
INSERT INTO mp_moduledefinitionsettings VALUES (30, 2, 'GoogleMapShowInfoWindowSetting', 'false', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 330);
INSERT INTO mp_moduledefinitionsettings VALUES (31, 2, 'GoogleMapEnableLocalSearchSetting', 'false', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 340);
INSERT INTO mp_moduledefinitionsettings VALUES (32, 2, 'GoogleMapEnableDirectionsSetting', 'false', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 350);
INSERT INTO mp_moduledefinitionsettings VALUES (33, 2, 'GoogleMapInitialMapTypeSetting', 'G_SATELLITE_MAP', 'ISettingControl', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '~/Controls/GMapTypeSetting.ascx', '', 360);
INSERT INTO mp_moduledefinitionsettings VALUES (34, 2, 'GoogleMapInitialZoomSetting', '13', 'ISettingControl', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '~/Controls/GMapZoomLevelSetting.ascx', '', 370);
INSERT INTO mp_moduledefinitionsettings VALUES (35, 2, 'OdiogoFeedIDSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 380);
INSERT INTO mp_moduledefinitionsettings VALUES (36, 2, 'OdiogoPodcastUrlSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 390);
INSERT INTO mp_moduledefinitionsettings VALUES (37, 2, 'BlogAddThisDotComUsernameSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 400);
INSERT INTO mp_moduledefinitionsettings VALUES (38, 2, 'BlogAddThisRssButtonImageUrlSetting', '~/Data/SiteImages/addthisrss.gif', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 410);
INSERT INTO mp_moduledefinitionsettings VALUES (39, 2, 'BlogAddThisDotComUseMouseOverWidgetSetting', 'true', 'CheckBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 420);
INSERT INTO mp_moduledefinitionsettings VALUES (40, 2, 'BlogAddThisButtonImageUrlSetting', '~/Data/SiteImages/addthissharebutton.gif', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 430);
INSERT INTO mp_moduledefinitionsettings VALUES (41, 2, 'BlogAddThisCustomBrandSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 440);
INSERT INTO mp_moduledefinitionsettings VALUES (42, 2, 'BlogAddThisCustomOptionsSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 450);
INSERT INTO mp_moduledefinitionsettings VALUES (43, 2, 'BlogAddThisCustomLogoUrlSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 460);
INSERT INTO mp_moduledefinitionsettings VALUES (44, 2, 'BlogAddThisCustomLogoBackColorSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 470);
INSERT INTO mp_moduledefinitionsettings VALUES (45, 2, 'BlogAddThisCustomLogoForeColorSetting', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 480);
INSERT INTO mp_moduledefinitionsettings VALUES (46, 2, 'BlogFeedburnerFeedUrl', '', 'TextBox', '', '026cbead-2b80-4491-906d-b83e37179ccf', 'Resource', '', '', 490);
INSERT INTO mp_moduledefinitionsettings VALUES (47, 3, 'ContactFormEmailSetting', '', 'TextBox', '', '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (48, 3, 'ContactFormEditorHeightSetting', '350', 'TextBox', '^[1-9][0-9]{0,4}$', '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (49, 3, 'ContactFormUseCommentSpamBlocker', 'false', 'CheckBox', '', '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (50, 3, 'ContactFormMessageListPageSizeSetting', '9', 'TextBox', '^[1-9][0-9]{0,2}$', '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (51, 3, 'ContactFormSubjectPrefixSetting', '', 'TextBox', '', '99019eb8-db13-4bb3-81ea-073571a60dba', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (52, 4, 'CalendarUseFillerOnEmptyDays', 'true', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (53, 4, 'GoogleMapHeightSetting', '300', 'TextBox', '^[1-9][0-9]{0,4}$', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (54, 4, 'GoogleMapWidthSetting', '500', 'TextBox', '^[1-9][0-9]{0,4}$', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (55, 4, 'GoogleMapEnableMapTypeSetting', 'false', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (56, 4, 'GoogleMapEnableZoomSetting', 'false', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (57, 4, 'GoogleMapShowInfoWindowSetting', 'false', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (58, 4, 'GoogleMapEnableLocalSearchSetting', 'false', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (59, 4, 'GoogleMapEnableDirectionsSetting', 'true', 'CheckBox', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (60, 4, 'GoogleMapInitialMapTypeSetting', 'G_NORMAL_MAP', 'ISettingControl', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '~/Controls/GMapTypeSetting.ascx', '', 180);
INSERT INTO mp_moduledefinitionsettings VALUES (61, 4, 'GoogleMapInitialZoomSetting', '13', 'ISettingControl', '', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e', 'Resource', '~/Controls/GMapZoomLevelSetting.ascx', '', 190);
INSERT INTO mp_moduledefinitionsettings VALUES (62, 5, 'ForumEnableRSSAtModuleLevel', 'false', 'CheckBox', '', '38aa5a84-9f5c-42eb-8f4c-105983d419fb', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (63, 5, 'ForumEnableRSSAtForumLevel', 'false', 'CheckBox', '', '38aa5a84-9f5c-42eb-8f4c-105983d419fb', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (64, 5, 'ForumEnableRSSAtThreadLevel', 'false', 'CheckBox', '', '38aa5a84-9f5c-42eb-8f4c-105983d419fb', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (65, 6, 'GoogleMapLocationSetting', 'Times Square, New York, NY', 'TextBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (66, 6, 'GoogleMapCaptionSetting', '', 'TextBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (67, 6, 'GoogleMapHeightSetting', '300', 'TextBox', '^[1-9][0-9]{0,4}$', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (68, 6, 'GoogleMapWidthSetting', '500', 'TextBox', '^[1-9][0-9]{0,4}$', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (69, 6, 'GoogleMapEnableZoomSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (70, 6, 'GoogleMapShowInfoWindowSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (71, 6, 'GoogleMapEnableLocalSearchSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (72, 6, 'GoogleMapEnableDirectionsSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 180);
INSERT INTO mp_moduledefinitionsettings VALUES (73, 6, 'GoogleMapUseLocationForTitleSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 190);
INSERT INTO mp_moduledefinitionsettings VALUES (74, 6, 'GoogleMapShowLocationCaptionSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 200);
INSERT INTO mp_moduledefinitionsettings VALUES (75, 6, 'GoogleMapEnableMapTypeSetting', 'false', 'CheckBox', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '', '', 205);
INSERT INTO mp_moduledefinitionsettings VALUES (76, 6, 'GoogleMapInitialMapTypeSetting', 'G_NORMAL_MAP', 'ISettingControl', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '~/Controls/GMapTypeSetting.ascx', '', 210);
INSERT INTO mp_moduledefinitionsettings VALUES (77, 6, 'GoogleMapInitialZoomSetting', '13', 'ISettingControl', '', '5219a554-d176-481e-abc0-9ea2ee4c8efc', 'Resource', '~/Controls/GMapZoomLevelSetting.ascx', '', 220);
INSERT INTO mp_moduledefinitionsettings VALUES (78, 7, 'FolderGalleryRootFolder', '', 'TextBox', '', '9e58fcda-90de-4ed7-abc7-12f096f5c58f', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (79, 8, 'GalleryAllowFullSizeViewSetting', 'true', 'CheckBox', '', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (80, 8, 'GalleryShowTechnicalDataSetting', 'false', 'CheckBox', '', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (81, 8, 'GalleryCompactModeSetting', 'true', 'CheckBox', '', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (82, 8, 'GalleryThumbnailHeightSetting', '75', 'TextBox', '^[1-9][0-9]{0,2}$', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (83, 8, 'GalleryThumbnailWidthSetting', '100', 'TextBox', '^[1-9][0-9]{0,2}$', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (84, 8, 'GalleryThumbnailsPerPageSetting', '20', 'TextBox', '^[1-9][0-9]{0,2}$', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (85, 8, 'GalleryWebImageHeightSetting', '320', 'TextBox', '^[1-9][0-9]{0,2}$', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (86, 8, 'GalleryWebImageWidthSetting', '480', 'TextBox', '^[1-9][0-9]{0,2}$', 'd572f6b4-d0ed-465d-ad60-60433893b401', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (87, 9, 'LinksShowDescriptionSetting', 'false', 'CheckBox', '', '74bdbcc2-0e79-47ff-bcd4-a159270bf36e', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (88, 9, 'LinksShowDeleteIconSetting', 'false', 'CheckBox', '', '74bdbcc2-0e79-47ff-bcd4-a159270bf36e', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (89, 10, 'RSSFeedShowHeadingsOnlySetting', 'false', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (90, 10, 'RSSFeedShowErrorMessageOnInvalidPosts', 'false', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (91, 10, 'RSSFeedListLabelSetting', 'Feeds', 'TextBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (92, 10, 'RSSFeedFeedListCacheTimeoutSetting', '240', 'TextBox', '^[1-9][0-9]{0,4}$', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (93, 10, 'RSSFeedEntryCacheTimeoutSetting', '120', 'TextBox', '^[1-9][0-9]{0,4}$', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (94, 10, 'RSSFeedFeedListColumnsSetting', '1', 'TextBox', '^[1-9][0-9]{0,2}$', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (95, 10, 'RSSFeedMaxDayCountSetting', '90', 'TextBox', '^[1-9][0-9]{0,3}$', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (96, 10, 'RSSFeedMaxPostsPerFeedSetting', '20', 'TextBox', '^[1-9][0-9]{0,3}$', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (97, 10, 'RSSFeedShowAggregateFeedLink', 'true', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 180);
INSERT INTO mp_moduledefinitionsettings VALUES (98, 10, 'RSSFeedShowIndividualFeedLinks', 'true', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 190);
INSERT INTO mp_moduledefinitionsettings VALUES (99, 10, 'RSSFeedShowFeedListRightSetting', 'true', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 200);
INSERT INTO mp_moduledefinitionsettings VALUES (100, 10, 'RSSFeedUseFeedListAsFilterSetting', 'false', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 210);
INSERT INTO mp_moduledefinitionsettings VALUES (101, 10, 'RSSFeedAllowExternalImages', 'false', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 220);
INSERT INTO mp_moduledefinitionsettings VALUES (102, 10, 'RSSFeedSortAscending', 'false', 'CheckBox', '', '5ef82464-e2d3-4982-8dfd-01e1afa615f9', 'Resource', '', '', 230);
INSERT INTO mp_moduledefinitionsettings VALUES (103, 11, 'SharedFilesEnableVersioningSetting', 'true', 'CheckBox', '', 'dc873d76-5bf2-4ac5-bff7-434a87a3fc8e', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (107, 13, 'HtmlFragmentSourceSetting', 'fragment1.htm', 'TextBox', '', 'f193cce1-6e28-4b73-88e7-e00cd1d642c9', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (108, 14, 'XmlModuleXmlSourceSetting', '', 'TextBox', '', 'fa969c0a-6d02-4dcb-86b8-ac69d80c1fb1', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (109, 14, 'XmlModuleXslSourceSetting', '', 'TextBox', '', 'fa969c0a-6d02-4dcb-86b8-ac69d80c1fb1', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (6, 1, 'HtmlEditorHeightSetting', '350', 'TextBox', '^[1-9][0-9]{0,4}$', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 150);
INSERT INTO mp_moduledefinitionsettings VALUES (110, 1, 'EnableContentRatingSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 160);
INSERT INTO mp_moduledefinitionsettings VALUES (111, 1, 'EnableRatingCommentsSetting', 'false', 'CheckBox', '', '881e4e00-93e4-444c-b7b0-6672fb55de10', 'Resource', '', '', 170);
INSERT INTO mp_moduledefinitionsettings VALUES (104, 12, 'SiteStatistics_ShowMemberStatisitics', 'true', 'CheckBox', '', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 100);
INSERT INTO mp_moduledefinitionsettings VALUES (105, 12, 'SiteStatistics_ShowOnlineStatistics', 'true', 'CheckBox', '', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 110);
INSERT INTO mp_moduledefinitionsettings VALUES (106, 12, 'SiteStatistics_ShowOnlineMembers', 'true', 'CheckBox', '', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 120);
INSERT INTO mp_moduledefinitionsettings VALUES (112, 12, 'ShowMemberGraphSetting', 'false', 'CheckBox', '', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 130);
INSERT INTO mp_moduledefinitionsettings VALUES (113, 12, 'MemberGraphHeightSetting', '300', 'TextBox', '^[1-9][0-9]{0,4}$', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 140);
INSERT INTO mp_moduledefinitionsettings VALUES (114, 12, 'MemberGraphWidthSetting', '500', 'TextBox', '^[1-9][0-9]{0,4}$', '1999e312-0378-4bca-8753-201d17957a74', 'Resource', '', '', 150);


--
-- Data for Name: mp_modules; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_modules VALUES (1, 1, 'Welcome', '', 360, 0, true, 1, false, -1, '2008-12-26 04:57:05.287695', 0, 'blank.gif', true, '3c85bbad-1b11-4e32-a014-6346d85d327a', '881e4e00-93e4-444c-b7b0-6672fb55de10', '9d74618a-141e-4541-a78b-ba7411a6dd45', NULL, false, false);


--
-- Data for Name: mp_modulesettings; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_modulesettings VALUES (1, 1, 'HtmlMultipleItemsSetting', 'false', 'CheckBox', '', '3c85bbad-1b11-4e32-a014-6346d85d327a', '6bcc5bae-32d9-4a11-ae74-12fe19974b82', '', '', 100);
INSERT INTO mp_modulesettings VALUES (2, 1, 'HtmlShowDateSetting', 'false', 'CheckBox', '', '3c85bbad-1b11-4e32-a014-6346d85d327a', '63149347-ed42-4b20-8cdd-f76fa7acaef7', '', '', 110);
INSERT INTO mp_modulesettings VALUES (3, 1, 'HtmlUseExcerptSetting', 'false', 'CheckBox', '', '3c85bbad-1b11-4e32-a014-6346d85d327a', '2cac2f49-b80e-4e86-8d09-303db65cc671', '', '', 120);
INSERT INTO mp_modulesettings VALUES (4, 1, 'HtmlUseMoreLinkSetting', 'false', 'CheckBox', '', '3c85bbad-1b11-4e32-a014-6346d85d327a', '9e718ecf-3143-4741-abec-2f74846ccf15', '', '', 130);
INSERT INTO mp_modulesettings VALUES (5, 1, 'HtmlMoreLinkNewWindowSetting', 'true', 'CheckBox', '', '3c85bbad-1b11-4e32-a014-6346d85d327a', '25707162-6b1c-4059-9eca-1e1357a0100d', '', '', 140);
INSERT INTO mp_modulesettings VALUES (6, 1, 'HtmlEditorHeightSetting', '350', 'TextBox', '^[1-9][0-9]{0,4}$', '3c85bbad-1b11-4e32-a014-6346d85d327a', '4f5bd48b-fbe3-4284-a677-1bd1c2953ae3', '', '', 150);


--
-- Data for Name: mp_pagemodules; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_pagemodules VALUES (1, 1, 'contentpane', 1, '2008-12-26 04:57:05.298583', NULL, '3c85bbad-1b11-4e32-a014-6346d85d327a', 'a62d573b-a4c2-4e8f-b953-1e47793fca07');


--
-- Data for Name: mp_pages; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_pages VALUES (1, -1, 1, 1, 'Home', '', 'All Users;', 'Content Publishers;', 'Content Publishers;', false, true, false, '', '', '', '', 'home.gif', true, '~/home.aspx', false, false, false, false, '', true, 'Daily', '0.5', '2008-12-26 04:57:04.999832', 'a62d573b-a4c2-4e8f-b953-1e47793fca07', '00000000-0000-0000-0000-000000000000', false, '9d74618a-141e-4541-a78b-ba7411a6dd45', '', '2008-12-26 04:57:04.995911');


--
-- Data for Name: mp_paypallog; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_redirectlist; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_roles; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_roles VALUES (1, 1, 'Admins', 'Administrators', '9d74618a-141e-4541-a78b-ba7411a6dd45', 'b2f9a45f-15fb-4710-a2eb-93692901f28b');
INSERT INTO mp_roles VALUES (2, 1, 'Role Admins', 'Role Administrators', '9d74618a-141e-4541-a78b-ba7411a6dd45', '2fe54e05-f058-4137-be15-4ced554339a9');
INSERT INTO mp_roles VALUES (3, 1, 'Content Administrators', 'Content Administrators', '9d74618a-141e-4541-a78b-ba7411a6dd45', '102a8689-9de3-4c93-af3d-24a4a7bce014');
INSERT INTO mp_roles VALUES (4, 1, 'Authenticated Users', 'Authenticated Users', '9d74618a-141e-4541-a78b-ba7411a6dd45', '3833a756-2ad8-4cec-8f44-98685c7fe6b3');
INSERT INTO mp_roles VALUES (5, 1, 'Content Publishers', 'Content Publishers', '9d74618a-141e-4541-a78b-ba7411a6dd45', '493290b1-cda7-4bf8-bca2-2f084be71a84');
INSERT INTO mp_roles VALUES (6, 1, 'Content Authors', 'Content Authors', '9d74618a-141e-4541-a78b-ba7411a6dd45', '3ead7c8f-c8a9-4132-a00a-c6e71644ddc7');
INSERT INTO mp_roles VALUES (7, 1, 'Newsletter Administrators', 'Newsletter Administrators', '9d74618a-141e-4541-a78b-ba7411a6dd45', '41d05930-51cc-4c76-97a3-832857334514');


--
-- Data for Name: mp_rssfeedentries; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_rssfeeds; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_schemascripthistory; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_schemascripthistory VALUES (1, '077e4857-f583-488e-836e-34a4b04be855', '2.2.4.9.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (2, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.0.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (3, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.1.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (4, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.2.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (5, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.3.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (6, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.4.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (7, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.5.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (8, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.6.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (9, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.7.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (10, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.8.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (11, '077e4857-f583-488e-836e-34a4b04be855', '2.2.5.9.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (12, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.0.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (13, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.1.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (14, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.2.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (15, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.3.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (16, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.4.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (17, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.5.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (18, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.6.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (19, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.7.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (20, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.8.config', '2008-12-26 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (21, '077e4857-f583-488e-836e-34a4b04be855', '2.2.6.9.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (22, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.0.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (23, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.1.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (24, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.2.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (25, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.3.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (26, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.4.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (27, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.5.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (28, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.6.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (29, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.7.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (30, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.8.config', '2009-03-05 00:00:00', false, '', '');
INSERT INTO mp_schemascripthistory VALUES (31, '077e4857-f583-488e-836e-34a4b04be855', '2.2.7.9.config', '2009-03-05 00:00:00', false, '', '');


--
-- Data for Name: mp_schemaversion; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_schemaversion VALUES ('01b6eb9c-f096-4fe8-b42a-c88a6d306c0a', 'blog', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('26418748-d0da-43b4-a8c2-3f05cd425d11', 'contactform', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('82db6aaa-d5b4-4c22-bc07-66296d72bf89', 'eventcalendar', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('306ae6ea-cd00-4a30-b095-cdeccc1d6237', 'feed-manager', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('5b2b9770-20aa-4ccb-a93f-4374a4f343c9', 'forums', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('7b3435c5-1038-4109-bb70-979e0f8af35a', 'imagegallery', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('e4d68882-684c-4d87-9518-36b05df108f7', 'linksmodule', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('3de49b39-555b-449c-a950-3dad8c6934c7', 'sharedfiles', 0, 0, 0, 1);
INSERT INTO mp_schemaversion VALUES ('077e4857-f583-488e-836e-34a4b04be855', 'mojoportal-core', 2, 2, 7, 9);


--
-- Data for Name: mp_sharedfilefolders; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sharedfiles; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sharedfileshistory; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sitefolders; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sitehosts; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sitemoduledefinitions; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_sitemoduledefinitions VALUES (1, 1, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '881e4e00-93e4-444c-b7b0-6672fb55de10');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 2, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '026cbead-2b80-4491-906d-b83e37179ccf');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 3, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '99019eb8-db13-4bb3-81ea-073571a60dba');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 4, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'c5e6a5df-ac2a-43d3-bb7f-9739bc47194e');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 5, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '38aa5a84-9f5c-42eb-8f4c-105983d419fb');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 6, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '5219a554-d176-481e-abc0-9ea2ee4c8efc');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 7, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '9e58fcda-90de-4ed7-abc7-12f096f5c58f');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 8, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'd572f6b4-d0ed-465d-ad60-60433893b401');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 9, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '74bdbcc2-0e79-47ff-bcd4-a159270bf36e');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 10, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '5ef82464-e2d3-4982-8dfd-01e1afa615f9');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 11, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'dc873d76-5bf2-4ac5-bff7-434a87a3fc8e');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 12, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', '1999e312-0378-4bca-8753-201d17957a74');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 13, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'f193cce1-6e28-4b73-88e7-e00cd1d642c9');
INSERT INTO mp_sitemoduledefinitions VALUES (1, 14, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45', 'fa969c0a-6d02-4dcb-86b8-ac69d80c1fb1');


--
-- Data for Name: mp_sitepaths; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sitepersonalizationallusers; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sitepersonalizationperuser; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_sites; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_sites VALUES (1, NULL, 'mojoPortal', 'styleshout-techmania', 'normal', 'mojomoonprint.jpg', '', 'PageNameWithDotASPX', false, false, false, true, false, true, false, true, false, false, 'mojoPortal, C#, ASP.NET, mono, linux', 'A site of interest to .NET developers wanting to deploy ASP.NET on Linux', '<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />', '', true, false, true, '', 389, '', '', 'CN', '9d74618a-141e-4541-a78b-ba7411a6dd45', true, true, true, true, 5, 5, 0, 4, 0, '', 'noreply@yourdomain.com', false, 'FCKeditorProvider', 'SimpleMathCaptchaProvider', 'mojoDatePicker', '', '', '', '', '', false, false, '', '', '', '', '', '');


--
-- Data for Name: mp_sitesettingsex; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPUser', '9d74618a-141e-4541-a78b-ba7411a6dd45', '', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPPassword', '9d74618a-141e-4541-a78b-ba7411a6dd45', '', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPServer', '9d74618a-141e-4541-a78b-ba7411a6dd45', 'localhost', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPPort', '9d74618a-141e-4541-a78b-ba7411a6dd45', '25', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPRequiresAuthentication', '9d74618a-141e-4541-a78b-ba7411a6dd45', 'false', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPUseSsl', '9d74618a-141e-4541-a78b-ba7411a6dd45', 'false', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SMTPPreferredEncoding', '9d74618a-141e-4541-a78b-ba7411a6dd45', '', 'SMTP');
INSERT INTO mp_sitesettingsex VALUES (1, 'SiteRootEditRoles', '9d74618a-141e-4541-a78b-ba7411a6dd45', 'Admins;Content Administrators', 'Admin');


--
-- Data for Name: mp_sitesettingsexdef; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_sitesettingsexdef VALUES ('SMTPUser', 'SMTP', '', 100);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPPassword', 'SMTP', '', 200);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPServer', 'SMTP', 'localhost', 300);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPPort', 'SMTP', '25', 400);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPRequiresAuthentication', 'SMTP', 'false', 500);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPUseSsl', 'SMTP', 'false', 600);
INSERT INTO mp_sitesettingsexdef VALUES ('SMTPPreferredEncoding', 'SMTP', '', 700);
INSERT INTO mp_sitesettingsexdef VALUES ('SiteRootEditRoles', 'Admin', 'Admins;Content Administrators', 100);


--
-- Data for Name: mp_taskqueue; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_taxclass; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_taxrate; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_taxratehistory; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_userlocation; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_userlocation VALUES ('b0aa10c8-11c4-46e5-949a-78aeea85d5d5', '26e6fde9-917c-4c3b-9554-a0b8b1ba68b4', '9d74618a-141e-4541-a78b-ba7411a6dd45', '137.65.135.29', 495403401, '137.65.135.29', 0, 0, '', '', '', '', '', '', 2, '2009-03-05 21:55:07.682522', '2009-03-05 22:23:47.791879');


--
-- Data for Name: mp_userpages; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_userproperties; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Data for Name: mp_userroles; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_userroles VALUES (1, 1, 4, '26e6fde9-917c-4c3b-9554-a0b8b1ba68b4', '3833a756-2ad8-4cec-8f44-98685c7fe6b3');
INSERT INTO mp_userroles VALUES (2, 1, 1, '26e6fde9-917c-4c3b-9554-a0b8b1ba68b4', 'b2f9a45f-15fb-4710-a2eb-93692901f28b');


--
-- Data for Name: mp_users; Type: TABLE DATA; Schema: public; Owner: test
--

INSERT INTO mp_users VALUES (1, 1, 'Admin', 'admin@admin.com', 'admin', 'admin', ' ', true, true, false, true, '', '', '', '', '', '', '', '', '', 0, '', 0, '', '2008-12-26 04:57:03.077542', '26e6fde9-917c-4c3b-9554-a0b8b1ba68b4', '', false, 'admin@admin.com', 'What is your user name?', 'admin', '2009-03-05 22:23:54.385679', '2009-03-05 22:23:47.674826', NULL, NULL, NULL, NULL, false, 0, 0, NULL, NULL, '', '00000000-0000-0000-0000-000000000000', NULL, NULL, '9d74618a-141e-4541-a78b-ba7411a6dd45');


--
-- Data for Name: mp_webparts; Type: TABLE DATA; Schema: public; Owner: test
--



--
-- Name: mp_bannedipaddresses_pkey; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_bannedipaddresses
    ADD CONSTRAINT mp_bannedipaddresses_pkey PRIMARY KEY (rowid);


--
-- Name: mp_sitemoduledefinitions_pkey; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitemoduledefinitions
    ADD CONSTRAINT mp_sitemoduledefinitions_pkey PRIMARY KEY (siteid, moduledefid);


--
-- Name: pk_authorizenetlog; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_authorizenetlog
    ADD CONSTRAINT pk_authorizenetlog PRIMARY KEY (rowguid);


--
-- Name: pk_blogcategories; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_blogcategories
    ADD CONSTRAINT pk_blogcategories PRIMARY KEY (categoryid);


--
-- Name: pk_blogcomments; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_blogcomments
    ADD CONSTRAINT pk_blogcomments PRIMARY KEY (blogcommentid);


--
-- Name: pk_blogitemcategories; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_blogitemcategories
    ADD CONSTRAINT pk_blogitemcategories PRIMARY KEY (id);


--
-- Name: pk_blogs; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_blogs
    ADD CONSTRAINT pk_blogs PRIMARY KEY (itemid);


--
-- Name: pk_calendarevents; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_calendarevents
    ADD CONSTRAINT pk_calendarevents PRIMARY KEY (itemid);


--
-- Name: pk_contactformmessage; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_contactformmessage
    ADD CONSTRAINT pk_contactformmessage PRIMARY KEY (rowguid);


--
-- Name: pk_contentrating; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_contentrating
    ADD CONSTRAINT pk_contentrating PRIMARY KEY (rowguid);


--
-- Name: pk_currency; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_currency
    ADD CONSTRAINT pk_currency PRIMARY KEY (guid);


--
-- Name: pk_forumposts; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_forumposts
    ADD CONSTRAINT pk_forumposts PRIMARY KEY (postid);


--
-- Name: pk_forums; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_forums
    ADD CONSTRAINT pk_forums PRIMARY KEY (itemid);


--
-- Name: pk_forumsubscriptions; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_forumsubscriptions
    ADD CONSTRAINT pk_forumsubscriptions PRIMARY KEY (subscriptionid);


--
-- Name: pk_forumthreads; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_forumthreads
    ADD CONSTRAINT pk_forumthreads PRIMARY KEY (threadid);


--
-- Name: pk_forumthreadsubscriptions; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_forumthreadsubscriptions
    ADD CONSTRAINT pk_forumthreadsubscriptions PRIMARY KEY (threadsubscriptionid);


--
-- Name: pk_friendlyurls; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_friendlyurls
    ADD CONSTRAINT pk_friendlyurls PRIMARY KEY (urlid);


--
-- Name: pk_galleryimages; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_galleryimages
    ADD CONSTRAINT pk_galleryimages PRIMARY KEY (itemid);


--
-- Name: pk_geocountry; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_geocountry
    ADD CONSTRAINT pk_geocountry PRIMARY KEY (guid);


--
-- Name: pk_googlecheckoutlog; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_googlecheckoutlog
    ADD CONSTRAINT pk_googlecheckoutlog PRIMARY KEY (rowguid);


--
-- Name: pk_htmlcontent; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_htmlcontent
    ADD CONSTRAINT pk_htmlcontent PRIMARY KEY (itemid);


--
-- Name: pk_indexingqueue; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_indexingqueue
    ADD CONSTRAINT pk_indexingqueue PRIMARY KEY (rowid);


--
-- Name: pk_language; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_language
    ADD CONSTRAINT pk_language PRIMARY KEY (guid);


--
-- Name: pk_letter; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_letter
    ADD CONSTRAINT pk_letter PRIMARY KEY (letterguid);


--
-- Name: pk_letterhtmltemplate; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_letterhtmltemplate
    ADD CONSTRAINT pk_letterhtmltemplate PRIMARY KEY (guid);


--
-- Name: pk_letterinfo; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_letterinfo
    ADD CONSTRAINT pk_letterinfo PRIMARY KEY (letterinfoguid);


--
-- Name: pk_lettersendlog; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_lettersendlog
    ADD CONSTRAINT pk_lettersendlog PRIMARY KEY (rowid);


--
-- Name: pk_lettersubscriber; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_lettersubscriber
    ADD CONSTRAINT pk_lettersubscriber PRIMARY KEY (letterinfoguid, userguid);


--
-- Name: pk_lettersubscriberhx; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_lettersubscriberhx
    ADD CONSTRAINT pk_lettersubscriberhx PRIMARY KEY (rowid);


--
-- Name: pk_links; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_links
    ADD CONSTRAINT pk_links PRIMARY KEY (itemid);


--
-- Name: pk_mgeozone; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_geozone
    ADD CONSTRAINT pk_mgeozone PRIMARY KEY (guid);


--
-- Name: pk_moduledefinitions; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_moduledefinitions
    ADD CONSTRAINT pk_moduledefinitions PRIMARY KEY (moduledefid);


--
-- Name: pk_moduledefinitionsettings; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_moduledefinitionsettings
    ADD CONSTRAINT pk_moduledefinitionsettings PRIMARY KEY (id);


--
-- Name: pk_modules; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_modules
    ADD CONSTRAINT pk_modules PRIMARY KEY (moduleid);


--
-- Name: pk_modulesettings; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_modulesettings
    ADD CONSTRAINT pk_modulesettings PRIMARY KEY (id);


--
-- Name: pk_mp_sitepaths; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitepaths
    ADD CONSTRAINT pk_mp_sitepaths PRIMARY KEY (pathid);


--
-- Name: pk_mp_sitepersonalizationallusers; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitepersonalizationallusers
    ADD CONSTRAINT pk_mp_sitepersonalizationallusers PRIMARY KEY (pathid);


--
-- Name: pk_pagemodules; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_pagemodules
    ADD CONSTRAINT pk_pagemodules PRIMARY KEY (pageid, moduleid);


--
-- Name: pk_pages; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_pages
    ADD CONSTRAINT pk_pages PRIMARY KEY (pageid);


--
-- Name: pk_paypallog; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_paypallog
    ADD CONSTRAINT pk_paypallog PRIMARY KEY (rowguid);


--
-- Name: pk_redirectlist; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_redirectlist
    ADD CONSTRAINT pk_redirectlist PRIMARY KEY (rowguid);


--
-- Name: pk_roles; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_roles
    ADD CONSTRAINT pk_roles PRIMARY KEY (roleid);


--
-- Name: pk_rssfeedentries; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_rssfeedentries
    ADD CONSTRAINT pk_rssfeedentries PRIMARY KEY (rowguid);


--
-- Name: pk_rssfeeds; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_rssfeeds
    ADD CONSTRAINT pk_rssfeeds PRIMARY KEY (itemid);


--
-- Name: pk_schemascripthistory; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_schemascripthistory
    ADD CONSTRAINT pk_schemascripthistory PRIMARY KEY (id);


--
-- Name: pk_schemaversion; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_schemaversion
    ADD CONSTRAINT pk_schemaversion PRIMARY KEY (applicationid);


--
-- Name: pk_sharedfilefolders; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sharedfilefolders
    ADD CONSTRAINT pk_sharedfilefolders PRIMARY KEY (folderid);


--
-- Name: pk_sharedfiles; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sharedfiles
    ADD CONSTRAINT pk_sharedfiles PRIMARY KEY (itemid);


--
-- Name: pk_sharedfileshistory; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sharedfileshistory
    ADD CONSTRAINT pk_sharedfileshistory PRIMARY KEY (id);


--
-- Name: pk_sitefolders; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitefolders
    ADD CONSTRAINT pk_sitefolders PRIMARY KEY (guid);


--
-- Name: pk_sitehosts; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitehosts
    ADD CONSTRAINT pk_sitehosts PRIMARY KEY (hostid);


--
-- Name: pk_sitepersonalizationperuser; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitepersonalizationperuser
    ADD CONSTRAINT pk_sitepersonalizationperuser PRIMARY KEY (id);


--
-- Name: pk_sites; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sites
    ADD CONSTRAINT pk_sites PRIMARY KEY (siteid);


--
-- Name: pk_sitesettingsex; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitesettingsex
    ADD CONSTRAINT pk_sitesettingsex PRIMARY KEY (siteid, keyname);


--
-- Name: pk_sitesettingsexdef; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_sitesettingsexdef
    ADD CONSTRAINT pk_sitesettingsexdef PRIMARY KEY (keyname);


--
-- Name: pk_taskqueue; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_taskqueue
    ADD CONSTRAINT pk_taskqueue PRIMARY KEY (guid);


--
-- Name: pk_taxclass; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_taxclass
    ADD CONSTRAINT pk_taxclass PRIMARY KEY (guid);


--
-- Name: pk_taxrate; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_taxrate
    ADD CONSTRAINT pk_taxrate PRIMARY KEY (guid);


--
-- Name: pk_taxratehistory; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_taxratehistory
    ADD CONSTRAINT pk_taxratehistory PRIMARY KEY (guid);


--
-- Name: pk_userlocation; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_userlocation
    ADD CONSTRAINT pk_userlocation PRIMARY KEY (rowid);


--
-- Name: pk_userproperties; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_userproperties
    ADD CONSTRAINT pk_userproperties PRIMARY KEY (propertyid);


--
-- Name: pk_userroles; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_userroles
    ADD CONSTRAINT pk_userroles PRIMARY KEY (id);


--
-- Name: pk_users; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_users
    ADD CONSTRAINT pk_users PRIMARY KEY (userid);


--
-- Name: pk_webparts; Type: CONSTRAINT; Schema: public; Owner: test; Tablespace: 
--

ALTER TABLE ONLY mp_webparts
    ADD CONSTRAINT pk_webparts PRIMARY KEY (webpartid);


--
-- Name: idxcontentratingg; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxcontentratingg ON mp_contentrating USING btree (contentguid);


--
-- Name: idxcontentratingi; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxcontentratingi ON mp_contentrating USING btree (ipaddress);


--
-- Name: idxcontentratings; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxcontentratings ON mp_contentrating USING btree (siteguid);


--
-- Name: idxcontentratingu; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxcontentratingu ON mp_contentrating USING btree (userguid);


--
-- Name: idxentryhash; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxentryhash ON mp_rssfeedentries USING btree (entryhash);


--
-- Name: idxfeedid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxfeedid ON mp_rssfeedentries USING btree (feedid);


--
-- Name: idxmoduleguid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxmoduleguid ON mp_rssfeedentries USING btree (moduleguid);


--
-- Name: idxredirectsguid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxredirectsguid ON mp_redirectlist USING btree (siteguid);


--
-- Name: idxredirectsid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxredirectsid ON mp_redirectlist USING btree (siteid);


--
-- Name: idxredirecturl; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX idxredirecturl ON mp_redirectlist USING btree (oldurl);


--
-- Name: ifk_blogcategories_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_blogcategories_moduleid ON mp_blogcategories USING btree (moduleid);


--
-- Name: ifk_blogitemcategories_categoryid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_blogitemcategories_categoryid ON mp_blogitemcategories USING btree (categoryid);


--
-- Name: ifk_blogitemcategories_itemid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_blogitemcategories_itemid ON mp_blogitemcategories USING btree (itemid);


--
-- Name: ifk_blogs_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_blogs_moduleid ON mp_blogs USING btree (moduleid);


--
-- Name: ifk_blogstats_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_blogstats_moduleid ON mp_blogstats USING btree (moduleid);


--
-- Name: ifk_calendarevents_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_calendarevents_moduleid ON mp_calendarevents USING btree (moduleid);


--
-- Name: ifk_calendarevents_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_calendarevents_userid ON mp_calendarevents USING btree (userid);


--
-- Name: ifk_forumposts_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_forumposts_userid ON mp_forumposts USING btree (userid);


--
-- Name: ifk_forums_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_forums_moduleid ON mp_forums USING btree (moduleid);


--
-- Name: ifk_forumsubscriptions_forumid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_forumsubscriptions_forumid ON mp_forumsubscriptions USING btree (forumid);


--
-- Name: ifk_forumsubscriptions_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_forumsubscriptions_userid ON mp_forumsubscriptions USING btree (userid);


--
-- Name: ifk_forumthreadsubscriptio_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_forumthreadsubscriptio_userid ON mp_forumthreadsubscriptions USING btree (userid);


--
-- Name: ifk_friendlyurls_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_friendlyurls_siteid ON mp_friendlyurls USING btree (siteid);


--
-- Name: ifk_galleryimages_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_galleryimages_moduleid ON mp_galleryimages USING btree (moduleid);


--
-- Name: ifk_htmlcontent_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_htmlcontent_moduleid ON mp_htmlcontent USING btree (moduleid);


--
-- Name: ifk_htmlcontent_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_htmlcontent_userid ON mp_htmlcontent USING btree (userid);


--
-- Name: ifk_links_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_links_moduleid ON mp_links USING btree (moduleid);


--
-- Name: ifk_mgeozone_countryguid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_mgeozone_countryguid ON mp_geozone USING btree (countryguid);


--
-- Name: ifk_modulesettings_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_modulesettings_moduleid ON mp_modulesettings USING btree (moduleid);


--
-- Name: ifk_pagemodules_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_pagemodules_moduleid ON mp_pagemodules USING btree (moduleid);


--
-- Name: ifk_pagemodules_pageid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_pagemodules_pageid ON mp_pagemodules USING btree (pageid);


--
-- Name: ifk_pages_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_pages_siteid ON mp_pages USING btree (siteid);


--
-- Name: ifk_roles_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_roles_siteid ON mp_roles USING btree (siteid);


--
-- Name: ifk_rssfeeds_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_rssfeeds_moduleid ON mp_rssfeeds USING btree (moduleid);


--
-- Name: ifk_rssfeeds_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_rssfeeds_userid ON mp_rssfeeds USING btree (userid);


--
-- Name: ifk_schemascripthistory_applicationid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_schemascripthistory_applicationid ON mp_schemascripthistory USING btree (applicationid);


--
-- Name: ifk_sharedfilefolders_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sharedfilefolders_moduleid ON mp_sharedfilefolders USING btree (moduleid);


--
-- Name: ifk_sharedfiles_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sharedfiles_moduleid ON mp_sharedfiles USING btree (moduleid);


--
-- Name: ifk_sharedfileshistory_itemid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sharedfileshistory_itemid ON mp_sharedfileshistory USING btree (itemid);


--
-- Name: ifk_sharedfileshistory_moduleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sharedfileshistory_moduleid ON mp_sharedfileshistory USING btree (moduleid);


--
-- Name: ifk_sitehosts_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sitehosts_siteid ON mp_sitehosts USING btree (siteid);


--
-- Name: ifk_sitemoduledefinitions_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sitemoduledefinitions_siteid ON mp_sitemoduledefinitions USING btree (siteid);


--
-- Name: ifk_sitepersonalizationper_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_sitepersonalizationper_userid ON mp_sitepersonalizationperuser USING btree (userid);


--
-- Name: ifk_taskqueue_siteguid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_taskqueue_siteguid ON mp_taskqueue USING btree (siteguid);


--
-- Name: ifk_userlocation_userguid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_userlocation_userguid ON mp_userlocation USING btree (userguid);


--
-- Name: ifk_userpages_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_userpages_siteid ON mp_userpages USING btree (siteid);


--
-- Name: ifk_userroles_roleid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_userroles_roleid ON mp_userroles USING btree (roleid);


--
-- Name: ifk_userroles_userid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_userroles_userid ON mp_userroles USING btree (userid);


--
-- Name: ifk_webparts_siteid; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX ifk_webparts_siteid ON mp_webparts USING btree (siteid);


--
-- Name: mp_authorizenetlog_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_authorizenetlog_pkey ON mp_authorizenetlog USING btree (rowguid);


--
-- Name: mp_contactformmessage_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_contactformmessage_pkey ON mp_contactformmessage USING btree (rowguid);


--
-- Name: mp_contentrating_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_contentrating_pkey ON mp_contentrating USING btree (rowguid);


--
-- Name: mp_currency_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_currency_pkey ON mp_currency USING btree (guid);


--
-- Name: mp_friendlyurls_idxfriendlyurl_idx; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX mp_friendlyurls_idxfriendlyurl_idx ON mp_friendlyurls USING btree (friendlyurl);


--
-- Name: mp_geocountry_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_geocountry_pkey ON mp_geocountry USING btree (guid);


--
-- Name: mp_geozone_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_geozone_pkey ON mp_geozone USING btree (guid);


--
-- Name: mp_googlecheckoutlog_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_googlecheckoutlog_pkey ON mp_googlecheckoutlog USING btree (rowguid);


--
-- Name: mp_indexingqueue_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_indexingqueue_pkey ON mp_indexingqueue USING btree (rowid);


--
-- Name: mp_language_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_language_pkey ON mp_language USING btree (guid);


--
-- Name: mp_modulesettings_ix_modul_0; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX mp_modulesettings_ix_modul_0 ON mp_modulesettings USING btree (moduleid, settingname);


--
-- Name: mp_paypallog_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_paypallog_pkey ON mp_paypallog USING btree (rowguid);


--
-- Name: mp_redirectlist_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_redirectlist_pkey ON mp_redirectlist USING btree (rowguid);


--
-- Name: mp_roles_idxsiteid_idx; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX mp_roles_idxsiteid_idx ON mp_roles USING btree (siteid);


--
-- Name: mp_rssfeedentries_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_rssfeedentries_pkey ON mp_rssfeedentries USING btree (rowguid);


--
-- Name: mp_sitehosts_idxhostname_idx; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_sitehosts_idxhostname_idx ON mp_sitehosts USING btree (hostname);


--
-- Name: mp_sitesettingsex_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_sitesettingsex_pkey ON mp_sitesettingsex USING btree (siteid, keyname);


--
-- Name: mp_sitesettingsexdef_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_sitesettingsexdef_pkey ON mp_sitesettingsexdef USING btree (keyname);


--
-- Name: mp_taxclass_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_taxclass_pkey ON mp_taxclass USING btree (guid);


--
-- Name: mp_taxrate_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_taxrate_pkey ON mp_taxrate USING btree (guid);


--
-- Name: mp_taxratehistory_pkey; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE UNIQUE INDEX mp_taxratehistory_pkey ON mp_taxratehistory USING btree (guid);


--
-- Name: mp_users_idxemail_idx; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX mp_users_idxemail_idx ON mp_users USING btree (email);


--
-- Name: mp_users_idxname_idx; Type: INDEX; Schema: public; Owner: test; Tablespace: 
--

CREATE INDEX mp_users_idxname_idx ON mp_users USING btree (name);


--
-- Name: fk_blogcomments_blogs; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_blogcomments
    ADD CONSTRAINT fk_blogcomments_blogs FOREIGN KEY (itemid) REFERENCES mp_blogs(itemid);


--
-- Name: fk_blogitemcategories_blogs; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_blogitemcategories
    ADD CONSTRAINT fk_blogitemcategories_blogs FOREIGN KEY (itemid) REFERENCES mp_blogs(itemid);


--
-- Name: fk_blogitemcategoriesblogcategories; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_blogitemcategories
    ADD CONSTRAINT fk_blogitemcategoriesblogcategories FOREIGN KEY (categoryid) REFERENCES mp_blogcategories(categoryid);


--
-- Name: fk_forumposts_forumthreads; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_forumposts
    ADD CONSTRAINT fk_forumposts_forumthreads FOREIGN KEY (threadid) REFERENCES mp_forumthreads(threadid);


--
-- Name: fk_forumthreads_forums; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_forumthreads
    ADD CONSTRAINT fk_forumthreads_forums FOREIGN KEY (forumid) REFERENCES mp_forums(itemid);


--
-- Name: fk_forumthreadsubscriptions_forumthreads; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_forumthreadsubscriptions
    ADD CONSTRAINT fk_forumthreadsubscriptions_forumthreads FOREIGN KEY (threadid) REFERENCES mp_forumthreads(threadid);


--
-- Name: fk_letter_letterinfo; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_letter
    ADD CONSTRAINT fk_letter_letterinfo FOREIGN KEY (letterinfoguid) REFERENCES mp_letterinfo(letterinfoguid);


--
-- Name: fk_mgeozone_geocountry; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_geozone
    ADD CONSTRAINT fk_mgeozone_geocountry FOREIGN KEY (countryguid) REFERENCES mp_geocountry(guid) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- Name: fk_modules_moduledefinitions_fk; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_modules
    ADD CONSTRAINT fk_modules_moduledefinitions_fk FOREIGN KEY (moduledefid) REFERENCES mp_moduledefinitions(moduledefid);


--
-- Name: fk_modulesettings_modules; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_modulesettings
    ADD CONSTRAINT fk_modulesettings_modules FOREIGN KEY (moduleid) REFERENCES mp_modules(moduleid);


--
-- Name: fk_pagemodules_modules; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_pagemodules
    ADD CONSTRAINT fk_pagemodules_modules FOREIGN KEY (moduleid) REFERENCES mp_modules(moduleid);


--
-- Name: fk_pagemodules_pages; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_pagemodules
    ADD CONSTRAINT fk_pagemodules_pages FOREIGN KEY (pageid) REFERENCES mp_pages(pageid);


--
-- Name: fk_pages_sites; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_pages
    ADD CONSTRAINT fk_pages_sites FOREIGN KEY (siteid) REFERENCES mp_sites(siteid);


--
-- Name: fk_roles_portals_fk; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_roles
    ADD CONSTRAINT fk_roles_portals_fk FOREIGN KEY (siteid) REFERENCES mp_sites(siteid);


--
-- Name: fk_roles_sites; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_roles
    ADD CONSTRAINT fk_roles_sites FOREIGN KEY (siteid) REFERENCES mp_sites(siteid);


--
-- Name: fk_sitemoduledefinitions_sites; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_sitemoduledefinitions
    ADD CONSTRAINT fk_sitemoduledefinitions_sites FOREIGN KEY (siteid) REFERENCES mp_sites(siteid);


--
-- Name: fk_sitepaths_sites; Type: FK CONSTRAINT; Schema: public; Owner: test
--

ALTER TABLE ONLY mp_sitepaths
    ADD CONSTRAINT fk_sitepaths_sites FOREIGN KEY (siteid) REFERENCES mp_sites(siteid);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: mp_bannedipaddresses_count(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_count() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_count() FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_count() TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_count() TO PUBLIC;


--
-- Name: mp_bannedipaddresses_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_delete(integer) TO PUBLIC;


--
-- Name: mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_insert(character varying, timestamp without time zone, character varying) TO PUBLIC;


--
-- Name: mp_bannedipaddresses_select_all(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_select_all() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_select_all() FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_select_all() TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_select_all() TO PUBLIC;


--
-- Name: mp_bannedipaddresses_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_select_one(integer) TO PUBLIC;


--
-- Name: mp_bannedipaddresses_selectpage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_selectpage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_selectpage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_selectpage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_selectpage(integer, integer) TO PUBLIC;


--
-- Name: mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) FROM test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) TO test;
GRANT ALL ON FUNCTION mp_bannedipaddresses_update(integer, character varying, timestamp without time zone, character varying) TO PUBLIC;


--
-- Name: mp_blog_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_blog_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_blog_delete(integer) TO PUBLIC;


--
-- Name: mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) FROM test;
GRANT ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) TO test;
GRANT ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone, character, character) TO PUBLIC;


--
-- Name: mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) FROM test;
GRANT ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) TO test;
GRANT ALL ON FUNCTION mp_blog_insert(integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, integer, text, character, timestamp without time zone, character, character, character varying) TO PUBLIC;


--
-- Name: mp_blog_select(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_select(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_select(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blog_select(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blog_select(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blog_selectarchivebymonth(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectarchivebymonth(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectarchivebymonth(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectarchivebymonth(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blog_selectarchivebymonth(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blog_selectbycategory(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectbycategory(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectbycategory(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectbycategory(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_blog_selectbycategory(integer, integer) TO PUBLIC;


--
-- Name: mp_blog_selectbyenddate(integer, date); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectbyenddate(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectbyenddate(integer, date) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectbyenddate(integer, date) TO test;
GRANT ALL ON FUNCTION mp_blog_selectbyenddate(integer, date) TO PUBLIC;


--
-- Name: mp_blog_selectbymonth(integer, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectbymonth(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectbymonth(integer, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectbymonth(integer, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_blog_selectbymonth(integer, integer, integer) TO PUBLIC;


--
-- Name: mp_blog_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_blog_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_blog_selectdrafts(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectdrafts(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectdrafts(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectdrafts(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blog_selectdrafts(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blog_selectone2(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_selectone2(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_selectone2(integer) FROM test;
GRANT ALL ON FUNCTION mp_blog_selectone2(integer) TO test;
GRANT ALL ON FUNCTION mp_blog_selectone2(integer) TO PUBLIC;


--
-- Name: mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blog_update(integer, integer, character varying, character varying, character varying, text, timestamp without time zone, boolean, boolean, character varying, integer, text, character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blogcategories_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_delete(integer) TO PUBLIC;


--
-- Name: mp_blogcategories_insert(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_insert(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_insert(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_insert(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_insert(integer, character varying) TO PUBLIC;


--
-- Name: mp_blogcategories_select_bymodule(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_select_bymodule(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_select_bymodule(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_select_bymodule(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_select_bymodule(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blogcategories_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_select_one(integer) TO PUBLIC;


--
-- Name: mp_blogcategories_selectlist_bymodule(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_selectlist_bymodule(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_selectlist_bymodule(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_selectlist_bymodule(integer) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_selectlist_bymodule(integer) TO PUBLIC;


--
-- Name: mp_blogcategories_update(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcategories_update(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcategories_update(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_blogcategories_update(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_blogcategories_update(integer, character varying) TO PUBLIC;


--
-- Name: mp_blogcomment_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcomment_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcomment_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogcomment_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_blogcomment_delete(integer) TO PUBLIC;


--
-- Name: mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_blogcomment_insert(integer, integer, character varying, character varying, character varying, text, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_blogcomments_select(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogcomments_select(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogcomments_select(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_blogcomments_select(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_blogcomments_select(integer, integer) TO PUBLIC;


--
-- Name: mp_blogitemcategories_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogitemcategories_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogitemcategories_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogitemcategories_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_blogitemcategories_delete(integer) TO PUBLIC;


--
-- Name: mp_blogitemcategories_insert(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogitemcategories_insert(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogitemcategories_insert(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_blogitemcategories_insert(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_blogitemcategories_insert(integer, integer) TO PUBLIC;


--
-- Name: mp_blogitemcategories_select_byitem(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogitemcategories_select_byitem(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogitemcategories_select_byitem(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogitemcategories_select_byitem(integer) TO test;
GRANT ALL ON FUNCTION mp_blogitemcategories_select_byitem(integer) TO PUBLIC;


--
-- Name: mp_blogstats_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_blogstats_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_blogstats_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_blogstats_select(integer) TO test;
GRANT ALL ON FUNCTION mp_blogstats_select(integer) TO PUBLIC;


--
-- Name: mp_calendarevents_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_delete(integer) TO PUBLIC;


--
-- Name: mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_insert(integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character, text, timestamp without time zone, numeric, boolean) TO PUBLIC;


--
-- Name: mp_calendarevents_select_bydate(integer, date, date); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_select_bydate(integer, date, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_select_bydate(integer, date, date) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_select_bydate(integer, date, date) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_select_bydate(integer, date, date) TO PUBLIC;


--
-- Name: mp_calendarevents_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_select_one(integer) TO PUBLIC;


--
-- Name: mp_calendarevents_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) FROM test;
GRANT ALL ON FUNCTION mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) TO test;
GRANT ALL ON FUNCTION mp_calendarevents_update(integer, integer, character varying, text, character varying, timestamp without time zone, timestamp without time zone, timestamp without time zone, character, text, timestamp without time zone, numeric, boolean) TO PUBLIC;


--
-- Name: mp_contactformmessage_count(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_contactformmessage_count(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_contactformmessage_count(character) FROM test;
GRANT ALL ON FUNCTION mp_contactformmessage_count(character) TO test;
GRANT ALL ON FUNCTION mp_contactformmessage_count(character) TO PUBLIC;


--
-- Name: mp_contactformmessage_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_contactformmessage_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_contactformmessage_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_contactformmessage_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_contactformmessage_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_forum_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forum_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forum_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_forum_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_forum_delete(integer) TO PUBLIC;


--
-- Name: mp_forumposts_countbythread(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_countbythread(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_countbythread(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_countbythread(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_countbythread(integer) TO PUBLIC;


--
-- Name: mp_forumposts_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_delete(integer) TO PUBLIC;


--
-- Name: mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_forumposts_insert(integer, character varying, text, boolean, integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_forumposts_selectallbythread(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectallbythread(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectallbythread(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectallbythread(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectallbythread(integer) TO PUBLIC;


--
-- Name: mp_forumposts_selectallbythreadreversesorted(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectallbythreadreversesorted(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectallbythreadreversesorted(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectallbythreadreversesorted(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectallbythreadreversesorted(integer) TO PUBLIC;


--
-- Name: mp_forumposts_selectbythread(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectbythread(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectbythread(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectbythread(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectbythread(integer, integer) TO PUBLIC;


--
-- Name: mp_forumposts_selectbythread_v2(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectbythread_v2(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectbythread_v2(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectbythread_v2(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectbythread_v2(integer, integer) TO PUBLIC;


--
-- Name: mp_forumposts_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectone(integer) TO PUBLIC;


--
-- Name: mp_forumposts_selectsortedthread(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_selectsortedthread(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_selectsortedthread(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_selectsortedthread(integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_selectsortedthread(integer) TO PUBLIC;


--
-- Name: mp_forumposts_update(integer, character varying, text, integer, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_update(integer, character varying, text, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_update(integer, character varying, text, integer, boolean) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_update(integer, character varying, text, integer, boolean) TO test;
GRANT ALL ON FUNCTION mp_forumposts_update(integer, character varying, text, integer, boolean) TO PUBLIC;


--
-- Name: mp_forumposts_updatethreadsequence(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumposts_updatethreadsequence(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumposts_updatethreadsequence(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumposts_updatethreadsequence(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumposts_updatethreadsequence(integer, integer) TO PUBLIC;


--
-- Name: mp_forums_decrementpostcount(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_decrementpostcount(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_decrementpostcount(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_decrementpostcount(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_decrementpostcount(integer) TO PUBLIC;


--
-- Name: mp_forums_decrementthreadcount(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_decrementthreadcount(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_decrementthreadcount(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_decrementthreadcount(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_decrementthreadcount(integer) TO PUBLIC;


--
-- Name: mp_forums_incrementpostcount(integer, integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_incrementpostcount(integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_incrementpostcount(integer, integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_forums_incrementpostcount(integer, integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_forums_incrementpostcount(integer, integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_forums_incrementpostcountonly(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_incrementpostcountonly(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_incrementpostcountonly(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_incrementpostcountonly(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_incrementpostcountonly(integer) TO PUBLIC;


--
-- Name: mp_forums_incrementthreadcount(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_incrementthreadcount(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_incrementthreadcount(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_incrementthreadcount(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_incrementthreadcount(integer) TO PUBLIC;


--
-- Name: mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) FROM test;
GRANT ALL ON FUNCTION mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) TO test;
GRANT ALL ON FUNCTION mp_forums_insert(integer, integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) TO PUBLIC;


--
-- Name: mp_forums_recalculatepoststats(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_recalculatepoststats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_recalculatepoststats(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_recalculatepoststats(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_recalculatepoststats(integer) TO PUBLIC;


--
-- Name: mp_forums_select(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_select(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_select(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_select(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forums_select(integer, integer) TO PUBLIC;


--
-- Name: mp_forums_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_selectone(integer) TO PUBLIC;


--
-- Name: mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) FROM test;
GRANT ALL ON FUNCTION mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) TO test;
GRANT ALL ON FUNCTION mp_forums_update(integer, character varying, text, boolean, boolean, integer, integer, integer, boolean) TO PUBLIC;


--
-- Name: mp_forums_updatepoststats(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_updatepoststats(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_updatepoststats(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_updatepoststats(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forums_updatepoststats(integer, integer) TO PUBLIC;


--
-- Name: mp_forums_updatethreadstats(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forums_updatethreadstats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forums_updatethreadstats(integer) FROM test;
GRANT ALL ON FUNCTION mp_forums_updatethreadstats(integer) TO test;
GRANT ALL ON FUNCTION mp_forums_updatethreadstats(integer) TO PUBLIC;


--
-- Name: mp_forumsubscriptions_exists(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumsubscriptions_exists(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumsubscriptions_exists(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_exists(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_exists(integer, integer) TO PUBLIC;


--
-- Name: mp_forumsubscriptions_insert(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumsubscriptions_insert(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumsubscriptions_insert(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_insert(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_insert(integer, integer) TO PUBLIC;


--
-- Name: mp_forumsubscriptions_unsubscribe(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumsubscriptions_unsubscribe(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumsubscriptions_unsubscribe(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_unsubscribe(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumsubscriptions_unsubscribe(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_decrementreplycount(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_decrementreplycount(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_decrementreplycount(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_decrementreplycount(integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_decrementreplycount(integer) TO PUBLIC;


--
-- Name: mp_forumthreads_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_delete(integer) TO PUBLIC;


--
-- Name: mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_incrementreplycount(integer, integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_insert(integer, character varying, integer, boolean, integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_forumthreads_selectbyforum(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforum(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforum(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforum(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforum(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_selectbyforumdesc(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforumdesc(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforumdesc(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforumdesc(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforumdesc(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_selectbyforumdesc_v2(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforumdesc_v2(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_selectbyforumdesc_v2(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforumdesc_v2(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbyforumdesc_v2(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_selectone(integer) TO PUBLIC;


--
-- Name: mp_forumthreads_update(integer, integer, character varying, integer, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_update(integer, integer, character varying, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_update(integer, integer, character varying, integer, boolean) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_update(integer, integer, character varying, integer, boolean) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_update(integer, integer, character varying, integer, boolean) TO PUBLIC;


--
-- Name: mp_forumthreads_updateforumsequence(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_updateforumsequence(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_updateforumsequence(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_updateforumsequence(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_updateforumsequence(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreads_updateviewstats(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreads_updateviewstats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreads_updateviewstats(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreads_updateviewstats(integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreads_updateviewstats(integer) TO PUBLIC;


--
-- Name: mp_forumthreadsubscribers_selectbythread(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreadsubscribers_selectbythread(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreadsubscribers_selectbythread(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreadsubscribers_selectbythread(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreadsubscribers_selectbythread(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreadsubscriptions_exists(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_exists(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_exists(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_exists(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_exists(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreadsubscriptions_insert(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_insert(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_insert(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_insert(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_insert(integer, integer) TO PUBLIC;


--
-- Name: mp_forumthreadsubscriptions_unsubscribeallthreads(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribeallthreads(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribeallthreads(integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribeallthreads(integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribeallthreads(integer) TO PUBLIC;


--
-- Name: mp_forumthreadsubscriptions_unsubscribethread(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribethread(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribethread(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribethread(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_forumthreadsubscriptions_unsubscribethread(integer, integer) TO PUBLIC;


--
-- Name: mp_friendlyurls_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_delete(integer) TO PUBLIC;


--
-- Name: mp_friendlyurls_deletebypageid(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_deletebypageid(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_deletebypageid(character varying) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_deletebypageid(character varying) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_deletebypageid(character varying) TO PUBLIC;


--
-- Name: mp_friendlyurls_exists(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_exists(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_exists(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_exists(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_exists(integer, character varying) TO PUBLIC;


--
-- Name: mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_insert(integer, character varying, character varying, boolean, character, character, character) TO PUBLIC;


--
-- Name: mp_friendlyurls_selectbyhost(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_selectbyhost(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_selectbyhost(character varying) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbyhost(character varying) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbyhost(character varying) TO PUBLIC;


--
-- Name: mp_friendlyurls_selectbysiteid(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_selectbysiteid(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_selectbysiteid(integer) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbysiteid(integer) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbysiteid(integer) TO PUBLIC;


--
-- Name: mp_friendlyurls_selectbysiteurl(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_selectbysiteurl(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_selectbysiteurl(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbysiteurl(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbysiteurl(integer, character varying) TO PUBLIC;


--
-- Name: mp_friendlyurls_selectbyurl(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_selectbyurl(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_selectbyurl(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbyurl(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectbyurl(character varying, character varying) TO PUBLIC;


--
-- Name: mp_friendlyurls_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_selectone(integer) TO PUBLIC;


--
-- Name: mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) FROM test;
GRANT ALL ON FUNCTION mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) TO test;
GRANT ALL ON FUNCTION mp_friendlyurls_update(integer, integer, character varying, character varying, boolean, character) TO PUBLIC;


--
-- Name: mp_galleryimages_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_delete(integer) TO PUBLIC;


--
-- Name: mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO PUBLIC;


--
-- Name: mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_galleryimages_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_select(integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_select(integer) TO PUBLIC;


--
-- Name: mp_galleryimages_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_galleryimages_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_selectone(integer) TO PUBLIC;


--
-- Name: mp_galleryimages_selectthumbsbypage(integer, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_selectthumbsbypage(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_selectthumbsbypage(integer, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_selectthumbsbypage(integer, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_selectthumbsbypage(integer, integer, integer) TO PUBLIC;


--
-- Name: mp_galleryimages_selectwebimagebypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_selectwebimagebypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_selectwebimagebypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_selectwebimagebypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_selectwebimagebypage(integer, integer) TO PUBLIC;


--
-- Name: mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM test;
GRANT ALL ON FUNCTION mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO test;
GRANT ALL ON FUNCTION mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO PUBLIC;


--
-- Name: mp_htmlcontent_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_delete(integer) TO PUBLIC;


--
-- Name: mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_insert(integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, timestamp without time zone, integer, character, character, character) TO PUBLIC;


--
-- Name: mp_htmlcontent_select(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_select(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_select(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_select(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_select(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_htmlcontent_selectall(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_selectall() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_selectall() FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectall() TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectall() TO PUBLIC;


--
-- Name: mp_htmlcontent_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_htmlcontent_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_selectone(integer) TO PUBLIC;


--
-- Name: mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_htmlcontent_update(integer, integer, character varying, text, text, character varying, integer, timestamp without time zone, timestamp without time zone, character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_letter_count(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_count(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_count(character) FROM test;
GRANT ALL ON FUNCTION mp_letter_count(character) TO test;
GRANT ALL ON FUNCTION mp_letter_count(character) TO PUBLIC;


--
-- Name: mp_letter_countdrafts(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_countdrafts(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_countdrafts(character) FROM test;
GRANT ALL ON FUNCTION mp_letter_countdrafts(character) TO test;
GRANT ALL ON FUNCTION mp_letter_countdrafts(character) TO PUBLIC;


--
-- Name: mp_letter_delete(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_delete(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_delete(character) FROM test;
GRANT ALL ON FUNCTION mp_letter_delete(character) TO test;
GRANT ALL ON FUNCTION mp_letter_delete(character) TO PUBLIC;


--
-- Name: mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) FROM test;
GRANT ALL ON FUNCTION mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) TO test;
GRANT ALL ON FUNCTION mp_letter_insert(character, character, character varying, text, text, character, timestamp without time zone, character, timestamp without time zone, boolean, character) TO PUBLIC;


--
-- Name: mp_letter_select_all(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_select_all(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_select_all(character) FROM test;
GRANT ALL ON FUNCTION mp_letter_select_all(character) TO test;
GRANT ALL ON FUNCTION mp_letter_select_all(character) TO PUBLIC;


--
-- Name: mp_letter_select_one(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_select_one(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_select_one(character) FROM test;
GRANT ALL ON FUNCTION mp_letter_select_one(character) TO test;
GRANT ALL ON FUNCTION mp_letter_select_one(character) TO PUBLIC;


--
-- Name: mp_letter_selectdraftspage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_selectdraftspage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_selectdraftspage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_letter_selectdraftspage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_letter_selectdraftspage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_letter_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_letter_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_letter_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) FROM test;
GRANT ALL ON FUNCTION mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) TO test;
GRANT ALL ON FUNCTION mp_letter_update(character, character, character varying, text, text, character, timestamp without time zone, boolean, character) TO PUBLIC;


--
-- Name: mp_letter_updatesendclicked(character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_updatesendclicked(character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_updatesendclicked(character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_letter_updatesendclicked(character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_letter_updatesendclicked(character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_letter_updatesendsomplete(character, timestamp without time zone, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_updatesendsomplete(character, timestamp without time zone, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_updatesendsomplete(character, timestamp without time zone, integer) FROM test;
GRANT ALL ON FUNCTION mp_letter_updatesendsomplete(character, timestamp without time zone, integer) TO test;
GRANT ALL ON FUNCTION mp_letter_updatesendsomplete(character, timestamp without time zone, integer) TO PUBLIC;


--
-- Name: mp_letter_updatesendstarted(character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letter_updatesendstarted(character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letter_updatesendstarted(character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_letter_updatesendstarted(character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_letter_updatesendstarted(character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_count(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_count(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_count(character) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_count(character) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_count(character) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_delete(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_delete(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_delete(character) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_delete(character) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_delete(character) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_insert(character, character, character varying, text, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_select_all(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_select_all(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_select_all(character) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_select_all(character) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_select_all(character) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_select_one(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_select_one(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_select_one(character) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_select_one(character) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_select_one(character) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_letterhtmltemplate_update(character, character varying, text, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_letterinfo_count(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_count(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_count(character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_count(character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_count(character) TO PUBLIC;


--
-- Name: mp_letterinfo_delete(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_delete(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_delete(character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_delete(character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_delete(character) TO PUBLIC;


--
-- Name: mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_insert(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) TO PUBLIC;


--
-- Name: mp_letterinfo_select_all(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_select_all(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_select_all(character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_select_all(character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_select_all(character) TO PUBLIC;


--
-- Name: mp_letterinfo_select_one(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_select_one(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_select_one(character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_select_one(character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_select_one(character) TO PUBLIC;


--
-- Name: mp_letterinfo_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_update(character, character, character varying, text, text, boolean, boolean, boolean, character varying, character varying, character varying, integer, boolean, boolean, text, text, text, timestamp without time zone, character, timestamp without time zone, character) TO PUBLIC;


--
-- Name: mp_letterinfo_updatesubscribercount(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_letterinfo_updatesubscribercount(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_letterinfo_updatesubscribercount(character) FROM test;
GRANT ALL ON FUNCTION mp_letterinfo_updatesubscribercount(character) TO test;
GRANT ALL ON FUNCTION mp_letterinfo_updatesubscribercount(character) TO PUBLIC;


--
-- Name: mp_lettersendlog_count(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_count(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_count(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_count(character) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_count(character) TO PUBLIC;


--
-- Name: mp_lettersendlog_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_delete(integer) TO PUBLIC;


--
-- Name: mp_lettersendlog_deletebyletter(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_deletebyletter(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_deletebyletter(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_deletebyletter(character) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_deletebyletter(character) TO PUBLIC;


--
-- Name: mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_insert(character, character, character varying, timestamp without time zone, boolean, text) TO PUBLIC;


--
-- Name: mp_lettersendlog_select_byletter(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_select_byletter(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_select_byletter(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_select_byletter(character) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_select_byletter(character) TO PUBLIC;


--
-- Name: mp_lettersendlog_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_select_one(integer) TO PUBLIC;


--
-- Name: mp_lettersendlog_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) FROM test;
GRANT ALL ON FUNCTION mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) TO test;
GRANT ALL ON FUNCTION mp_lettersendlog_update(integer, character, character, character varying, timestamp without time zone, boolean, text) TO PUBLIC;


--
-- Name: mp_lettersubscriber_countbyletter(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_countbyletter(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_countbyletter(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_countbyletter(character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_countbyletter(character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_delete(character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_delete(character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_delete(character, character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_delete(character, character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_delete(character, character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_insert(character, character, boolean, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_lettersubscriber_select_one(character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_select_one(character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_select_one(character, character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_select_one(character, character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_select_one(character, character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_select_unsentbyletter(character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_select_unsentbyletter(character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_select_unsentbyletter(character, character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_select_unsentbyletter(character, character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_select_unsentbyletter(character, character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_selectbyletter(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_selectbyletter(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_selectbyletter(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectbyletter(character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectbyletter(character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_selectbyuser(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_selectbyuser(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_selectbyuser(character) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectbyuser(character) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectbyuser(character) TO PUBLIC;


--
-- Name: mp_lettersubscriber_selectpage(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriber_selectpage(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriber_selectpage(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectpage(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriber_selectpage(character, integer, integer) TO PUBLIC;


--
-- Name: mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_lettersubscriberhx_insert(character, character, boolean, timestamp without time zone, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_links_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_links_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_links_delete(integer) TO PUBLIC;


--
-- Name: mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_links_insert(integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying, character, character, character) TO PUBLIC;


--
-- Name: mp_links_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_links_select(integer) TO test;
GRANT ALL ON FUNCTION mp_links_select(integer) TO PUBLIC;


--
-- Name: mp_links_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_links_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_links_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_links_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_links_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_links_selectone(integer) TO PUBLIC;


--
-- Name: mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_links_update(integer, integer, character varying, character varying, integer, text, timestamp without time zone, integer, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitions_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_delete(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitions_deletesettingbyid(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_deletesettingbyid(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_deletesettingbyid(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_deletesettingbyid(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_deletesettingbyid(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_insert(integer, character varying, character varying, integer, boolean, character varying, integer, character, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitions_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_select(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_select(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitions_selectbysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_selectbysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_selectbysite(character) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectbysite(character) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectbysite(character) TO PUBLIC;


--
-- Name: mp_moduledefinitions_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectone(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitions_selectonebyguid(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_selectonebyguid(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_selectonebyguid(character) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectonebyguid(character) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectonebyguid(character) TO PUBLIC;


--
-- Name: mp_moduledefinitions_selectusermodules(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_selectusermodules(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_selectusermodules(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectusermodules(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_selectusermodules(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitions_update(integer, character varying, character varying, integer, boolean, character varying, integer, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_select(integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_select(integer) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_selectone(character, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_selectone(character, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_selectone(character, character varying) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_selectone(character, character varying) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_selectone(character, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_update(integer, character varying, character varying, character varying, text, character, character varying, character varying, character varying, integer) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying) TO PUBLIC;


--
-- Name: mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_moduledefinitionsettings_updatebyid(integer, integer, character varying, character varying, character varying, text, character varying, character varying, character varying, integer) TO PUBLIC;


--
-- Name: mp_modules_countnonadmin(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_countnonadmin(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_countnonadmin(integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_countnonadmin(integer) TO test;
GRANT ALL ON FUNCTION mp_modules_countnonadmin(integer) TO PUBLIC;


--
-- Name: mp_modules_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_modules_delete(integer) TO PUBLIC;


--
-- Name: mp_modules_deleteinstance(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_deleteinstance(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_deleteinstance(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_deleteinstance(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_modules_deleteinstance(integer, integer) TO PUBLIC;


--
-- Name: mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character) TO PUBLIC;


--
-- Name: mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) FROM test;
GRANT ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) TO test;
GRANT ALL ON FUNCTION mp_modules_insert(integer, integer, character varying, text, integer, boolean, boolean, integer, timestamp without time zone, boolean, character varying, character, character, character, boolean, boolean) TO PUBLIC;


--
-- Name: mp_modules_selectbypageid(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_selectbypageid(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_selectbypageid(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_modules_selectbypageid(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_modules_selectbypageid(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_modules_selectformypage(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_selectformypage(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_selectformypage(integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_selectformypage(integer) TO test;
GRANT ALL ON FUNCTION mp_modules_selectformypage(integer) TO PUBLIC;


--
-- Name: mp_modules_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_modules_selectone(integer) TO PUBLIC;


--
-- Name: mp_modules_selectonebypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_selectonebypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_selectonebypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_selectonebypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_modules_selectonebypage(integer, integer) TO PUBLIC;


--
-- Name: mp_modules_selectpage(integer, integer, integer, boolean, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_selectpage(integer, integer, integer, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_selectpage(integer, integer, integer, boolean, boolean) FROM test;
GRANT ALL ON FUNCTION mp_modules_selectpage(integer, integer, integer, boolean, boolean) TO test;
GRANT ALL ON FUNCTION mp_modules_selectpage(integer, integer, integer, boolean, boolean) TO PUBLIC;


--
-- Name: mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) FROM test;
GRANT ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) TO test;
GRANT ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying) TO PUBLIC;


--
-- Name: mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) FROM test;
GRANT ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) TO test;
GRANT ALL ON FUNCTION mp_modules_update(integer, integer, character varying, text, integer, boolean, integer, boolean, boolean, character varying, boolean, boolean) TO PUBLIC;


--
-- Name: mp_modules_updatecountofuseonmypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_updatecountofuseonmypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_updatecountofuseonmypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_updatecountofuseonmypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_modules_updatecountofuseonmypage(integer, integer) TO PUBLIC;


--
-- Name: mp_modules_updatemoduleorder(integer, integer, integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_updatemoduleorder(integer, integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_updatemoduleorder(integer, integer, integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_modules_updatemoduleorder(integer, integer, integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_modules_updatemoduleorder(integer, integer, integer, character varying) TO PUBLIC;


--
-- Name: mp_modules_updatepage(integer, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modules_updatepage(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modules_updatepage(integer, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_modules_updatepage(integer, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_modules_updatepage(integer, integer, integer) TO PUBLIC;


--
-- Name: mp_modulesettings_createdefaultsettings(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_createdefaultsettings(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_createdefaultsettings(integer) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_createdefaultsettings(integer) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_createdefaultsettings(integer) TO PUBLIC;


--
-- Name: mp_modulesettings_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_delete(integer) TO PUBLIC;


--
-- Name: mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character) TO PUBLIC;


--
-- Name: mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_insert(integer, character varying, character varying, character varying, text, character, character, character varying, character varying, integer) TO PUBLIC;


--
-- Name: mp_modulesettings_selectsettings(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_selectsettings(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_selectsettings(integer) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_selectsettings(integer) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_selectsettings(integer) TO PUBLIC;


--
-- Name: mp_modulesettings_update(integer, character varying, character varying, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_modulesettings_update(integer, character varying, character varying, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_modulesettings_update(integer, character varying, character varying, character, character) FROM test;
GRANT ALL ON FUNCTION mp_modulesettings_update(integer, character varying, character varying, character, character) TO test;
GRANT ALL ON FUNCTION mp_modulesettings_update(integer, character varying, character varying, character, character) TO PUBLIC;


--
-- Name: mp_mp_galleryimages_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_mp_galleryimages_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_mp_galleryimages_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_delete(integer) TO PUBLIC;


--
-- Name: mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_insert(integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying, character, character, character) TO PUBLIC;


--
-- Name: mp_mp_galleryimages_selectall(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_mp_galleryimages_selectall() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_mp_galleryimages_selectall() FROM test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_selectall() TO test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_selectall() TO PUBLIC;


--
-- Name: mp_mp_galleryimages_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_mp_galleryimages_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_mp_galleryimages_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_selectone(integer) TO PUBLIC;


--
-- Name: mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) FROM test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO test;
GRANT ALL ON FUNCTION mp_mp_galleryimages_update(integer, integer, integer, character varying, text, text, character varying, character varying, character varying, timestamp without time zone, character varying) TO PUBLIC;


--
-- Name: mp_pagemodule_exists(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pagemodule_exists(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pagemodule_exists(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pagemodule_exists(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pagemodule_exists(integer, integer) TO PUBLIC;


--
-- Name: mp_pagemodule_selectbymodule(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pagemodule_selectbymodule(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pagemodule_selectbymodule(integer) FROM test;
GRANT ALL ON FUNCTION mp_pagemodule_selectbymodule(integer) TO test;
GRANT ALL ON FUNCTION mp_pagemodule_selectbymodule(integer) TO PUBLIC;


--
-- Name: mp_pagemodule_selectbypage(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pagemodule_selectbypage(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pagemodule_selectbypage(integer) FROM test;
GRANT ALL ON FUNCTION mp_pagemodule_selectbypage(integer) TO test;
GRANT ALL ON FUNCTION mp_pagemodule_selectbypage(integer) TO PUBLIC;


--
-- Name: mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_pagemodules_insert(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_pagemodules_update(integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_pages_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_delete(integer) TO PUBLIC;


--
-- Name: mp_pages_getauthroles(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_getauthroles(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_getauthroles(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_getauthroles(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pages_getauthroles(integer, integer) TO PUBLIC;


--
-- Name: mp_pages_getbreadcrumbs(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_getbreadcrumbs(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_getbreadcrumbs(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_getbreadcrumbs(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_getbreadcrumbs(integer) TO PUBLIC;


--
-- Name: mp_pages_getnextpageorder(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_getnextpageorder(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_getnextpageorder(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_getnextpageorder(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pages_getnextpageorder(integer, integer) TO PUBLIC;


--
-- Name: mp_pages_getpagelist(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_getpagelist(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_getpagelist(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_getpagelist(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_getpagelist(integer) TO PUBLIC;


--
-- Name: mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_pages_insert(integer, integer, character varying, integer, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, character, boolean, character, text, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_pages_selectchildpages(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selectchildpages(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selectchildpages(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_selectchildpages(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_selectchildpages(integer) TO PUBLIC;


--
-- Name: mp_pages_selectlist(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selectlist(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selectlist(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_selectlist(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_selectlist(integer) TO PUBLIC;


--
-- Name: mp_pages_selectone(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selectone(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selectone(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_selectone(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pages_selectone(integer, integer) TO PUBLIC;


--
-- Name: mp_pages_selectonebyguid(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selectonebyguid(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selectonebyguid(character) FROM test;
GRANT ALL ON FUNCTION mp_pages_selectonebyguid(character) TO test;
GRANT ALL ON FUNCTION mp_pages_selectonebyguid(character) TO PUBLIC;


--
-- Name: mp_pages_selecttree(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selecttree(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selecttree(integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_selecttree(integer) TO test;
GRANT ALL ON FUNCTION mp_pages_selecttree(integer) TO PUBLIC;


--
-- Name: mp_pages_selecttreeformodule(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_selecttreeformodule(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_selecttreeformodule(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_selecttreeformodule(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pages_selecttreeformodule(integer, integer) TO PUBLIC;


--
-- Name: mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_pages_update(integer, integer, integer, integer, character varying, text, text, text, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, character varying, boolean, boolean, boolean, character varying, boolean, character varying, character varying, boolean, character varying, character varying, timestamp without time zone, character, boolean, text, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_pages_updatepageorder(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_updatepageorder(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_updatepageorder(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_pages_updatepageorder(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_pages_updatepageorder(integer, integer) TO PUBLIC;


--
-- Name: mp_pages_updatetimestamp(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_pages_updatetimestamp(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_pages_updatetimestamp(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_pages_updatetimestamp(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_pages_updatetimestamp(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_roles_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_roles_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_roles_delete(integer) TO PUBLIC;


--
-- Name: mp_roles_insert(integer, character varying, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_insert(integer, character varying, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_insert(integer, character varying, character, character) FROM test;
GRANT ALL ON FUNCTION mp_roles_insert(integer, character varying, character, character) TO test;
GRANT ALL ON FUNCTION mp_roles_insert(integer, character varying, character, character) TO PUBLIC;


--
-- Name: mp_roles_roleexists(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_roleexists(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_roleexists(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_roles_roleexists(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_roles_roleexists(integer, character varying) TO PUBLIC;


--
-- Name: mp_roles_select2(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_select2(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_select2(integer) FROM test;
GRANT ALL ON FUNCTION mp_roles_select2(integer) TO test;
GRANT ALL ON FUNCTION mp_roles_select2(integer) TO PUBLIC;


--
-- Name: mp_roles_selectbyname(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_selectbyname(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_selectbyname(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_roles_selectbyname(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_roles_selectbyname(integer, character varying) TO PUBLIC;


--
-- Name: mp_roles_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_roles_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_roles_selectone(integer) TO PUBLIC;


--
-- Name: mp_roles_update(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_roles_update(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_roles_update(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_roles_update(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_roles_update(integer, character varying) TO PUBLIC;


--
-- Name: mp_rssfeeds_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_rssfeeds_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_rssfeeds_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_rssfeeds_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_rssfeeds_delete(integer) TO PUBLIC;


--
-- Name: mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_rssfeeds_insert(integer, integer, character varying, character varying, character varying, character, character, character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_rssfeeds_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_rssfeeds_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_rssfeeds_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_rssfeeds_select(integer) TO test;
GRANT ALL ON FUNCTION mp_rssfeeds_select(integer) TO PUBLIC;


--
-- Name: mp_rssfeeds_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_rssfeeds_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_rssfeeds_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_rssfeeds_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_rssfeeds_select_one(integer) TO PUBLIC;


--
-- Name: mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_rssfeeds_update(integer, integer, character varying, character varying, character varying, character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_schemascripthistory_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_delete(integer) TO PUBLIC;


--
-- Name: mp_schemascripthistory_exists(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_exists(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_exists(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_exists(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_exists(character varying, character varying) TO PUBLIC;


--
-- Name: mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_insert(character varying, character varying, timestamp without time zone, boolean, text, text) TO PUBLIC;


--
-- Name: mp_schemascripthistory_select_byapp(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_select_byapp(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_select_byapp(character varying) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_byapp(character varying) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_byapp(character varying) TO PUBLIC;


--
-- Name: mp_schemascripthistory_select_errorsbyapp(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_select_errorsbyapp(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_select_errorsbyapp(character varying) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_errorsbyapp(character varying) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_errorsbyapp(character varying) TO PUBLIC;


--
-- Name: mp_schemascripthistory_select_one(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemascripthistory_select_one(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemascripthistory_select_one(integer) FROM test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_one(integer) TO test;
GRANT ALL ON FUNCTION mp_schemascripthistory_select_one(integer) TO PUBLIC;


--
-- Name: mp_schemaversion_delete(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemaversion_delete(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemaversion_delete(character varying) FROM test;
GRANT ALL ON FUNCTION mp_schemaversion_delete(character varying) TO test;
GRANT ALL ON FUNCTION mp_schemaversion_delete(character varying) TO PUBLIC;


--
-- Name: mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_schemaversion_insert(character varying, character varying, integer, integer, integer, integer) TO PUBLIC;


--
-- Name: mp_schemaversion_select_all(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemaversion_select_all() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemaversion_select_all() FROM test;
GRANT ALL ON FUNCTION mp_schemaversion_select_all() TO test;
GRANT ALL ON FUNCTION mp_schemaversion_select_all() TO PUBLIC;


--
-- Name: mp_schemaversion_select_one(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemaversion_select_one(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemaversion_select_one(character varying) FROM test;
GRANT ALL ON FUNCTION mp_schemaversion_select_one(character varying) TO test;
GRANT ALL ON FUNCTION mp_schemaversion_select_one(character varying) TO PUBLIC;


--
-- Name: mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_schemaversion_update(character varying, character varying, integer, integer, integer, integer) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_delete(integer) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_insert(integer, character varying, integer, character, character, character) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_selectallbymodulev2(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectallbymodulev2(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectallbymodulev2(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectallbymodulev2(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectallbymodulev2(integer) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_selectbymodulev2(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectbymodulev2(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectbymodulev2(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectbymodulev2(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectbymodulev2(integer, integer) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_selectonev2(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectonev2(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_selectonev2(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectonev2(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_selectonev2(integer) TO PUBLIC;


--
-- Name: mp_sharedfilefolders_update(integer, integer, character varying, integer, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfilefolders_update(integer, integer, character varying, integer, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfilefolders_update(integer, integer, character varying, integer, character) FROM test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_update(integer, integer, character varying, integer, character) TO test;
GRANT ALL ON FUNCTION mp_sharedfilefolders_update(integer, integer, character varying, integer, character) TO PUBLIC;


--
-- Name: mp_sharedfiles_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_delete(integer) TO PUBLIC;


--
-- Name: mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character, character, character) TO PUBLIC;


--
-- Name: mp_sharedfiles_selectbymodule(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_selectbymodule(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_selectbymodule(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectbymodule(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectbymodule(integer, integer) TO PUBLIC;


--
-- Name: mp_sharedfiles_selectbypage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_selectbypage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_selectbypage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectbypage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectbypage(integer, integer) TO PUBLIC;


--
-- Name: mp_sharedfiles_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_selectone(integer) TO PUBLIC;


--
-- Name: mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) FROM test;
GRANT ALL ON FUNCTION mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) TO test;
GRANT ALL ON FUNCTION mp_sharedfiles_update(integer, integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, character, character) TO PUBLIC;


--
-- Name: mp_sharedfileshistory_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfileshistory_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfileshistory_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_delete(integer) TO PUBLIC;


--
-- Name: mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) FROM test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) TO test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_insert(integer, integer, character varying, character varying, character varying, integer, timestamp without time zone, integer, timestamp without time zone, character, character, character) TO PUBLIC;


--
-- Name: mp_sharedfileshistory_select(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfileshistory_select(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfileshistory_select(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_select(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_select(integer, integer) TO PUBLIC;


--
-- Name: mp_sharedfileshistory_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sharedfileshistory_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sharedfileshistory_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_sharedfileshistory_selectone(integer) TO PUBLIC;


--
-- Name: mp_sitefolders_delete(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_delete(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_delete(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_delete(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_delete(character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_exists(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_exists(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_exists(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_exists(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_exists(character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_insert(character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_insert(character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_insert(character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_insert(character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_insert(character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_select_bysite(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_select_bysite(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_select_bysite(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_select_bysite(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_select_bysite(character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_select_one(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_select_one(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_select_one(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_select_one(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_select_one(character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_selectsiteguid(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_selectsiteguid(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_selectsiteguid(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_selectsiteguid(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_selectsiteguid(character varying) TO PUBLIC;


--
-- Name: mp_sitefolders_update(character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitefolders_update(character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitefolders_update(character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitefolders_update(character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitefolders_update(character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitehosts_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitehosts_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitehosts_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_sitehosts_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_sitehosts_delete(integer) TO PUBLIC;


--
-- Name: mp_sitehosts_insert(integer, character varying, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitehosts_insert(integer, character varying, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitehosts_insert(integer, character varying, character) FROM test;
GRANT ALL ON FUNCTION mp_sitehosts_insert(integer, character varying, character) TO test;
GRANT ALL ON FUNCTION mp_sitehosts_insert(integer, character varying, character) TO PUBLIC;


--
-- Name: mp_sitehosts_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitehosts_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitehosts_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_sitehosts_select(integer) TO test;
GRANT ALL ON FUNCTION mp_sitehosts_select(integer) TO PUBLIC;


--
-- Name: mp_sitehosts_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitehosts_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitehosts_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_sitehosts_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_sitehosts_selectone(integer) TO PUBLIC;


--
-- Name: mp_sitehosts_update(integer, integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitehosts_update(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitehosts_update(integer, integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitehosts_update(integer, integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitehosts_update(integer, integer, character varying) TO PUBLIC;


--
-- Name: mp_sitemoduledefinitions_delete(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_delete(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_delete(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_delete(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_delete(integer, integer) TO PUBLIC;


--
-- Name: mp_sitemoduledefinitions_deletev2(character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_deletev2(character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_deletev2(character, character) FROM test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_deletev2(character, character) TO test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_deletev2(character, character) TO PUBLIC;


--
-- Name: mp_sitemoduledefinitions_ensureforadminsites(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_ensureforadminsites() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_ensureforadminsites() FROM test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_ensureforadminsites() TO test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_ensureforadminsites() TO PUBLIC;


--
-- Name: mp_sitemoduledefinitions_insert(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_insert(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_insert(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_insert(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_insert(integer, integer) TO PUBLIC;


--
-- Name: mp_sitemoduledefinitions_insertv2(character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_insertv2(character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitemoduledefinitions_insertv2(character, character) FROM test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_insertv2(character, character) TO test;
GRANT ALL ON FUNCTION mp_sitemoduledefinitions_insertv2(character, character) TO PUBLIC;


--
-- Name: mp_sitepaths_count(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepaths_count(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepaths_count(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepaths_count(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepaths_count(integer, character varying) TO PUBLIC;


--
-- Name: mp_sitepaths_getpathid(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepaths_getpathid(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepaths_getpathid(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepaths_getpathid(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepaths_getpathid(integer, character varying) TO PUBLIC;


--
-- Name: mp_sitepaths_insert(character varying, integer, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepaths_insert(character varying, integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepaths_insert(character varying, integer, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepaths_insert(character varying, integer, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepaths_insert(character varying, integer, character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationallusers_countall(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_countall() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_countall() FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_countall() TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_countall() TO PUBLIC;


--
-- Name: mp_sitepersonalizationallusers_countbypath(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_countbypath(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_countbypath(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_countbypath(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_countbypath(character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationallusers_getpersonalizationblob(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_getpersonalizationblob(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_getpersonalizationblob(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_getpersonalizationblob(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_getpersonalizationblob(character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_insert(character varying, bytea, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationallusers_updatepersonalizationblob(character varying, bytea, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countall(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countall() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countall() FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countall() TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countall() TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbypath(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbypath(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbypath(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbypath(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbypath(character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbypathsince(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbyuser(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuser(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuser(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuser(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuser(character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpath(character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyuserpathsince(character varying, character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countbyusersince(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_countinactivesince(timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_deletebypath(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_deletebypath(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_deletebypath(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_deletebypath(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_deletebypath(character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_getpersonalizationblob(character varying, character varying) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_insert(character varying, character varying, character varying, bytea, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_sitepersonalizationperuser_updatepersonalizationblob(character varying, character varying, bytea, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_sites_count(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_count() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_count() FROM test;
GRANT ALL ON FUNCTION mp_sites_count() TO test;
GRANT ALL ON FUNCTION mp_sites_count() TO PUBLIC;


--
-- Name: mp_sites_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_sites_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_sites_delete(integer) TO PUBLIC;


--
-- Name: mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sites_insert(character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_sites_selectall(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_selectall() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_selectall() FROM test;
GRANT ALL ON FUNCTION mp_sites_selectall() TO test;
GRANT ALL ON FUNCTION mp_sites_selectall() TO PUBLIC;


--
-- Name: mp_sites_selectonebyguidv2(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_selectonebyguidv2(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_selectonebyguidv2(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sites_selectonebyguidv2(character varying) TO test;
GRANT ALL ON FUNCTION mp_sites_selectonebyguidv2(character varying) TO PUBLIC;


--
-- Name: mp_sites_selectonebyhostv2(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_selectonebyhostv2(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_selectonebyhostv2(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sites_selectonebyhostv2(character varying) TO test;
GRANT ALL ON FUNCTION mp_sites_selectonebyhostv2(character varying) TO PUBLIC;


--
-- Name: mp_sites_selectonev2(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_selectonev2(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_selectonev2(integer) FROM test;
GRANT ALL ON FUNCTION mp_sites_selectonev2(integer) TO test;
GRANT ALL ON FUNCTION mp_sites_selectonev2(integer) TO PUBLIC;


--
-- Name: mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_sites_update(integer, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, character varying, integer, character varying, character varying, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) TO test;
GRANT ALL ON FUNCTION mp_sites_updateextendedproperties(integer, boolean, boolean, boolean, integer, integer, boolean, integer, integer, integer, text, character varying) TO PUBLIC;


--
-- Name: mp_sitesettings_getpagelist(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitesettings_getpagelist(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitesettings_getpagelist(integer) FROM test;
GRANT ALL ON FUNCTION mp_sitesettings_getpagelist(integer) TO test;
GRANT ALL ON FUNCTION mp_sitesettings_getpagelist(integer) TO PUBLIC;


--
-- Name: mp_sitesettings_selectdefaultpage(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitesettings_selectdefaultpage(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitesettings_selectdefaultpage(character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitesettings_selectdefaultpage(character varying) TO test;
GRANT ALL ON FUNCTION mp_sitesettings_selectdefaultpage(character varying) TO PUBLIC;


--
-- Name: mp_sitesettings_selectdefaultpagebyid(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitesettings_selectdefaultpagebyid(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitesettings_selectdefaultpagebyid(integer) FROM test;
GRANT ALL ON FUNCTION mp_sitesettings_selectdefaultpagebyid(integer) TO test;
GRANT ALL ON FUNCTION mp_sitesettings_selectdefaultpagebyid(integer) TO PUBLIC;


--
-- Name: mp_sitesettings_selectpage(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_sitesettings_selectpage(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_sitesettings_selectpage(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_sitesettings_selectpage(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_sitesettings_selectpage(integer, character varying) TO PUBLIC;


--
-- Name: mp_taskqueue_count(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_count() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_count() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_count() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_count() TO PUBLIC;


--
-- Name: mp_taskqueue_countbysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_countbysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_countbysite(character) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_countbysite(character) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_countbysite(character) TO PUBLIC;


--
-- Name: mp_taskqueue_countunfinished(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_countunfinished() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_countunfinished() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_countunfinished() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_countunfinished() TO PUBLIC;


--
-- Name: mp_taskqueue_countunfinishedbysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_countunfinishedbysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_countunfinishedbysite(character) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_countunfinishedbysite(character) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_countunfinishedbysite(character) TO PUBLIC;


--
-- Name: mp_taskqueue_delete(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_delete(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_delete(character) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_delete(character) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_delete(character) TO PUBLIC;


--
-- Name: mp_taskqueue_deletecompleted(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_deletecompleted() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_deletecompleted() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_deletecompleted() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_deletecompleted() TO PUBLIC;


--
-- Name: mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_insert(character, character, character, character varying, boolean, character varying, character varying, character varying, text, boolean, boolean, integer, timestamp without time zone, double precision, character varying, text, character varying) TO PUBLIC;


--
-- Name: mp_taskqueue_select_one(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_select_one(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_select_one(character) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_select_one(character) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_select_one(character) TO PUBLIC;


--
-- Name: mp_taskqueue_select_tasksfornotification(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksfornotification() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksfornotification() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksfornotification() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksfornotification() TO PUBLIC;


--
-- Name: mp_taskqueue_select_tasksnotfinished(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotfinished() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotfinished() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotfinished() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotfinished() TO PUBLIC;


--
-- Name: mp_taskqueue_select_tasksnotfinishedbysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotfinishedbysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotfinishedbysite(character) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotfinishedbysite(character) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotfinishedbysite(character) TO PUBLIC;


--
-- Name: mp_taskqueue_select_tasksnotstarted(); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotstarted() FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_select_tasksnotstarted() FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotstarted() TO test;
GRANT ALL ON FUNCTION mp_taskqueue_select_tasksnotstarted() TO PUBLIC;


--
-- Name: mp_taskqueue_selectpage(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_selectpage(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_selectpage(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpage(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpage(integer, integer) TO PUBLIC;


--
-- Name: mp_taskqueue_selectpagebysite(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_selectpagebysite(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_selectpagebysite(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpagebysite(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpagebysite(character, integer, integer) TO PUBLIC;


--
-- Name: mp_taskqueue_selectpageunfinished(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_selectpageunfinished(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_selectpageunfinished(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpageunfinished(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpageunfinished(integer, integer) TO PUBLIC;


--
-- Name: mp_taskqueue_selectpageunfinishedbysite(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_selectpageunfinishedbysite(character, integer, integer) TO PUBLIC;


--
-- Name: mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_update(character, timestamp without time zone, timestamp without time zone, timestamp without time zone, double precision, character varying) TO PUBLIC;


--
-- Name: mp_taskqueue_updatenotification(character, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_updatenotification(character, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_updatenotification(character, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_updatenotification(character, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_updatenotification(character, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_updatestart(character, timestamp without time zone, timestamp without time zone, double precision, character varying) TO PUBLIC;


--
-- Name: mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) FROM test;
GRANT ALL ON FUNCTION mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) TO test;
GRANT ALL ON FUNCTION mp_taskqueue_updatestatus(character, timestamp without time zone, double precision, character varying) TO PUBLIC;


--
-- Name: mp_userlocation_countbysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_countbysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_countbysite(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_countbysite(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_countbysite(character) TO PUBLIC;


--
-- Name: mp_userlocation_countbyuser(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_countbyuser(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_countbyuser(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_countbyuser(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_countbyuser(character) TO PUBLIC;


--
-- Name: mp_userlocation_delete(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_delete(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_delete(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_delete(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_delete(character) TO PUBLIC;


--
-- Name: mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_userlocation_insert(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_userlocation_select_bysite(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_select_bysite(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_select_bysite(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_select_bysite(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_select_bysite(character) TO PUBLIC;


--
-- Name: mp_userlocation_select_byuser(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_select_byuser(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_select_byuser(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_select_byuser(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_select_byuser(character) TO PUBLIC;


--
-- Name: mp_userlocation_select_one(character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_select_one(character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_select_one(character) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_select_one(character) TO test;
GRANT ALL ON FUNCTION mp_userlocation_select_one(character) TO PUBLIC;


--
-- Name: mp_userlocation_select_onebyuserandip(character, bigint); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_select_onebyuserandip(character, bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_select_onebyuserandip(character, bigint) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_select_onebyuserandip(character, bigint) TO test;
GRANT ALL ON FUNCTION mp_userlocation_select_onebyuserandip(character, bigint) TO PUBLIC;


--
-- Name: mp_userlocation_selectpagebyite(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_selectpagebyite(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_selectpagebyite(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_selectpagebyite(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_userlocation_selectpagebyite(character, integer, integer) TO PUBLIC;


--
-- Name: mp_userlocation_selectpagebyuser(character, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_selectpagebyuser(character, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_selectpagebyuser(character, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_selectpagebyuser(character, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_userlocation_selectpagebyuser(character, integer, integer) TO PUBLIC;


--
-- Name: mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_userlocation_update(character, character, character, character varying, bigint, character varying, double precision, double precision, character varying, character varying, character varying, character varying, character varying, character varying, integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_userpages_delete(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_delete(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_delete(character varying) FROM test;
GRANT ALL ON FUNCTION mp_userpages_delete(character varying) TO test;
GRANT ALL ON FUNCTION mp_userpages_delete(character varying) TO PUBLIC;


--
-- Name: mp_userpages_getnextpageorder(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_getnextpageorder(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_getnextpageorder(character varying) FROM test;
GRANT ALL ON FUNCTION mp_userpages_getnextpageorder(character varying) TO test;
GRANT ALL ON FUNCTION mp_userpages_getnextpageorder(character varying) TO PUBLIC;


--
-- Name: mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) FROM test;
GRANT ALL ON FUNCTION mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) TO test;
GRANT ALL ON FUNCTION mp_userpages_insert(character varying, integer, character varying, character varying, character varying, integer, character) TO PUBLIC;


--
-- Name: mp_userpages_select_byuserv2(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_select_byuserv2(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_select_byuserv2(character varying) FROM test;
GRANT ALL ON FUNCTION mp_userpages_select_byuserv2(character varying) TO test;
GRANT ALL ON FUNCTION mp_userpages_select_byuserv2(character varying) TO PUBLIC;


--
-- Name: mp_userpages_select_onev2(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_select_onev2(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_select_onev2(character varying) FROM test;
GRANT ALL ON FUNCTION mp_userpages_select_onev2(character varying) TO test;
GRANT ALL ON FUNCTION mp_userpages_select_onev2(character varying) TO PUBLIC;


--
-- Name: mp_userpages_update(character varying, character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_update(character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_update(character varying, character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_userpages_update(character varying, character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_userpages_update(character varying, character varying, integer) TO PUBLIC;


--
-- Name: mp_userpages_updatepageorder(character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userpages_updatepageorder(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userpages_updatepageorder(character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_userpages_updatepageorder(character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_userpages_updatepageorder(character varying, integer) TO PUBLIC;


--
-- Name: mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) FROM test;
GRANT ALL ON FUNCTION mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) TO test;
GRANT ALL ON FUNCTION mp_userproperties_insert(character varying, character varying, character varying, text, bytea, date, boolean) TO PUBLIC;


--
-- Name: mp_userproperties_propertyexists(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userproperties_propertyexists(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userproperties_propertyexists(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_userproperties_propertyexists(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_userproperties_propertyexists(character varying, character varying) TO PUBLIC;


--
-- Name: mp_userproperties_select_byuser(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userproperties_select_byuser(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userproperties_select_byuser(character varying) FROM test;
GRANT ALL ON FUNCTION mp_userproperties_select_byuser(character varying) TO test;
GRANT ALL ON FUNCTION mp_userproperties_select_byuser(character varying) TO PUBLIC;


--
-- Name: mp_userproperties_select_one(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userproperties_select_one(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userproperties_select_one(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_userproperties_select_one(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_userproperties_select_one(character varying, character varying) TO PUBLIC;


--
-- Name: mp_userproperties_update(character varying, character varying, text, bytea, date, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) FROM test;
GRANT ALL ON FUNCTION mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) TO test;
GRANT ALL ON FUNCTION mp_userproperties_update(character varying, character varying, text, bytea, date, boolean) TO PUBLIC;


--
-- Name: mp_userroles_delete(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userroles_delete(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userroles_delete(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_userroles_delete(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_userroles_delete(integer, integer) TO PUBLIC;


--
-- Name: mp_userroles_deleteuserroles(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userroles_deleteuserroles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userroles_deleteuserroles(integer) FROM test;
GRANT ALL ON FUNCTION mp_userroles_deleteuserroles(integer) TO test;
GRANT ALL ON FUNCTION mp_userroles_deleteuserroles(integer) TO PUBLIC;


--
-- Name: mp_userroles_insert(integer, integer, character, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userroles_insert(integer, integer, character, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userroles_insert(integer, integer, character, character) FROM test;
GRANT ALL ON FUNCTION mp_userroles_insert(integer, integer, character, character) TO test;
GRANT ALL ON FUNCTION mp_userroles_insert(integer, integer, character, character) TO PUBLIC;


--
-- Name: mp_userroles_selectbyroleid(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userroles_selectbyroleid(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userroles_selectbyroleid(integer) FROM test;
GRANT ALL ON FUNCTION mp_userroles_selectbyroleid(integer) TO test;
GRANT ALL ON FUNCTION mp_userroles_selectbyroleid(integer) TO PUBLIC;


--
-- Name: mp_userroles_selectnotinrole(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_userroles_selectnotinrole(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_userroles_selectnotinrole(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_userroles_selectnotinrole(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_userroles_selectnotinrole(integer, integer) TO PUBLIC;


--
-- Name: mp_users_accountlockout(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_accountlockout(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_accountlockout(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_accountlockout(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_accountlockout(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_clearlockout(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_clearlockout(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_clearlockout(character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_clearlockout(character varying) TO test;
GRANT ALL ON FUNCTION mp_users_clearlockout(character varying) TO PUBLIC;


--
-- Name: mp_users_confirmregistration(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_confirmregistration(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_confirmregistration(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_confirmregistration(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_confirmregistration(character varying, character varying) TO PUBLIC;


--
-- Name: mp_users_count(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_count(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_count(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_count(integer) TO test;
GRANT ALL ON FUNCTION mp_users_count(integer) TO PUBLIC;


--
-- Name: mp_users_countbyfirstletter(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_countbyfirstletter(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_countbyfirstletter(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_countbyfirstletter(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_countbyfirstletter(integer, character varying) TO PUBLIC;


--
-- Name: mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_countbyregistrationdaterange(integer, timestamp without time zone, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_countonlinesince(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_countonlinesince(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_countonlinesince(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_countonlinesince(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_countonlinesince(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_decrementtotalposts(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_decrementtotalposts(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_decrementtotalposts(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_decrementtotalposts(integer) TO test;
GRANT ALL ON FUNCTION mp_users_decrementtotalposts(integer) TO PUBLIC;


--
-- Name: mp_users_delete(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_delete(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_delete(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_delete(integer) TO test;
GRANT ALL ON FUNCTION mp_users_delete(integer) TO PUBLIC;


--
-- Name: mp_users_flagasdeleted(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_flagasdeleted(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_flagasdeleted(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_flagasdeleted(integer) TO test;
GRANT ALL ON FUNCTION mp_users_flagasdeleted(integer) TO PUBLIC;


--
-- Name: mp_users_getnewestid(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_getnewestid(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_getnewestid(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_getnewestid(integer) TO test;
GRANT ALL ON FUNCTION mp_users_getnewestid(integer) TO PUBLIC;


--
-- Name: mp_users_gettop50usersonlinesince(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_gettop50usersonlinesince(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_gettop50usersonlinesince(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_gettop50usersonlinesince(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_gettop50usersonlinesince(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_getuserroles(integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_getuserroles(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_getuserroles(integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_users_getuserroles(integer, integer) TO test;
GRANT ALL ON FUNCTION mp_users_getuserroles(integer, integer) TO PUBLIC;


--
-- Name: mp_users_getusersonlinesince(integer, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_getusersonlinesince(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_getusersonlinesince(integer, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_getusersonlinesince(integer, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_getusersonlinesince(integer, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_incrementtotalposts(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_incrementtotalposts(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_incrementtotalposts(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_incrementtotalposts(integer) TO test;
GRANT ALL ON FUNCTION mp_users_incrementtotalposts(integer) TO PUBLIC;


--
-- Name: mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) FROM test;
GRANT ALL ON FUNCTION mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) TO test;
GRANT ALL ON FUNCTION mp_users_insert(integer, character varying, character varying, character varying, character varying, character, timestamp without time zone, character) TO PUBLIC;


--
-- Name: mp_users_login(integer, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_login(integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_login(integer, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_login(integer, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_login(integer, character varying, character varying) TO PUBLIC;


--
-- Name: mp_users_loginbyemail(integer, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_loginbyemail(integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_loginbyemail(integer, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_loginbyemail(integer, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_loginbyemail(integer, character varying, character varying) TO PUBLIC;


--
-- Name: mp_users_select(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_select(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_select(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_select(integer) TO test;
GRANT ALL ON FUNCTION mp_users_select(integer) TO PUBLIC;


--
-- Name: mp_users_selectbyemail(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectbyemail(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectbyemail(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_selectbyemail(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_selectbyemail(integer, character varying) TO PUBLIC;


--
-- Name: mp_users_selectbyloginname(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectbyloginname(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectbyloginname(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_selectbyloginname(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_selectbyloginname(integer, character varying) TO PUBLIC;


--
-- Name: mp_users_selectguidbyopeniduri(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectguidbyopeniduri(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectguidbyopeniduri(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_selectguidbyopeniduri(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_selectguidbyopeniduri(integer, character varying) TO PUBLIC;


--
-- Name: mp_users_selectguidbywindowsliveid(integer, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectguidbywindowsliveid(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectguidbywindowsliveid(integer, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_selectguidbywindowsliveid(integer, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_selectguidbywindowsliveid(integer, character varying) TO PUBLIC;


--
-- Name: mp_users_selectone(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectone(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectone(integer) FROM test;
GRANT ALL ON FUNCTION mp_users_selectone(integer) TO test;
GRANT ALL ON FUNCTION mp_users_selectone(integer) TO PUBLIC;


--
-- Name: mp_users_selectonebyguid(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectonebyguid(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectonebyguid(character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_selectonebyguid(character varying) TO test;
GRANT ALL ON FUNCTION mp_users_selectonebyguid(character varying) TO PUBLIC;


--
-- Name: mp_users_selectpage(integer, integer, character varying, integer, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_selectpage(integer, integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_selectpage(integer, integer, character varying, integer, integer) FROM test;
GRANT ALL ON FUNCTION mp_users_selectpage(integer, integer, character varying, integer, integer) TO test;
GRANT ALL ON FUNCTION mp_users_selectpage(integer, integer, character varying, integer, integer) TO PUBLIC;


--
-- Name: mp_users_setfailedpasswordanswerattemptcount(character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptcount(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptcount(character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptcount(character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptcount(character varying, integer) TO PUBLIC;


--
-- Name: mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordanswerattemptstartwindow(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_setfailedpasswordattemptcount(character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_setfailedpasswordattemptcount(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_setfailedpasswordattemptcount(character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordattemptcount(character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordattemptcount(character varying, integer) TO PUBLIC;


--
-- Name: mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_setfailedpasswordattemptstartwindow(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_setregistrationguid(character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_setregistrationguid(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_setregistrationguid(character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_setregistrationguid(character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_setregistrationguid(character varying, character varying) TO PUBLIC;


--
-- Name: mp_users_smartdropdown(integer, character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_smartdropdown(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_smartdropdown(integer, character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_users_smartdropdown(integer, character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_users_smartdropdown(integer, character varying, integer) TO PUBLIC;


--
-- Name: mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_update(integer, character varying, character varying, character varying, character varying, character, boolean, boolean, boolean, boolean, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, text, integer, character varying, character varying) TO PUBLIC;


--
-- Name: mp_users_updatelastactivitytime(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_updatelastactivitytime(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_updatelastactivitytime(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_updatelastactivitytime(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_updatelastactivitytime(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_updatelastlogintime(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_updatelastlogintime(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_updatelastlogintime(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_updatelastlogintime(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_updatelastlogintime(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) FROM test;
GRANT ALL ON FUNCTION mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) TO test;
GRANT ALL ON FUNCTION mp_users_updatelastpasswordchangedate(character varying, timestamp without time zone) TO PUBLIC;


--
-- Name: mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_users_updatepasswordquestionandanswer(character varying, character varying, character varying) TO PUBLIC;


--
-- Name: mp_webparts_count(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_count(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_count(integer) FROM test;
GRANT ALL ON FUNCTION mp_webparts_count(integer) TO test;
GRANT ALL ON FUNCTION mp_webparts_count(integer) TO PUBLIC;


--
-- Name: mp_webparts_delete(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_delete(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_delete(character varying) FROM test;
GRANT ALL ON FUNCTION mp_webparts_delete(character varying) TO test;
GRANT ALL ON FUNCTION mp_webparts_delete(character varying) TO PUBLIC;


--
-- Name: mp_webparts_exists(integer, character varying, character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_exists(integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_exists(integer, character varying, character varying) FROM test;
GRANT ALL ON FUNCTION mp_webparts_exists(integer, character varying, character varying) TO test;
GRANT ALL ON FUNCTION mp_webparts_exists(integer, character varying, character varying) TO PUBLIC;


--
-- Name: mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) FROM test;
GRANT ALL ON FUNCTION mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) TO test;
GRANT ALL ON FUNCTION mp_webparts_insert(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, character) TO PUBLIC;


--
-- Name: mp_webparts_select_bysite(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_select_bysite(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_select_bysite(integer) FROM test;
GRANT ALL ON FUNCTION mp_webparts_select_bysite(integer) TO test;
GRANT ALL ON FUNCTION mp_webparts_select_bysite(integer) TO PUBLIC;


--
-- Name: mp_webparts_select_formypage(integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_select_formypage(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_select_formypage(integer) FROM test;
GRANT ALL ON FUNCTION mp_webparts_select_formypage(integer) TO test;
GRANT ALL ON FUNCTION mp_webparts_select_formypage(integer) TO PUBLIC;


--
-- Name: mp_webparts_select_onev2(character varying); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_select_onev2(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_select_onev2(character varying) FROM test;
GRANT ALL ON FUNCTION mp_webparts_select_onev2(character varying) TO test;
GRANT ALL ON FUNCTION mp_webparts_select_onev2(character varying) TO PUBLIC;


--
-- Name: mp_webparts_selectpage(integer, integer, integer, boolean, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_selectpage(integer, integer, integer, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_selectpage(integer, integer, integer, boolean, boolean) FROM test;
GRANT ALL ON FUNCTION mp_webparts_selectpage(integer, integer, integer, boolean, boolean) TO test;
GRANT ALL ON FUNCTION mp_webparts_selectpage(integer, integer, integer, boolean, boolean) TO PUBLIC;


--
-- Name: mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) FROM test;
GRANT ALL ON FUNCTION mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) TO test;
GRANT ALL ON FUNCTION mp_webparts_update(character varying, integer, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean) TO PUBLIC;


--
-- Name: mp_webparts_updatecountofuseonmypage(character varying, integer); Type: ACL; Schema: public; Owner: test
--

REVOKE ALL ON FUNCTION mp_webparts_updatecountofuseonmypage(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION mp_webparts_updatecountofuseonmypage(character varying, integer) FROM test;
GRANT ALL ON FUNCTION mp_webparts_updatecountofuseonmypage(character varying, integer) TO test;
GRANT ALL ON FUNCTION mp_webparts_updatecountofuseonmypage(character varying, integer) TO PUBLIC;


--
-- PostgreSQL database dump complete
--

